/*	PRODUCT: dmtmul		VERSION: S.61.1.6	*/


/*
 * @(#)gtihip.c	1.155
 */
#include "gti.h"

#ifndef GTI_DEBUG_WHIP
    #include "gtidsp.h"
    #include "gtiextn.h"
    #include "gti_rel.h"
#ifdef GTI_DEBUG
    #include "dbginfo.h"
    #include "p3hw.h"
    #include "extern.h"
    #include "global.h"
    #include "romtabls.h"
#else
    #define m_byteFromPTRs(a,b,c) (*(GTI_BYTE GTI_ADDRESS_QUAL *)(( GTI_DWORD )a + b + c))
#endif
    void I2Hex(GTI_WORD, GTI_BYTE ,GTI_BYTE ,GTI_BYTE *);
    void SerialTXStr(char GTI_ADDRESS_QUAL * );
#endif

/************************************************************************/
/*        TSM  Application Code                                         */
/* (C) Copyright 1996-2000 by GlobeSpan Technologies Inc                */
/************************************************************************/

/* File: hip.c                               */
/* Discription: All HIP releted activities   */
/*                                           */

#ifndef GTI_DEBUG_WHIP
/*Name: HIP2XCVR()                            */
/*Function: Execute the Command in the Mail box    */
/*                                                 */
void
HIP2XCVR(GTI_XCVR_INFO *GTISysPtr)
{

     switch(HIP_Mail[1]){
#ifdef GTI_DEBUG
       case 0x1b:      /* Execute Table Command */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          GTIExCommand(GTISysPtr);
          break;

       case 0x1c:      /* Program FLASH NOT for FIRST TIME */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          GTIFLASHProg();
          break;

       case 0x1d:      /* Download to RAM   */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          RAMLoad();
          break;

       case 0x1e:      /* Set Speed for commands           */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          GTIDownSpeed();
          break;

       case 0x21:      /* Enable Autoretrain */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          GTIRetrain();
          break;


       case 0x22:      /* FRAMER STATUS                          */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          /*GTIFramerStatus(); */
          break;

       case 0x24:      /* Code Write "word command    */
          GTICodeWrite(GTISysPtr);
          break;

       case 0x25:      /* XCVR Break Points */
                       /* ONLY USED FOR INTERNAL GTI APPLICATIONS*/
          GTIXCVRBreak();
          break;

       case 0x27:      /* Enable/Disable Warm Startup Procedure  */
          GTIWarm();
          break;


#ifdef GTI_PROD_ADSL7MC
       case 0x31:      /* Send/Print out Receive Packet */
          HIPGetPacket(GTISysPtr);
          break;
#endif
#if( defined(GTI_PROD_HDSL2) || defined(GTI_PROD_MSDSL) || defined(GTI_PROD_HDSL4W) )
       case 0x31:      /* Send/Print out Receive Packet */
          HIPEOCMsgBuffer(GTISysPtr);
          break;
#endif

#ifdef GTI_PROD_RADSLX
       case 0x32:      /* Read/Write Coeff */
          HIPReadWriteCoeff(GTISysPtr);
          break;
#endif

       case 0x33:      /* Programmable delay for debuginng timeouts */
          GTIDelay();
          break;

       case 0x35:
          HIPXcvrStatus();
          break;

#endif  /*GTI_DEBUG*/

#ifdef GTI_TRACE
       case 0x15:      /* Dump SAS History */
                       /* ONLY USED FOR DEBUGGING */
          GTISASHistory();
          break;
       case 0x34:      /* Stop SAS */
                       /* ONLY USED FOR DEBUGGING */
          GTISASStop();
          break;
#endif

#if ( !defined(GTI_PROD_DMT) && !defined(GTI_PROD_RADSLX) && !defined(GTI_PROD_IDSL) )
       case 0x10:      /* Issue a Clock Param Command */
          GTIClockHIP(GTISysPtr);
          break;
#endif

       case 0x11:      /* Issue a Param/Execute Command */
          GTIParamExec(GTISysPtr);
          break;

       case 0x12:      /* Read Framer                 */
          GTIReadFramerHIP(GTISysPtr);
          break;

       case 0x13:      /* Write Framer                 */
          GTIWriteFramerHIP(GTISysPtr);
          break;

       case 0x14:      /* Get Status information                 */
          GTIGetStatus(GTISysPtr);
          break;

       case 0x16:      /* Read RAM */
          GTIReadRam(GTISysPtr);
          break;

       case 0x17:      /* Write RAM */
          GTIWriteRam(GTISysPtr);
          break;

       case 0x18:      /* Read Host */
          GTIReadHost(GTISysPtr);
          break;

       case 0x19:      /* Write Host */
          GTIWriteHost(GTISysPtr);
          break;

       case 0x1a:      /* Reset STARLET */
          ResetDSP(GTISysPtr,GTI_DSP_ALL);  /* Customer Supplied */
          InitXCVR(GTISysPtr);
          break;

       case 0x20:      /* Generic Param Command       */
          GTIParamSetHIP(GTISysPtr);
          break;

       case 0x23:      /* Code Read "word" command    */
          GTICodeRead(GTISysPtr);
          break;

       case 0x26:      /* ID product type to AUTO Test Program   */
                       /* Sends Product #define to the PC        */
                       /* Sends other Identification information */
          GTIInfoInt();
          break;

       case 0x28:      /* Enable/Disable STARLET Interrupt */
          GTIStarInterrupt(GTISysPtr);
          break;

       case 0x29:      /* Allow customer to debug MultiXCVR systems frm HIP */
          GTISwitchXCVR();
          break;

       case 0x2a:
          GTISyncFramer(GTISysPtr);
          break;

       case 0x30:      /* Control Customer Interface Data leads             */
#ifndef GTI_PROD_DMT     /* Not Supported in DMT  product */
          GTIRxTxInterface(GTISysPtr);
#endif
          break;

#if ( defined (GTI_PROD_MSDSL ) || defined (GTI_PROD_M2B1Q) || defined (GTI_PROD_IDSL ) )
        case 0x36:
          GTISetTimeSlot(GTISysPtr);
          break;

        case 0x41:
          GTISetFrmClamp(GTISysPtr);
          break;
#endif
#if ( defined (GTI_PROD_MSDSL ) || defined (GTI_PROD_M2B1Q) || defined (GTI_PROD_HDSL2) )

        case 0x40:
          GTISetFrmParam(GTISysPtr);
          break;

        case 0x42:
          GTISetInsertError(GTISysPtr);
          break;

        case 0x43:
          GTISetGenericFramerParam(GTISysPtr);
          break;
#endif

#if ( defined (GTI_PROD_H2B1Q ) || defined (GTI_PROD_HDSL2) || defined (GTI_PROD_MSDSL) || defined(GTI_PROD_HDSL4W))

       case 0x37:
          GTIEOCData(GTISysPtr);
          break;

#endif

#if ( defined (GTI_PROD_M2B1Q ) )
       case 0x38:
          GTIF3Cell(GTISysPtr);
          break;
#endif

#if ( defined (GTI_PROD_IDSL ) || defined (GTI_PROD_MSDSL))
       case 0x39:
          GTISetPin(GTISysPtr);
          break;
#endif

     }
}
#endif /* not WHIP */


#ifndef GTI_DEBUG_WHIP
void
GTIReadHost(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_BYTE GTI_LOCAL_QUAL dsp_id;

      /*     Read Startlet Host Command     */
      /* Length =  3          =HIP_Mail[0]  */
      /* Op code=  0x18       =HIP_Mail[1]  */
      /* Segment = STARLET_ID =HIP_Mail[2]  */
      /* offset =  Host REG =  HIP_Mail[3]  */

      switch(HIP_Mail[2]){
         case 0x0b:
            dsp_id = GTI_DSP_B;
            break;

         case 0x0d:
         case 0x0c:
            dsp_id = GTI_DSP_DMA;
            SerialTXChar( READ_DSP_REG(GTISysPtr,HIP_Mail[3]) );
            return;

         case 0x00:
            /* Wrapper Host RAM - SAS*/
            SerialTXChar( GET_HOST_DB_B(GTISysPtr, HIP_Mail[3]));
            return;

         case 0x0a:
         default:
            dsp_id = GTI_DSP_A;
            break;
      }
      SerialTXChar( READ_DSP_BYTE(GTISysPtr,dsp_id,HIP_Mail[3]) );
      return;
}
void
GTIWriteHost( GTI_XCVR_INFO *GTISysPtr )
{
      GTI_BYTE GTI_LOCAL_QUAL dsp_id;

      /*     Read Starlet Host Command      */
      /* Length =  4          =HIP_Mail[0]  */
      /* Op code=  0x19       =HIP_Mail[1]  */
      /* Segment = STARLET_ID =HIP_Mail[2]  */
      /* offset =  Host REG =  HIP_Mail[3]  */
      /* dat    =  dat      =  HIP_Mail[4]  */

      switch(HIP_Mail[2]){
         case 0x0b:
            dsp_id = GTI_DSP_B;
            break;
         case 0x0d:
            /*dsp_id = GTI_DSP_DMA;*/
            WRITE_DSP_REG(GTISysPtr, HIP_Mail[3], HIP_Mail[4]);
            return;
         case 0x0c:
            dsp_id = GTI_DSP_AB;
            break;
         case 0x00:
            /* Wrapper Host RAM - SAS */
            SET_HOST_DB_B(GTISysPtr, HIP_Mail[3], HIP_Mail[4]);
            return;
         case 0x0a:
         default:
            dsp_id = GTI_DSP_A;
            break;
      }
      WRITE_DSP_BYTE(GTISysPtr, dsp_id, HIP_Mail[3], HIP_Mail[4]);
      return;
}
void
GTIReadRam(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_BYTE GTI_LOCAL_QUAL dsp_id;
      GTI_BYTE GTI_LOCAL_QUAL datal,datah;
      GTI_WORD GTI_LOCAL_QUAL result;

      /*     Read Starlet Host Command      */
      /* Length =  4          =HIP_Mail[0]  */
      /* Op code=  0x16       =HIP_Mail[1]  */
      /* Segment = STARLET_ID =HIP_Mail[2]  */
      /* ram =                =HIP_Mail[3]  */
      /* offset =             =HIP_Mail[4]  */

      switch(HIP_Mail[2]){
         case 0x0b:
            dsp_id = GTI_DSP_B;
            break;
         case 0x0c:
            dsp_id = GTI_DSP_C;
            break;
         case 0x0a:
         default:
            dsp_id = GTI_DSP_A;
            break;
      }
      /* Configure for Reading Internal Register */
      CONFIGURE_DSP(GTISysPtr, dsp_id, GTI_NO_AI);
      WRITE_DSP_ADDR(GTISysPtr,dsp_id,HIP_Mail[4],(GTI_BYTE)(HIP_Mail[3]|GTI_READ_DSP) );

      result = WRITE_DSP_WORD(GTISysPtr,dsp_id);
      datal = (GTI_BYTE) (result&0x00ff);
      datah = (GTI_BYTE) ((result>>8)&0x00ff);

      SerialTXChar(0x00);       /* Success */
      SerialTXChar(datal);
      SerialTXChar(datah);
      return;
}
void
GTIWriteRam(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_BYTE GTI_LOCAL_QUAL dsp_id;

      /*     Read Starlet Host Command      */
      /* Length =  6          =HIP_Mail[0]  */
      /* Op code=  0x17       =HIP_Mail[1]  */
      /* Segment = STARLET_ID =HIP_Mail[2]  */
      /* Ram =     RAM =      =HIP_Mail[3]  */
      /* offset =           =  HIP_Mail[4]  */
      /* datal  =  data     =  HIP_Mail[5]  */
      /* datah  =  data     =  HIP_Mail[6]  */

      switch(HIP_Mail[2]){
         case 0x0b:
            dsp_id = GTI_DSP_B;
            break;
         case 0x0c:
            dsp_id = GTI_DSP_C;
            break;
         case 0xab:
         case 0xba:
            dsp_id = GTI_DSP_AB;
            break;
         case 0x0a:
         default:
            dsp_id = GTI_DSP_A;
            break;
      }
      /* Configure for Write to STAR RAM-REG */
      CONFIGURE_DSP(GTISysPtr, dsp_id, GTI_NO_AI);
      WRITE_DSP_ADDR(GTISysPtr,dsp_id,HIP_Mail[4],HIP_Mail[3]);
      WRITE_DSP_WORD(GTISysPtr,dsp_id,HIP_Mail[5],HIP_Mail[6]);
      return;
}

void
GTIGetStatus(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_BYTE GTI_LOCAL_QUAL Status[4];

      /*     Read Starlet Host Command      */
      /* Length =  3          =HIP_Mail[0]  */
      /* Op code=  0x14       =HIP_Mail[1]  */
      /* what   = (sq,rel...) =HIP_Mail[2]  */
      /* channel=             =HIP_Mail[3]  */


         Status[0]=HIP_Mail[2];

      /* Old HIP dosn't send CHANNEL info   */
      /* Check length to if old way         */
      if( HIP_Mail[0] == 0x02 )Status[1]=GTI_CH_A;
      else Status[1]=HIP_Mail[3];

      StatusXCVR(GTISysPtr,Status);

      SerialTXChar( Status[0] );
      SerialTXChar( Status[1] );
      SerialTXChar( Status[2] );
      SerialTXChar( Status[3] );
      return;
}
#if ( !defined(GTI_PROD_DMT) && !defined(GTI_PROD_RADSLX) && !defined(GTI_PROD_IDSL) )
void
GTIClockHIP(GTI_XCVR_INFO *GTISysPtr)
{
      /*     Call Param/Execute             */
      /* Length =  8          =HIP_Mail[0]  */
      /* Op code=  0x10       =HIP_Mail[1]  */
      /* id                   =HIP_Mail[2]  */
      /* low rrm1             =HIP_Mail[3]  */
      /* high rrm1            =HIP_Mail[4]  */
      /* low rrm2             =HIP_Mail[5]  */
      /* high rrm2            =HIP_Mail[6]  */
      /* low divide           =HIP_Mail[7]  */
      /* high divide          =HIP_Mail[8]  */


      HIPGenericClock(GTISysPtr);

}
#endif
void
GTIParamSetHIP(GTI_XCVR_INFO *GTISysPtr)
{
    GTISysPtr = GTISysPtr;
      /*     Call Param routine specified   */
      /* Length =  x          =HIP_Mail[0]  */
      /* Op code=  0x20       =HIP_Mail[1]  */
      /* type                 =HIP_Mail[2]  */

      /* if type = 0x00 - Check Compatibility*/
      /* Length =  2          =HIP_Mail[0]  */

      /* if type = 0x01 - Power             */
      /* Length =  3          =HIP_Mail[0]  */
      /* TxPower_A            =HIP_Mail[3]  */

      /* if type = 0x02 - Upstream Rate     */
      /* Length =  3          =HIP_Mail[0]  */
      /* Reverse Rate         =HIP_Mail[3]  */

      /* if type = 0x03 - PPM               */
      /* Length =  4          =HIP_Mail[0]  */
      /* resulotion           =HIP_Mail[3]  */
      /* deviation            =HIP_Mail[4]  */

      /* if type = 0x04 -TXRX Clock(HDSL-4W)*/
      /* Length =  4          =HIP_Mail[0]  */
      /* id                   =HIP_Mail[3]  */
      /* state                =HIP_Mail[4]  */

      /* if type = 0x05 - Constellation     */
      /* Length =  6          =HIP_Mail[0]  */
      /* down Constel         =HIP_Mail[3]  */
      /* up Constel           =HIP_Mail[4]  */
      /* margin               =HIP_Mail[5]  */
      /* baud                 =HIP_Mail[6]  */

      /* if type = 0x06 - Framer            */
      /* Length =  4          =HIP_Mail[0]  */
      /* Config               =HIP_Mail[3]  */
      /* Mode                 =HIP_Mail[4]  */

      /* if type = 0x07 - Initiate          */
      /* Length =  3          =HIP_Mail[0]  */
      /* Initiate             =HIP_Mail[3]  */

      /* if type = 0x08 - Send Words        */
      /* Length =  8          =HIP_Mail[0]  */
      /* VendorID Low         =HIP_Mail[3]  */
      /* VendorID high        =HIP_Mail[4]  */
      /* Spec1    Low         =HIP_Mail[5]  */
      /* Spec1    high        =HIP_Mail[6]  */
      /* Spec2    Low         =HIP_Mail[7]  */
      /* Spec2    high        =HIP_Mail[8]  */

      /* if type = 0x09 - Bit Field         */
      /* Length =  4          =HIP_Mail[0]  */
      /* Bit Field            =HIP_Mail[3]  */
      /*  or Clock            =HIP_Mail[3]  */
      /* Framer Type          =HIP_Mail[4]  */

      /* if type = 0x0a -  TX Scale         */
      /* Length =  4          =HIP_Mail[0]  */
      /* Scale_A Low          =HIP_Mail[3]  */
      /* Scale_A High         =HIP_Mail[4]  */
      /* Scale_B Low          =HIP_Mail[5]  */
      /* Scale_B High         =HIP_Mail[6]  */


     switch(HIP_Mail[2]){
        case 0x00:
            /* Let HIP know it is the correct version */
            SerialTXChar( 0x00 );
            break;
        case 0x01:  /* Issue a TXPower Param Command */
            HIP_Param[0]=HIP_Mail[3]; /* Power Channel A */
            break;
        case 0x02:  /* Issue a SetUpstream Param Command */
            HIP_Param[0]=HIP_Mail[3]; /* Reverse Rate */
            break;
        case 0x03:  /* Issue a PPM Param Command */
            HIP_Param[2]=HIP_Mail[3]; /* Clock Low  */
            HIP_Param[3]=HIP_Mail[4]; /* Clock High */
            break;
        case 0x04:  /* Issue a RXTX clock Command */
#ifdef GTI_PROD_HDSL4W    /* Supported in HDSL4W product */
            ParamTXRXState(GTISysPtr,HIP_Mail[3],HIP_Mail[4]);
#endif
            break;
        case 0x05:  /* Issue a Constellation Param Command */
            HIP_Param[0]=HIP_Mail[3]; /* down */
            HIP_Param[1]=HIP_Mail[4]; /* up */
            HIP_Param[2]=HIP_Mail[5]; /* margin */
            HIP_Param[3]=HIP_Mail[6]; /* baud   */
            HIP_Param[4]=HIP_Mail[7]; /* Remote margin */
            HIP_Param[5]=HIP_Mail[8]; /* up baud   */

            break;
#ifndef GTI_PROD_H2B1Q
#ifndef GTI_PROD_HDSLG
#ifndef GTI_PROD_HDSL4W
#ifndef GTI_PROD_MSDSL
#ifndef GTI_PROD_HDSL2
#ifndef GTI_PROD_DMT
#ifndef GTI_PROD_M2B1Q
#ifndef GTI_PROD_RADSLX
#ifndef GTI_PROD_IDSL
        case 0x06:  /* Issue a ParamFramer  */
            ParamFramer(GTISysPtr,HIP_Mail[3],HIP_Mail[4]);
            break;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
        case 0x07:  /* Set Parameter Iniate for ADSL7MC,MSDSL */
            HIP_Param[1]=HIP_Mail[3];
            break;
        case 0x08:
#ifdef GTI_PROD_HDSL2
            ParamRepeater(GTISysPtr,(GTI_WORD)HIP_Mail[9]);
            ParamSend(GTISysPtr,(GTI_WORD)(HIP_Mail[4]<<8)|(HIP_Mail[3]),    /*Country Code 1 16 bits */
                                0x00,                                        /*Country Code 2 16 bits */
                                (GTI_WORD)(HIP_Mail[6]<<8)|(HIP_Mail[5]),    /*Provider Code 1 16 bits  */
                                0x00,                                        /*Provider Code 2 16 bits */
                                (GTI_WORD)(HIP_Mail[8]<<8)|(HIP_Mail[7]),    /* Vendor Data 1   */
                                0x0000,                                      /* Vendor Data 2   */
                                0x0000,                                      /* Vendor Data 3   */
                                0x0000 );                                    /* Vendor Data 4   */
#endif
#ifdef GTI_PROD_SDSLE1
            ParamRepeater(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
#endif
#ifdef GTI_PROD_HDSL4W
            ParamRepeater(GTISysPtr,(GTI_WORD)HIP_Mail[3],(GTI_WORD)HIP_Mail[4]);
#endif
#ifdef GTI_PROD_MSDSL
            ParamSend(GTISysPtr,(GTI_WORD)(HIP_Mail[4]<<8)|(HIP_Mail[3]),    /*Vendor ID */
                                (GTI_WORD)(HIP_Mail[6]<<8)|(HIP_Mail[5]),    /* Spec 1   */
                                (GTI_WORD)(HIP_Mail[8]<<8)|(HIP_Mail[7]),    /* Spec 2   */
                                0x0000,                            /* Spec 3   */
                                0x0000 );                          /* Spec 4   */
            ParamRepeater(GTISysPtr,(GTI_WORD)HIP_Mail[9]);
#endif
#ifdef GTI_PROD_RADSLX
            ParamSend(GTISysPtr,(HIP_Mail[4]<<8)|(HIP_Mail[3]),    /*Vendor ID */
                                (HIP_Mail[6]<<8)|(HIP_Mail[5]),    /* Spec 1   */
                                (HIP_Mail[8]<<8)|(HIP_Mail[7]),    /* Spec 2   */
                                0x0000,                            /* Spec 3   */
                                0x0000 );                          /* Spec 4   */
#endif
            break;

        case 0x09:  /* Set Bit Parameter Fix Bit Rate */

#ifdef GTI_PROD_HDSLG    /* Supported in HDSLG  product */
            ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);
#endif
#ifdef GTI_PROD_H2B1Q    /* Supported in H2B1Q  product */
            ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);
            ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
#endif
#ifdef GTI_PROD_M2B1Q    /* Supported in M2B1Q  product */
            ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);
            ParamLineInterface(GTISysPtr,(GTI_WORD)HIP_Mail[5]);
            ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
            ParamFixBit(GTISysPtr,(GTI_WORD)HIP_Mail[7],(GTI_WORD)HIP_Mail[8]);
            ParamPcuCode(GTISysPtr,(GTI_WORD)HIP_Mail[9]);
#endif
#ifdef GTI_PROD_HDSL2    /* Supported in HDSL2  product */
            ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);
            ParamLineInterface(GTISysPtr,(GTI_WORD)HIP_Mail[5]);
            ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
#endif
#ifdef GTI_PROD_SDSLE1    /* Supported in SDSLE1  product */
            ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);
            ParamLineInterface(GTISysPtr,(GTI_WORD)HIP_Mail[5]);
            ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
#endif
#ifdef GTI_PROD_HDSL4W    /* Supported in HDSL4W  product */
            ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);
            ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
#endif

#ifdef GTI_PROD_MSDSL    /* Supported in MSDSL  product */
            ParamFixBit(GTISysPtr,(GTI_WORD)HIP_Mail[3],(GTI_WORD)HIP_Mail[4]);
            ParamLineInterface(GTISysPtr,(GTI_WORD)HIP_Mail[5]);
            ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
            ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[7]);
#endif
#ifdef GTI_PROD_IDSL    /* Supported in IDSL  product */
            /*ParamClockType(GTISysPtr,(GTI_WORD)HIP_Mail[3]);*/
            /*ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[4]);*/
            /*ParamLineInterface(GTISysPtr,(GTI_WORD)HIP_Mail[5]);*/
            /*ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);*/
            /*ParamFixBit(GTISysPtr,(GTI_WORD)HIP_Mail[7],(GTI_WORD)HIP_Mail[8]);*/
#endif


#ifdef GTI_PROD_RADSLX
             /* 3 - bit fields */
             /* 4 - mode       */
             /* 5 - Framer     */
             /* 6 - A2D */
             if( HIP_Mail[3] != GTI_NO_CHANGE_BIT_FIELD ){


                ParamLineInterface(GTISysPtr,(GTI_WORD)HIP_Mail[4],
                                          (GTI_WORD)(HIP_Mail[3]&0x01));
                ParamPWRDown(GTISysPtr,(GTI_WORD)(HIP_Mail[3]&0x02));
                ParamClockType(GTISysPtr,(GTI_WORD)(HIP_Mail[3]&0x04));
                ParamFilterType(GTISysPtr,(GTI_WORD)(HIP_Mail[3]&0x10),
                                       (GTI_WORD)(HIP_Mail[3]&0x20));
                ParamStandby(GTISysPtr,(GTI_WORD)(HIP_Mail[3]&0x40));
                ParamFixBit(GTISysPtr,(GTI_WORD)(HIP_Mail[3]&0x80));
             }

             ParamFramerType(GTISysPtr,(GTI_WORD)HIP_Mail[5]);
             ParamA2D_D2A(GTISysPtr,(GTI_WORD)HIP_Mail[6]);
#endif



            break;


        case 0x0a:  /* Scale */
#ifdef GTI_PROD_HDSL2
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)));
#endif
#ifdef GTI_PROD_MSDSL
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)));
#endif
#ifdef GTI_PROD_IDSL
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)));
#endif
#ifdef GTI_PROD_M2B1Q
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)));
#endif
#ifdef GTI_PROD_SDSLE1
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)));
#endif
#ifdef GTI_PROD_H2B1Q
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)),
            (GTI_WORD)(HIP_Mail[5]|(HIP_Mail[6]<<8)));
#endif
#ifdef GTI_PROD_HDSLG
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)),
            (GTI_WORD)(HIP_Mail[5]|(HIP_Mail[6]<<8)));
#endif
#ifdef GTI_PROD_HDSL4W
            ParamTxScale(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)),
            (GTI_WORD)(HIP_Mail[5]|(HIP_Mail[6]<<8)));
#endif
            break;
#ifdef GTI_PROD_HDSL2
        case 0x0b:  /* HDSL2 */
            ParamDecoderCoeff(GTISysPtr,(GTI_WORD)(HIP_Mail[3]|(HIP_Mail[4]<<8)), GTI_DEC_A);
            ParamDecoderCoeff(GTISysPtr,(GTI_WORD)(HIP_Mail[5]|(HIP_Mail[6]<<8)),GTI_DEC_B);

            ParamStuffBits(GTISysPtr,(GTI_WORD)HIP_Mail[7] );
            ParamFrameSync(GTISysPtr,(GTI_WORD)( (HIP_Mail[9]<<8)|HIP_Mail[8] ) );

            if(  HIP_Mail[10] == 0 )
                 ParamPowerBackOff(GTISysPtr,GTI_POWER_BACKOFF_ENABLE );
            else
                 ParamPowerBackOff(GTISysPtr,GTI_POWER_BACKOFF_DISABLE );

            break;
#endif
     }
}

void
GTIParamExec(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_WORD GTI_LOCAL_QUAL result;

      /*     Call Param/Execute             */
      /* Length =  6          =HIP_Mail[0]  */
      /* Op code=  0x11       =HIP_Mail[1]  */
      /* Action               =HIP_Mail[2]  */
      /* Product              =HIP_Mail[3]  */
      /* Rate                 =HIP_Mail[4]  */
      /* Channel              =HIP_Mail[5]  */
      /* Mode                 =HIP_Mail[6]  */



      /* Param routine is based on product  */
      result = HIPGenericParam(GTISysPtr);


      SerialTXChar( (GTI_BYTE)(result&0x00ff) );
      if( result == GTI_OK ){
#ifdef GTI_TRACE
          HistPnt=0;
#endif
#ifdef GTI_DEBUG
#ifdef GTI_PROD_M2B1Q
         FPMode=HIP_Mail[6];        /* Only used for demo purposes */
#endif
          ConfigSys(GTI_XCVR_RUN); /* HW/Customer Dependent  routine */
                                   /* Configure System for doing XCVR*/
                                   /* Routine                        */
                                   /* i.e. Short interrupts...       */
#ifndef GTI_PROD_SDSLE1    /* Not Supported in SDSLE1 product */
#ifndef GTI_PROD_HDSL4W    /* Not Supported in HDSL4W product */
          HIPIntCount=1;
#endif
#endif
#endif

          /**********************************************************/
          /*        INTERRUPT Enabled Code - READ!!!!!              */
          /* If Interrupts are ENABLED the call ExecuteXCVR ONCE    */
          /* and then return.  Successive calls are to be handled   */
          /* by interrupt routine                                   */
          /**********************************************************/
          if(GET_HOST_DB_B(GTISysPtr, GTI_IPU_INTERRUPT_STATE) == GTI_TRUE)
          {
                ExecuteXCVR(GTISysPtr);
                return;
          }

          do{
             result=ExecuteXCVR(GTISysPtr);

             /* Operation less then 2ms go here*/

#ifdef GTI_DEBUG

             /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
             /*              READ                              */
             /* Customer must replace with own flag to support */
             /* status,abort during startup                    */
             /* When supported move outside "ifdef"            */
             /* This flag would be set when a complete HIP     */
             /* Command is received.  Need for AutoTest        */
             /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
             if( FlgGetHIPCmd == GTI_FINISHED ){
                 FlgGetHIPCmd=GTI_FALSE;
                 GTICheckHIPCmd(GTISysPtr);
             }
             /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
             /*              READ                              */
             /* For GTI debugging must have an abort where     */
             /* the state/starlet does not get inited          */
             /* Non  HIP command                               */
             /* then exit with out issuing abort command       */
             /* Can be triggered by a button push, character   */
             /* or a time out (i.e. 15 seconds)                */
             /* Need for AutoTest                              */
             /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
             if( GotChar == GTI_TRUE ){
                 GotChar = GTI_FALSE;
                 SerialTXString("Exiting SAS\r\n");
                 GTISysPtr->state=GTI_COMPLETE_FAIL;
                 break;
             }
#endif
          }while( result==GTI_ACTIVE);

#ifdef GTI_DEBUG
#ifdef GTI_DEMO
          /* Fix LEDs */
          ManageLEDs(GTISysPtr);
#endif
#ifdef GTI_PROD_RADSLX
          WarmStatus = GTI_FALSE;                /* Turn off Warm monitering in background */
#endif
          ConfigSys(GTI_XCVR_INACTIVE);  /* HW/Customer Dependent  routine */
#endif
      }

      return;


}
void
GTICheckHIPCmd(GTI_XCVR_INFO *GTISysPtr)
{
     GTI_WORD GTI_LOCAL_QUAL result;

    /* Execute HIP request during XCVR Active mode */
    /* Only allow status and abort requests        */

                                  /* Is it status request */
    if( HIP_Mail[1]==0x14 ) GTIGetStatus(GTISysPtr);

    else if( HIP_Mail[1]==0x35 ){ /* Which Xcvr */
        HIPXcvrStatus();
    }else if( HIP_Mail[1]==0x11 ){ /* Is it ABORT command  */

      result = GTI_NOT_SUPPORTED;

      /* Param routine is based on product  */
      result = HIPGenericParam(GTISysPtr);

      SerialTXChar( (GTI_BYTE)(result&0x00ff) );
    }
}

/**/
void
GTIWriteFramerHIP(GTI_XCVR_INFO *GTISysPtr)
{

     /*     Write to Framer                */
     /* Length =  4 or 5     =HIP_Mail[0]  */
     /* Op code=  0x13       =HIP_Mail[1]  */
     /* Which Framer         =HIP_Mail[2]  */
     /* Address              =HIP_Mail[3]  */
     /* Datalow              =HIP_Mail[4]  */
     /* Datahigh             =HIP_Mail[5]  */


    /* Framer:                             */
    /*   0    HDSL/ADSL        CSN2        */
    /*   1    E1T1 RamL       GPCSN       */
    /*   2    E1T1 RamH       TP25(LED16) */


#if ( !defined(GTI_DSPMULTI) && !defined(GTI_DSPQUAD) )
#ifdef GTI_DEBUG
   switch(HIP_Mail[2]){
       case 0:   /*HDSL or ADSL FRAMER */
            /* If 2 data bytes are sent then write low to zero  */
            /* and high to address specified                    */
            if(HIP_Mail[0] == 4){ /* HDSL */
               WriteHDSLFramerB(GTISysPtr,HIP_Mail[3],HIP_Mail[4]);
            }else{                /* ADSL */
               WriteADSLFramerW(GTISysPtr,HIP_Mail[3],(HIP_Mail[5]<<8)|HIP_Mail[4]);
            }
            break;
       case 1:   /*E1T1 RAM Low    INTERNAL APPLICATION */
            WriteRAMLE1T1(GTISysPtr,HIP_Mail[3],HIP_Mail[4]);
            break;
       case 2:   /*E1T1 RAM High   INTERNAL APPLICATION */
            WriteRAMHE1T1(GTISysPtr,HIP_Mail[3],HIP_Mail[4]);
            break;
       default:
            break;
   }
#endif
#else
   GTISysPtr=GTISysPtr;        /* To not get warning messages */
#endif

}
/**/
void
GTIReadFramerHIP(GTI_XCVR_INFO *GTISysPtr)
{
     GTI_BYTE GTI_LOCAL_QUAL dat;

#if ( !defined(GTI_DSPMULTI) && !defined(GTI_DSPQUAD) )

     /*     Read to Framer                 */
     /* Length =  3          =HIP_Mail[0]  */
     /* Op code=  0x12       =HIP_Mail[1]  */
     /* Which Framer         =HIP_Mail[2]  */
     /* Address              =HIP_Mail[3]  */


    /* Framer:                             */
    /*   0    HDSL/ADSL        CSN2        */
    /*   1    E1T1 RamL       GPCSN       */
    /*   2    E1T1 RamH       TP25(LED16) */

    dat =0;

#ifdef GTI_DEBUG
   switch(HIP_Mail[2]){
       case 0:   /*HDSL/ADSL FRAMER  */
            dat = ReadFramer(GTISysPtr,HIP_Mail[3]);
            break;
       case 1:   /*E1T1 RAM Low*/
            dat = ReadRAMLE1T1(GTISysPtr,HIP_Mail[3]);
            break;
       case 2:   /*E1T1 RAM High*/
            dat = ReadRAMHE1T1(GTISysPtr,HIP_Mail[3]);
            break;
   }
#endif

   SerialTXChar( 0x00 );
   SerialTXChar( dat );
   SerialTXChar( HIP_Mail[3] );
#else
   GTISysPtr=GTISysPtr;        /* To not get warning messages */
#endif

}

#if ( defined (GTI_PROD_MSDSL ) || defined (GTI_PROD_M2B1Q) || defined (GTI_PROD_IDSL ) )
void
GTISetTimeSlot(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_WORD GTI_LOCAL_QUAL empty;

      /*     Call Param/Execute             */
      /* Length =  8          =HIP_Mail[0]  */
      /* Op code=  0x36       =HIP_Mail[1]  */
      /* # of used slots      =HIP_Mail[2]  */
      /* Start Slot           =HIP_Mail[3]  */
      /* Idle Code            =HIP_Mail[4]  */
      /* # of interface slots =HIP_Mail[5]  */
      /* padding method       =HIP_Mail[6]  */
      /* TXcontrol            =HIP_Mail[7]  */
      /* RXcontrol            =HIP_Mail[8]  */

#ifndef GTI_PROD_IDSL
      SetParamFramer( GTISysPtr,GTI_NUM_TIMESLOTS_SELECTED,(GTI_WORD)HIP_Mail[2]);
      SetParamFramer( GTISysPtr,GTI_IDLE_TIMESLOT_CODE,(GTI_WORD)HIP_Mail[3]);
      SetParamFramer( GTISysPtr,GTI_START_TIMESLOT,(GTI_WORD)HIP_Mail[4]);
      SetParamFramer( GTISysPtr,GTI_NUM_TIMESLOTS_INTERFACE,(GTI_WORD)HIP_Mail[5]);
      SetParamFramer( GTISysPtr,GTI_PADDING_METHOD,(GTI_WORD)HIP_Mail[6]);
      SetParamFramer( GTISysPtr,GTI_TX_CONTROL_REG,(GTI_WORD)HIP_Mail[7]);
      SetParamFramer( GTISysPtr,GTI_RX_CONTROL_REG,(GTI_WORD)HIP_Mail[8]);
#else

      /*SetParamFramer( GTISysPtr,GTI_NUM_TIMESLOTS_SELECTED,(GTI_WORD)HIP_Mail[2]);*/
      SetParamFramer( GTISysPtr,GTI_MAP_64K,(GTI_WORD)HIP_Mail[2]);
      /*SetParamFramer( GTISysPtr,GTI_IDLE_TIMESLOT_CODE,(GTI_WORD)HIP_Mail[4]);*/
      SetParamFramer( GTISysPtr,GTI_DEMAP_64K,(GTI_WORD)HIP_Mail[3]);
      /*SetParamFramer( GTISysPtr,GTI_START_TIMESLOT,(GTI_WORD)HIP_Mail[3]);*/
      SetParamFramer( GTISysPtr,GTI_PAD_SYMBOL,(GTI_WORD)HIP_Mail[4]);
      /*SetParamFramer( GTISysPtr,GTI_NUM_TIMESLOTS_INTERFACE,(GTI_WORD)HIP_Mail[5]);*/
      SetParamFramer( GTISysPtr,GTI_FORCE_CORRUPT_CRC,(GTI_WORD)HIP_Mail[5]);
      SetParamFramer( GTISysPtr,GTI_PADDING_METHOD,(GTI_WORD)HIP_Mail[6]);
      SetParamFramer( GTISysPtr,GTI_TX_CONTROL_REG,(GTI_WORD)HIP_Mail[7]);
      SetParamFramer( GTISysPtr,GTI_RX_CONTROL_REG,(GTI_WORD)HIP_Mail[8]);
#endif

}

void
GTISetFrmClamp(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_WORD GTI_LOCAL_QUAL tmp;
      /*GTI_BYTE tmp_buffer[40];*/

      /*     Call Param/Execute             */
      /* Length =  2          =HIP_Mail[0]  */
      /* Op code=  0x41       =HIP_Mail[1]  */
      /* Clamping             =HIP_Mail[2]  */

      if( HIP_Mail[2] == 1 ) tmp = GTI_RX_CLK_CLAMP;
      else  tmp = GTI_RX_CLK_UNCLAMP;


      SetParamFramer( GTISysPtr,GTI_RX_INTERFACE,tmp);


      /*I2Hex(HIP_Mail[3],1,2,tmp_buffer);
      SerialTXStr("RXClock= ");
      SerialTXStr((char *)&tmp_buffer[0]);*/

}
#endif /*MSDSL M2B1Q*/

#if ( defined (GTI_PROD_MSDSL ) || defined (GTI_PROD_M2B1Q) || defined (GTI_PROD_HDSL2)  )
void
GTISetFrmParam(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_WORD itmp;
      /*GTI_BYTE tmp_buffer[40];*/

      /*     Call Param/Execute             */
      /* Length =  9          =HIP_Mail[0]  */
      /* Op code=  0x40       =HIP_Mail[1]  */
      /* TXClock              =HIP_Mail[2]  */
      /* RXClock              =HIP_Mail[3]  */
      /* RXPll                =HIP_Mail[4]  */
      /* framePulse           =HIP_Mail[5]  */
      /* AIS                  =HIP_Mail[6]  */
      /* Ind Bits             =HIP_Mail[7]  */
      /* TX Window            =HIP_Mail[8]  */
      /* RX Window            =HIP_Mail[9]  */
      /* UTOPIA TX Address    =HIP_Mail[a]  */
      /* UTOPIA RX Address    =HIP_Mail[b]  */


      SetParamFramer( GTISysPtr,GTI_TX_CLOCK,(GTI_WORD)HIP_Mail[2]);
      SetParamFramer( GTISysPtr,GTI_RX_CLOCK,(GTI_WORD)HIP_Mail[3]);
      SetParamFramer( GTISysPtr,GTI_RX_PLL_MODE,(GTI_WORD)HIP_Mail[4]);
      SetParamFramer( GTISysPtr,GTI_FRAME_PULSE_MODE,(GTI_WORD)(HIP_Mail[5]<<12));

      switch(HIP_Mail[6]){
           case 0:
             itmp=GTI_AIS_DISABLE_LINE_CUSTOMER;
             break;
           case 1:
             itmp=GTI_AIS_ENABLE_LINE_DISABLE_CUSTOMER;
             break;
           case 2:
             itmp=GTI_AIS_ENABLE_CUSTOMER_DISABLE_LINE;
             break;
           case 3:
             itmp=GTI_AIS_ENABLE_LINE_CUSTOMER;
             break;
           default:
             itmp=GTI_AIS_DISABLE_LINE_CUSTOMER;
             break;
      }


      SetParamFramer( GTISysPtr,GTI_AIS_MODE,itmp);
      SetParamFramer( GTISysPtr,GTI_INDICATOR_BITS,(GTI_WORD)(HIP_Mail[7]));
      SetParamFramer( GTISysPtr,GTI_TX_CLOCK_WINDOW,(GTI_WORD)(HIP_Mail[8]));
      SetParamFramer( GTISysPtr,GTI_RX_CLOCK_WINDOW,(GTI_WORD)(HIP_Mail[9]));
      SetParamFramer( GTISysPtr, GTI_UTOPIA_L2_RXTX_ADDRESS, (GTI_WORD)( HIP_Mail[0x0a]|(HIP_Mail[0x0b]<<8)) );

      /*I2Hex(HIP_Mail[6],1,2,tmp_buffer);
      SerialTXStr("AISlow= ");
      SerialTXStr((char *)&tmp_buffer[0]);*/

}
void
GTISetGenericFramerParam(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_WORD GTI_LOCAL_QUAL empty;
      /*GTI_BYTE tmp_buffer[40];*/

      /*     Call Param/Execute             */
      /* Length =  5          =HIP_Mail[0]  */
      /* Op code=  0x43       =HIP_Mail[1]  */
      /* Type of PAram        =HIP_Mail[2]  */
      /* Type of PAram        =HIP_Mail[3]  */
      /* Value of Param       =HIP_Mail[4]  */
      /* Value of Param       =HIP_Mail[5]  */

      SetParamFramer( GTISysPtr,(GTI_WORD)(HIP_Mail[2]|(HIP_Mail[3]<<8)),(GTI_WORD)(HIP_Mail[4]|(HIP_Mail[5]<<8)) );
}

void
GTISetInsertError(GTI_XCVR_INFO *GTISysPtr)
{
      /*GTI_BYTE tmp_buffer[40];*/

      /*     Call Param/Execute             */
      /* Length =  2          =HIP_Mail[0]  */
      /* Op code=  0x42       =HIP_Mail[1]  */
      /* state                =HIP_Mail[2]  */


      SetParamFramer( GTISysPtr,GTI_ERROR_INSERT_MODE,(GTI_WORD)HIP_Mail[2]);

      /*I2Hex(HIP_Mail[2],1,2,tmp_buffer);
      SerialTXStr("Error= ");
      SerialTXStr((char *)&tmp_buffer[0]);*/

}

#endif /*MSDSL M2B1Q HDSL2*/


/**/
void
GTICodeRead(GTI_XCVR_INFO *GTISysPtr)
{
      GTI_DWORD GTI_LOCAL_QUAL offset;

      /*     Call Param/Execute             */
      /* Length =  4or5       =HIP_Mail[0]  */
      /* Op code=  0x23       =HIP_Mail[1]  */
      /* Code Type            =HIP_Mail[2]  */
      /* Offset Low           =HIP_Mail[3]  */
      /* Offset High          =HIP_Mail[4]  */
      /* table                =HIP_Mail[5]  */


      /* Code type can be IPU,AVM,BE,TR,COEF*/

      if(HIP_Mail[0]==4){
            HIP_Mail[5]=0x0a; /* default table = a */
      }

      switch(HIP_Mail[5]){
                       case 0x0a:
                       case 0x0b:
                       case 0x0c:
                       case 0x0d:
                       case 0x0e:
                       case 0x0f:
                               HIP_Mail[5] -= 0x0a;
                               break;
                       default:
                               HIP_Mail[5]=0x0; /* default table = a */
                               break;
      }

                     /* Set pointers to correct page */
#ifdef GTI_MULTI_PROJ
#ifdef GTI_DEBUG
                     if( UsingRAM == GTI_TRUE ){
                             ReadRAMPointers(HIP_Mail[5]);
                     }
                     else InitPointers(GTISysPtr,HIP_Mail[5]);
#else
                     InitPointers(GTISysPtr,HIP_Mail[5]);
#endif
#endif

     offset = ((GTI_WORD)HIP_Mail[4]<<8)|HIP_Mail[3];
     offset = offset << 1; /* Convert to byte count */


      /* Can Always do Read                 */
      switch(HIP_Mail[2]){

             case GTI_CODE_IPU: /* Size is in words and IPU a word = 2 bytes */


                     /*result = *(GTISysPtr->PntIPU+offset);  low byte */
                     /*result |= (GTI_WORD)(*(GTISysPtr->PntIPU+offset+1))<<8; */

                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntIPU,offset,0));   /* low */
                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntIPU,offset,1)); /* high */

                     break;

             case GTI_CODE_AVM:

                     /*result = *(GTISysPtr->PntIPU+offset);  low byte */
                     /*result |= (GTI_WORD)(*(GTISysPtr->PntAVM+offset+1))<<8; */

                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntAVM,offset,0));   /* low */
                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntAVM,offset,1));   /* high */

                     break;

             case GTI_CODE_BE:

                     /*result = *(GTISysPtr->PntBE+offset);  low byte */
                     /*result |= (GTI_WORD)(*(GTISysPtr->PntBE+offset+1))<<8; */

                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntBE,offset,0));   /* low */
                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntBE,offset,1));   /* high */

                     break;

             case GTI_CODE_TR:

                     /*result = *(GTISysPtr->PntTR+offset);  low byte */
                     /*result |= (GTI_WORD)(*(GTISysPtr->PntTR+offset+1))<<8; */

                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntTR,offset,0));   /* low */
                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntTR,offset,1));   /* high */

                     break;

             case GTI_CODE_COEF:
                     break;

             case GTI_CODE_PCU:

                     /*result = *(GTISysPtr->PntPCU+offset);  low byte */
                     /*result |= (GTI_WORD)(*(GTISysPtr->PntIPU+offset+1))<<8; */

                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntPCU,offset,0));   /* low */
                     SerialTXChar(m_byteFromPTRs(GTISysPtr->PntPCU,offset,1)); /* high */

                     break;
         }
}

/*L*/
/* Name: SerialTXStr*/
/* Function: TX characters over serial interface*/
/* Input:   NULL Terminated String */
/* Return: None */
void
SerialTXStr(char GTI_ADDRESS_QUAL * msg)
{
    while( *msg )
    {
        if(*msg == '\n') 
            SerialTXChar('\r');
        SerialTXChar(*msg++);
    }
}

/*^L*/
void
HIPXcvrStatus(void )
{

#ifdef GTI_DEBUG
   SerialTXChar(SystemXCVR);
#else
   SerialTXChar(0x00);
#endif

}


/**/
#ifdef GTI_TRACE
void
GTISASHistory(void)
{
      GTI_WORD i;
      GTI_BYTE tmp_buffer[40];

     /*     Dump SAS History               */
     /* Length =  1          =HIP_Mail[0]  */
     /* Op code=  0x15       =HIP_Mail[1]  */

      SerialTXStr("History    Line#:Next\n");
      for( i=0;i<HistPnt;i++){
         I2Hex(History[0][i],3,4,tmp_buffer);
         SerialTXStr("         ");
         SerialTXStr((char *)&tmp_buffer[0]);
         SerialTXStr(":");
         I2Hex(History[2][i],3,4,tmp_buffer);
         SerialTXStr((char *)&tmp_buffer[0]);
         SerialTXStr(":");
         I2Hex(History[1][i],3,4,tmp_buffer);
         SerialTXStr((char *)&tmp_buffer[0]);
         if( (History[1][i]==GTI_CONTEX_A) ||
             (History[1][i]==GTI_CONTEX_B) ||
             (History[2][i]==GTI_CONTEX_CMD) ) {
              SerialTXStr(" !!CONTEX Next=YAT+:table:start!!");
         }
         SerialTXStr("\r\n");
      }

}
/* Name: I2Hex                                              */
/* Function: Convert INT to HEX Ascii representation        */
/* Input:   Interger, Array Offset,Length,buffer            */
/* Return:                                                  */
void
I2Hex(GTI_WORD inum,
      GTI_BYTE offset,GTI_BYTE length,GTI_BYTE tmp_buffer[])
{
        GTI_BYTE i;
        GTI_BYTE counter;

        counter=offset;

        tmp_buffer[length]=0x00; /* NULL Terminate */
        /* Generate HEX digits in reverse order*/
        do{
              i=(GTI_BYTE)inum%16;
              if(i>9){
                    i+=0x37;
              }else{
                    i+='0';
              }
              tmp_buffer[counter]=i;
              --counter;--length;
              if( counter == 0xff ) return;
              if( length == 0) return;
        }while( (inum/=16) >0 );

        for(;length != 0; --length,--counter)
        {
              tmp_buffer[counter]=0x30;
        }

}
void
GTISASStop(void)
{

     /*                                    */
     /* Length =  4          =HIP_Mail[0]  */
     /* Op code=  0x34       =HIP_Mail[1]  */
     /* low byte             =HIP_Mail[2]  */
     /* high byte            =HIP_Mail[3]  */
     /* baud                 =HIP_Mail[4]  */

     SASStop_line = (HIP_Mail[3]<<8)|HIP_Mail[2];
     SASStop_enable = GTI_TRUE;

#ifdef GTI_MULTI_PROJ
     SASStop_hip = HIP_Mail[4]-0x0a;
#endif


     return;
}
#endif /*TRACE */
/**/
void
GTIStarInterrupt(GTI_XCVR_INFO *GTISysPtr)
{

      /* Length =  3          =HIP_Mail[0]  */
      /* Op code=  0x28       =HIP_Mail[1]  */
      /* state                =HIP_Mail[2]  */
      /* type                 =HIP_Mail[3]  */

      if( HIP_Mail[0] == 2 ) /* Old HIP code */
            HIP_Mail[3] = 0xff;  /* ALL interrupts enable/disable */

      /* Are we Clearing Interrupts */
      if( HIP_Mail[2] == 0x02 ){

          /* Type = Core = 1 */
          if( (HIP_Mail[3]&0x02) != 0 )     
               ClearSTARInterrupt(GTISysPtr,GTI_DSP_ALL);

          /* Type = Framer = 1 */
          if( (HIP_Mail[3]&0x04) != 0 )
               ClearFRAMERInterrupt(GTISysPtr,GTI_FRAMER_INT_CLR);

          return;
      }



      /* Type = Core = 1 */
      if( (HIP_Mail[3]&0x02) != 0 )
           InitSTARInterrupt(GTISysPtr,HIP_Mail[2]);

#if (defined(GTI_DSPFRAMER) || defined (GTI_DSPFRAMER_B1) )
      /* Type = Framer = 1 */
      if( (HIP_Mail[3]&0x04) != 0 ){

          if( HIP_Mail[2] == GTI_TRUE ){

#ifdef GTI_PROD_H2B1Q
               InitFRAMERInterrupt(GTISysPtr,GTI_RXCHB_RXCHA_TXCHB_TXCHA_INT);
#endif
#ifdef GTI_PROD_HDSL2
               InitFRAMERInterrupt(GTISysPtr,GTI_FRM_ENABLE_INT);
#endif
#ifdef GTI_PROD_MSDSL
               /* Only turn on Rx interrupts */
               /* When sending EOC Tx will be turn on automatically */
               InitFRAMERInterrupt(GTISysPtr,GTI_RX_1_INT);
#endif

#ifdef GTI_PROD_HDSL4W
               /* Only turn on Rx interrupts */
               /* When sending EOC Tx will be turn on automatically */
               ClearFRAMERInterrupt(GTISysPtr,GTI_FRAMER_INT_CLR);
               InitFRAMERInterrupt(GTISysPtr,GTI_RXCHA_INT);
#endif

          }else{

#ifdef GTI_PROD_H2B1Q
               InitFRAMERInterrupt(GTISysPtr,GTI_FRM_DISABLE_INT);
#endif
#ifdef GTI_PROD_HDSL2
               InitFRAMERInterrupt(GTISysPtr,GTI_FRM_DISABLE_INT);
#endif
#ifdef GTI_PROD_MSDSL
               /* Disable All interrupts */
               InitFRAMERInterrupt(GTISysPtr,GTI_FRM_DISABLE_INT);
#endif
#ifdef GTI_PROD_HDSL4W
               /* Disable All interrupts */
               InitFRAMERInterrupt(GTISysPtr,GTI_FRM_DISABLE_INT);
#endif
          }

     }

#endif


      ClearSTARInterrupt(GTISysPtr,GTI_DSP_ALL);

#ifdef GTI_DEBUG
      /* Type = 188 = 1 */
      if( (HIP_Mail[3]&0x01) != 0 ){
         /* 188 Interrupts Enable/Disable */
         if( HIP_Mail[2] == GTI_TRUE ){
                InitInt0();
                InitInt1();
                SerialTXStr("\r\nEnable Int0  and Int 1 188 Interrupts\r\n");
         }else{
                DisableInt0();
                DisableInt1();
                SerialTXStr("\r\nDisable Int0  and Int 1 188 Interrupts\r\n");
         }
      }
#endif /* Debug- Internal */





}
/**/
void
GTISwitchXCVR( void )
{

      /*     Command from HIP to switch XCVR System      */
      /* Length =  2          =HIP_Mail[0]  */
      /* Op code=  0x29       =HIP_Mail[1]  */
      /* Segment = New XCVR   =HIP_Mail[2]  */

      /* The HIP command is XCVR #                  */
      /* Where the number is hex-decimal 0->ff      */

      SwitchXCVR(HIP_Mail[2]);

      return;
}

/**/
void
GTISyncFramer( GTI_XCVR_INFO *GTISysPtr )
{

      /* Length =  1          =HIP_Mail[0]  */
      /* Op code=  0x2a       =HIP_Mail[1]  */
#ifdef GTI_PROD_HDSL2

      SetParamFramer( GTISysPtr, GTI_FRAMER_RESYNC, GTI_TXRX_RESYNC);

#endif

}


#ifndef GTI_PROD_DMT       /* Not Supported in DMT product */
/**/
void
GTIRxTxInterface(GTI_XCVR_INFO *GTISysPtr)
{
    /*     Send ID to PC                  */
    /* Length =  4/5        =HIP_Mail[0]  */
    /* Op code=  0x30       =HIP_Mail[1]  */
    /* Tx_clk               =HIP_Mail[2]  */
    /* Rx_clk               =HIP_Mail[3]  */
    /* rx_data              =HIP_Mail[4]  */
    /* Channel              =HIP_Mail[5]  */

#if ( defined (GTI_PROD_HDSL4W) || defined (GTI_PROD_H2B1Q) )
    ParamInterface(GTISysPtr,HIP_Mail[5], HIP_Mail[2],HIP_Mail[3],HIP_Mail[4]);
#else
    ParamInterface(GTISysPtr,HIP_Mail[2],HIP_Mail[3],HIP_Mail[4]);
#endif

}
#endif

#if ( defined (GTI_PROD_H2B1Q ) || defined (GTI_PROD_HDSL2) || defined (GTI_PROD_HDSL4W) )
void
GTIEOCData(GTI_XCVR_INFO *GTISysPtr)
{


    /*     Send ID to PC                  */
    /* Length =  5          =HIP_Mail[0]  */
    /* Op code=  0x37       =HIP_Mail[1]  */
    /* Channel              =HIP_Mail[2]  */
    /* EOCByte                 =HIP_Mail[3]  */
    /* EOCNibble               =HIP_Mail[4]  */
    /* EOCBit                  =HIP_Mail[5]  */
    /*  OHByte                 =HIP_Mail[6]  */
    /*  OHNibble               =HIP_Mail[7]  */
    /*  OHBit                  =HIP_Mail[8]  */

#if(defined (GTI_PROD_H2B1Q) || defined(GTI_PROD_HDSL4W) )

   struct EOC_OH_BUFFER Ptr;

   Ptr.EOCByte = HIP_Mail[3];
   Ptr.EOCNibble = HIP_Mail[4];
   Ptr.EOCBit = HIP_Mail[5];
   Ptr.OHByte = HIP_Mail[6];
   Ptr.OHNibble = HIP_Mail[7];
   Ptr.OHBit = HIP_Mail[8];

   EOC_OH2Xcvr(GTISysPtr,HIP_Mail[2],&Ptr);
#else
   EOC_BUFFER Ptr;

   Ptr.EOCByte1 = HIP_Mail[2];
   Ptr.EOCByte2 = HIP_Mail[3];
   Ptr.EOCByte3 = HIP_Mail[4];
   EOC2Xcvr(GTISysPtr,&Ptr);
#endif

}
#endif

#if ( defined (GTI_PROD_MSDSL) )
void
GTIEOCData(GTI_XCVR_INFO *GTISysPtr)
{

     struct EOC_BUFFER Ptr;

    /*     Send ID to PC                  */
    /* Length =  5          =HIP_Mail[0]  */
    /* Op code=  0x37       =HIP_Mail[1]  */
    /* Channel              =HIP_Mail[2]  */
    /* EOCNibble0           =HIP_Mail[3]  */
    /* EOCNibble1           =HIP_Mail[4]  */
    /* EOCNibble2           =HIP_Mail[5]  */
    /* EOCNibble3           =HIP_Mail[6]  */
    /* EOCNibble4           =HIP_Mail[7]  */
    /* EOCNibble5           =HIP_Mail[8]  */

   Ptr.EOCNibble0 = HIP_Mail[3];
   Ptr.EOCNibble1 = HIP_Mail[4];
   Ptr.EOCNibble2 = HIP_Mail[5];
   Ptr.EOCNibble3 = HIP_Mail[6];
   Ptr.EOCNibble4 = HIP_Mail[7];
   Ptr.EOCNibble5 = HIP_Mail[8];

   EOC_OH2Xcvr(GTISysPtr, &Ptr);

}
#endif


#ifdef GTI_PROD_M2B1Q
void
GTIF3Cell(GTI_XCVR_INFO *GTISysPtr)
{

     GTI_BYTE tmp[48];
     GTI_WORD result;
     GTI_WORD sum;
     GTI_BYTE i;
     GTI_BYTE tmp_buffer[40];

    /* Length =  2          =HIP_Mail[0]  */
    /* Op code=  0x38       =HIP_Mail[1]  */
    /* rx or tx             =HIP_Mail[2]  */

    if( HIP_Mail[2] == 1 )/* Tx */
    {
        TxF3Cell(GTISysPtr);
        SerialTXStr("\nSending F3 Cell");
    }else{
        result = IsUtopiaReady(GTISysPtr);
        if( result == GTI_ACTIVE) SerialTXStr("\nUtopia is ACTIVE");
        else{
                ReqRxF3Cell(GTISysPtr);
                result= RxF3Cell(GTISysPtr,&tmp[0]);
                if( result == GTI_FAIL )SerialTXStr("\nRx Buffer empty");
                else{
                        sum=0;
                        for(i=0;i<=47;i=i+2){
                             I2Hex(tmp[i+1],1,2,tmp_buffer);
                             SerialTXStr("\n0x");
                             SerialTXStr((char *)&tmp_buffer[0]);

                             I2Hex(tmp[i],1,2,tmp_buffer);
                             SerialTXStr((char *)&tmp_buffer[0]);

                             sum += (GTI_WORD)((tmp[i+1]<<8)+tmp[i]);
                        }
                        SerialTXStr("\n           CheckSum = 0x");
                        I2Hex(sum,3,4,tmp_buffer);
                        SerialTXStr((char *)&tmp_buffer[0]);
                }
        }
    }


}

#endif

#if ( defined (GTI_PROD_IDSL ) || defined (GTI_PROD_MSDSL))
void
GTISetPin(GTI_XCVR_INFO *GTISysPtr)
{

     GTI_BYTE tmp[48];
     GTI_WORD result;
     GTI_WORD sum;
     GTI_BYTE i;
     GTI_BYTE tmp_buffer[40];

    /* Length =  3          =HIP_Mail[0]  */
    /* Op code=  0x39       =HIP_Mail[1]  */
    /* pin                  =HIP_Mail[2]  */
    /* state                =HIP_Mail[3]  */

   SerialTXChar( (GTI_BYTE)(SetPinMode(GTISysPtr,(GTI_WORD)HIP_Mail[2],(GTI_WORD)HIP_Mail[3])) );
}


#endif /*IDSL*/

/*^L*/
void
GTIInfoInt(void)
{
    /* Op code=  0x26       =HIP_Mail[1]  */
    /* 0-    Send ID to PC                */
    /* type                 =HIP_Mail[2]  */
    /* Length =  2          =HIP_Mail[0]  */

#ifdef GTI_DEBUG
    if( HIP_Mail[2] == 0x00 ){
            SerialTXStr(GTI_PRODUCT);
    }
    if( UsingRAM == GTI_TRUE ){
       if( HIP_Mail[2] == 0x01 )
            SerialTXChar( UsingRAM );
       else if( HIP_Mail[2] == 0x02 ){
            fSerialTXStr(PntUTime);
       }
       else if( HIP_Mail[2] == 0x03 ){
            fSerialTXStr(PntDTime);
       }
       else if( HIP_Mail[2] == 0x04 ){
            fSerialTXStr(PntType);
       }
       else if( HIP_Mail[2] == 0x05 ){
            fSerialTXStr(PntCode);
       }
       else if( HIP_Mail[2] == 0x06 ){
            fSerialTXStr(PntVerHIP);
       }
       else if( HIP_Mail[2] == 0x07 ){
            fSerialTXStr(PntXcvr);
       }
       else if( HIP_Mail[2] == 0x08 ){
            fSerialTXStr(PntOwner);
       }
    }else{
       if( HIP_Mail[2] == 0x01 )
            SerialTXChar( UsingRAM );
       else if( HIP_Mail[2] == 0x02 ){
            SerialTXStr((GTI_BYTE far *)&UTime_tbl[0]);
       }
       else if( HIP_Mail[2] == 0x03 ){
            SerialTXStr((GTI_BYTE far *)&DTime_tbl[0]);
       }
       else if( HIP_Mail[2] == 0x04 ){
            SerialTXStr((GTI_BYTE far *)&Type_tbl[0]);
       }
       else if( HIP_Mail[2] == 0x05 ){
            SerialTXStr((GTI_BYTE far *)&Code_tbl[0]);
       }
       else if( HIP_Mail[2] == 0x06 ){
            SerialTXStr((GTI_BYTE far *)&VerHip_tbl[0]);
       }
       else if( HIP_Mail[2] == 0x07 ){
            SerialTXStr((GTI_BYTE far *)&Xcvr_tbl[0]);
       }
       else if( HIP_Mail[2] == 0x08 ){
            SerialTXStr((GTI_BYTE far *)&Owner_tbl[0]);
       }
    }

#endif

}
#endif  /* not WHIP */

