/*
* @(#)gtiparam.c	1.210.2.7
*/

/***********************************************************************/
/* DMT Application Code-(C) Copyright 1998-2003 by GTI                 */
/* This File contains code going to GTI          customers             */
/***********************************************************************/

#include "gti.h"
#include "gtiextn.h"
#include "gti_reg.h"

#ifdef GTI_DEBUG
#include "p3hw.h"
#include "global.h"
#include "extern.h"
#endif

#if (defined(GTI_DSPVIKING) && defined(GTI_HOSTVSC))
#include "dsl_typedef.h"
extern SDSLConfigParams	DSLConfigParams[];
#endif


#ifdef GTI_PROD_DMT
extern void GTIEocInit(GTIEOC_INFO *eInfoPtr);
#endif

/* Local Functions */
static GTI_WORD  LocalStateMachine(GTI_XCVR_INFO *pSysInfo);
static GTI_WORD  CalcTestResult(GTI_XCVR_INFO *pSysInfo, GTI_WORD wTestMode, GTI_DWORD wThrshld,
                                GTI_WORD *pBins, GTI_DWORD *pRefMin, GTI_DWORD *pRefMax,
                                GTI_WORD wBinLength, GTI_BYTE *pResults );
static GTI_DWORD CalcTotPwr(GTI_DWORD *pSpectrum, GTI_WORD wStartBin, GTI_WORD wEndBin);
static GTI_WORD  CalcNotchSNR(GTI_DWORD *pSpectrum, GTI_WORD wNotchBin);
static GTI_WORD  GetDecibel(GTI_DWORD value);
static void      AbortDspCmd(GTI_XCVR_INFO *pSysInfo);

/***********************************************************************/
/*  Name: Gti_GetParamXCVR                                             */
/*  Input:                                                             */
/*         pointer to an EXECUTE_CMD structure - XCVR system selected  */
/*         pointer to PARAMXCVR_ARRAY structure - list of paramaters   */
/*  Output:                                                            */
/*         Customer parameters listed in gtiparam.h                    */
/*                                                                     */
/***********************************************************************/

GTI_WORD
Gti_GetParamXCVR(GTI_XCVR_INFO *pXcvrInfo,
                 struct PARAM_XCVR_ARRAY *ParamTbl)
{

#define _GET_ITEM(p,n) ((ParamTbl->item[(p)])= lclParam[(n)])

#define _GET_DCMP(p,n) ((ParamTbl->item[(p)])= (GTI_WORD) \
    (lclParam[(n)]) << 0x08)

#define _GET_WORD(p,n) ((ParamTbl->item[(p)])= MAKEWORD(lclParam[(n)], \
    lclParam[(n + 1)]))

#define _GET_EXT(p,n) ((ParamTbl->item[(p)]) = MAKEWORD((lclParam[(n)]>>4 | \
    lclParam[(n+1)] << 4), (lclParam[(n+1)] >> 4 | lclParam[(n+2)] << 4)))


    GTI_BYTE lclParam[GTI_HOST_CONF_END - GTI_HOST_CONF_START + 2];

    GET_HOST_DB_BLOCK(pXcvrInfo, GTI_HOST_CONF_START,
        (GTI_WORD)(sizeof(lclParam)), lclParam);


    _GET_ITEM(GTI_ACTION_ITEM, GTI_ACTION);
    _GET_ITEM(GTI_MODE_ITEM, GTI_MODE);

    _GET_ITEM(GTI_INITIATE_ITEM, GTI_INITIATE);
    _GET_ITEM(GTI_DATA_INTERFACE_TYPE_ITEM, GTI_HW_FRAMING_MODE);

    _GET_DCMP(GTI_TRELLIS_ITEM, GTI_TRELLIS + 1);
    _GET_ITEM(GTI_EC_FDM_ITEM, GTI_EC_OR_FDM);

    _GET_ITEM(GTI_STANDARD_ITEM, GTI_STANDARD);
    _GET_ITEM(GTI_MAX_BITS_PER_BIN_ITEM, GTI_MAX_BITS_PER_BIN);

    _GET_WORD(GTI_TX_START_BIN_ITEM, GTI_TX_START_BIN);
    _GET_WORD(GTI_TX_END_BIN_ITEM, GTI_TX_END_BIN);

    _GET_ITEM(GTI_LINE_DR_STBY_ITEM, GTI_LINE_DR_STBY);

    _GET_EXT(GTI_RX_START_BIN_ITEM, GTI_RX_START_BIN);
    _GET_EXT(GTI_RX_END_BIN_ITEM, GTI_RX_END_BIN);

    _GET_ITEM(GTI_RX_BIN_ADJUST_ITEM, GTI_RX_BIN_ADJUST);

    _GET_ITEM(GTI_TX_POWER_ATTENUATION_ITEM, GTI_TX_POWER_ATTENUATION);
    _GET_ITEM(GTI_NTR_ITEM, GTI_NTR);

    _GET_WORD(GTI_PMODE_ITEM, GTI_PMODE);


    ParamTbl->item[GTI_CODING_GAIN_ITEM] =
        ((GTI_WORD)(lclParam[GTI_CODING_GAIN]) >> 6) |
        ((GTI_WORD)(lclParam[GTI_CODING_GAIN+1]) << 2) |
        ((GTI_WORD)(lclParam[GTI_CODING_GAIN+2]&0x3f) << 0x0a);

    _GET_WORD(GTI_TONE_ORDERING_ITEM, GTI_TONE_ORDERING);

    _GET_ITEM(GTI_FRAMING_STRUCTURE_ITEM, GTI_FRAMING_STRUCTURE);

    ParamTbl->item[GTI_UTOPIA_L2_TX_ADDR_ITEM] =
        ((GTI_WORD)(lclParam[GTI_UTOPIA_L2_ADDR] & 0x0f) << 1 );

    ParamTbl->item[GTI_UTOPIA_L2_RX_ADDR_ITEM] =
        ((GTI_WORD)(lclParam[GTI_UTOPIA_L2_ADDR] & 0xf0) >> 3 );

    _GET_ITEM(GTI_CLOCK_TYPE_ITEM, GTI_CLOCK_TYPE);

    _GET_WORD(GTI_VENDOR_ID_ITEM, GTI_VENDOR_ID);
    _GET_ITEM(GTI_VENDOR_REV_SHORT_ITEM, GTI_VENDOR_REV_SHORT);

    _GET_WORD(GTI_EXPANDED_EXCHANGE_ITEM, GTI_SEL_EXCHANGE_TYPE);

    _GET_WORD(GTI_ESCAPE_FAST_RETRAIN_ITEM, GTI_ESCAPE_FAST_RETRAIN);
    _GET_WORD(GTI_FAST_RETRAIN_ENABLE_ITEM, GTI_FAST_RETRAIN_ENABLE);
    _GET_WORD(GTI_TRIGGER_MODE_ITEM, GTI_TRIGGER_MODE);
    _GET_WORD(GTI_ERASE_PROFILES_ITEM, GTI_ERASE_PROFILES_FLAG);

    _GET_DCMP(GTI_BIT_SWAP_ITEM, GTI_BIT_SWAP + 1);
    _GET_DCMP(GTI_US_BIT_SWAP_ITEM, GTI_BIT_SWAP);

    _GET_WORD(GTI_FULL_RETRAIN_ENABLE_ITEM, GTI_FULL_RETRAIN_ENABLE);

    if(ParamTbl->item[GTI_MODE_ITEM] == GTI_ATU_R)
    {
        _GET_WORD(GTI_PILOT_TONE_REQUEST_ITEM, GTI_PILOT_TONE_REQUEST);
        _GET_WORD(GTI_MAX_DOWN_RATE_ITEM, GTI_MAX_DOWN_RATE);
        _GET_WORD(GTI_DUAL_LATENCY_ITEM, GTI_DUAL_LATENCY);
        _GET_WORD(GTI_HW_REV_ITEM, GTI_HW_REV);
        _GET_WORD(GTI_CUTBACK_ITEM, GTI_CUTBACK);
        _GET_WORD(GTI_ANNEX_CH_OFFSET_TTR_R_ITEM, GTI_ANNEX_CH_OFFSET_TTR_R);
    }

    if(ParamTbl->item[GTI_MODE_ITEM] == GTI_ATU_C)
    {
        _GET_ITEM(GTI_MARGIN_UP_ITEM, GTI_MARGIN_UP);
        _GET_ITEM(GTI_MARGIN_DOWN_ITEM, GTI_MARGIN_DWN);

        _GET_WORD(GTI_BIT_RATE_MODE_ITEM, GTI_BIT_RATE);
        _GET_WORD(GTI_REMOTE_DATA_INTERFACE_ITEM, GTI_REMOTE_DATA_INTERFACE);

        /*
         * The second byte in the action word actually has the latency selected for each
         * subcarrier.  Starting at bit 0:  AS0 AS1 LS0 LS1
         * 1 = FAST, 0 = interleaved
         *
         */
        if(lclParam[GTI_ACTION+1] & 0x01)
        {
            _GET_ITEM(GTI_SPD1_AS0_BYTES_ITEM, GTI_RATE_BF_1_0);
            _GET_ITEM(GTI_SPD2_AS0_BYTES_ITEM, GTI_RATE_BF_2_0);
            _GET_ITEM(GTI_SPD3_AS0_BYTES_ITEM, GTI_RATE_BF_3_0);
            _GET_ITEM(GTI_SPD4_AS0_BYTES_ITEM, GTI_RATE_BF_4_0);
            ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] = GTI_FAST_BUFFER;
        }
        else
        {
            _GET_ITEM(GTI_SPD1_AS0_BYTES_ITEM, GTI_RATE_BI_1_0);
            _GET_ITEM(GTI_SPD2_AS0_BYTES_ITEM, GTI_RATE_BI_2_0);
            _GET_ITEM(GTI_SPD3_AS0_BYTES_ITEM, GTI_RATE_BI_3_0);
            _GET_ITEM(GTI_SPD4_AS0_BYTES_ITEM, GTI_RATE_BI_4_0);
            ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] = GTI_INTERLEAVE_BUFFER;
        }

        if(lclParam[GTI_ACTION+1] & 0x02)
        {
            _GET_ITEM(GTI_SPD1_AS1_BYTES_ITEM, GTI_RATE_BF_1_0+1);
            _GET_ITEM(GTI_SPD2_AS1_BYTES_ITEM, GTI_RATE_BF_2_0+1);
            _GET_ITEM(GTI_SPD3_AS1_BYTES_ITEM, GTI_RATE_BF_3_0+1);
            _GET_ITEM(GTI_SPD4_AS1_BYTES_ITEM, GTI_RATE_BF_4_0+1);
            ParamTbl->item[GTI_SPD1_AS1_LATENCY_ITEM] = GTI_FAST_BUFFER;
        }
        else
        {
            _GET_ITEM(GTI_SPD1_AS1_BYTES_ITEM, GTI_RATE_BI_1_0+1);
            _GET_ITEM(GTI_SPD2_AS1_BYTES_ITEM, GTI_RATE_BI_2_0+1);
            _GET_ITEM(GTI_SPD3_AS1_BYTES_ITEM, GTI_RATE_BI_3_0+1);
            _GET_ITEM(GTI_SPD4_AS1_BYTES_ITEM, GTI_RATE_BI_4_0+1);
            ParamTbl->item[GTI_SPD1_AS1_LATENCY_ITEM] = GTI_INTERLEAVE_BUFFER;
        }

        if(lclParam[GTI_ACTION+1] & 0x04)
        {
            _GET_ITEM(GTI_SPD1_LS0_BYTES_ITEM, GTI_RATE_BF_1_3+1);
            _GET_ITEM(GTI_SPD2_LS0_BYTES_ITEM, GTI_RATE_BF_2_3+1);
            _GET_ITEM(GTI_SPD3_LS0_BYTES_ITEM, GTI_RATE_BF_3_3+1);
            _GET_ITEM(GTI_SPD4_LS0_BYTES_ITEM, GTI_RATE_BF_4_3+1);
            ParamTbl->item[GTI_SPD1_LS0_LATENCY_ITEM] = GTI_FAST_BUFFER;
        }
        else
        {
            _GET_ITEM(GTI_SPD1_LS0_BYTES_ITEM, GTI_RATE_BI_1_3+1);
            _GET_ITEM(GTI_SPD2_LS0_BYTES_ITEM, GTI_RATE_BI_2_3+1);
            _GET_ITEM(GTI_SPD3_LS0_BYTES_ITEM, GTI_RATE_BI_3_3+1);
            _GET_ITEM(GTI_SPD4_LS0_BYTES_ITEM, GTI_RATE_BI_4_3+1);
            ParamTbl->item[GTI_SPD1_LS0_LATENCY_ITEM] = GTI_INTERLEAVE_BUFFER;
        }

        if(lclParam[GTI_ACTION+1] & 0x08)
        {
            _GET_ITEM(GTI_SPD1_LS1_BYTES_ITEM, GTI_RATE_BF_1_4);
            _GET_ITEM(GTI_SPD2_LS1_BYTES_ITEM, GTI_RATE_BF_2_4);
            _GET_ITEM(GTI_SPD3_LS1_BYTES_ITEM, GTI_RATE_BF_3_4);
            _GET_ITEM(GTI_SPD4_LS1_BYTES_ITEM, GTI_RATE_BF_4_4);
            ParamTbl->item[GTI_SPD1_LS1_LATENCY_ITEM] = GTI_FAST_BUFFER;
        }
        else
        {
            _GET_ITEM(GTI_SPD1_LS1_BYTES_ITEM, GTI_RATE_BI_1_4);
            _GET_ITEM(GTI_SPD2_LS1_BYTES_ITEM, GTI_RATE_BI_2_4);
            _GET_ITEM(GTI_SPD3_LS1_BYTES_ITEM, GTI_RATE_BI_3_4);
            _GET_ITEM(GTI_SPD4_LS1_BYTES_ITEM, GTI_RATE_BI_4_4);
            ParamTbl->item[GTI_SPD1_LS1_LATENCY_ITEM] = GTI_INTERLEAVE_BUFFER;
        }

        _GET_WORD(GTI_RS_FAST_OVRHD_DOWN_ITEM, GTI_RS_FAST_OVRHD_DOWN);
        _GET_WORD(GTI_RS_FAST_OVRHD_UP_ITEM, GTI_RS_FAST_OVRHD_UP);

        _GET_WORD(GTI_RS_INT_CORRECTION_DOWN_ITEM, GTI_RS_CORRECTION_DOWN);
        _GET_WORD(GTI_RS_INT_DELAY_DOWN_ITEM, GTI_RS_DELAY_DOWN);
        _GET_WORD(GTI_RS_INT_CORRECTION_UP_ITEM, GTI_RS_CORRECTION_UP);
        _GET_WORD(GTI_RS_INT_DELAY_UP_ITEM, GTI_RS_DELAY_UP);

        _GET_ITEM(GTI_RESERVED_ITEM, GTI_RESERVED);
        _GET_ITEM(GTI_ADI_2X_ITEM, GTI_ADI_2X);

        _GET_WORD(GTI_ALCTL_US_VER_ITEM, GTI_ALCTL_US_VER);
        _GET_WORD(GTI_MAX_D_CO_ITEM, GTI_MAX_D);
        _GET_WORD(GTI_USE_CUSTOM_BINS_ITEM, GTI_USE_CUSTOM_BINS);
        _GET_WORD(GTI_MAX_MARGIN_ITEM, GTI_MAX_MARGIN);
        _GET_WORD(GTI_HW_PWR_RED_ITEM, GTI_HW_PWR_RED);
        _GET_WORD(GTI_FULL_RETRAIN_ENABLE_ITEM, GTI_FULL_RETRAIN_ENABLE);
    }

    if(ParamTbl->item[GTI_MODE_ITEM] == GTI_ATU_C)
        ParamTbl->length = GTI_NUM_OF_ATU_C_CMD_PARAMETERS;
    else
        ParamTbl->length = GTI_NUM_OF_ATU_R_CMD_PARAMETERS;

    return(GTI_OK);
}

/***********************************************************************/
/*  Name: Gti_SetParamXCVR                                             */
/*  Input:                                                             */
/*         pointer to an EXECUTE_CMD structure - XCVR system selected  */
/*         pointer to PARAMXCVR_ARRAY structure - list of paramaters   */
/*  Output:                                                            */
/*         One of the result codes listed in gti.h                     */
/*                                                                     */
/*  Example: Following is an example of filling the paramter list      */
/*           before calling Gti_SetParamXCVR                           */
/*                                                                     */
/*        struct PARAM_XCVR_ARRAY Items;                               */
/*                                                                     */
/*        Items.length = GTI_NUM_OF_CMD_PARAMETERS;                    */
/*                                                                     */
/*        Items.item[GTI_ACTION_ITEM] =GTI_STARTUP_REQ;                */
/*        Items.item[GTI_MODE_ITEM] =GTI_CO;                           */
/*        Items.item[GTI_VENDOR_ID_ITEM] =      ;                      */
/*        Items.item[GTI_VENDOR_REV_SHORT_ITEM] =      ;               */
/*        Items.item[GTI_CLOCK_TYPE_ITEM] =GTI_CLOCK_CRYSTAL;          */
/*        Items.item[GTI_INITIATE_ITEM] =GTI_DEFAULT_INITIATE;         */
/*        Items.item[GTI_BIT_RATE_MODE_ITEM] =GTI_ADAPTIVE_RATE;       */
/*        Items.item[GTI_SPD1_AS0_BYTES_ITEM] = 0x200;                 */
/*        Items.item[GTI_SPD1_AS0_LATENCY_ITEM] =GTI_INTERLEAVE_BUFFER;*/
/*        .                                                            */
/*        .                                                            */
/*        .                                                            */
/*        .                                                            */
/*                                                                     */
/*                                                                     */
/*        return(Gti_SetParamXCVR(  pXcvrInfo, &Items));                 */
/* See gti.h for legal values for all Arguments                        */
/***********************************************************************/

GTI_WORD
Gti_SetParamXCVR(GTI_XCVR_INFO *pXcvrInfo,
                 struct PARAM_XCVR_ARRAY *ParamTbl)
{

#define SET_PARAM(p,d) (lclParamDB[(p)]=(GTI_BYTE)(d))
#define GET_PARAM(p)    lclParamDB[(p)]

    GTI_WORD wAnnex;
    GTI_WORD result, selectSpectrum, itmp, nMaxTbl, btmp, wPageNumber;

#if defined(GTI_USE_DMAXFR) || defined(GTI_USE_XDPXFR)
    GTI_LBUS_INFO *pLbusInfo;
    GTI_WORD bCopyFlag;
#else
    GTI_DWORD dwActionAddr;
#endif

#ifdef GTI_BUILD_DSP_SEPERATE
    GTI_BYTE GTI_ADDRESS_QUAL *ptmp;
    GTI_WORD itmp1;
#endif


#if defined(GTI_USE_DMAXFR) || defined(GTI_USE_XDPXFR)
    GTI_BYTE lclParamDB[GTI_HOST_CONF_END - GTI_HOST_CONF_START];
#else
    GTI_BYTE *lclParamDB = (GTI_BYTE *)&(pXcvrInfo->paramsDB[0]);
    pXcvrInfo->CmdInfo.ReturnLabel = GTI_EMPTY; /* Empty out SAS stack */
#endif

    nMaxTbl = GTI_HOST_CONF_END - GTI_HOST_CONF_START;

#if defined(GTI_USE_DMAXFR) || defined(GTI_USE_XDPXFR)

    bCopyFlag = GTI_FALSE;
    pLbusInfo = &(pXcvrInfo->pChipInfo->pSystInfo->Lbus_db[pXcvrInfo->pChipInfo->wLbusID]);

    for(itmp=0; itmp < nMaxTbl; itmp++)
        lclParamDB[itmp] = 0;
#endif

#ifdef GTI_TRACE
    HistPnt = 0;
#endif


    result = GTI_NOT_SUPPORTED;
    selectSpectrum = GTI_FALSE;

    if(ParamTbl->item[GTI_MODE_ITEM] == GTI_ATU_C)
    {
        if(ParamTbl->length != GTI_NUM_OF_ATU_C_CMD_PARAMETERS)
        {
            return (GTI_INCOMPATIABLE_VERSION);
        }
    }
    else
    {
        if(ParamTbl->length != GTI_NUM_OF_ATU_R_CMD_PARAMETERS)
        {
            return(GTI_INCOMPATIABLE_VERSION);
        }
    }

    pXcvrInfo->wAnnexSlctd = ParamTbl->item[GTI_ANNEX_TYPE_ITEM];
    wAnnex =  ParamTbl->item[GTI_ANNEX_TYPE_ITEM];
#ifdef GTI_PAGE_A_BUILT
#ifndef GTI_PAGE_D_BUILT
    if(ParamTbl->item[GTI_ANNEX_TYPE_ITEM] == GTI_TYPE_ANNEX_B)
        wAnnex = GTI_TYPE_ANNEX_A;
#endif
#endif

#ifdef GTI_BUILD_DSP_SEPERATE
    /* When DSP is build seperately - need to check binary to see */
    /* if supported - can not use GTI_PAGE_X_BUILT!!!             */
    wPageNumber = ParamTbl->item[GTI_ANNEX_TYPE_ITEM];
#else /* Host w/ DSP code */

    switch(wAnnex)
    {
#ifdef GTI_PAGE_A_BUILT
        case GTI_TYPE_ANNEX_A:
            wPageNumber = GTI_PAGE_A;
            break;
#endif
#ifdef GTI_PAGE_D_BUILT
            case GTI_TYPE_ANNEX_B:
                wPageNumber = GTI_PAGE_D;
                break;
#endif
#ifdef GTI_PAGE_B_BUILT
            case GTI_TYPE_ANNEX_C:
                wPageNumber = GTI_PAGE_B;
                break;
#endif
            case GTI_TYPE_ANNEX_H:
                wPageNumber = GTI_PAGE_E;
                break;
            default:
                return (GTI_NOT_SUPPORTED);
    }
#endif /* Host w/ DSP */

#if defined(GTI_USE_DMAXFR) || defined(GTI_USE_XDPXFR)
#ifdef GTI_PAGE_D_BUILT
      if(((pLbusInfo->wLoadedAnnexBmp & GTI_LB_CONFIG_ANNEX_B) == 0) &&
#else
      /* This handles the case where only Annex B is built */
      if(((pLbusInfo->wLoadedAnnexBmp & GTI_LB_CONFIG_ANNEX_A) == 0) &&
#endif
        (wAnnex == GTI_TYPE_ANNEX_B))

        return (GTI_NOT_SUPPORTED);

    if(((pLbusInfo->wLoadedAnnexBmp & GTI_LB_CONFIG_ANNEX_A) == 0) &&
        (wAnnex == GTI_TYPE_ANNEX_A))

        return (GTI_NOT_SUPPORTED);

    if(((pLbusInfo->wLoadedAnnexBmp & GTI_LB_CONFIG_ANNEX_C) == 0) &&
        (wAnnex == GTI_TYPE_ANNEX_C))

        return (GTI_NOT_SUPPORTED);

    if(((pLbusInfo->wLoadedAnnexBmp & GTI_LB_CONFIG_ANNEX_H) == 0) &&
        (wAnnex == GTI_TYPE_ANNEX_H))

        return (GTI_NOT_SUPPORTED);

#endif

    /* Is XCVR active */
    if((pXcvrInfo->CmdInfo.state == GTI_ACTIVE) &&
        (ParamTbl->item[GTI_ACTION_ITEM] != GTI_ABORT_REQ))
    {
        return (GTI_CONFLICT);
    }

    if(ParamTbl->item[GTI_ACTION_ITEM] > GTI_MAX_ACTION_REQ_NUMBER)
        return (GTI_NOT_SUPPORTED);

    pXcvrInfo->cmd_start = (GTI_BYTE)ParamTbl->item[GTI_ACTION_ITEM];

    switch(ParamTbl->item[GTI_ACTION_ITEM])
    {
    case GTI_STARTUP_REQ:
        if(ParamTbl->item[GTI_MODE_ITEM] == GTI_CO)
        {
            if(ParamTbl->item[GTI_INITIATE_ITEM] == GTI_DEFAULT_INITIATE)
                ParamTbl->item[GTI_INITIATE_ITEM] = GTI_WAIT_PN;
        }
        else
        if(ParamTbl->item[GTI_MODE_ITEM] == GTI_CPE)
        {
            if(ParamTbl->item[GTI_INITIATE_ITEM] == GTI_DEFAULT_INITIATE)
                ParamTbl->item[GTI_INITIATE_ITEM] = GTI_INITIATE_PN;
        }
 
#if (defined(GTI_DSPVIKING) && defined(GTI_HOSTVSC))
        if(DSLConfigParams[0].bWhipEnable == GTI_TRUE)
        {
             DSLConfigParams[0].s32LoopCommand = e_DSL_LOOP_START_CMD;
        }
#endif


        /* Initialize the EOC module back to idle */
        GTIEocInit(&(pXcvrInfo->eocInfo));
        break;

    case GTI_ANALOG_LB_REQ:
    case GTI_DOWNLOAD_REQ:
    case GTI_DRIVERS_TEST_REQ:
        wPageNumber = GTI_PAGE_C;
        break;

    case GTI_FAST_RETRAIN_REQ:
    case GTI_PROF_MNGT_REQ:

    case GTI_BIT_SWAPPING_REQ:
    case GTI_BERT_START_REQ:
    case GTI_BERT_STOP_REQ:
    case GTI_RS_MEM_TEST_REQ:
        break;

    case GTI_SPECTRUM_REVERB_REQ:
    case GTI_SPECTRUM_MEDLEY_REQ:
    case GTI_SPECTRUM_PILOT_REQ:
    case GTI_SPECTRUM_C_PBIN_REQ:
    case GTI_SPECTRUM_R_PBIN_REQ:
        break;

    case GTI_SPECTRUM_JUPITER_TX_REQ:
    case GTI_SPECTRUM_C_MTPR_RX_REQ:
        wPageNumber = GTI_PAGE_C;
        selectSpectrum = GTI_TRUE;
        break;

    case GTI_SPECTRUM_REVERB_RX_REQ:
        wPageNumber = GTI_PAGE_C;
        selectSpectrum = GTI_TRUE;
        break;

    case GTI_DIGITAL_LB_REQ:
        wPageNumber = GTI_PAGE_C;
        break;

    case GTI_ATM_LP_REQ:
        wPageNumber = GTI_PAGE_C;
        break;

    case GTI_ABORT_REQ:
    case GTI_DISCONNECT_REQ:
        pXcvrInfo->CmdInfo.state = GTI_COMPLETE_PASS; /* Get out of ACTIVE state */

#if (defined(GTI_DSPVIKING) && defined(GTI_HOSTVSC))
        if(DSLConfigParams[0].bWhipEnable == GTI_TRUE)
        {
             DSLConfigParams[0].s32LoopCommand = e_DSL_LOOP_STOP_CMD;
        }
#endif

        /* Initialize the EOC module back to idle */
        GTIEocInit(&(pXcvrInfo->eocInfo));
        break;

    default:
        break;
    }

    if(pXcvrInfo->cmd_start >= GTI_MAX_ACTION_REQ_NUMBER)
        return (GTI_NOT_SUPPORTED);

    if(ParamTbl->item[GTI_MODE_ITEM] > 1)
        return (GTI_NOT_SUPPORTED);

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)

   /* Host Mode */

    itmp = (GTI_WORD)(((pXcvrInfo->cmd_start) * 2) + ParamTbl->item[GTI_MODE_ITEM]);


    #ifdef GTI_BUILD_DSP_SEPERATE
    itmp1 =Gti_InitPointers(&(pXcvrInfo->CmdInfo), (GTI_BYTE)wPageNumber);
    if( itmp1 == GTI_OK )
    {
           /* Get SAS start */
           ptmp = (GTI_BYTE GTI_ADDRESS_QUAL *)((pXcvrInfo->CmdInfo.PntCmdPnt +
                         (itmp*GTI_SIZE_OF_ACTION_TABLE) ) );
           dwActionAddr =  *(ptmp+0);
           dwActionAddr |= *(ptmp+1)<<8;
           dwActionAddr |= *(ptmp+2)<<16;
           dwActionAddr |= *(ptmp+3)<<24;
           /*printf("Address of Action Table:0x%x, Address of Action:0x%x, SAS #:0x%x\n",
                        pXcvrInfo->CmdInfo.PntCmdPnt, ptmp, dwActionAddr ); */
    }
    else
    {
           if( itmp1 == GTI_FAIL )
           {
               dwActionAddr = GTI_EMPTY_ACTION;
           }
           else
           {
               return (itmp1);
           }
    }

    #else /* Host mode Not binary */
    result =Gti_InitPointers(&(pXcvrInfo->CmdInfo), (GTI_BYTE)wPageNumber);
    if( result != GTI_OK )
    {
           dwActionAddr = GTI_EMPTY_ACTION;
    }else
    {
           dwActionAddr = pXcvrInfo->CmdInfo.PntCmdPnt[itmp];
    }
    #endif /* Host DSP Binary */

    /* Check that Command exists. If not then return Not supported */
    if(dwActionAddr == GTI_EMPTY_ACTION)
        return (GTI_NOT_SUPPORTED);

    /* Point to the start of command */
    pXcvrInfo->CmdInfo.table_pnt = (GTI_WORD)dwActionAddr;

#else /* GTI_USE_DMAXFR */
    pXcvrInfo->wStartBapr = (GTI_WORD)(wPageNumber);
#endif

    switch( ParamTbl->item[GTI_ACTION_ITEM])
    {
    case GTI_ABORT_REQ:
            SET_PARAM(GTI_ANNEX_TYPE, (wPageNumber));
            SET_PARAM(GTI_GSI_RESERVED2,
                (GTI_BYTE)ParamTbl->item[GTI_GSI_RESERVED2_ITEM]);
            SET_PARAM(GTI_GSI_RESERVED2 + 1,
                ((ParamTbl->item[GTI_GSI_RESERVED2_ITEM]) >> 0x08));
        break;

    case GTI_DISCONNECT_REQ:
    case GTI_BERT_START_REQ:
    case GTI_BERT_STOP_REQ:
    case GTI_DRIVERS_TEST_REQ:
    case GTI_FAST_RETRAIN_REQ:
    case GTI_PROF_MNGT_REQ:
    case GTI_BIT_SWAPPING_REQ:
            SET_PARAM(GTI_ANNEX_TYPE, (wPageNumber));
        break;

    default:
#if defined(GTI_USE_DMAXFR) || defined(GTI_USE_XDPXFR)
        bCopyFlag = GTI_TRUE;
#endif
        /* Initialize the hostram space to zero (except Expected standard) */
        if((pXcvrInfo->bExpStandard & GTI_INIT_EXP_STANDARD_MASK) == 0)
            pXcvrInfo->bExpStandard = GET_HOST_DB_B(pXcvrInfo, GTI_EXP_STANDARD);
        else
            pXcvrInfo->bExpStandard &= ~GTI_INIT_EXP_STANDARD_MASK;

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)
        for(itmp=0; itmp < nMaxTbl; itmp++)
            lclParamDB[itmp] = 0;
#endif

        SET_PARAM(GTI_ANNEX_TYPE, (wPageNumber));
        SET_PARAM(GTI_EXP_STANDARD, pXcvrInfo->bExpStandard);
        SET_PARAM(GTI_EXP_STANDARD + 1, 0x0);
        SET_PARAM(GTI_IPU_INTERRUPT_STATE, pXcvrInfo->IrEnabled);

        /*******************************************************/
        /* Copy options to Host Ram Space                      */
        /* CO and CP options                                   */
        /* CP only options                                     */
        /* CO only options                                     */
        /*******************************************************/

        /*************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************/
        /*              INSERT CO and CP PARAMETERS HERE                    */
        /*************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************/

        /*
         * These 16 bits are lower half is ACTION_ITEM, upper half contains latency.
         */
        SET_PARAM(GTI_ACTION,ParamTbl->item[GTI_ACTION_ITEM]);
        SET_PARAM(GTI_ACTION+1,
            ((ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER) ? 0x01 : 0x00) |
            ((ParamTbl->item[GTI_SPD1_AS1_LATENCY_ITEM] == GTI_FAST_BUFFER) ? 0x02 : 0x00) |
            ((ParamTbl->item[GTI_SPD1_LS0_LATENCY_ITEM] == GTI_FAST_BUFFER) ? 0x04 : 0x00) |
            ((ParamTbl->item[GTI_SPD1_LS1_LATENCY_ITEM] == GTI_FAST_BUFFER) ? 0x08 : 0x00));

        SET_PARAM(GTI_MODE, ParamTbl->item[GTI_MODE_ITEM]);
        pXcvrInfo->CurrentMode = (GTI_BYTE)ParamTbl->item[GTI_MODE_ITEM];

        if( selectSpectrum == GTI_TRUE )
        {
            SET_PARAM(GTI_VENDOR_ID, 0x00 );
            SET_PARAM(GTI_VENDOR_ID + 1,
                ((ParamTbl->item[GTI_EC_FDM_ITEM] >> 0x08)&0xfe) );

            if( (ParamTbl->item[GTI_EC_FDM_ITEM]&GTI_CUSTOMER_PIN_OFF) != 0x00 )
            {
                if( (ParamTbl->item[GTI_EC_FDM_ITEM]&GTI_CUSTOMER_PIN_ON) ==
                    GTI_CUSTOMER_PIN_ON )
                    itmp = 0x000c;
                else
                    itmp = 0x0008;
            }
            else
                itmp = 0x0000;

            SET_PARAM(GTI_VENDOR_REV_SHORT, (GTI_BYTE)itmp );
            SET_PARAM(GTI_VENDOR_REV_SHORT+1, (GTI_BYTE)(itmp >> 8) );
        }
        else
        {

            SET_PARAM(GTI_VENDOR_ID,
                ParamTbl->item[GTI_VENDOR_ID_ITEM]);

            SET_PARAM(GTI_VENDOR_ID + 1,
                ParamTbl->item[GTI_VENDOR_ID_ITEM] >> 0x08);

            SET_PARAM(GTI_VENDOR_REV_SHORT,
                ParamTbl->item[GTI_VENDOR_REV_SHORT_ITEM]);
        }

        SET_PARAM(GTI_QUAD_VER, pXcvrInfo->pChipInfo->bChipVersion);
        SET_PARAM(GTI_QUAD_VER + 1, 0x0);

        SET_PARAM(GTI_AFE_VER, pXcvrInfo->pChipInfo->bAfeVersion);
        SET_PARAM(GTI_AFE_VER + 1, 0x0);


        SET_PARAM(GTI_HW_FRAMING_MODE, ParamTbl->item[GTI_DATA_INTERFACE_TYPE_ITEM]);

        SET_PARAM(GTI_TRELLIS + 1, ParamTbl->item[GTI_TRELLIS_ITEM] >> 0x08);

        SET_PARAM(GTI_EC_OR_FDM, ParamTbl->item[GTI_EC_FDM_ITEM]&0x0f);

        SET_PARAM(GTI_STANDARD, ParamTbl->item[GTI_STANDARD_ITEM]);

        /* Based on standard update the Expected Remote Standard */
        switch( ParamTbl->item[GTI_STANDARD_ITEM] )
        {
        case GTI_MULTIMODE_STANDARD:
            break;
        case GTI_T1_413_AUTO_STANDARD:
            break;
        case GTI_T1_413_STANDARD:
            break;
#if ( defined(GTI_BUILD_CP) && defined(GTI_ATLAS_AFE) )
        case GTI_G_DMT_STANDARD:
            break;
#endif
        case GTI_ALCTL14_STANDARD:
        case GTI_ALCTL_STANDARD:
        case GTI_ADI_STANDARD:
            SET_PARAM(GTI_EXP_STANDARD, ParamTbl->item[GTI_STANDARD_ITEM]);
            break;
        default:
            SET_PARAM(GTI_EXP_STANDARD, 0x00);
            break;
        }

        GTI_PRIMARY_PROJECT_ID(pXcvrInfo) = (GTI_BYTE)ParamTbl->item[GTI_ANNEX_TYPE_ITEM];

        SET_PARAM(GTI_NTR, (GTI_BYTE)ParamTbl->item[GTI_NTR_ITEM]);

        SET_PARAM(GTI_INITIATE, ParamTbl->item[GTI_INITIATE_ITEM]);

        SET_PARAM(GTI_CLOCK_TYPE, ParamTbl->item[GTI_CLOCK_TYPE_ITEM]);

        SET_PARAM(GTI_MAX_BITS_PER_BIN, ParamTbl->item[GTI_MAX_BITS_PER_BIN_ITEM]);

        SET_PARAM(GTI_RX_START_BIN + 0, ParamTbl->item[GTI_RX_START_BIN_ITEM] << 0x04);
        SET_PARAM(GTI_RX_START_BIN + 1, ParamTbl->item[GTI_RX_START_BIN_ITEM] >> 0x04);
        SET_PARAM(GTI_RX_START_BIN + 2, ParamTbl->item[GTI_RX_START_BIN_ITEM] >> 0x0c);

        SET_PARAM(GTI_RX_END_BIN + 0, ParamTbl->item[GTI_RX_END_BIN_ITEM] << 0x04);
        SET_PARAM(GTI_RX_END_BIN + 1, ParamTbl->item[GTI_RX_END_BIN_ITEM] >> 0x04);
        SET_PARAM(GTI_RX_END_BIN + 2, ParamTbl->item[GTI_RX_END_BIN_ITEM] >> 0x0c);

        SET_PARAM(GTI_RX_BIN_ADJUST, ParamTbl->item[GTI_RX_BIN_ADJUST_ITEM]);

        SET_PARAM(GTI_TX_START_BIN, ParamTbl->item[GTI_TX_START_BIN_ITEM]);
        SET_PARAM(GTI_TX_START_BIN + 1, ParamTbl->item[GTI_TX_START_BIN_ITEM] >> 0x08);

        SET_PARAM(GTI_TX_END_BIN, ParamTbl->item[GTI_TX_END_BIN_ITEM]);

        SET_PARAM(GTI_TX_END_BIN + 1, ParamTbl->item[GTI_TX_END_BIN_ITEM] >> 0x08);

        SET_PARAM(GTI_TX_BIN_ADJUST, ParamTbl->item[GTI_TX_BIN_ADJUST_ITEM]);

        /*origSET_PARAM(GTI_LINE_DR_STBY, ParamTbl->item[GTI_LINE_DR_STBY_ITEM]);*/
        SET_PARAM(GTI_LINE_DR_STBY, 0x00); 

        SET_PARAM(GTI_TX_POWER_ATTENUATION, ParamTbl->item[GTI_TX_POWER_ATTENUATION_ITEM]);

        SET_PARAM(GTI_UTOPIA_L2_ADDR,
            (GTI_BYTE)((((GTI_BYTE)ParamTbl->item[GTI_UTOPIA_L2_RX_ADDR_ITEM]&0xfe) << 3) |
            ((GTI_BYTE)ParamTbl->item[GTI_UTOPIA_L2_TX_ADDR_ITEM] >> 0x01)) );

        SET_PARAM(GTI_BIT_SWAP + 1,
            (ParamTbl->item[GTI_BIT_SWAP_ITEM] >> 0x08));

            /*
            BIT SWAP NOT IN MAIN CODE so comment out of this version
            SET_PARAM(GTI_US_BIT_SWAP + 1,
            (ParamTbl->item[GTI_US_BIT_SWAP_ITEM] >> 0x08));
        */

        SET_PARAM(GTI_FULL_RETRAIN_ENABLE,
            ParamTbl->item[GTI_FULL_RETRAIN_ENABLE_ITEM]);

        SET_PARAM(GTI_FULL_RETRAIN_ENABLE + 1,
            ParamTbl->item[GTI_FULL_RETRAIN_ENABLE_ITEM] >> 0x08);

        /* Host CO and CP are same location */


        SET_PARAM(GTI_ERASE_PROFILES_FLAG,
            ParamTbl->item[GTI_ERASE_PROFILES_ITEM]);

        SET_PARAM(GTI_ERASE_PROFILES_FLAG + 1,
            ParamTbl->item[GTI_ERASE_PROFILES_ITEM] >> 0x08);

        SET_PARAM(GTI_FAST_RETRAIN_ENABLE,
            ParamTbl->item[GTI_FAST_RETRAIN_ENABLE_ITEM]);

        SET_PARAM(GTI_FAST_RETRAIN_ENABLE + 1,
            ParamTbl->item[GTI_FAST_RETRAIN_ENABLE_ITEM] >> 0x08);

        SET_PARAM(GTI_ESCAPE_FAST_RETRAIN,
            ParamTbl->item[GTI_ESCAPE_FAST_RETRAIN_ITEM]);

        SET_PARAM(GTI_ESCAPE_FAST_RETRAIN + 1,
            ParamTbl->item[GTI_ESCAPE_FAST_RETRAIN_ITEM] >> 0x08);

        SET_PARAM(GTI_TRIGGER_MODE, ParamTbl->item[GTI_TRIGGER_MODE_ITEM]);

        SET_PARAM(GTI_TRIGGER_MODE + 1,
            ParamTbl->item[GTI_TRIGGER_MODE_ITEM] >> 0x08);

        SET_PARAM(GTI_PMODE, ParamTbl->item[GTI_PMODE_ITEM]);
        SET_PARAM(GTI_PMODE + 1, ParamTbl->item[GTI_PMODE_ITEM] >> 0x08);

        if( (ParamTbl->item[GTI_ACTION_ITEM] == GTI_SPECTRUM_REVERB_RX_REQ) ||
            (ParamTbl->item[GTI_ACTION_ITEM] == GTI_SPECTRUM_C_MTPR_RX_REQ) )
        {
            SET_PARAM(GTI_CODING_GAIN + 0, 0x00 );
            SET_PARAM(GTI_CODING_GAIN + 1,
                ParamTbl->item[GTI_CODING_GAIN_ITEM]);
            SET_PARAM(GTI_CODING_GAIN + 2,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] >> 8);

        }
        else
        {
            SET_PARAM(GTI_CODING_GAIN + 0,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] << 6);
            SET_PARAM(GTI_CODING_GAIN + 1,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] >> 2);
            SET_PARAM(GTI_CODING_GAIN + 2,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] >> 0x0a);
            /* used in Annex C CP side */
            SET_PARAM(GTI_CODING_GAIN_ORG + 0,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] << 6);
            SET_PARAM(GTI_CODING_GAIN_ORG + 1,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] >> 2);
            SET_PARAM(GTI_CODING_GAIN_ORG + 2,
                ParamTbl->item[GTI_CODING_GAIN_ITEM] >> 0x0a);
        }

        SET_PARAM(GTI_FRAMING_STRUCTURE,
            ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM]);

        SET_PARAM(GTI_TONE_ORDERING,
            ParamTbl->item[GTI_TONE_ORDERING_ITEM]);
        SET_PARAM(GTI_TONE_ORDERING + 1,
            ParamTbl->item[GTI_TONE_ORDERING_ITEM] >> 0x08);

        SET_PARAM(GTI_SEL_EXCHANGE_TYPE,
            ParamTbl->item[GTI_EXPANDED_EXCHANGE_ITEM]);
        SET_PARAM(GTI_SEL_EXCHANGE_TYPE + 1,
            ParamTbl->item[GTI_EXPANDED_EXCHANGE_ITEM] >> 0x08);

        /* Parameters for Annex C Only*/
        SET_PARAM(GTI_ANNEX_C_MODE,
                ParamTbl->item[GTI_ANNEX_C_MODE_ITEM]);
        SET_PARAM(GTI_ANNEX_C_MODE + 1,
                ParamTbl->item[GTI_ANNEX_C_MODE_ITEM] >> 0x08);

        SET_PARAM(GTI_ANNEX_C_PILOT_TONE,
                ParamTbl->item[GTI_ANNEX_C_PILOT_TONE_ITEM]);
        SET_PARAM(GTI_ANNEX_C_PILOT_TONE + 1,
                ParamTbl->item[GTI_ANNEX_C_PILOT_TONE_ITEM] >> 0x08);

        /*************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************/
        /*              INSERT CP PARAMETERS HERE                           */
        /*************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************/
        if(ParamTbl->item[GTI_MODE_ITEM] == GTI_CPE)
        {
            SET_PARAM(GTI_PILOT_TONE_REQUEST,
                ParamTbl->item[GTI_PILOT_TONE_REQUEST_ITEM]);

            SET_PARAM(GTI_PILOT_TONE_REQUEST + 1,
                ParamTbl->item[GTI_PILOT_TONE_REQUEST_ITEM] >> 0x08);

            SET_PARAM(GTI_MAX_DOWN_RATE,
                ParamTbl->item[GTI_MAX_DOWN_RATE_ITEM]);

            SET_PARAM(GTI_MAX_DOWN_RATE + 1,
                ParamTbl->item[GTI_MAX_DOWN_RATE_ITEM] >> 0x08);

            SET_PARAM(GTI_DUAL_LATENCY, ParamTbl->item[GTI_DUAL_LATENCY_ITEM]);

            SET_PARAM(GTI_DUAL_LATENCY + 1,
                ParamTbl->item[GTI_DUAL_LATENCY_ITEM] >> 0x08);

            SET_PARAM(GTI_HW_REV, ParamTbl->item[GTI_HW_REV_ITEM]);

            SET_PARAM(GTI_HW_REV + 1,
                ParamTbl->item[GTI_HW_REV_ITEM] >> 0x08);

            SET_PARAM(GTI_CUTBACK, ParamTbl->item[GTI_CUTBACK_ITEM]);

            SET_PARAM(GTI_CUTBACK + 1,
                ParamTbl->item[GTI_CUTBACK_ITEM] >> 0x08);

            /* Annex C */
            SET_PARAM(GTI_ANNEX_CH_OFFSET_TTR_R,
                ParamTbl->item[GTI_ANNEX_CH_OFFSET_TTR_R_ITEM]);
            SET_PARAM(GTI_ANNEX_CH_OFFSET_TTR_R + 1,
                ParamTbl->item[GTI_ANNEX_CH_OFFSET_TTR_R_ITEM] >> 0x08);

            SET_PARAM(GTI_MAX_D,
                (GTI_BYTE)ParamTbl->item[GTI_MAX_D_CP_ITEM]);
            SET_PARAM(GTI_MAX_D + 1,
                ((ParamTbl->item[GTI_MAX_D_CP_ITEM]) >> 0x08));


        }

        /*************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************/
        /*              INSERT CO PARAMETERS HERE                           */
        /*************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************/
        if(ParamTbl->item[GTI_MODE_ITEM] == GTI_CO)
        {
            /* Do not disable RS for framing 0,2, */
            /* except both fast and interleave disabled */
            if (((GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM] != GTI_FRAMING_TYPE_3)
               && ((GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM] != GTI_FRAMING_TYPE_1))
            {
               /* downstream */
               if (((ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM] != GTI_DISABLE_RS)
                    &&(ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM] != 0x8000))
                    ||((ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] != GTI_DISABLE_RS)
                    &&(ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] != 0x8000)))
               {
                  if ((ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM] == GTI_DISABLE_RS)
                       ||(ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM] == 0x8000))
                      ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM] = 0x8002;
                  if (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] == GTI_DISABLE_RS)
                  {
                      ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] = 0x8002;
                      ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM] = 0x0101;
                  }
                  if (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] == 0x8000)
                      ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] = 0x8002;
               }
               /* upstream */
               if (((ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM] != GTI_DISABLE_RS)
                    &&(ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM] != 0x8000))
                    ||((ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] != GTI_DISABLE_RS)
                    &&(ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] != 0x8000)))
               {
                  if ((ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM] == 0x8000)
                       ||(ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM] == GTI_DISABLE_RS))
                     ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM] = 0x8002;
                  if (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] == GTI_DISABLE_RS)
                  {
                      ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = 0x8002;
                      ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM] = 0x0101;
                  }
                  if (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] == 0x8000)
                      ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = 0x8002;
                }

                /* set bit rate <= 0x8M for framing 0 and 1 */
               if ((GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM] != GTI_FRAMING_TYPE_2)
               {
                    if(ParamTbl->item[GTI_SPD1_AS0_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD1_AS0_BYTES_ITEM] = 0x00fa;
                    if(ParamTbl->item[GTI_SPD2_AS0_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD2_AS0_BYTES_ITEM] = 0x00fa;
                    if(ParamTbl->item[GTI_SPD3_AS0_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD3_AS0_BYTES_ITEM] = 0x00fa;
                    if(ParamTbl->item[GTI_SPD4_AS0_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD4_AS0_BYTES_ITEM] = 0x00fa;

                    if(ParamTbl->item[GTI_SPD1_AS1_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD1_AS1_BYTES_ITEM] = 0x00fa;
                    if(ParamTbl->item[GTI_SPD2_AS1_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD2_AS1_BYTES_ITEM] = 0x00fa;
                    if(ParamTbl->item[GTI_SPD3_AS1_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD3_AS1_BYTES_ITEM] = 0x00fa;
                    if(ParamTbl->item[GTI_SPD4_AS1_BYTES_ITEM] > 0x00fa)
                       ParamTbl->item[GTI_SPD4_AS1_BYTES_ITEM] = 0x00fa;
                }
            }

            SET_PARAM(GTI_RS_FAST_OVRHD_DOWN,
                ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM]);

            SET_PARAM(GTI_RS_FAST_OVRHD_DOWN + 1,
                ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM] >> 0x08);

            SET_PARAM(GTI_RS_FAST_OVRHD_UP,
                ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM]);

            SET_PARAM(GTI_RS_FAST_OVRHD_UP + 1,
                ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM] >> 0x08);

            if( (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] != GTI_DISABLE_RS) &&
                ((ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] & 0x8000) != 0x8000)&&
                (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM]>GTI_RS_INT_CORRECT_ENHANCED))
            {
                if(ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] >
                    (ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM] + 2))
                {
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] =
                        (GTI_WORD)(ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM] + 2);
                }

            }

            SET_PARAM(GTI_RS_CORRECTION_DOWN,
                (GTI_BYTE)ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM]);

            SET_PARAM(GTI_RS_CORRECTION_DOWN + 1,
                (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] >> 0x08));

            SET_PARAM(GTI_RS_DELAY_DOWN,
                ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM]);

            SET_PARAM(GTI_RS_DELAY_DOWN + 1,
                (ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM] >> 0x08));

            if( ParamTbl->item[GTI_ANNEX_TYPE_ITEM] == GTI_TYPE_ANNEX_A )
            {
                if ((ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM] == GTI_RS_INT_DELAY_1MS) )  /* ||
                                     (ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM] ==
                                     GTI_RS_INT_DELAY_2MS))   */
                {
                 /*   ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = GTI_DISABLE_RS;*/
                }
            }

            /* New RS only for ANNEX C  and ANNEX H !!!! */
            if( (ParamTbl->item[GTI_ANNEX_TYPE_ITEM] == GTI_TYPE_ANNEX_C) ||
                (ParamTbl->item[GTI_ANNEX_TYPE_ITEM] == GTI_TYPE_ANNEX_H)  )
            {
                /* change upstream to new RS setting */
                if( (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] != GTI_DISABLE_RS) &&
                    ((ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] & 0x8000) != 0x8000)&&
                    (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] > GTI_RS_INT_CORRECT_ENHANCED))
                {
                    if (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] >(GTI_WORD) ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM])
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = GTI_RS_INT_CORRECT_ENHANCED;
                    else
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = GTI_RS_INT_CORRECT_NORMAL;
                }
                /* change downstream to new RS setting */
                if( (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] != GTI_DISABLE_RS) &&
                    ((ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] & 0x8000) != 0x8000)&&
                    (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] > GTI_RS_INT_CORRECT_ENHANCED))
                {
                    if (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] >(GTI_WORD) ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM])
                        ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] = GTI_RS_INT_CORRECT_ENHANCED;
                    else
                        ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] = GTI_RS_INT_CORRECT_NORMAL;
                }
            }

            /* based on downstream correction setting, adjust upstream option */
            if( (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] != GTI_DISABLE_RS) &&
                ((ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] & 0x8000) != 0x8000) )
            {
                if( (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] > GTI_RS_INT_CORRECT_ENHANCED)&&
                    (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] > GTI_RS_INT_CORRECT_ENHANCED))
                {
                    if(ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] > ( ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM]+2))
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = (GTI_WORD)(ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM]+2);
                }
                if ( (ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] <= GTI_RS_INT_CORRECT_ENHANCED)&&
                    (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] > GTI_RS_INT_CORRECT_ENHANCED))
                {
                    if (ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] >(GTI_WORD) ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM])
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = GTI_RS_INT_CORRECT_ENHANCED;
                    else
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = GTI_RS_INT_CORRECT_NORMAL;
                }
                if(ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM] > GTI_RS_INT_CORRECT_ENHANCED)
                {
                    if(ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] == GTI_RS_INT_CORRECT_NO_CONSTRAIN)
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM];
                    if(ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] == GTI_RS_INT_CORRECT_NORMAL)
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM];
                    if(ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] == GTI_RS_INT_CORRECT_ENHANCED)
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = (GTI_WORD)(ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM]+0x1);

                    if((GTI_WORD)ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM]<0x3)
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = 0x3;
                    if((GTI_WORD)ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM]>0x8)
                        ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] = 0x8;
                }
            }

            SET_PARAM(GTI_RS_CORRECTION_UP,
                ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM]);

            SET_PARAM(GTI_RS_CORRECTION_UP + 1,
                ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM] >> 0x08);

            SET_PARAM(GTI_RS_DELAY_UP,
                ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM]);

            SET_PARAM(GTI_RS_DELAY_UP + 1,
                (ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM] >> 0x08));

            if ((ParamTbl->item[GTI_DATA_INTERFACE_TYPE_ITEM] == GTI_SERIAL_FRAMING)
                ||(ParamTbl->item[GTI_DATA_INTERFACE_TYPE_ITEM]== GTI_SERIAL_ATM_FRAMING)
                ||(ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM] == GTI_SERIAL_FRAMING)
                ||(ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM]== GTI_SERIAL_ATM_FRAMING))

                ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM] = GTI_SERIAL_FRAMING;
            else
                ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM] = GTI_UTOPIA_L1_FRAMING;

            SET_PARAM(GTI_REMOTE_DATA_INTERFACE,
                (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM]);

            SET_PARAM(GTI_REMOTE_DATA_INTERFACE + 1,
                ((ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM]) >> 0x08));

            SET_PARAM(GTI_ANNEX_CH_TTR_EDGE_DETECT,
                ParamTbl->item[GTI_ANNEX_CH_TTR_EDGE_DETECT_ITEM]);
            SET_PARAM(GTI_ANNEX_CH_TTR_EDGE_DETECT + 1,
                ParamTbl->item[GTI_ANNEX_CH_TTR_EDGE_DETECT_ITEM] >> 0x08);

            SET_PARAM(GTI_ANNEX_CH_TTR_SYNCH,
                ParamTbl->item[GTI_ANNEX_CH_TTR_SYNC_ITEM]);
            SET_PARAM(GTI_ANNEX_CH_TTR_SYNCH + 1,
                ParamTbl->item[GTI_ANNEX_CH_TTR_SYNC_ITEM] >> 0x08);

            SET_PARAM(GTI_ANNEX_CH_TTR_DCS_OFFSET,
                ParamTbl->item[GTI_ANNEX_CH_TTR_DCS_OFFSET_ITEM]);
            SET_PARAM(GTI_ANNEX_CH_TTR_DCS_OFFSET + 1,
                ParamTbl->item[GTI_ANNEX_CH_TTR_DCS_OFFSET_ITEM] >> 0x08);

            SET_PARAM(GTI_ANNEX_CH_OFFSET_TTR_C,
                ParamTbl->item[GTI_ANNEX_CH_OFFSET_TTR_C_ITEM]);
            SET_PARAM(GTI_ANNEX_CH_OFFSET_TTR_C + 1,
                ParamTbl->item[GTI_ANNEX_CH_OFFSET_TTR_C_ITEM] >> 0x08);

            SET_PARAM(GTI_ALCTL_US_VER,
                (GTI_BYTE)ParamTbl->item[GTI_ALCTL_US_VER_ITEM]);

            SET_PARAM(GTI_ALCTL_US_VER + 1,
                ((ParamTbl->item[GTI_ALCTL_US_VER_ITEM]) >> 0x08));

            SET_PARAM(GTI_MAX_D,
                (GTI_BYTE)ParamTbl->item[GTI_MAX_D_CO_ITEM]);
            SET_PARAM(GTI_MAX_D + 1,
                ((ParamTbl->item[GTI_MAX_D_CO_ITEM]) >> 0x08));

            SET_PARAM(GTI_GSI_RESERVED1,
                (GTI_BYTE)ParamTbl->item[GTI_GSI_RESERVED1_ITEM]);
            SET_PARAM(GTI_GSI_RESERVED1 + 1,
                ((ParamTbl->item[GTI_GSI_RESERVED1_ITEM]) >> 0x08));

            SET_PARAM(GTI_GSI_RESERVED2,
                (GTI_BYTE)ParamTbl->item[GTI_GSI_RESERVED2_ITEM]);
            SET_PARAM(GTI_GSI_RESERVED2 + 1,
                ((ParamTbl->item[GTI_GSI_RESERVED2_ITEM]) >> 0x08));

            SET_PARAM(GTI_GSI_RESERVED3,
                (GTI_BYTE)ParamTbl->item[GTI_GSI_RESERVED3_ITEM]);
            SET_PARAM(GTI_GSI_RESERVED3 + 1,
                ((ParamTbl->item[GTI_GSI_RESERVED3_ITEM]) >> 0x08));

            SET_PARAM(GTI_GSI_RESERVED4,
                (GTI_BYTE)ParamTbl->item[GTI_GSI_RESERVED4_ITEM]);
            SET_PARAM(GTI_GSI_RESERVED4 + 1,
                ((ParamTbl->item[GTI_GSI_RESERVED4_ITEM]) >> 0x08));

            SET_PARAM(GTI_USE_CUSTOM_BINS,
                (GTI_BYTE)ParamTbl->item[GTI_USE_CUSTOM_BINS_ITEM]);
            SET_PARAM(GTI_USE_CUSTOM_BINS + 1,
                ((ParamTbl->item[GTI_USE_CUSTOM_BINS_ITEM]) >> 0x08));

           SET_PARAM(GTI_ANNEX_PAGE,
                (wPageNumber));

            SET_PARAM(GTI_MARGIN_UP,
                ParamTbl->item[GTI_MARGIN_UP_ITEM]);

            SET_PARAM(GTI_MARGIN_DWN, ParamTbl->item[GTI_MARGIN_DOWN_ITEM]);

            SET_PARAM(GTI_ADI_2X,
                ParamTbl->item[GTI_ADI_2X_ITEM]);

            SET_PARAM(GTI_RESERVED,
                ParamTbl->item[GTI_RESERVED_ITEM]);

            SET_PARAM(GTI_BIT_RATE,
                ParamTbl->item[GTI_BIT_RATE_MODE_ITEM]);

            SET_PARAM(GTI_BIT_RATE + 1,
                (ParamTbl->item[GTI_BIT_RATE_MODE_ITEM] >> 0x08));

            SET_PARAM(GTI_MAX_MARGIN,
                ParamTbl->item[GTI_MAX_MARGIN_ITEM]);

            SET_PARAM(GTI_MAX_MARGIN + 1,
                (ParamTbl->item[GTI_MAX_MARGIN_ITEM] >> 0x08));

            SET_PARAM(GTI_HW_PWR_RED,
                ParamTbl->item[GTI_HW_PWR_RED_ITEM]);

            SET_PARAM(GTI_HW_PWR_RED + 1,
                (ParamTbl->item[GTI_HW_PWR_RED_ITEM] >> 0x08));


            SET_PARAM(GTI_WHICH_CORE, pXcvrInfo->dsp_B_cs);

            /* if dual latency and adaptive, set all fast opitons the same as 1 */
            if(ParamTbl->item[GTI_BIT_RATE_MODE_ITEM] == GTI_ADAPTIVE_RATE)
            {
                if ((ParamTbl->item[GTI_SPD1_AS0_BYTES_ITEM] > 0x0) &&
                    (ParamTbl->item[GTI_SPD1_AS1_BYTES_ITEM] > 0x0) )
                {
                    if (ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
                    {
                        ParamTbl->item[GTI_SPD4_AS0_BYTES_ITEM] = ParamTbl->item[GTI_SPD1_AS0_BYTES_ITEM];
                    }
                    else
                    {
                        ParamTbl->item[GTI_SPD4_AS1_BYTES_ITEM] = ParamTbl->item[GTI_SPD1_AS1_BYTES_ITEM];
                    }
                }
                if ((ParamTbl->item[GTI_SPD1_LS0_BYTES_ITEM]> 0x0) &&
                    (ParamTbl->item[GTI_SPD1_LS1_BYTES_ITEM]> 0x0) )
                {
                    if (ParamTbl->item[GTI_SPD1_LS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
                    {
                        ParamTbl->item[GTI_SPD4_LS0_BYTES_ITEM] = ParamTbl->item[GTI_SPD1_LS0_BYTES_ITEM];
                    }
                    else
                    {
                        ParamTbl->item[GTI_SPD4_LS1_BYTES_ITEM] = ParamTbl->item[GTI_SPD1_LS1_BYTES_ITEM];
                    }
                }
            }

            if(ParamTbl->item[GTI_BIT_RATE_MODE_ITEM] == GTI_ADAPTIVE_RATE)
            {
                Gti_CreateSpeed_23(ParamTbl);
            }

            Gti_CreateSpeedMsg(lclParamDB, ParamTbl->item);



                    /* option 1, downstream, interleave */
                /*if( (ParamTbl->item[GTI_SPD1_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_INTERLEAVE_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
                }*/

                btmp = 0;
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BI_1_0) + btmp +
                    GET_PARAM(GTI_RATE_BI_1_0 + 1) ),
                    (GTI_WORD)64,
                    GTI_RATE_RRSD_1_0 + 1,
                    GTI_RATE_RRSD_1_1,
                    GTI_RATE_RRSD_1_1 + 1);

                if (result != GTI_OK)
                    return (result);

                /* save D=128 and D=256 parameters to hostram */
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BI_1_0) + btmp +
                    GET_PARAM(GTI_RATE_BI_1_0 + 1) ),
                    (GTI_WORD)128,
                    GTI_RFRI_1_128 + 1,
                    GTI_SD_1_128,
                    GTI_SD_1_128 + 1);
                if(result != GTI_OK)
                    return (result);

                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BI_1_0) + btmp +
                    GET_PARAM(GTI_RATE_BI_1_0 + 1) ),
                    (GTI_WORD)128,
                    GTI_RFRI_1_256 + 1,
                    GTI_SD_1_256,
                    GTI_SD_1_256 + 1);
                if(result != GTI_OK)
                    return (result);


                /* option 2, downstream, interleave */
                /*if( (ParamTbl->item[GTI_SPD2_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_INTERLEAVE_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
            }*/
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BI_2_0) + btmp +
                    GET_PARAM(GTI_RATE_BI_2_0 + 1) ),
                    (GTI_WORD)64,
                    GTI_RATE_RRSD_2_0 + 1,
                    GTI_RATE_RRSD_2_1,
                    GTI_RATE_RRSD_2_1 + 1);

                if (result != GTI_OK)
                    return (result);

                /* option 3, downstream, interleave */
                /*if( (ParamTbl->item[GTI_SPD3_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_INTERLEAVE_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
            }*/
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BI_3_0) + btmp +
                    GET_PARAM(GTI_RATE_BI_3_0 + 1) ),
                    (GTI_WORD)64,
                    GTI_RATE_RRSD_3_0 + 1,
                    GTI_RATE_RRSD_3_1,
                    GTI_RATE_RRSD_3_1 + 1);

                if(result != GTI_OK)
                    return (result);

                /* option 4, downstream, interleave */
                /*if( (ParamTbl->item[GTI_SPD4_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_INTERLEAVE_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
                }*/
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_DOWN_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BI_4_0) + btmp +
                    GET_PARAM(GTI_RATE_BI_4_0 + 1) ),
                    (GTI_WORD)64,
                    GTI_RATE_RRSD_4_0 + 1,
                    GTI_RATE_RRSD_4_1,
                    GTI_RATE_RRSD_4_1 + 1);

                if(result != GTI_OK)
                    return (result);

                /* option 1, uptream, interleave */
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM],
                    (GTI_WORD)( GET_PARAM(GTI_RATE_BI_1_3 + 1) +
                                GET_PARAM(GTI_RATE_BI_1_4)),
                    (GTI_WORD)8,
                    GTI_RATE_RRSD_1_3,
                    GTI_RATE_RRSD_1_3 + 1,
                    GTI_RATE_RRSD_1_4);

                if(result != GTI_OK)
                    return (result);

                /* option 2, uptream, interleave */
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM],
                    (GTI_WORD)( GET_PARAM(GTI_RATE_BI_2_3 + 1) +
                                GET_PARAM(GTI_RATE_BI_2_4)),
                    (GTI_WORD)8,
                    GTI_RATE_RRSD_2_3,
                    GTI_RATE_RRSD_2_3 + 1,
                    GTI_RATE_RRSD_2_4);

                if(result != GTI_OK)
                    return (result);

                /* option 3, uptream, interleave */
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM],
                    (GTI_WORD)( GET_PARAM(GTI_RATE_BI_3_3 + 1) +
                                GET_PARAM(GTI_RATE_BI_3_4)),
                    (GTI_WORD)8,
                    GTI_RATE_RRSD_3_3,
                    GTI_RATE_RRSD_3_3 + 1,
                    GTI_RATE_RRSD_3_4);

                if(result != GTI_OK)
                    return (result);

                /* option 4, uptream, interleave */
                result = Gti_rsIntKCalc(lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_REMOTE_DATA_INTERFACE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    (GTI_BYTE)ParamTbl->item[GTI_STANDARD_ITEM],
                    ParamTbl->item[GTI_RS_INT_CORRECTION_UP_ITEM],
                    ParamTbl->item[GTI_RS_INT_DELAY_UP_ITEM],
                    (GTI_WORD)( GET_PARAM(GTI_RATE_BI_4_3 + 1) +
                                GET_PARAM(GTI_RATE_BI_4_4)),
                    (GTI_WORD)8,
                    GTI_RATE_RRSD_4_3,
                    GTI_RATE_RRSD_4_3 + 1,
                    GTI_RATE_RRSD_4_4);

                if(result != GTI_OK)
                    return (result);


                /* option 1, downtream, fast */
                /*if( (ParamTbl->item[GTI_SPD1_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
                }*/
                result = Gti_rsFastKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM],
                    (GTI_WORD)((GET_PARAM(GTI_RATE_BF_1_0)+ btmp +
                    (GTI_WORD) GET_PARAM(GTI_RATE_BF_1_0 + 1))),
                    GTI_RATE_RRSD_1_0);

                if(result != GTI_OK)
                    return (result);

                /* option 2, downtream, fast */
                /*if( (ParamTbl->item[GTI_SPD2_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
                }*/
                result = Gti_rsFastKCalc(lclParamDB,(GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BF_2_0)+ btmp +
                               GET_PARAM(GTI_RATE_BF_2_0 + 1)),
                    GTI_RATE_RRSD_2_0);

                if(result != GTI_OK)
                    return (result);

                /* option 3, downtream, fast */
                /*if( (ParamTbl->item[GTI_SPD3_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
                }*/
                result = Gti_rsFastKCalc(lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BF_3_0)+ btmp +
                               GET_PARAM(GTI_RATE_BF_3_0 + 1)),
                    GTI_RATE_RRSD_3_0);

                if(result != GTI_OK)
                    return (result);

                /* option 4, downtream, fast */
                /*if( (ParamTbl->item[GTI_SPD4_AS0_BYTES_ITEM] > 0x00ff )
                &&(ParamTbl->item[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER ) ){
                btmp = 0x100;
                }
                else {
                btmp = 0;
                }*/
                result = Gti_rsFastKCalc( lclParamDB, (GTI_BYTE)GTI_DOWN_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_DOWN_ITEM],
                    (GTI_WORD)(GET_PARAM(GTI_RATE_BF_4_0)+ btmp +
                               GET_PARAM(GTI_RATE_BF_4_0 + 1)),
                    GTI_RATE_RRSD_4_0);

                if(result != GTI_OK)
                    return (result);

                /* option 1, uptream, fast */
                result = Gti_rsFastKCalc( lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM],
                    (GTI_WORD) (GET_PARAM( GTI_RATE_BF_1_3 + 1)+
                                GET_PARAM( GTI_RATE_BF_1_4)),
                    GTI_RATE_RRSD_1_2 + 1);

                if(result != GTI_OK)
                    return (result);

                /* option 2, uptream, fast */
                result = Gti_rsFastKCalc( lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM],
                    (GTI_WORD) (GET_PARAM(GTI_RATE_BF_2_3 + 1)+
                                GET_PARAM(GTI_RATE_BF_3_4)),
                    GTI_RATE_RRSD_2_2 + 1);

                if(result != GTI_OK)
                    return (result);

                /* option 3, uptream, fast */
                result = Gti_rsFastKCalc( lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM],
                    (GTI_WORD)( GET_PARAM(GTI_RATE_BF_3_3 + 1)+
                                GET_PARAM(GTI_RATE_BF_3_4)),
                    GTI_RATE_RRSD_3_2 + 1);

                if(result != GTI_OK)
                    return (result);

                /* option 4, uptream, fast */
                result = Gti_rsFastKCalc( lclParamDB, (GTI_BYTE)GTI_UP_STREAM,
                    (GTI_BYTE)ParamTbl->item[GTI_FRAMING_STRUCTURE_ITEM],
                    ParamTbl->item[GTI_RS_FAST_OVRHD_UP_ITEM],
                    (GTI_WORD) (GET_PARAM(GTI_RATE_BF_4_3 + 1) +
                                GET_PARAM(GTI_RATE_BF_4_4)),
                    GTI_RATE_RRSD_4_2 + 1);

                if(result != GTI_OK)
                    return (result);



            SET_PARAM(GTI_RFRI_1_128, GET_PARAM(GTI_RATE_RRSD_1_0));
            SET_PARAM(GTI_RFRI_2_128, GET_PARAM(GTI_RATE_RRSD_2_0));
            SET_PARAM(GTI_RFRI_3_128, GET_PARAM(GTI_RATE_RRSD_3_0));
            SET_PARAM(GTI_RFRI_4_128, GET_PARAM(GTI_RATE_RRSD_4_0));
            SET_PARAM(GTI_RFRI_1_256, GET_PARAM(GTI_RATE_RRSD_1_0));
            SET_PARAM(GTI_RFRI_2_256, GET_PARAM(GTI_RATE_RRSD_2_0));
            SET_PARAM(GTI_RFRI_3_256, GET_PARAM(GTI_RATE_RRSD_3_0));
            SET_PARAM(GTI_RFRI_4_256, GET_PARAM(GTI_RATE_RRSD_4_0));


        }/* End CO Parameters */

        break;
    }

#ifdef GTI_USE_DMAXFR
    if(bCopyFlag)
    {
        /* Load HOSTRAM memory space into internal memory */
        CONFIGURE_DSP( pXcvrInfo, GTI_DSP_A, GTI_DMA);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x00, GTI_IRAME);
        WRITE_DSP_BLOCK(pXcvrInfo,GTI_DSP_A,GTI_DATAL_DSP,
            GTI_HOST_CONF_END - GTI_HOST_CONF_START, lclParamDB);

        UPDATE_DSP(pXcvrInfo);
    }

    /* Set the RS memory mode (128K0 for the RS test.     */
    /* The chip must be reset after the test is completed */
    if(ParamTbl->item[GTI_ACTION_ITEM] == GTI_RS_MEM_TEST_REQ)
    {
        WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_75, 0x03);
        WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_75, 0x02);
        WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_75, 0xFA);
    }

    UPDATE_DSP(pXcvrInfo);

    return  Gti_StartCommand(pXcvrInfo);
#else
#if defined(GTI_USE_XDPXFR)

    (void) bCopyFlag;
    nMaxTbl = 0;

    if(ParamTbl->item[GTI_ACTION_ITEM] != GTI_ABORT_REQ)
    {
        nMaxTbl = Gti_BuildDspMsg(pXcvrInfo, 0, GTI_DSP_MSG_SET_PARAM,
            GTI_HOST_CONF_END - GTI_HOST_CONF_START, lclParamDB);

        if(nMaxTbl == 0)
            return GTI_INCOMPATIABLE_VERSION;
    }

    nMaxTbl = Gti_BuildDspMsg(pXcvrInfo, nMaxTbl, ParamTbl->item[GTI_ACTION_ITEM], 0, 0);

    if(Gti_SendDspMsg(pXcvrInfo, ParamTbl->item[GTI_ANNEX_TYPE_ITEM]) == GTI_FALSE)
        return GTI_FAIL;

#endif
    return (GTI_OK);
#endif
}

/******************************************************************************/
/* Procedure: Gti_CreateSpeed_23                            Created: 31.05.00 */
/* ------------------------                                                   */
/* Returns void                                                               */
/* -------------------------------------------------------------------------- */
void
Gti_CreateSpeed_23(struct PARAM_XCVR_ARRAY *PtrParam)
{
    GTI_BYTE spdDiff;

    /* Create speeds 2 and 3  for AS0 AS1 LS0 LS1*/

    /* As0 */
    spdDiff = (GTI_BYTE)((PtrParam->item[GTI_SPD1_AS0_BYTES_ITEM] -
        PtrParam->item[GTI_SPD4_AS0_BYTES_ITEM]) / 3);

    PtrParam->item[GTI_SPD3_AS0_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD4_AS0_BYTES_ITEM] + spdDiff);

    PtrParam->item[GTI_SPD2_AS0_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD3_AS0_BYTES_ITEM] + spdDiff);

    /* PtrParam->item[GTI_SPD3_AS0_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_AS0_LATENCY_ITEM];*/

    /* PtrParam->item[GTI_SPD2_AS0_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_AS0_LATENCY_ITEM];*/

    /* As1 */
    spdDiff = (GTI_BYTE)((PtrParam->item[GTI_SPD1_AS1_BYTES_ITEM] -
        PtrParam->item[GTI_SPD4_AS1_BYTES_ITEM])/3);

    PtrParam->item[GTI_SPD3_AS1_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD4_AS1_BYTES_ITEM] + spdDiff);

    PtrParam->item[GTI_SPD2_AS1_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD3_AS1_BYTES_ITEM] + spdDiff);


        /* PtrParam->item[GTI_SPD3_AS1_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_AS1_LATENCY_ITEM];
    PtrParam->item[GTI_SPD2_AS1_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_AS1_LATENCY_ITEM]; */

    /* Ls0 */
    spdDiff = (GTI_BYTE)((PtrParam->item[GTI_SPD1_LS0_BYTES_ITEM] -
        PtrParam->item[GTI_SPD4_LS0_BYTES_ITEM])/3);

    PtrParam->item[GTI_SPD3_LS0_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD4_LS0_BYTES_ITEM] + spdDiff);

    PtrParam->item[GTI_SPD2_LS0_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD3_LS0_BYTES_ITEM] + spdDiff);


        /* PtrParam->item[GTI_SPD3_LS0_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_LS0_LATENCY_ITEM];
    PtrParam->item[GTI_SPD2_LS0_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_LS0_LATENCY_ITEM]; */

    /* Ls1 */
    spdDiff = (GTI_BYTE)((PtrParam->item[GTI_SPD1_LS1_BYTES_ITEM] -
        PtrParam->item[GTI_SPD4_LS1_BYTES_ITEM])/3);

    PtrParam->item[GTI_SPD3_LS1_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD4_LS1_BYTES_ITEM] + spdDiff);

    PtrParam->item[GTI_SPD2_LS1_BYTES_ITEM] = (GTI_WORD)
        (PtrParam->item[GTI_SPD3_LS1_BYTES_ITEM] + spdDiff);

        /* PtrParam->item[GTI_SPD3_LS1_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_LS1_LATENCY_ITEM];
    PtrParam->item[GTI_SPD2_LS1_LATENCY_ITEM] = PtrParam->item[GTI_SPD1_LS1_LATENCY_ITEM]; */
}

/******************************************************************************/
/* Procedure: Gti_CreateSpeedMsg                            Created: 31.05.00 */
/* ------------------------                                                   */
/* Returns void                                                               */
/* -------------------------------------------------------------------------- */
void Gti_CreateSpeedMsg(GTI_BYTE *lclParamDB, GTI_WORD *pPrmSrc)
{

    GTI_WORD wTmpSpeed;

        /* Now Based on latency load up the Rate Block */
        /* All Speed 1 First */
        if(pPrmSrc[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if(pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BF_1_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_1_0, pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM]);
        }
        else
        {
            if(pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_1_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_1_0, pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM]);
        }

        if(pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM] != 0) {
            SET_PARAM(GTI_MAX_SPEED_DOWN, pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM]);
            SET_PARAM(GTI_MAX_SPEED_DOWN + 1, pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM] >> 0x08);
        }
        else
        {
            SET_PARAM(GTI_MAX_SPEED_DOWN, pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM]);
            SET_PARAM(GTI_MAX_SPEED_DOWN + 1, pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM] >> 0x08);
        }

        if(pPrmSrc[GTI_SPD1_AS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if(pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM] > 0xfc)
               SET_PARAM(GTI_RATE_BF_1_0 + 1, 0xfc);
            else
               SET_PARAM(GTI_RATE_BF_1_0 + 1, pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM]);
        }
        else
        {
            if(pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_1_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_1_0 + 1, pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM]);
            if(pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM] != 0x0)
            {
                SET_PARAM(GTI_MAX_SPEED_DOWN, pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM]);
                SET_PARAM(GTI_MAX_SPEED_DOWN + 1, pPrmSrc[GTI_SPD1_AS1_BYTES_ITEM] >> 0x08);
            }
        }

        if(pPrmSrc[GTI_SPD1_LS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_1_3 + 1, pPrmSrc[GTI_SPD1_LS0_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_1_3 + 1, pPrmSrc[GTI_SPD1_LS0_BYTES_ITEM]);

        if(pPrmSrc[GTI_SPD1_LS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_1_4, pPrmSrc[GTI_SPD1_LS1_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_1_4, pPrmSrc[GTI_SPD1_LS1_BYTES_ITEM]);

        /* All Speed 2 First */
        if(pPrmSrc[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if (pPrmSrc[GTI_SPD2_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BF_2_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_2_0, pPrmSrc[GTI_SPD2_AS0_BYTES_ITEM]);
        }
        else
        {
            if (pPrmSrc[GTI_SPD2_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_2_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_2_0, pPrmSrc[GTI_SPD2_AS0_BYTES_ITEM]);
        }
        if(pPrmSrc[GTI_SPD1_AS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if (pPrmSrc[GTI_SPD2_AS1_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BF_2_0 + 1, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_2_0 + 1, pPrmSrc[GTI_SPD2_AS1_BYTES_ITEM]);
        }
        else
        {
            if (pPrmSrc[GTI_SPD2_AS1_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_2_0 + 1, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_2_0 + 1, pPrmSrc[GTI_SPD2_AS1_BYTES_ITEM]);
        }

        if(pPrmSrc[GTI_SPD1_LS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_2_3 + 1, pPrmSrc[GTI_SPD2_LS0_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_2_3 + 1, pPrmSrc[GTI_SPD2_LS0_BYTES_ITEM]);

        if(pPrmSrc[GTI_SPD1_LS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_2_4, pPrmSrc[GTI_SPD2_LS1_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_2_4, pPrmSrc[GTI_SPD2_LS1_BYTES_ITEM]);

        /* All Speed 3 First */
        if(pPrmSrc[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if (pPrmSrc[GTI_SPD3_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BF_3_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_3_0, pPrmSrc[GTI_SPD3_AS0_BYTES_ITEM]);
        }
        else
        {
            if (pPrmSrc[GTI_SPD3_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_3_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_3_0, pPrmSrc[GTI_SPD3_AS0_BYTES_ITEM]);
        }

        if(pPrmSrc[GTI_SPD1_AS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if (pPrmSrc[GTI_SPD3_AS1_BYTES_ITEM] >0xfc)
                SET_PARAM(GTI_RATE_BF_3_0 + 1, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_3_0 + 1, pPrmSrc[GTI_SPD3_AS1_BYTES_ITEM]);
        }
        else
        {
            if (pPrmSrc[GTI_SPD3_AS1_BYTES_ITEM] >0xfc)
                SET_PARAM(GTI_RATE_BI_3_0 + 1, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_3_0 + 1,pPrmSrc[GTI_SPD3_AS1_BYTES_ITEM]);
        }
        if(pPrmSrc[GTI_SPD1_LS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_3_3 + 1, pPrmSrc[GTI_SPD3_LS0_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_3_3 + 1, pPrmSrc[GTI_SPD3_LS0_BYTES_ITEM]);

        if(pPrmSrc[GTI_SPD1_LS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_3_4, pPrmSrc[GTI_SPD3_LS1_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_3_4, pPrmSrc[GTI_SPD3_LS1_BYTES_ITEM]);

       /* All Speed 4 First */
        if(pPrmSrc[GTI_SPD1_AS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if (pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BF_4_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_4_0, pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM]);
        }
        else
        {
            if(pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_4_0, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_4_0, pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM]);
        }

        if(pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM] != 0)
        {
            SET_PARAM(GTI_MIN_SPEED_DOWN, pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM]);
            SET_PARAM(GTI_MIN_SPEED_DOWN + 1, pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM] >> 0x08);
        }
        else
        {
            SET_PARAM(GTI_MIN_SPEED_DOWN, pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM]);
            SET_PARAM(GTI_MIN_SPEED_DOWN + 1, pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM] >> 0x08);
        }

        if(pPrmSrc[GTI_SPD1_AS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
        {
            if (pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BF_4_0 + 1, 0xfc);
            else
                SET_PARAM(GTI_RATE_BF_4_0 + 1, pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM]);
        }
        else
        {
            if (pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM] > 0xfc)
                SET_PARAM(GTI_RATE_BI_4_0 + 1, 0xfc);
            else
                SET_PARAM(GTI_RATE_BI_4_0 + 1, pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM]);
            if(pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM] != 0x0)
            {
                SET_PARAM(GTI_MIN_SPEED_DOWN, pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM]);
                SET_PARAM(GTI_MIN_SPEED_DOWN + 1, pPrmSrc[GTI_SPD4_AS1_BYTES_ITEM] >> 0x08);
            }
        }
       /* set min-speed to be odd number if it is greater than 0xfc */
        wTmpSpeed = MAKEWORD(GET_PARAM(GTI_MIN_SPEED_DOWN),
            (GET_PARAM(GTI_MIN_SPEED_DOWN + 1)));

        if(wTmpSpeed > 0xfc)
        {
            wTmpSpeed = (GTI_WORD) (wTmpSpeed|0x1);
            SET_PARAM(GTI_MIN_SPEED_DOWN, wTmpSpeed);
            SET_PARAM(GTI_MIN_SPEED_DOWN + 1, wTmpSpeed >> 0x08);
        }

        /* set max-speed >= min-speed */
        if(MAKEWORD(GET_PARAM(GTI_MAX_SPEED_DOWN),
            (GET_PARAM(GTI_MAX_SPEED_DOWN + 1))) < wTmpSpeed)
        {
            SET_PARAM(GTI_MAX_SPEED_DOWN, wTmpSpeed);
            SET_PARAM(GTI_MAX_SPEED_DOWN + 1, wTmpSpeed >> 0x08);
        }

        if(pPrmSrc[GTI_SPD1_LS0_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_4_3 + 1, pPrmSrc[GTI_SPD4_LS0_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_4_3 + 1, pPrmSrc[GTI_SPD4_LS0_BYTES_ITEM]);

        if(pPrmSrc[GTI_SPD1_LS1_LATENCY_ITEM] == GTI_FAST_BUFFER)
            SET_PARAM(GTI_RATE_BF_4_4, pPrmSrc[GTI_SPD4_LS1_BYTES_ITEM]);
        else
            SET_PARAM(GTI_RATE_BI_4_4, pPrmSrc[GTI_SPD4_LS1_BYTES_ITEM]);

}

/******************************************************************************/
/* Procedure: Gti_CreateSpeedMsgLite                        Created: 31.05.00 */
/* ------------------------                                                   */
/* Returns void                                                               */
/* -------------------------------------------------------------------------- */
void
Gti_CreateSpeedMsgLite(GTI_BYTE *lclParamDB, GTI_WORD *pPrmSrc)
{
    SET_PARAM(GTI_BI_AS0_OPT1, pPrmSrc[GTI_SPD1_AS0_BYTES_ITEM]);
    SET_PARAM(GTI_BI_LS0_OPT1, pPrmSrc[GTI_SPD1_LS0_BYTES_ITEM]);

    SET_PARAM(GTI_BI_AS0_OPT2, pPrmSrc[GTI_SPD2_AS0_BYTES_ITEM]);
    SET_PARAM(GTI_BI_LS0_OPT2, pPrmSrc[GTI_SPD2_LS0_BYTES_ITEM]);

    SET_PARAM(GTI_BI_AS0_OPT3, pPrmSrc[GTI_SPD3_AS0_BYTES_ITEM]);
    SET_PARAM(GTI_BI_LS0_OPT3, pPrmSrc[GTI_SPD3_LS0_BYTES_ITEM]);

    SET_PARAM(GTI_BI_AS0_OPT4, pPrmSrc[GTI_SPD4_AS0_BYTES_ITEM]);
    SET_PARAM(GTI_BI_LS0_OPT4, pPrmSrc[GTI_SPD4_LS0_BYTES_ITEM]);
}

/******************************************************************************/
/* Procedure: Gti_InitProductHRAM                           Created: 31.05.00 */
/* ------------------------                                                   */
/* Description: The procedure initializes the product specific HRAM settings  */
/* Returns VOID                                                               */
/* -------------------------------------------------------------------------- */
void
Gti_InitProductHRAM(GTI_XCVR_INFO *pXcvrInfo)
{
    /* Product Specific Host RAM are initialized here */

    /* DSP Reset configure for Level 2 I/O */
    Gti_RegInit(pXcvrInfo, &Level2RegTable[0]);

#ifdef GTI_DSPQUAD
    /* Init Register 0x80 */
    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(pXcvrInfo,GTI_DSP_A, 0x80, GTI_IREGA);
    WRITE_DSP_WORD(pXcvrInfo,GTI_DSP_A, 0x03, 0x00);
#endif /* QUAD */
}

/******************************************************************************/
/* Procedure: Gti_rsFastKCalc                               Created: 31.05.00 */
/* ------------------------                                                   */
/* Returns GTI_WORD                                                           */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_rsFastKCalc(GTI_BYTE *lclParamDB, GTI_BYTE bStreamDir,
                GTI_BYTE bFrmStruct, GTI_WORD wOvrHead,
                GTI_WORD wKfInput, GTI_WORD wRSOutput)
{

    GTI_WORD RLcl ;

    /* check for disabled */
    if(wOvrHead == GTI_DISABLE_RS)
    {
        SET_PARAM(wRSOutput, 0);
       /* if(bFrmStruct == GTI_FRAMING_TYPE_3)
            SET_PARAM(wRSOutput, 0);
        else
            SET_PARAM(wRSOutput, 2); */
        return (GTI_OK) ;
    }

    /* check for no data */
    if(wKfInput == 0)
    {
        if(bFrmStruct == GTI_FRAMING_TYPE_3){
            SET_PARAM(wRSOutput, 0);
        }else{
            SET_PARAM(wRSOutput, 2);
        }
        return (GTI_OK) ;
    }

    if(wOvrHead & 0xff00)
    {
        SET_PARAM(wRSOutput, (GTI_BYTE)wOvrHead);
        return (GTI_OK) ;
    }

    /*   RF=0 for high rate */
    if ( wKfInput >=254 ) {
        RLcl = 0;
        SET_PARAM(wRSOutput, (GTI_BYTE) RLcl);
        return (GTI_OK);
    }

    if(( wOvrHead < 1) || ( wOvrHead > 7))
        return(0xfffe) ;


    wKfInput = (GTI_WORD)(wKfInput + 0x01); /* 1 overhead byte for framing 2 & 3 */

    if ((bFrmStruct==GTI_FRAMING_TYPE_0)||(bFrmStruct==GTI_FRAMING_TYPE_1))
    {
        wKfInput = (GTI_WORD)(wKfInput + 0x01); /* 2 overhead for framing 0 & 1, up stream */
        if( bStreamDir == GTI_DOWN_STREAM )
        {
            wKfInput = (GTI_WORD)(wKfInput + 0x01); /* 3 overhead for framing 0 & 1, down stream */
        }
    }


    RLcl = (GTI_WORD)(wKfInput /  (GTI_WORD)( ( 1 << wOvrHead) - 1));
    RLcl = (GTI_WORD)(( ( RLcl + 1) >> 0x01) << 0x01 );

    if(RLcl < 2)
        RLcl = 2 ;

    if(RLcl > 16)
        RLcl = 16 ;

    if ( wKfInput <= 253 ) {
        if(( RLcl + wKfInput) > 255)
        {
            RLcl = (GTI_WORD)(255 - wKfInput);
            RLcl = (GTI_WORD)(( RLcl >> 0x01) << 0x01);
        }
    }

    SET_PARAM(wRSOutput, (GTI_BYTE) RLcl);
    return (GTI_OK) ;
}

/******************************************************************************/
/* Procedure: Gti_rsIntKCalc                                Created: 31.05.99 */
/* ------------------------                                                   */
/* Returns GTI_WORD                                                           */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_rsIntKCalc(GTI_BYTE *lclParamDB,
               GTI_BYTE bStreamDir, GTI_BYTE bRmtInterface, GTI_BYTE bFrmStruct,
               GTI_BYTE bStandard,GTI_WORD wCeInput,
               GTI_WORD wDeInput, GTI_WORD wKiInput, GTI_WORD wDMaxInput,
               GTI_WORD wRSOutput, GTI_WORD wSOutput, GTI_WORD wDOutput)
{
    GTI_WORD shftTmp;
    GTI_WORD DeLcl;
    GTI_WORD SeLcl;
    GTI_WORD SLcl;
    GTI_WORD RLcl;
    GTI_WORD DLcl;
    GTI_WORD wKiTmp, wNTmp;
    GTI_BYTE bSMin, bDelay;

    SLcl = 0;

    /* check for disabled */
    if(wCeInput == GTI_DISABLE_RS)
    {
         SET_PARAM(wRSOutput, 0);
         SET_PARAM(wSOutput, 1);
         SET_PARAM(wDOutput, 1);
           if (wKiInput >= 0x100)
               SET_PARAM(wSOutput, 0);

        return (GTI_OK) ;
    }

    /* check for no data */
    if(wKiInput == 0)
    {
        SET_PARAM(wSOutput, 1);
        SET_PARAM(wDOutput, 1);
        if(bFrmStruct == GTI_FRAMING_TYPE_3)
            SET_PARAM(wRSOutput, 0);
        else
            SET_PARAM(wRSOutput, 2);
        return (GTI_OK) ;
    }

    /* Forced */
    if(wCeInput & 0xff00)
    {
        SET_PARAM(wRSOutput, (GTI_BYTE) wCeInput);
        SET_PARAM(wSOutput, (GTI_BYTE) wDeInput);
        SET_PARAM(wDOutput, (GTI_BYTE) (wDeInput>> 0x08));
        return(GTI_OK) ;
    }

    /* Input Check rules */
    if(wCeInput > 8)
        return (0xfffe) ;
    if((wDeInput > 8)&&(wDeInput < 0x8000))
        return (0xfffd) ;
    if(wDeInput > 0x8008)
        return (0xfffd) ;
        
    /* Add framing overhead byte */
    wKiInput = (GTI_WORD)(wKiInput + 0x01); /* 1 overhead byte for framing 2 & 3 */
    if ((bFrmStruct==GTI_FRAMING_TYPE_0)||(bFrmStruct==GTI_FRAMING_TYPE_1))
    {
        wKiInput =(GTI_WORD)( wKiInput + 0x01); /* 2 overhead for framing 0 & 1, up stream */
        if( bStreamDir == GTI_DOWN_STREAM )
            wKiInput = (GTI_WORD)(wKiInput + 0x01); /* 3 overhead for framing 0 & 1, down stream */
    }

    /* Start to calculate R,S and D based on Ce */
    /* if Ce > 2, old algorithm; otherwise, new algorithm */
    if(wCeInput > GTI_RS_INT_CORRECT_ENHANCED)
    {
        if(wDeInput > 8)   /* illegal values of delay */
            return (0xfffd) ;
        SeLcl = 0 ;
        wKiTmp = wKiInput;
        if ( wKiInput > 253)
        {
            wKiInput = (GTI_WORD)(wKiInput/2);
        }
        else
        {
            if((bStreamDir == GTI_UP_STREAM)&&(bRmtInterface == 0))
            {
                while ( ( ( wKiInput<<SeLcl) < 64) && ( SeLcl < 4))
                    ++SeLcl;
            }
            else
            {
                while ( ( ( wKiInput<<SeLcl) < 128) && ( SeLcl < 4))
                    ++SeLcl;
            }
        }

        DeLcl = (GTI_WORD)(wDeInput - SeLcl);
        while ( DeLcl & 0x8000)
        {
            DeLcl = (GTI_WORD)(DeLcl + 1);
            SeLcl = (GTI_WORD)(SeLcl - 1);
        }

        RLcl =  (GTI_WORD)(( wKiInput << ( SeLcl + wCeInput)) / ( ( 0x01 <<(wDeInput+3)) - ( 0x01 <<wCeInput)));
        if(( ( RLcl >> SeLcl) << SeLcl) != RLcl)
            RLcl =  (GTI_WORD)(( (RLcl + 1) >> SeLcl) << SeLcl);

        if(RLcl < 2)
        {
            if(SeLcl > 0)
                RLcl =  (GTI_WORD)(0x1 << SeLcl);
            else
                RLcl = 2 ;
        }


        if (RLcl > 16) {
            while ( ( SeLcl > 0) && ( ( ( wKiInput << SeLcl) + 16 )> 255))
            {
                SeLcl = (GTI_WORD)(SeLcl - 1);
                DeLcl = (GTI_WORD)(DeLcl + 1);
                RLcl = (GTI_WORD)((( RLcl + 2) / 4) * 2) ;
            }
        }
        else {
            while ( ( SeLcl > 0) && ( ( ( wKiInput << SeLcl) + RLcl )> 255))
            {
                SeLcl = (GTI_WORD)(SeLcl - 1);
                DeLcl = (GTI_WORD)(DeLcl + 1);
                RLcl = (GTI_WORD)((( RLcl + 2) / 4) * 2) ;
            }
        }

        if(RLcl > 16)
            RLcl = 16 ;

        if(( ( RLcl >> SeLcl) << SeLcl) != RLcl)
            RLcl = (GTI_WORD)(( RLcl >> SeLcl) << SeLcl);

        if(RLcl < 2)
        {
            if(SeLcl == 0)
                RLcl = 2 ;
            else
                RLcl = (GTI_WORD)(0x1 << SeLcl);
        }

        /* check to see if delay too long */
        shftTmp = (GTI_WORD)(DeLcl + SeLcl - wCeInput + 3);
        while ( ( shftTmp > 7) || ( ( RLcl << shftTmp) / ( ( ( ( wKiInput << SeLcl) + RLcl) * 3) / 2)))
        {
            if(DeLcl > 0)
            {
                DeLcl = (GTI_WORD)(DeLcl - 1);
            }
            else
            if(( SeLcl > 0) && ( RLcl > 2))
            {
                SeLcl = (GTI_WORD)(SeLcl - 1);
                RLcl = (GTI_WORD)(RLcl / 2);
            }
            else
                break ; /* Sorry, nothing I could do */

            shftTmp = (GTI_WORD)(DeLcl + SeLcl - wCeInput + 3);
        }

        if(( DeLcl == 0) && ( SeLcl > 0))
        {
            if(RLcl > 2)
            {
                RLcl = (GTI_WORD)(( RLcl >> 2) << 0x01);
                SeLcl = (GTI_WORD)(SeLcl - 1);
                DeLcl = 1 ;
            }
            else
                SeLcl = 0 ;
        }

        RLcl = (GTI_WORD)(( ( RLcl + 1) / 2) * 2 );

        DLcl =  (GTI_WORD)(0x01 << DeLcl);
        if(DLcl > wDMaxInput)
        {
            while ( DLcl > wDMaxInput)
            {
                DLcl = (GTI_WORD)(DLcl >> 0x01);
                DeLcl = (GTI_WORD)(DeLcl - 1);
                if(( ( wKiInput << SeLcl) + (2* RLcl)) < 256)
                {
                    RLcl =(GTI_WORD)( RLcl<<1 );
                    if(RLcl > 16)
                        RLcl = 16;
                }
            }
        }

        /* can only happen if SeLcl = 0 */
        if(( wKiInput + RLcl) > 255)
            RLcl = (GTI_WORD)(( ( 255 - wKiInput) / 2) * 2 );

        SET_PARAM(wRSOutput, (GTI_BYTE)(RLcl >> SeLcl));

        if (wKiTmp>253 )
        {
            SeLcl = 0x0;   /* 0x1; */
            DLcl = (GTI_WORD)(DLcl*2);
            RLcl = 6;      /* fix R=6 for S=1/2 */
            SET_PARAM(wRSOutput, (GTI_BYTE) RLcl );
            if (DLcl > wDMaxInput) {
                DLcl = wDMaxInput;
            }
        }
        else
        {
            SeLcl = (GTI_WORD)(0x01 << SeLcl);
        }

        SET_PARAM(wSOutput, (GTI_BYTE) SeLcl );
        SET_PARAM(wDOutput, (GTI_BYTE) DLcl );
    }
    /* -----   new algorithm ----- */
    else
    {
        /* Set R and N */
        RLcl = 16;
        if((bStreamDir == GTI_UP_STREAM)&&(bRmtInterface == 0))
          wNTmp = 128;
        else
          wNTmp = 256;
        if (wCeInput == GTI_RS_INT_CORRECT_ENHANCED)   /* enhanced impulse protection */
          wNTmp = 128;

        /* set min S and max D */
        bSMin = 1;
        if (bStandard == GTI_G_LITE_STANDARD)
        {
            RLcl = 16;     /* R = 0,4,8,16 for lite */
            if ((bStreamDir == GTI_DOWN_STREAM)&&(wDMaxInput > 16))
                wDMaxInput = 16;
        }
      /* Set max Se  */
        switch (RLcl)
        {
        case 2:
        case 6:
        case 10:
        case 14:
            SLcl = 2;
            break;
        case 4:
        case 12:
            SLcl = 4;
            break;
        case 8:
            SLcl = 8;
            break;
        case 0:
        case 16:
            SLcl = 16;
            break;
        default:
            SLcl = 2;
            break;
        }
        bDelay = 0;
        /* require delay */
        if (wDeInput<=0x0f)
        {
            bDelay = (GTI_BYTE)(1<<(wDeInput-2));
            if (SLcl > bDelay*4 )
                SLcl = (GTI_WORD)(bDelay*4);
        }
        
        /* Search S based on code word N */
        while ( ((wKiInput*SLcl + RLcl) > wNTmp) && (SLcl >bSMin))
            SLcl = (GTI_WORD)(SLcl/2);

        if (SLcl == 0)
        {
            DLcl = (GTI_WORD)(bDelay*4*2);
            RLcl = 16;   /* R/S in c_rates1*/
            SET_PARAM(wSOutput, (GTI_BYTE) 0 );
        }
        else
        {
            DLcl = (GTI_WORD)(bDelay*4/SLcl);
            RLcl = (GTI_WORD)(RLcl/SLcl);        /* R/S in c_rates1*/
            SET_PARAM(wSOutput, (GTI_BYTE) SLcl );
        }

        /*if ((wCeInput != GTI_RS_INT_CORRECT_ENHANCED)||(bSMin ==1))*/
        if((wKiInput <= 253) && ((wKiInput + RLcl) > 255))
        {
                RLcl = (GTI_WORD)(( ( 255 - wKiInput) / 2) * 2 );
                SET_PARAM(wSOutput, (GTI_BYTE) 1 );
                DLcl = (GTI_WORD)(bDelay*4);
        }
        /* require interleave depth */
        if (wDeInput > 0x0f)
        {
            DLcl = (GTI_WORD)(1<< (wDeInput&0xf));
        }
            
        /* Compare D */
        if(DLcl > wDMaxInput)
            DLcl = wDMaxInput;
        SET_PARAM(wRSOutput, (GTI_BYTE) RLcl);
        SET_PARAM(wDOutput, (GTI_BYTE) DLcl );
    }   /* end of new algorithm */

    if (DLcl == 256)
        SET_PARAM(wSOutput, (GTI_BYTE)( SLcl + 64) );

    return (GTI_OK);
}

/******************************************************************************/
/* Procedure: Gti_rsIntKCalcLITE                            Created: 31.05.99 */
/* ------------------------                                                   */
/* Returns GTI_WORD                                                           */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_rsIntKCalcLITE(GTI_BYTE *lclParamDB,
                   GTI_WORD wCeInput, GTI_WORD wDeInput, GTI_WORD wKiInput,
                   GTI_WORD wDMaxInput,
                   GTI_WORD wRSOutput, GTI_WORD wSOutput, GTI_WORD wDOutput)
{
    GTI_WORD shftTmp, DeLcl, SeLcl, RLcl, DLcl;

    /* check for disabled */
    if(wCeInput == GTI_DISABLE_RS)
    {
        SET_PARAM(wRSOutput, 0);
        SET_PARAM(wSOutput, 1);
        SET_PARAM(wDOutput, 1);
        return (GTI_OK) ;
    }

    /* check for no data */
    if(wKiInput < 2)
    {
        SET_PARAM(wRSOutput, 2);
        SET_PARAM(wSOutput, 1);
        SET_PARAM(wDOutput, 1);
        return (GTI_OK) ;
    }

    if(wCeInput & 0xff00)
    {
        SET_PARAM(wRSOutput,(GTI_BYTE) wCeInput);
        SET_PARAM(wSOutput, (GTI_BYTE) wDeInput);
        SET_PARAM(wDOutput, (GTI_BYTE) (wDeInput >> 0x08));
        return (GTI_OK) ;
    }

    /* Input Check rules */
    if(( wKiInput < 2) || ( wKiInput > 253))
        return (0xffff) ;
    if(wCeInput > 8)
        return (0xfffe) ;
    if(wDeInput > 8)
        return (0xfffd) ;

    if(wCeInput > ( wDeInput + 2))
        wCeInput = (GTI_WORD)( wDeInput + 2);

    SeLcl = 0 ;

    DeLcl = (GTI_WORD)(wDeInput - SeLcl);
    while ( DeLcl & 0x8000)
    {
        DeLcl = (GTI_WORD)(DeLcl + 1);
        SeLcl = (GTI_WORD)(SeLcl - 1);
    }

    RLcl = (GTI_WORD)(( wKiInput << ( SeLcl + wCeInput)) / ( ( 0x01 << (wDeInput+3)) - ( 0x01 << wCeInput)));
    if(( ( RLcl >> SeLcl) << SeLcl) != RLcl)
        RLcl = (GTI_WORD)(( (RLcl + 1) >> SeLcl) << SeLcl);

    if(RLcl < 2)
    {
        if(SeLcl > 0)
            RLcl = (GTI_WORD)(0x01 << SeLcl);
        else
            RLcl = 2 ;
    }

    while ( ( SeLcl > 0) && ( ( ( wKiInput << SeLcl) + RLcl) > 249))
    {
        SeLcl = (GTI_WORD)(SeLcl - 1);
        DeLcl = (GTI_WORD)(DeLcl + 1);
        RLcl = (GTI_WORD)(( ( RLcl + 2) / 4) * 2 );
    }

    if(RLcl > 16)
    {
        if(( RLcl > 22) &&( SeLcl > 0))
        {
            SeLcl = (GTI_WORD)(SeLcl - 1);
            DeLcl = (GTI_WORD)(DeLcl + 1);
        }
        RLcl = 16 ;
    }

    if(( ( RLcl >> SeLcl) << SeLcl) != RLcl)
        RLcl = (GTI_WORD)(( RLcl >> SeLcl) << SeLcl);

    if(RLcl < 2)
    {
        if(SeLcl == 0)
            RLcl = 2 ;
        else
            RLcl = (GTI_WORD)(0x01 << SeLcl);
    }

    /* check to see if delay too long */
    shftTmp = (GTI_WORD)(DeLcl + SeLcl - wCeInput + 3);
    while ( ( shftTmp > 7) || ( ( RLcl << shftTmp) / ( ( ( ( wKiInput << SeLcl) + RLcl) * 3) / 2)))
    {
        if(DeLcl > 0)
            DeLcl =  (GTI_WORD)(DeLcl - 1);
        else
        if(( SeLcl > 0) && ( RLcl > 2))
        {
            SeLcl = (GTI_WORD)(SeLcl - 1);
            RLcl = (GTI_WORD)(RLcl / 2);
        }
        else
            break ; /* Sorry, nothing I could do */

        shftTmp = (GTI_WORD)(DeLcl + SeLcl - wCeInput + 3);
    }

    if(( DeLcl == 0) && ( SeLcl > 0))
    {
        if(RLcl > 2)
        {
            RLcl = (GTI_WORD)(( RLcl >> 2) << 0x01);
            SeLcl = (GTI_WORD)(SeLcl - 1);
            DeLcl = 1 ;
        }
        else
            SeLcl = 0 ;
    }

    RLcl = (GTI_WORD)(( ( RLcl + 1) / 2) * 2 );

    DLcl =  (GTI_WORD)(0x01 << DeLcl);
    if(DLcl > wDMaxInput)
    {
        while ( DLcl > wDMaxInput)
        {
            DLcl = (GTI_WORD)(DLcl >> 0x01);
            DeLcl = (GTI_WORD)(DeLcl - 1);

            if(( ( wKiInput << SeLcl) + (2 * RLcl)) < 256)
            {
                RLcl = (GTI_WORD)(RLcl << 0x01) ;
                if(RLcl > 16)
                    RLcl = 16;
            }
        }
    }

    /* can only happen if SeLcl = 0 */
    if(( wKiInput + RLcl) > 255)
        RLcl = (GTI_WORD)(( ( 255 - wKiInput) / 2) * 2 );

    SET_PARAM(wRSOutput,(GTI_BYTE)(RLcl >> SeLcl));
    SET_PARAM(wSOutput, (GTI_BYTE)( 0x01 <<SeLcl));
    SET_PARAM(wDOutput, (GTI_BYTE)DLcl);

    return (GTI_OK);
}

/******************************************************************************/
/* Procedure: Gti_rsFastKCalcAnnC           Created: Copied dmthvyccp 1.73    */
/* ------------------------                                                   */
/* Returns GTI_WORD                                                           */
/* -------------------------------------------------------------------------- */

GTI_WORD
Gti_rsFastKCalcAnnC(GTI_BYTE *lclParamDB,
            GTI_BYTE bFrmStruct, GTI_WORD wOvrHead,
            GTI_WORD wKfInput, GTI_WORD wRSOutput)
{

    GTI_WORD RLcl ;

    /* check for disabled */
    if(wOvrHead == GTI_DISABLE_RS)
    {
        SET_PARAM(wRSOutput, 0);
        return (GTI_OK) ;
    }

    /* check for no data */
    if(bFrmStruct == 3)
    {
        if(wKfInput < 2)
        {
            SET_PARAM(wRSOutput, 0);
            return (GTI_OK) ;
        }
    }
    else
    {
        if(wKfInput < 2)
        {
            SET_PARAM(wRSOutput, 2);
            return (GTI_OK) ;
        }
    }

    if(wOvrHead & 0xff00)
    {
        SET_PARAM(wRSOutput, (GTI_BYTE)wOvrHead);
        return (GTI_OK) ;
    }

   /* Input Check rules */
    if(wKfInput > 253)
        return (0xffff) ;

    if(( wOvrHead < 1) || ( wOvrHead > 7))
        return(0xfffe) ;

    RLcl = (GTI_WORD) (wKfInput /  ( ( 1 << wOvrHead) - 1)) ;
    RLcl = (GTI_WORD)(( ( RLcl + 1) >> 0x01) << 0x01 );


    if(RLcl < 2)
        RLcl = 4 ;

    if(RLcl > 16)
        RLcl = 16 ;

    if(( RLcl + wKfInput) > 255)
    {
        RLcl = (GTI_WORD)(255 - wKfInput) ;
        RLcl = (GTI_WORD)(( RLcl >> 0x01) << 0x01) ;
    }

    /* if data rate is 32 kbps + 32 kbps overhead, then make R = 0,     */
    /* this is to make a patch for prebuffering issue when user rate    */
    /* is 3 bytes/symbol.                                               */
    if (wKfInput == 2)
    {
                RLcl = 0;        /* R = 0 */
    }

    SET_PARAM(wRSOutput, (GTI_BYTE) RLcl);
    return (GTI_OK) ;
}

GTI_WORD
Gti_rsIntKCalcAnnC(GTI_BYTE *lclParamDB,
           GTI_BYTE bStreamDir, GTI_BYTE bRmtInterface,
           GTI_BYTE bFrmStruct, GTI_WORD wCeInput,
           GTI_WORD wDeInput, GTI_WORD wKiInput, GTI_WORD wDMaxInput,
           GTI_WORD wRSOutput, GTI_WORD wSOutput, GTI_WORD wDOutput)
{
    GTI_WORD shftTmp;
    GTI_WORD DeLcl;
    GTI_WORD SeLcl;
    GTI_WORD RLcl;
    GTI_WORD DLcl;

    /* check for disabled */
    if(wCeInput == GTI_DISABLE_RS)
    {
        SET_PARAM(wRSOutput, 0);
        SET_PARAM(wSOutput, 1);
        SET_PARAM(wDOutput, 1);
        return (GTI_OK) ;
    }

    /* check for no data */
    if(bFrmStruct == 3)
    {

        if(wKiInput < 2)
        {
            SET_PARAM(wRSOutput, 0);
            SET_PARAM(wSOutput, 1);
            SET_PARAM(wDOutput, 1);
            return (GTI_OK) ;
        }
    }
    else
    {
        if(wKiInput < 2)
        {
            SET_PARAM(wRSOutput, 2);
            SET_PARAM(wSOutput, 1);
            SET_PARAM(wDOutput, 1);
            return (GTI_OK) ;
        }
    }

    if(wCeInput & 0xff00)
    {
        SET_PARAM(wRSOutput, (GTI_BYTE) wCeInput);
        SET_PARAM(wSOutput, (GTI_BYTE) wDeInput);
        SET_PARAM(wDOutput, (GTI_BYTE) (wDeInput>> 0x08));
        return(GTI_OK) ;
    }

    /* Input Check rules */
    if(( wKiInput < 2) || ( wKiInput > 253))
        return (0xffff) ;
    if(wCeInput > 8)
        return (0xfffe) ;
    if(wDeInput > 8)
        return (0xfffd) ;

    SeLcl = 0 ;
    if((bStreamDir == 0)&&(bRmtInterface == 0))
    {
        while ( ( ( wKiInput<<SeLcl) < 64) && ( SeLcl < 4))
             ++SeLcl;
    }
    else
    {
        while ( ( ( wKiInput<<SeLcl) < 128) && ( SeLcl < 4))
            ++SeLcl;
    }

    DeLcl = (GTI_WORD)(wDeInput - SeLcl) ;
    while ( DeLcl & 0x8000)
    {
        DeLcl = (GTI_WORD) (DeLcl + 1) ;
        SeLcl = (GTI_WORD) (SeLcl - 1) ;
        if (SeLcl == 0)
                { SeLcl = 1; }   /* force S >1 -libin */
    }

    RLcl = (GTI_WORD)(( wKiInput << ( SeLcl + wCeInput)) / ( (1<<(wDeInput+3)) - (1<<wCeInput))) ;
    if(( ( RLcl >> SeLcl) << SeLcl) != RLcl)
        RLcl = (GTI_WORD)(( (RLcl + 1) >> SeLcl) << SeLcl) ;

    if(RLcl < 2)
    {
        if(SeLcl > 0)
            RLcl = (GTI_WORD) (0x1 << SeLcl) ;
        else
            RLcl = 2 ;
    }

    while ( ( SeLcl > 1) && ( ( ( wKiInput << SeLcl) + RLcl) > 249))
    {
        SeLcl = (GTI_WORD)(SeLcl - 1) ;
        DeLcl = (GTI_WORD)(DeLcl + 1) ;
        RLcl = (GTI_WORD)((( RLcl + 2) / 4) * 2) ;
    }

    if(RLcl > 16)
    {
        if(( RLcl > 60) &&( SeLcl > 1))
        {
             SeLcl = (GTI_WORD) (SeLcl - 1) ;
             DeLcl = (GTI_WORD) (DeLcl + 1) ;
        }
        RLcl = 16 ;
    }

    if(( ( RLcl >> SeLcl) << SeLcl) != RLcl)
        RLcl = (GTI_WORD)(( RLcl >> SeLcl) << SeLcl) ;

    if(RLcl < 2)
    {
        if(SeLcl == 0)
            RLcl = 2 ;
        else
            RLcl = (GTI_WORD)(1 << SeLcl) ;
    }

    /* check to see if delay too long */
    shftTmp = (GTI_WORD)(DeLcl + SeLcl - wCeInput + 3 );
    while ( ( shftTmp > 7) || ( ( RLcl << shftTmp) / ( ( ( ( wKiInput << SeLcl) + RLcl) * 3) / 2)))
    {
        if(DeLcl > 0)
            DeLcl = (GTI_WORD)(DeLcl - 1) ;
        else
        if(( SeLcl > 1) && ( RLcl > 2))
        {
            SeLcl = (GTI_WORD)(SeLcl - 1) ;
            RLcl = (GTI_WORD)(RLcl / 2) ;
        }
        else
            break ; /* Sorry, nothing I could do */

        shftTmp = (GTI_WORD)(DeLcl + SeLcl - wCeInput + 3) ;
    }

    if(( DeLcl == 0) && ( SeLcl > 1))
    {
        if(RLcl > 2)
        {
             RLcl = (GTI_WORD)(( RLcl >> 0x02) << 0x01) ;
             SeLcl = (GTI_WORD)(SeLcl - 1) ;
             DeLcl = 1 ;
        }
        else
            SeLcl = 1 ;
    }

    RLcl = (GTI_WORD)(( ( RLcl + 1) / 2) * 2) ;

    DLcl = (GTI_WORD)(1<<DeLcl) ;
    if(DLcl > wDMaxInput)
    {
        while ( DLcl > wDMaxInput)
        {
            DLcl = (GTI_WORD)(DLcl>>1) ;
            DeLcl = (GTI_WORD)(DeLcl - 1) ;
            if(( ( wKiInput << SeLcl) + (2* RLcl)) < 256)
            {
                RLcl = (GTI_WORD)(RLcl<<0x01);
                if(RLcl > 16)
                    RLcl = 16;
            }
        }
    }

    /* minimum R is 4, for NEC  -- dliu */
    if (RLcl == 2)
        RLcl = 4;

    /* can only happen if SeLcl = 0 */
    if(( wKiInput + RLcl) > 255)
        RLcl = (GTI_WORD)(( ( 255 - wKiInput) / 2) * 2) ;

    /* if data rate is 32 kbps + 32 kbps overhead, then make R = 0,     */
    /* this is to make a patch for prebuffering issue when user rate    */
    /* is 3 bytes/symbol.                                               */
    if (wKiInput == 2)
    {
                RLcl = 0;        /* R = 0 */
                SeLcl = 0;       /* S = 1 */
                DLcl = 1;        /* D = 1 */
    }

    SET_PARAM(wSOutput, (GTI_BYTE)(1<<SeLcl) );
    SET_PARAM(wDOutput, (GTI_BYTE)DLcl);

    if (DLcl == 256)
    {
        SET_PARAM(wSOutput, (GTI_BYTE)(1<<SeLcl) + 64);
    }

    SET_PARAM(wRSOutput, (GTI_BYTE)(RLcl >> SeLcl));

    /*
    D = DLcl ;
    */

    return (GTI_OK);
}


#ifdef GTI_DSPQUAD
/****************************************************************/
/* Name: Gti_UtopiaEnableOddAddress                             */
/* Usage: Enable Odd Address                                    */
/* Should be called whenever DSP chip is "Reset/Powerup"        */
/* Should be called after InitXCVR                              */
/****************************************************************/
void
Gti_UtopiaEnableOddAddress( GTI_XCVR_INFO *pXcvrInfo )
{
    WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_79, 0xaa);
    UPDATE_DSP(pXcvrInfo);
}

/****************************************************************/
/* Name: Gti_UtopiaEnableOddEvenOddEvenAddress                  */
/* Usage: Enable Odd-Even-Odd-Even Address                      */
/* Should be called whenever DSP chip is "Reset/Powerup"        */
/* Should be called after InitXCVR                              */
/****************************************************************/
void
Gti_UtopiaEnableOddEvenOddEvenAddress( GTI_XCVR_INFO *pXcvrInfo )
{
    WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_79, 0x55);
    UPDATE_DSP(pXcvrInfo);
}


/****************************************************************/
/* Name: Gti_UtopiaSetExtAddress                                */
/* Usage: Sets Extended Utopia Address                          */
/****************************************************************/
void
Gti_UtopiaSetExtAddress( GTI_XCVR_INFO *pXcvrInfo, GTI_BYTE pData)
{

#if defined(GTI_USE_DMAXFR)
    WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_7C,0x0f);

    if(pXcvrInfo->pChipInfo->XCVR_db[0]->paramsBA == (GTI_LBUS_RW_START_ADDR >> 0x08))
        WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_7D, (GTI_BYTE)((pData&0x0f)| 0xc0));
    else
        WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_7D,(GTI_BYTE)(pData&0x0f));
#else
    WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_7C,0x0f);
    WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_7D,(GTI_BYTE)(pData&0x0f));
#endif
}

#endif /* GTI_DSPQUAD */

/******************************************************************************/
/* Procedure: Gti_ParamSetIO                                Created: 31.05.00 */
/* ------------------------                                                   */
/* Description: The procedure sets Parameters IO.                             */
/* Returns VOID                                                               */
/* -------------------------------------------------------------------------- */
void
Gti_ParamSetIO( GTI_XCVR_INFO *pXcvrInfo, GTI_WORD interfaceType)
{
    struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL *RegPtr;

    switch( interfaceType)
    {
    case GTI_SERIAL_IO:
        RegPtr = &SerialRegTable[0];
        break;
    case GTI_LEVEL1_IO:
        RegPtr = &Level1RegTable[0];
        break;
    case GTI_LEVEL2_IO:
        RegPtr = &Level2RegTable[0];
        break;
    case GTI_GLUELESS_SAR_IO:
    default:
        RegPtr = &GluelessSARRegTable[0];
        break;
    }

    Gti_RegInit(pXcvrInfo, RegPtr);
    UPDATE_DSP(pXcvrInfo);
}
/******************************************************************************/
/* Procedure: Gti_SelectBinUsage                            Created: 04.06.01 */
/* ------------------------                                                   */
/* Description:  This API allows customers to Select custom Bin usage         */
/* Scope: Can only be called when XCVR is in IDLE state                       */
/*        Bin selection is effective at next startup request                  */
/*        Must set item "GTI_USE_CUSTOM_BINS_ITEM" = GTI_ENABLE when          */
/*        requesting startup                                                  */
/*                                                                            */
/*        This API MUST be called prior to EVERY startup where custom bin     */
/*        is wanted                                                           */
/* Input:                                                                     */
/*         pXcvrInfo - pointer to XCVR selected                               */
/*         binSelect - pointer to 32 byte array where a "1" in bit position   */
/*                     use corresponding bin                                  */
/* Returns GTI_WORD                                                           */
/*         GTI_FAIL - call not allowed at this time                           */
/*         GTI_OK   - next startup will use Bin Selection                     */
/*                    If selected via item "GTI_USE_CUSTOM_BINS_ITEM"         */
/*                                                                            */
/* Caveat: This data is overwritten during datamode initiation                */
/*         Therefor customer must re-init selection by calling this API       */
/*         prior to EVERY Startup Request.                                    */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_SelectBinUsage( GTI_XCVR_INFO *pXcvrInfo, GTI_BYTE *binSelect  )
{
     GTI_WORD result;
     GTI_WORD i;
     GTI_WORD dspState = 0;

     result = GTI_OK;

     /* Only allowed to execute if not in data mode and SAS is not active */
     if( !Gti_IsCXfrActive(pXcvrInfo))
     {
         /* Check for IDLE state */
         (void)Gti_SStatusXCVR( pXcvrInfo, GTI_OP_STATE, &dspState, sizeof(dspState), 0 );
         if( dspState == GTI_IDLE_OP)
         {
             CONFIGURE_DSP( pXcvrInfo, GTI_DSP_A, GTI_AP );
             WRITE_DSP_ADDR( pXcvrInfo, GTI_DSP_A, 0x00, GTI_FDPSRAMD );
             WRITE_DSP_BYTE( pXcvrInfo, GTI_DSP_A, GTI_EXT_DATA_DSP, 0x00 );
             for (i=0; i<=30; i+=2)
             {
                 WRITE_DSP_WORD( pXcvrInfo, GTI_DSP_A, *(binSelect+i), *(binSelect+i+1) );
             }

         }else
         {
             result = GTI_FAIL;
         }

     }else
     {
          result = GTI_FAIL;
     }

     return(result);
}
/******************************************************************************/
/* Procedure: Gti_RegInit                                   Created: 31.05.00 */
/* ------------------------                                                   */
/* Description: The procedure initializes the Registers from the tables.      */
/* Returns VOID                                                               */
/* -------------------------------------------------------------------------- */
void
Gti_RegInit( GTI_XCVR_INFO *pXcvrInfo,
            struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL *RegPtr)
{
    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AI);

    for(; RegPtr->reg_space != GTI_EOT; RegPtr++)
    {
        switch(RegPtr->reg_space)
        {
        case GTI_DSP_DMA:
            WRITE_DSP_REG(pXcvrInfo,
                RegPtr->reg_num, RegPtr->value_low);
            break;

        case GTI_DSP_A:
            WRITE_DSP_ADDR(pXcvrInfo,GTI_DSP_A,
                RegPtr->reg_num, GTI_IREGA);

            WRITE_DSP_WORD(pXcvrInfo,GTI_DSP_A,
                RegPtr->value_low, RegPtr->value_high);
            break;
        default:
            break;
        }
    }

    UPDATE_DSP(pXcvrInfo);
}

/**************PARAMETRIC TESTING CODE***************************************/
/****************************************************************************/
/* Description: This file contains source code designed to implement        */
/*              parametric testing of the analog front end (AFE) of a       */
/*              GlopeSpan Transceiver.  Warning:  The customer needs to     */
/*              implement a time out in their calling routine (~2sec), in   */
/*              case the DSP hangs.                                         */
/*              Otherwise they may get stuck in an infinite loop.           */
/****************************************************************************/

/***************************************************************************************/
/* Procedure    : Gti_Rcv_Linearity                         Created: 21.08.00          */
/* ------------------------                                                            */
/* Description : This function measures the noise in a notched bin from an             */
/*               externally supplied MTPR input waveform.  The DSP measures            */
/*               the noise in a user specified notch bin. The DSP uses the             */
/*               power in the adjacent bins for the SIGNAL measurement in              */
/*               calculating the SNR value.  The SNR is compared to the user           */
/*               specified threshold(in dB) and a PASS/FAIL is returned.  The          */
/*               user should continue to poll this function until the returned         */
/*               value of GTI_TEST_BUSY changes to something else.                     */
/*                                                                                     */
/* Arguments   :pSysInfo   is a pointer to the transceiver system being accessed.      */
/*              pRcvPwr    is a pointer to an array where to store the power           */
/*                         results of the 256 bins (needs to be 256 * 4 = 1024 bytes). */
/*              wSnrThrshld  is a User specified SNR threshold (in 10*dB) for comparing*/
/*                         results of test. If the calculated SNR is below this        */
/*                         threshold, the test fails.                                  */
/*              wNotchBin  is the bin number to use for the noise measurement.         */
/*                                                                                     */
/* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is   */
/*               complete, the function will return GTI_TEST_PASS if the test passed or*/
/*               GTI_TEST_FAIL.  In the case of some sort of an error, the function    */
/*               will return GTI_TEST_ERROR.                                           */
/*                                                                                     */
/* Note: GTI_TEST_CODE ifdef is not for customer use!!!                                */
/* Reference   : none                                                                  */
/***************************************************************************************/
GTI_WORD Gti_Rcv_Linearity(GTI_XCVR_INFO *pSysInfo,
                           void        *pRcvPwr,
                           GTI_WORD    wSnrThrshld,
                           GTI_WORD    wNotchBin
                           )
{
    GTI_WORD test_status;                        /* Current Test Results */
#ifdef GTI_TEST_CODE
    static GTI_WORD first_time = GTI_TRUE;

    if ( first_time)
    {
        DisplayMsg("\r\nRcv Linearity Starting....\r\n");
        first_time = GTI_FALSE;
    }
#endif

    test_status = LocalStateMachine(pSysInfo);
    if ( test_status == GTI_TEST_DONE)
    {
        test_status = CalcTestResult(pSysInfo, TEST_RCV_LINEARITY,
            (GTI_DWORD)wSnrThrshld, &wNotchBin, NULL, NULL, 1, (GTI_BYTE *)(pRcvPwr));
    }
    return test_status;
}


/***************************************************************************************/
/* Procedure    : Gti_Rcv_Filter                            Created: 21.08.00          */
/* ------------------------                                                            */
/* Description : This function causes the DSP to measure the power received from an    */
/*               externally supplied multi-tone waveform and validates that the power  */
/*               in user specified bins are within a user specified range given by     */
/*               pRcvRef +/- wRcvTol.  The user should continue to poll this function  */
/*               until the returned value of GTI_TEST_BUSY changes to something        */
/*               else.                                                                 */
/* Arguments   : pSysInfo     is a pointer to the transceiver system being accessed.   */
/*               pRcvPwr      is a pointer to an array where to store the power results*/
/*                            of the 256 bins (needs to be 256 * 4 = 1024 bytes).      */
/*               pRcvBins     is a pointer to an array containing the bin numbers for  */
/*                            the power measurement.  The bins can be 0x01-0xFF.       */
/*               wBinLength   length(in bytes) of the array that pRcvBins points to.   */
/*               pRcvMin      is a pointer to an array containing the min. power levels*/
/*                            for the bins can have. Power can be 0x0000-0xFFFF:FFFF.  */
/*               pRcvMax      is a pointer to an array containing the max. power levels*/
/*                            for the bins can have. Power can be 0x0000-0xFFFF:FFFF.  */
/*               wRefLength   is the length(in bytes) of the arrays that pRcvmin &     */
/*                            pRcvMax point to.                                        */
/*                                                                                     */
/* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is   */
/*               complete, the function will return GTI_TEST_PASS if the test passed or*/
/*               GTI_TEST_FAIL. In the case of some sort of an error, the function will*/
/*               return GTI_TEST_ERROR.                                                */
/* Reference   : none                                                                  */
/***************************************************************************************/
GTI_WORD Gti_Rcv_Filter(GTI_XCVR_INFO *pSysInfo,
                        void        *pRcvPwr,
                        void *      pRcvBins,
                        GTI_WORD    wBinLength,
                        void *      pRcvMin,
                        void *      pRcvMax,
                        GTI_WORD    wRefLength)
{
    GTI_WORD test_status;                        /* Current Test Results */

#ifdef GTI_TEST_CODE
    static GTI_WORD first_time = GTI_TRUE;

    if ( first_time)
    {
        DisplayMsg("\r\nRcv Filter Starting....\r\n");
        first_time = GTI_FALSE;
    }
#endif

    wRefLength = wRefLength;

    test_status = LocalStateMachine(pSysInfo);
    if ( test_status == GTI_TEST_DONE)
    {
        test_status = CalcTestResult(pSysInfo, TEST_RCV_FILTER, 0,
            (GTI_WORD*)pRcvBins, (GTI_DWORD*)pRcvMin, (GTI_DWORD*)pRcvMax,
            (GTI_WORD)(wBinLength/sizeof(GTI_WORD)), (GTI_BYTE *)(pRcvPwr) );
    }

    return test_status;
}


/***************************************************************************************/
/* Procedure    : Gti_Rcv_Power_Per_Bin                     Created: 21.08.00          */
/* ------------------------                                                            */
/* Description : This function causes the DSP to measure the power received in each    */
/*               bin.  The user should continue to poll this function until the        */
/*               returned value of GTI_TEST_BUSY changes to something else.            */
/* Arguments   : pSysInfo     is a pointer to the transceiver system being accessed.   */
/*               pRcvPwr      is a pointer to an array where to store the power results*/
/*                            of the 256 bins (needs to be 256 * 4 = 1024 bytes).      */
/* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is   */
/*               complete, the function will return GTI_TEST_PASS if everything was    */
/*               sucessful.  In the case of some                                       */
/*               sort of an error, the function will return GTI_TEST_ERROR.            */
/* Reference   : none                                                                  */
/***************************************************************************************/
GTI_WORD Gti_Rcv_Power_Per_Bin(GTI_XCVR_INFO *pSysInfo,
                               void        *pRcvPwr)
{
    GTI_WORD test_status;                        /* Current Test Results */
#ifdef GTI_TEST_CODE
    static GTI_WORD first_time = GTI_TRUE;

    if ( first_time)
    {
        DisplayMsg("\r\nRcv Power Per Bin...\r\n");
        first_time = GTI_FALSE;
    }
#endif


    test_status = LocalStateMachine(pSysInfo);
    if ( test_status == GTI_TEST_DONE)
    {
        test_status = CalcTestResult(pSysInfo, TEST_RCV_PWR_PBIN, 0, NULL,
            NULL, NULL, 0, (GTI_BYTE *)(pRcvPwr) );
    }

    return test_status;
}


/***************************************************************************************/
/* Procedure    : Gti_Total_Idle_Noise                      Created: 21.08.00          */
/* ------------------------                                                            */
/* Description : This function causes the DSP to measure the total received power and  */
/*               compares it to a user suppplied threshold value.  The user should     */
/*               continue to poll this function until the returned value of            */
/*               GTI_TEST_BUSY changes to something else.                              */
/*                                                                                     */
/* Arguments   : pSysInfo     is a pointer to the transceiver system being accessed.   */
/*               pRcvPwr      is a pointer to an array where to store the power results*/
/*                            of the 256 bins (needs to be 256 * 4 = 1024 bytes).      */
/*               wBinStart    is the starting bin number to use in making measurements.*/
/*               wBinEnd      is the last bin number to use in making measurements.    */
/*               wPwrThrshld  is the user specified power threshold.                   */
/*                                                                                     */
/* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is   */
/*               complete, the function will return GTI_TEST_PASS if the test passed or*/
/*               GTI_TEST_FAIL.  In the case of some sort of error, the function will  */
/*               return GTI_TEST_ERROR.                                                */
/*                                                                                     */
/* Reference   : none                                                                  */
/***************************************************************************************/
GTI_WORD Gti_Total_Idle_Noise(GTI_XCVR_INFO *pSysInfo,
                              void          *pRcvPwr,
                              GTI_WORD      wBinStart,
                              GTI_WORD      wBinEnd,
                              GTI_DWORD     wPwrThrshld)
{
    GTI_WORD test_status;                        /* Current Test Results */
    GTI_WORD bins[2];
#ifdef GTI_TEST_CODE
    static GTI_WORD first_time = GTI_TRUE;

    if ( first_time)
    {
        DisplayMsg("\r\nTotal Idle Noise Starting....\r\n");
        first_time = GTI_FALSE;
    }
#endif


    test_status = LocalStateMachine(pSysInfo);
    if ( test_status == GTI_TEST_DONE)
    {
        bins[0] = wBinStart;
        bins[1] = wBinEnd;
        test_status = CalcTestResult(pSysInfo, TEST_TOTAL_IDLE_NOISE, wPwrThrshld, bins,
            NULL, NULL, 0, (GTI_BYTE *)(pRcvPwr) );
    }

    return test_status;
}


/***************************************************************************************/
/* Procedure    : Gti_Per_Bin_Idle_Noise                    Created: 21.08.00          */
/* ------------------------                                                            */
/*                                                                                     */
/* Description : This function causes the DSP to measure the received power per bin and*/
/*               compares it to a user suppplied threshold value.  The user should     */
/*               continue to poll this function until ther eturned value of            */
/*               GTI_TEST_BUSY changes to something else.                              */
/*                                                                                     */
/* Arguments   : pSysInfo      is a pointer to the transceiver system being accessed.  */
/*               pRcvPwr       is a pointer to an array where to store the power       */
/*                             results of the 256 bins (needs to be 256*4=1024 bytes). */
/*               wBinStart     is the starting bin number to use in making measurements*/
/*               wBinEnd       is the last bin number to use in making measurements.   */
/*               wNoiseThrshld is the user specified power threshold.                  */
/*                                                                                     */
/* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is   */
/*               complete, the function will return GTI_TEST_PASS if the test passed or*/
/*               GTI_TEST_FAIL.  In the case of some sort of error, the function will  */
/*               return GTI_TEST_ERROR.                                                */
/*                                                                                     */
/* Reference   : none                                                                  */
/***************************************************************************************/
GTI_WORD Gti_Per_Bin_Idle_Noise(GTI_XCVR_INFO *pSysInfo,
                                void          *pRcvPwr,
                                GTI_WORD      wBinStart,
                                GTI_WORD      wBinEnd,
                                GTI_DWORD     wNoiseThrshld)
{
    GTI_WORD test_status;                        /* Current Test Results */
    GTI_WORD bins[2];
#ifdef GTI_TEST_CODE
    static GTI_WORD first_time = GTI_TRUE;

    if ( first_time)
    {
        DisplayMsg("\r\nPer Bin Idle Noise Starting....\r\n");
        first_time = GTI_FALSE;
    }
#endif


    test_status = LocalStateMachine(pSysInfo);
    if ( test_status == GTI_TEST_DONE)
    {
        bins[0] = wBinStart;
        bins[1] = wBinEnd;
        test_status = CalcTestResult(pSysInfo, TEST_PBIN_IDLE_NOISE, wNoiseThrshld, bins,
            NULL, NULL, 0, (GTI_BYTE *)(pRcvPwr) );
    }

    return test_status;
}


/***************************************************************************************/
/* Procedure    : Gti_Hybrid_Loss                           Created: 21.08.00          */
/* ------------------------                                                            */
/*                                                                                     */
/* Description : This function causes the DSP to transmit REVERB for bins 1-255 with no*/
/*               cyclic prefix. It then measures the received echo power for each bin. */
/*               A user specified window will be used to validate the received power   */
/*               envelope for the specified bins.  The user should continue to poll    */
/*               this function until the returned value of GTI_TEST_BUSY changes to    */
/*               something else.                                                       */
/*                                                                                     */
/* Arguments   : pSysInfo     is a pointer to the transceiver system being accessed.   */
/*               pRcvPwr      is a pointer to an array where to store the power results*/
/*                            of the 256 bins (needs to be 256 * 4 = 1024 bytes).      */
/*               wTestStart   is the starting bin number to use in making measurements.*/
/*               wTestEnd     is the last bin number to use in making measurements.    */
/*               pHybMin      is a pointer to an array containing min. power levels    */
/*                            that the bins can have.                                  */
/*                            The power can be 0x0000-0xFFFF:FFFF.                     */
/*               pHybMax      is a pointer to an array containing max. power levels    */
/*                            that the bins can have.                                  */
/*                            The power can be 0x0000-0xFFFF:FFFF.                     */
/*               wRefLength   is the length of the arrays(in bytes) that pHybmin &     */
/*                            pHybMax point to.                                        */
/*                                                                                     */
/* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is   */
/*               complete, the function will return GTI_TEST_PASS if the test passed or*/
/*               GTI_TEST_FAIL.  In the case of some sort of error, the function will  */
/*               return GTI_TEST_ERROR.                                                */
/*                                                                                     */
/* Reference   : none                                                                  */
/***************************************************************************************/
GTI_WORD Gti_Hybrid_Loss(GTI_XCVR_INFO *pSysInfo,
                         void        *pRcvPwr,
                         GTI_WORD    wTestStart,
                         GTI_WORD    wTestEnd,
                         void *      pHybMin,
                         void *      pHybMax,
                         GTI_WORD    wRefLength)
{
    GTI_WORD test_status;                        /* Current Test Results */
    GTI_WORD bin_length;                        /* Number of Bins used in measurement */
#ifdef GTI_TEST_CODE
    static GTI_WORD first_time = GTI_TRUE;

    if ( first_time)
    {
        DisplayMsg("\r\nHybrid Loss....\r\n");
        first_time = GTI_FALSE;
    }
#endif

    wRefLength = wRefLength;

    test_status = LocalStateMachine(pSysInfo);
    if ( test_status == GTI_TEST_DONE)
    {

        bin_length = (GTI_WORD)(wTestEnd - wTestStart + 1);
        test_status = CalcTestResult(pSysInfo, TEST_HYBRID_LOSS, 0, &wTestStart, (GTI_DWORD*)pHybMin,
            (GTI_DWORD*)pHybMax, bin_length, (GTI_BYTE *)(pRcvPwr) );
    }

    return test_status;
}


/************************************************************************************************/
/*                                             LOCAL FUNCTIONS                                  */
/************************************************************************************************/
/*
* Function    : LocalStateMachine
*
* Description : This function polls the DSP until the requested test is finished.  The calling
*               function then will read the results of the test and decide whether it passes or
*               fails.
*
* Arguments   : 'pSysInfo'     is a pointer to the transceiver system being accessed.
*
* Returns     : While the DSP is busy, GTI_TEST_BUSY is returned.  Once the test is complete and the
*               results are stored at pResults, the function will return GTI_TEST_DONE.  In the case
*               of some sort of error, the function will return GTI_TEST_ERROR.
*
* Reference   : none
*****************************************************************************************************
*/
static GTI_WORD LocalStateMachine(GTI_XCVR_INFO *pSysInfo)
{
   GTI_WORD test_status = GTI_TEST_BUSY;
    GTI_BYTE dsp_status;
 
    /* Poll Status to See if Test is Done */
    (void)Gti_SStatusXCVR(pSysInfo, GTI_ACTION_REQUEST_STATUS, &dsp_status,
        sizeof(dsp_status), GTI_DSP_A );
 
    test_status  = GTI_TEST_ERROR;
 
    if( dsp_status == GTI_ACTIVE )
        test_status  = GTI_TEST_BUSY;
 
    if( dsp_status == GTI_COMPLETE_PASS )
        test_status  = GTI_TEST_DONE;
 
    if( dsp_status == GTI_COMPLETE_FAIL )
        test_status  = GTI_TEST_ERROR;
 
    return (test_status);
}


/******************************************************************************************************
* Function    : CalcTestResult
*
* Description : This function gets the results from the DSP and does the calculations needed to
*               determine whether or not the test passed.
*
* Arguments   : 'pSysInfo'     is a pointer to the transceiver system being accessed.
*               'wTestMode'    determines which test to run on the DSP results.
*               'wThrshld'     is a threshold to compare to in test.
*               'pBins'        is a pointer to an array containing the bin numbers for the power
*                              measurement.
*               'pRefMin'      is a pointer to an array containing the min. values that the
*                              measured power must lie in for the specified bins.
*               'pRefMax'      is a pointer to an array containing the max. values that the
*                              measured power must lie in for the specified bins.
*               'wBinLength'   is the number of specified bins.
*               'pResults'     is a pointer to where to store the DSP spectrum (if needed).
*
* Returns     : The function will return GTI_TEST_PASS if the test passed or GTI_TEST_FAIL.  In the
*               case of some sort of error, the function will return GTI_TEST_ERROR.
*
* Reference   : none
*****************************************************************************************************
*/
static GTI_WORD CalcTestResult(GTI_XCVR_INFO *pSysInfo,
                               GTI_WORD  wTestMode,
                               GTI_DWORD wThrshld,
                               GTI_WORD  *pBins,
                               GTI_DWORD *pRefMin,
                               GTI_DWORD *pRefMax,
                               GTI_WORD  wBinLength,
                               GTI_BYTE  *pResults )
{
    GTI_WORD test_status;
    GTI_DWORD temp;
    GTI_WORD i, index;

    /* Get DSP Results (64 bins at a time)*/

    (void)Gti_SStatusXCVR(pSysInfo, GTI_RX_TEST_RESULTS_1_64, &(pResults[0]),
        GTI_RX_TEST_RESULTS_LEN, GTI_DSP_A );
    (void)Gti_SStatusXCVR(pSysInfo, GTI_RX_TEST_RESULTS_64_128,
        &(pResults[GTI_RX_TEST_RESULTS_LEN]), GTI_RX_TEST_RESULTS_LEN, GTI_DSP_A );
    (void)Gti_SStatusXCVR(pSysInfo, GTI_RX_TEST_RESULTS_128_192,
        &(pResults[GTI_RX_TEST_RESULTS_LEN*2]), GTI_RX_TEST_RESULTS_LEN, GTI_DSP_A );
    (void)Gti_SStatusXCVR(pSysInfo, GTI_RX_TEST_RESULTS_192_256,
        &(pResults[GTI_RX_TEST_RESULTS_LEN*3]), GTI_RX_TEST_RESULTS_LEN, GTI_DSP_A );


    switch (wTestMode)
    {
    case TEST_RCV_LINEARITY :
        /* Calculate SNR (in dB) */
        /* pBins is a pointer to a variable containing the notch bin */
        temp = CalcNotchSNR((GTI_DWORD*)pResults, *pBins);
#ifdef GTI_TEST_CODE
        DisplayMsg("Calc SNR(10*db) =");
        DisplayNum((GTI_WORD)temp);
        DisplayMsg(", Threshold(10*db) =");
        DisplayNum((GTI_WORD)wThrshld);
        DisplayMsg("\r\n");
#endif
        /* See if SNR Results meets the user threshold */
        test_status = (GTI_WORD)((temp >= wThrshld) ? GTI_TEST_PASS : GTI_TEST_FAIL);
        break;
    case TEST_RCV_PWR_PBIN :
        /* Nothing to do, Power Spectrum already in pResult */
        test_status = GTI_TEST_PASS;
        break;
    case TEST_RCV_FILTER :
        /* Compare Results to User Criteria */
        test_status = GTI_TEST_PASS;

        for ( i=0; i<wBinLength; i++)
        {
            index  = pBins[i];                  /* Get Bin Number                           */

            /* See if power in bin falls in window */
            if ((((GTI_DWORD*)pResults)[index]>(pRefMax[i])) ||
                (((GTI_DWORD*)pResults)[index]<(pRefMin[i])))
            {
#ifdef GTI_TEST_CODE
                DisplayMsg("Test failed at bin# ");
                DisplayNum(index);
                DisplayMsg("\r\n");
                DisplayMsg("Pwr =");
                DisplayNum((GTI_WORD)((((GTI_DWORD*)pResults)[index])>>16));
                DisplayNum((GTI_WORD)((((GTI_DWORD*)pResults)[index])));
                DisplayMsg("\r\n");
#endif
                test_status = GTI_TEST_FAIL;    /* Test Fails               */
                break;                          /* No point continuing test */
            }
        }
        break;
    case TEST_TOTAL_IDLE_NOISE :
        temp = CalcTotPwr((GTI_DWORD*)pResults, pBins[0], pBins[1]);    /* Calculate Total Rx Power */
#ifdef GTI_TEST_CODE
        DisplayMsg("Calc Total Idle Noise Pwr =");
        DisplayNum((GTI_WORD)(temp>>16));
        DisplayNum((GTI_WORD)temp);
        DisplayMsg("\r\n");
        DisplayMsg("Threshold =");
        DisplayNum((GTI_WORD)(wThrshld>>16));
        DisplayNum((GTI_WORD)wThrshld);
        DisplayMsg("\r\n");
#endif
        /* See if total Noise power is below threshold */
        test_status = (GTI_WORD)((temp < wThrshld) ? GTI_TEST_PASS : GTI_TEST_FAIL);
        break;
    case TEST_PBIN_IDLE_NOISE :
#ifdef GTI_TEST_CODE
        DisplayMsg("\r\n(start):");
        DisplayNum(pBins[0]);
        DisplayMsg("\r\n(end):");
        DisplayNum(pBins[1]);
        DisplayMsg("\r\n");
#endif
        /* Compare Results to User Criteria */
        test_status = GTI_TEST_PASS;
        for ( i=pBins[0]; i <= pBins[1]; i++)
        {
            /* See if noise power in bin is above threshold */
            if ( ((((GTI_DWORD*)pResults)[i])) > wThrshld)
            {
#ifdef GTI_TEST_CODE
                DisplayMsg("Test failed at bin# ");
                DisplayNum(i);
                DisplayMsg("\r\n");
                DisplayMsg("Noise Pwr =");
                DisplayNum((GTI_WORD)(((((GTI_DWORD*)pResults)[i]))>>16));
                DisplayNum((GTI_WORD)((((GTI_DWORD*)pResults)[i])));
                DisplayMsg("\r\n");
                DisplayMsg("Threshold =");
                DisplayNum((GTI_WORD)(wThrshld>>16));
                DisplayNum((GTI_WORD)wThrshld);
                DisplayMsg("\r\n");
#endif
                test_status = GTI_TEST_FAIL;    /* Test Fails               */
                break;                          /* No point continuing test */
            }
        }
        break;
    case TEST_HYBRID_LOSS :
        test_status = GTI_TEST_PASS;

        index = *pBins;             /* pBins points to a variable with the starting bin number */

        for ( i=0; i<wBinLength; i++)
        {
            /* See if power in bin falls in window */
            if ((((GTI_DWORD*)pResults)[index]>(pRefMax[i])) ||
                (((GTI_DWORD*)pResults)[index]<(pRefMin[i])))
            {
#ifdef GTI_TEST_CODE
                DisplayMsg("Test failed at bin# ");
                DisplayNum(index);
                DisplayMsg("Hybrid Pwr =");
                DisplayNum((GTI_WORD)(((((GTI_DWORD*)pResults)[index]))>>16));
                DisplayNum((GTI_WORD)((((GTI_DWORD*)pResults)[index])));
                DisplayMsg("\r\n");
                DisplayMsg("Max Ref =");
                DisplayNum((GTI_WORD)(pRefMax[i]>>16));
                DisplayNum((GTI_WORD)(pRefMax[i]));
                DisplayMsg("\r\n");
                DisplayMsg("Min Ref =");
                DisplayNum((GTI_WORD)(pRefMin[i]>>16));
                DisplayNum((GTI_WORD)(pRefMin[i]));
                DisplayMsg("\r\n");
#endif
                test_status = GTI_TEST_FAIL;     /* Test Fails               */
                break;                          /* No point continuing test */
            }
            index++;                            /* Goto next Bin Number     */
        }
        break;
    default :                                   /* Shouldn't Be Here, Return Error */
        test_status  = GTI_TEST_ERROR;
        break;
    }

    AbortDspCmd(pSysInfo);                          /* Stop Current Command */

    return test_status;
}


/*
*****************************************************************************************************
* Function    : AbortDspCmd
*
* Description : This function causes the DSP to abort any operations that it is currently doing.
*               Should be called at the end of any tests.
*
* Arguments   : 'pSysInfo'     is a pointer to the transceiver system being accessed.
*
* Returns     : none
*
* Reference   : none
*****************************************************************************************************
*/
static void AbortDspCmd(GTI_XCVR_INFO *pSysInfo)
{
    GTI_WORD k;
    struct PARAM_XCVR_ARRAY param_tbl;

    for(k=0; k < GTI_NUM_OF_CMD_PARAMETERS; k++)
    {
        param_tbl.item[k] = 0;
    }

    /* Stop Current Command */
    param_tbl.length                 = GTI_NUM_OF_CMD_PARAMETERS;
    param_tbl.item[GTI_ACTION_ITEM]  = GTI_ABORT_REQ;
    (void)Gti_SetParamXCVR(pSysInfo, &param_tbl);
    (void)Gti_ExecuteXCVR(pSysInfo);
}


/*
*****************************************************************************************************
* Function    : CalcTotPwr
*
* Description : This function calculates the Total Power in the specified bins.
*
* Arguments   : 'pSpectrum'    is a pointer to an array containing the power of bins 1-255.
*               'wStartBin'    is the bin to start power average calculatations.
*               'wEndBin'      is the bin to end power average calculations.
*
* Returns     : The Power Average is returned.
*****************************************************************************************************
*/
static GTI_DWORD CalcTotPwr(GTI_DWORD *pSpectrum, GTI_WORD wStartBin, GTI_WORD wEndBin)
{
    GTI_WORD  i;
    GTI_DWORD tmp;
    GTI_DWORD pwr = 0;

    for ( i=wStartBin; i<=wEndBin; i++)             /* Accumulate power              */
    {
        tmp = pwr + pSpectrum[i];

        if ( tmp < pwr)                             /* Check for value overflow      */
        {
            pwr = 0x7FFFFFFFL;                      /* Clip Total Power at Max value */
#ifdef GTI_TEST_CODE
            DisplayMsg("Clipping Pwr\r\n");
#endif
        }
        else
        {
            pwr = tmp;
        }
    }

    return pwr;
}


/*
*****************************************************************************************************
* Function    : CalcNotchSNR
*
* Description : This function calculates the SNR of the Notch Bin specified.  It calculates the power
*               in the adjacent bins (1 on each side of notch) and uses the noise found in the notch
*               bin to calculate the SNR value.  Don't use the first or last valid bin number as the
*               notch bin because the calculated signal average will not be valid.
*
* Arguments   : 'pSpectrum'    is a pointer to an array containing the power of bins 0-255.
*               'wNotchBin'    is the notch bin number (limited to 1-254).
*
* Returns     : The SNR value is returned.
*****************************************************************************************************
*/
static GTI_WORD CalcNotchSNR(GTI_DWORD *pSpectrum, GTI_WORD wNotchBin)
{
    GTI_DWORD sig_ave;
    GTI_DWORD noise;

    /* Check for out of bound conditions */
    if ( wNotchBin < 1)
    {
        wNotchBin = 1;
    }
    else if ( wNotchBin > 254)
    {
        wNotchBin = 254;
    }

    /* Calculate Signal Average of Adjacent Bins to wNotchBin */
    sig_ave = (pSpectrum[wNotchBin - 1] + pSpectrum[wNotchBin + 1])/2;

    noise  = pSpectrum[wNotchBin];
    noise  = (noise == 0)?1:noise;                  /* Avoid possible divide by zero */

    /* We multiply the ratio SNR by *16 so we keep some of the fractional bits */
    return (GetDecibel((sig_ave*16)/noise));        /* Return SNR (in 10*dB) */
}


/*
*****************************************************************************************************
* Function    : GetDecibel
*
* Description : This function converts a number to 10 * decibels.  So if the number is x, then it is
*               converted to 10*(10*log(x)).  The last multiplication by 10 is so we can use integer
*               arithmetic (eg. 3.5 dB becomes 35).
*
* Arguments   : 'value'  is the number to be converted.  It should have been multiplied by 16
*                        before calling this function (this allows some of the fractional value to
*                        be kept).
*
* Returns     : The value is returned in 10 * dB.
*****************************************************************************************************
*/
static GTI_WORD GetDecibel(GTI_DWORD value)
{
    GTI_WORD start, end;
    GTI_WORD index;
    GTI_DWORD value_x16;

    /* dB lookup table */
    /* The resolution is 0.5dB except between 35-40dB where it is 0.2dB */
    static const struct struct_dB_Table
    {
        GTI_WORD dB_x10;                            /* dB value*10      */
        GTI_DWORD value_x16;                        /* integer value*16 */
    } dB_LookUpTable[] =
    {{  0, 0x000010}, {  5, 0x000012}, { 10, 0x000014}, { 15, 0x000017}, { 20, 0x000019},
    { 25, 0x00001C}, { 30, 0x000020}, { 35, 0x000024}, { 40, 0x000028}, { 45, 0x00002D},
    { 50, 0x000033}, { 55, 0x000039}, { 60, 0x000040}, { 65, 0x000047}, { 70, 0x000050},
    { 75, 0x00005A}, { 80, 0x000065}, { 85, 0x000071}, { 90, 0x00007F}, { 95, 0x00008F},
    {100, 0x0000A0}, {105, 0x0000B4}, {110, 0x0000C9}, {115, 0x0000E2}, {120, 0x0000FE},
    {125, 0x00011D}, {130, 0x00013F}, {135, 0x000166}, {140, 0x000192}, {145, 0x0001C3},
    {150, 0x0001FA}, {155, 0x000238}, {160, 0x00027D}, {165, 0x0002CB}, {170, 0x000322},
    {175, 0x000384}, {180, 0x0003F2}, {185, 0x00046D}, {190, 0x0004F7}, {195, 0x000592},
    {200, 0x000640}, {205, 0x000703}, {210, 0x0007DE}, {215, 0x0008D4}, {220, 0x0009E8},
    {225, 0x000B1D}, {230, 0x000C78}, {235, 0x000DFE}, {240, 0x000FB3}, {245, 0x00119D},
    {250, 0x0013C4}, {255, 0x00162D}, {260, 0x0018E2}, {265, 0x001BEB}, {270, 0x001F53},
    {275, 0x002325}, {280, 0x00276F}, {285, 0x002C3F}, {290, 0x0031A5}, {295, 0x0037B4},
    {300, 0x003E80}, {305, 0x004620}, {310, 0x004EAF}, {315, 0x005849}, {320, 0x00630E},
    {325, 0x006F24}, {330, 0x007CB4}, {335, 0x008BEC}, {340, 0x009CFE}, {345, 0x00B026},
    {350, 0x00C5A4}, {352, 0x00CEF5}, {354, 0x00D8B6}, {356, 0x00E2EC}, {358, 0x00ED9E},
    {360, 0x00F8D1}, {362, 0x01048B}, {364, 0x0110D3}, {366, 0x011DAE}, {368, 0x012B25},
    {370, 0x01393E}, {372, 0x014801}, {374, 0x015777}, {376, 0x0167A6}, {378, 0x01789A},
    {380, 0x018A59}, {382, 0x019CEF}, {384, 0x01B065}, {386, 0x01C4C6}, {388, 0x01DA1C},
    {390, 0x01F075}, {392, 0x0207DA}, {394, 0x02205A}, {396, 0x023A02}, {398, 0x0254DF},
    {400, 0x027100}, {405, 0x02BD43}, {410, 0x0312D4}, {415, 0x0372D6}, {420, 0x03DE8F},
    {425, 0x04576D}, {430, 0x04DF0A}, {435, 0x057733}, {440, 0x0621EE}, {445, 0x06E17D},
    {450, 0x07B86C}, {455, 0x08A995}, {460, 0x09B82B}, {465, 0x0AE7C6}, {470, 0x0C3C6C},
    {475, 0x0DBAA2}, {480, 0x0F677C}, {485, 0x1148A9}, {490, 0x13648D}, {495, 0x15C252},
    {500, 0x186A00}, {505, 0x1B649E}, {510, 0x1EBC49}, {515, 0x227C5C}, {520, 0x26B195},
    {525, 0x2B6A3F}, {530, 0x30B664}, {535, 0x36A802}, {540, 0x3D534A}, {545, 0x44CEE5},
    {550, 0x4D343C}, {555, 0x569FD6}, {560, 0x6131B3}, {565, 0x6D0DB9}, {570, 0x7A5C34},
    {575, 0x894A55}, {580, 0x9A0AD6}, {585, 0xACD69D}, {590, 0xC1ED84}, {595, 0xD9972F},
    {600, 0xF42400}};

    start = 0;
    end   = (sizeof(dB_LookUpTable)/sizeof(struct struct_dB_Table)) - 1; /* Last Index in table */

    /* Check for min. and max. extremes */
    if ( value < dB_LookUpTable[0].value_x16)
    {
        value_x16 = dB_LookUpTable[0].value_x16;
    }
    else if ( value > dB_LookUpTable[end].value_x16)
    {
        value_x16 = dB_LookUpTable[end].value_x16;
    }
    else
    {
        value_x16 = (GTI_WORD)value;
    }

    /* Search Lookup table for closest match by breaking table into halves each interation*/
    while ((end-start)>1)
    {
        index = (GTI_WORD)((start + end)/2);                    /* Look at middle value */

        if (value_x16 >= dB_LookUpTable[index].value_x16)
        {
            start = index;
        }
        else
        {
            end = index;
        }

    }

    /* Use Closest Value */
    if ((dB_LookUpTable[end].value_x16-value_x16) >= (value_x16-dB_LookUpTable[start].value_x16))
    {
        index = start;
    }
    else
    {
        index = end;
    }

    return (dB_LookUpTable[index].dB_x10);          /* Return dB Value      */
}


/***************************************************************************/
/*  Name: Gti_TestIODrivers                                                */
/* ------------------------                                                */
/*  Usage:  Equivalent to the GTI_TEST_DRIVERS_REQ                         */
/*          Customers using SELF downloading feature, must use this        */
/*          API to test the IO drivers before doing any DSP action         */
/*          Commands                                                       */
/*  Input:                                                                 */
/*         pointer to an EXECUTE_CMD structure - XCVR system selected      */
/*  Output:                                                                */
/*         GTI_COMPLETE_PASS -- PASS IO Drivers Test                       */
/*         GTI_HREG_FAIL_TEST - Fail test to single Host register 0x73     */
/*                              0x73 - Fourte  0x0a - Nova                 */
/*         GTI_ID_FAIL_TEST - Set "ID" to GTI_DSP_AB and writes failed     */
/*         GTI_BLOCK_READ_FAIL_TEST - Failed when using DSP internal       */
/*                         auto increment pointer.                         */
/*                         Check the byte order in IO drivers.             */
/*         GTI_DMA_ID_FAIL_TEST - Set "ID" to GTI_DSP_DMA and writes failed*/
/*                                                                         */
/* ------------------------                                                */
/*  Caveats:  Should follow XCVR init process after running test           */
/***************************************************************************/
GTI_WORD
Gti_TestIODrivers( GTI_XCVR_INFO *pXcvrInfo )
{
    GTI_WORD result;

#if defined(GTI_DSPQUAD) || defined(GTI_DSPMULTI)
    GTI_BYTE bdata;
#endif


    /********************************************************/
    /*Test: Write a pattern to a single Register sitting on */
    /*      host processor address/data bus                 */
    /********************************************************/
#ifdef GTI_DSPQUAD

    WRITE_DSP_REG(pXcvrInfo, GTI_GLOBAL_73, 0x5a);
    bdata = READ_DSP_REG(pXcvrInfo, GTI_GLOBAL_73);

    if( bdata != 0x5a )
    {
        return( GTI_HREG_FAIL_TEST );
    }

#elif defined GTI_DSPMULTI

    WRITE_DSP_REG(pXcvrInfo, (GTI_MASKTEST_DSP | GTI_CORE_0_MSK), 0x58);
    bdata = (GTI_BYTE)((READ_DSP_REG(pXcvrInfo, (GTI_MASKTEST_DSP | GTI_CORE_0_MSK)))&0xfc);

    if( bdata != 0xa4 ){
        return( GTI_HREG_FAIL_TEST );
    }

#endif

    /*****************************************************/
    /*Test: Write to internal memory using different IDs */
    /*****************************************************/
    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_NO_AI);

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_AB, 0x00, GTI_ISRAM);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_AB, 0x34,0x12);

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_AB, 0x01, GTI_ISRAM);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_AB, 0xaa,0x55);

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_AB, 0x02, GTI_ISRAM);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_AB, 0x00,0xff);

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x00, GTI_ISRAM|GTI_READ_DSP);
    result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    if( result != 0x1234 )
    {
        return( GTI_ID_FAIL_TEST );
    }

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x01, GTI_ISRAM|GTI_READ_DSP);
    result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    if( result != 0x55aa )
    {
        return( GTI_ID_FAIL_TEST );
    }

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x02, GTI_ISRAM|GTI_READ_DSP);
    result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    if( result != 0xff00 )
    {
        return( GTI_ID_FAIL_TEST );
    }


    /*****************************************************/
    /*Test: Block Reads using auto increament            */
    /*****************************************************/
    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x00, GTI_ISRAM);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0x34,0x12);

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x01, GTI_ISRAM);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0x78,0x56);

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x02, GTI_ISRAM);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0xbc,0x9a);

    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AP);
    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x00, GTI_ISRAM|GTI_READ_DSP);
    result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);

    if( result != 0x1234 )
    {
        return( GTI_BLOCK_READ_FAIL_TEST );
    }

    result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    if( result != 0x5678 )
    {
        return( GTI_BLOCK_READ_FAIL_TEST );
    }

    result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    if( result != 0x9abc )
    {
        return( GTI_BLOCK_READ_FAIL_TEST );
    }

    /*****************************************************/
    /*Test: Test "ID" field = GTI_DSP_DMA                */
    /*****************************************************/
    /* Only do if Core 0 */
    if( pXcvrInfo->dsp_B_cs == GTI_CORE_0_MSK )
    {
        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_NO_AI);

        WRITE_DSP_REG(pXcvrInfo, 0x0c, 0x01);
        WRITE_DSP_REG(pXcvrInfo, 0x0d, 0x05);
        WRITE_DSP_REG(pXcvrInfo, 0x0e, 0xaa);
        WRITE_DSP_REG(pXcvrInfo, 0x0f, 0x55);

        /* put different data in Fifo's before read */
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x02, GTI_ISRAM);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0xbc,0x9a);

        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, 0x01, GTI_ISRAM|GTI_READ_DSP);
        result = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
        if( result != 0x55aa )
        {
            return( GTI_DMA_ID_FAIL_TEST );
        }
    }


    return(GTI_COMPLETE_PASS);
}
#ifdef GTI_TRACE
void
Gti_ResetTraceBuffer(void)
{
    HistPnt=0;
}
#endif
