/*
	@(#)gtipeoc.c	1.29
*/

/************************************************************************
* FILE NAME   : gtipeoc.c                                              *
* DESCRIPTION :  ATU-R *
*                                                                      *
* COMMENT     : *
*                                                                      *
* (C) Copyright 1999 by GlobeSpan Semiconductor Inc                    *
*                                                                      *
************************************************************************/

/************************************************************************
*                             HEADER FILES
************************************************************************/
#include "gti.h"
#include "gti_eoca.h"
#include "gtiextn.h"
#if (defined(GTI_XDP_EOC) || defined(GTI_PAGE_I_BUILT))
    #include "gti_sym.h"
#endif
#ifndef GTI_PAGE_I_BUILT
#if (defined(GTI_DSPVIKING) && defined(GTI_HOSTVSC) )
#ifndef GTI_XDP_EOC /* host eoc */
#include "dsl_typedef.h"
extern U32 gu32ErrorSeconds;
extern SDSLCurrIntervalStats gsDSLCurrIntervalStats;
extern SDSLDayStats gsDSLCurrDayStats;
extern SDSLDayStats gsDSLPrevDayStats;
#endif
#endif


/************************************************************************
*                          DATA DECLARATIONS
************************************************************************/

#ifdef GTI_SUPPORT_LINE_MONITORING
static int isExtended;      /* local flag for EOC state machine to handle extended protocol */
static unsigned int extOffset;
unsigned char extBuffer[GTI_SIZE_OF_LINE_MONITORING_RESP];
#endif /* GTI_SUPPORT_LINE_MONITORING */

extern GTIEOC_DATA_REG  eocDataReg;

GTIEOC_REG_TABLE GTIEocRegInfo[]=
{
#ifndef GTI_XDP_EOC
    {GTI_EOC_CMD_READREG0,  (&(eocDataReg.vendorId[0])),    GTI_EOC_VENDOR_LEN},
    {GTI_EOC_CMD_READREG1,  (&(eocDataReg.revisionNum[0])), GTI_EOC_REV_NUM_LEN},
    {GTI_EOC_CMD_READREG2,  (&(eocDataReg.serialNum[0])),   GTI_EOC_SERIAL_LEN},
    {GTI_EOC_CMD_READREG3,  (&(eocDataReg.selfTest[0])),    GTI_EOC_SELFTEST_LEN},
    {GTI_EOC_CMD_READREG4,  (&(eocDataReg.vendorDisc1[0])), GTI_EOC_VEN_DISC1_LEN},
    {GTI_EOC_CMD_READREG5,  (&(eocDataReg.vendorDisc2[0])), GTI_EOC_VEN_DISC2_LEN},
    {GTI_EOC_CMD_READREG6,  (&(eocDataReg.lineAtten[0])),   GTI_EOC_ATTENU_LEN},
    {GTI_EOC_CMD_READREG7,  (&(eocDataReg.snrMargin[0])),   GTI_EOC_SNRMARGN_LEN},
    {GTI_EOC_CMD_READREG8,  (&(eocDataReg.aturConfig[0])),  GTI_EOC_CONFIG_LEN},
    {GTI_EOC_CMD_READREGA,  (&(eocDataReg.registryA[0])),   GTI_EOC_REGA_LEN},
#endif
    {GTI_EOC_CMD_WRITEREG0, (&(eocDataReg.vendorId[0])),    GTI_EOC_VENDOR_LEN},
    {GTI_EOC_CMD_WRITEREG1, (&(eocDataReg.revisionNum[0])), GTI_EOC_REV_NUM_LEN},
    {GTI_EOC_CMD_WRITEREG2, (&(eocDataReg.serialNum[0])),   GTI_EOC_SERIAL_LEN},
    {GTI_EOC_CMD_WRITEREG3, (&(eocDataReg.selfTest[0])),    GTI_EOC_SELFTEST_LEN},
    {GTI_EOC_CMD_WRITEREG4, (&(eocDataReg.vendorDisc1[0])), GTI_EOC_VEN_DISC1_LEN},
    {GTI_EOC_CMD_WRITEREG5, (&(eocDataReg.vendorDisc2[0])), GTI_EOC_VEN_DISC2_LEN},
    {GTI_EOC_CMD_WRITEREG6, (&(eocDataReg.lineAtten[0])),   GTI_EOC_ATTENU_LEN},
    {GTI_EOC_CMD_WRITEREG7, (&(eocDataReg.snrMargin[0])),   GTI_EOC_SNRMARGN_LEN},
    {GTI_EOC_CMD_WRITEREG8, (&(eocDataReg.aturConfig[0])),  GTI_EOC_CONFIG_LEN},
#ifndef GTI_XDP_EOC
    {GTI_EOC_CMD_WRITEREGA, (&(eocDataReg.registryA[0])),   GTI_EOC_REGA_LEN},
    {GTI_EOC_CMD_VPP0,      (&(eocDataReg.vendorProp[0])),  GTI_EOC_VEN_PROP_LEN},
    {GTI_EOC_CMD_VPP1,      (&(eocDataReg.vendorProp[0])),  GTI_EOC_VEN_PROP_LEN}
#else
    {GTI_EOC_CMD_VPP3,      (&(eocDataReg.vendorProp[0])),  GTI_EOC_VEN_PROP3_LEN}
#endif
};

/************************************************************************
*                          FUNCTION Prototypes
************************************************************************/
#ifndef GTI_XDP_EOC /* host eoc */
#ifdef GTI_PAGE_D_BUILT
void GTIEocDataReg(GTI_XCVR_INFO *GTISysPtr, GTIEOC_INFO *infoPtr, GTIEOC_CMD *hostPtr);
#else
void GTIEocDataReg(GTIEOC_INFO *infoPtr, GTIEOC_CMD *hostPtr);
#endif
#endif
GTI_BYTE GTIEocSpecialAction(GTI_XCVR_INFO *GTISysPtr);
GTI_WORD GTIEocStateIdle(GTI_XCVR_INFO *GTISysPtr,
                         GTIEOC_CMD *hostPtr,
                         GTIEOC_FIELDS *fields);
GTI_WORD GTIEocStateWrite(GTI_XCVR_INFO *GTISysPtr,
                          GTIEOC_CMD *hostPtr,
                          GTIEOC_FIELDS *fields);
GTI_WORD GTIEocStatePreRead(GTI_XCVR_INFO *GTISysPtr,
                            GTIEOC_CMD *hostPtr,
                            GTIEOC_FIELDS *fields);
GTI_WORD GTIEocStateRead(GTI_XCVR_INFO *GTISysPtr,
                         GTIEOC_CMD *hostPtr,
                         GTIEOC_FIELDS *fields);

#else
extern GTIOH_REG_INFO ohRegInfo[];
GTIOH_WRITE_REG GTIOhWriteReg[]=
{
    {GTI_OH_CMD_WRITE_ID, {GTI_OH_CMD_INVENTORY, GTI_OH_CMD_INV_ID, 0}},
    {GTI_OH_CMD_WRITE_AUX_ID, {GTI_OH_CMD_INVENTORY, GTI_OH_CMD_INV_AUX_ID, 0}},
    {GTI_OH_CMD_WRITE_STR, {GTI_OH_CMD_INVENTORY, GTI_OH_CMD_INV_STR, 0}},
    {GTI_OH_CMD_WRITE_LATN, {GTI_OH_CMD_TPR, GTI_OH_CMD_TPR_SINGLE,
        GTI_OH_CMD_TPR_SGL_LATN}},
    {GTI_OH_CMD_WRITE_SNRM, {GTI_OH_CMD_TPR, GTI_OH_CMD_TPR_SINGLE,
        GTI_OH_CMD_TPR_SGL_SNRM}},
    {GTI_OH_CMD_WRITE_MULTI_TP, {GTI_OH_CMD_TPR, GTI_OH_CMD_TPR_MULTIPLE, 0}}
};

GTIOH_RESP_NACK GTIOhRespNack[]=
{
{GTI_OH_CMD_OLR, 3, {GTI_OH_CMD_OLR_DEFER1, GTI_OH_CMD_OLR_DEFER2,
    GTI_OH_CMD_OLR_DEFER3}},
{GTI_OH_CMD_PM, 3, {GTI_OH_CMD_PM_REJECT, GTI_OH_CMD_PM_REJECT_L2,
    GTI_OH_CMD_PM_REJECT_TRIM}},
{GTI_OH_CMD_PM, 3, {GTI_OH_CMD_PM_REJECT, GTI_OH_CMD_PM_REJECT_L2,
    GTI_OH_CMD_PM_REJECT_TRIM}},
{GTI_OH_CMD_CEOC, 1, {GTI_OH_CMD_CEOC_NACK, 0, 0}},
{GTI_OH_CMD_NSF, 1, {GTI_OH_CMD_NSF_NACK, 0, 0}},
{GTI_OH_CMD_TPR, 1, {GTI_OH_CMD_TPR_NACK, 0, 0}},
{GTI_OH_CMD_NSF_LP, 1, {GTI_OH_CMD_NSF_LP_NACK, 0, 0}},
};
#endif /* GTI_PAGE_I_BUILT */
/************************************************************************
*                          FUNCTION CALLS
************************************************************************/

/************************************************************************
* FUNCTION     : GTIEocInit()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void GTIEocInit(GTIEOC_INFO *eInfoPtr)
{
    eInfoPtr->txEocMsg = 0x0;
    eInfoPtr->lastRxEocMsg = 0;
    eInfoPtr->nIdentEocMsg = 0;
    eInfoPtr->rxErrCnt = 0;
    eInfoPtr->latch = GTI_FALSE;
    eInfoPtr->state = GTI_EOC_STATE_IDLE;
    eInfoPtr->saveMsg = 0;
    eInfoPtr->status = GTI_EOC_COMPLETE;

    eInfoPtr->eocDisabled = GTI_TRUE;
    eInfoPtr->frameType3Found = GTI_FALSE;
    eInfoPtr->txEocOffset = 9;

   eInfoPtr->specialAction = GTI_FALSE;
   eInfoPtr->sendCompressedData = GTI_FALSE;
   eInfoPtr->ignoreReceivedData = GTI_FALSE;

#ifdef GTI_SUPPORT_LINE_MONITORING
   isExtended = GTI_FALSE;      /* default is not extended protocol */
#endif
}

void GTIEocProc(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr)
{
#ifdef GTI_PAGE_I_BUILT
    Gti_EocProcBis(GTISysPtr, hostPtr);
#else
    #ifdef GTI_XDP_EOC
       Gti_EocProcXdp(GTISysPtr, hostPtr);
    #else
       Gti_EocProcHost(GTISysPtr, hostPtr);
    #endif
#endif
}

#ifndef GTI_PAGE_I_BUILT /* Not bis */
#ifdef GTI_PAGE_D_BUILT
/************************************************************************
* FUNCTION     : GTIAocProc()
* DESCRIPTION  : Annex B only
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void GTIAocProc(GTI_XCVR_INFO *GTISysPtr, GTIEOC_INFO *eocInfoPtr,
        GTIEOC_CMD *hostPtr)
{
    static GTI_BYTE aocMsgLen, aocMsg[GTI_MAX_AOC_LEN], aocTimes, aocPointer;
    GTI_BYTE i, aocBuffer[GTI_MAX_AOC_LEN];

    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_AOC_TXBUFF_FLAG_OFFSET, (GTI_READ_DSP | GTI_ISRAM) );
    if (READ_DSP_WORD(GTISysPtr, GTI_DSP_A) == GTI_AOC_TXBUFF_EMPTY)
    {

        if (!eocInfoPtr->tick) /*first time */
        {
            aocMsgLen = hostPtr->tx.EocLen;
            aocTimes = aocPointer = 0;
            for(i=0; i<aocMsgLen; i++)
                aocMsg[i] = hostPtr->tx.EocData[i];
        }
        eocInfoPtr->tick++;

        /* fill aoc buffer with aoc msg */
        for(i=0; i<GTI_MAX_AOC_LEN && aocTimes<GTI_MAX_AOC_TIMES; i++)
        {
            aocBuffer[i] = aocMsg[aocPointer++];
            if (aocPointer >= aocMsgLen)
            {
                aocPointer = 0;
                aocTimes++;
            }
        }
        for( ; i < GTI_MAX_AOC_LEN; i++) /*rest fill with 0 */
            aocBuffer[i] = 0;

        if (aocTimes >= GTI_MAX_AOC_TIMES)
            eocInfoPtr->tick = 0;
        else
            hostPtr->tx.Status = GTI_EOC_BUSY;

        /* Turn ON the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
        /* Write the Data to the DSP */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_OFFSET, GTI_ISRAM );
        for (i=0; i<GTI_EOC_MAX_NUMOF_MSG; i++)
        {
        /* Note: Frame 0 (CRC), Frame 1 (IB7:0), Frame 34 (IB15:8), and
            Frame 35 (IB23:16) will be over written by the PCU */
            if ( (i == 0) || (i == GTI_EOC_FRAME_34) )
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0xFF, 0xFF);
            /* EOC */
            else if (i<GTI_EOC_FRAME_34)
            {
                /* Write Control Synch. Byte */
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                    (GTI_EOC_SYNCH_CONTROL & 0xFF),
                    ((GTI_EOC_SYNCH_CONTROL >> 8) & 0xFF) );
            }
            /* AOC */
            else
            {
                /* Write AOC command to the DSP */
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                    aocBuffer [(i-GTI_EOC_FRAME_34-1)*2],
                    aocBuffer [(i-GTI_EOC_FRAME_34-1)*2+1]);
            }
        }

        /* Turn OFF the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
        /* Set the Flag to say GO */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_AOC_TXBUFF_FLAG_OFFSET, GTI_ISRAM );
        WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, 0x80);
    }
}

#endif

#ifndef GTI_XDP_EOC /* host eoc */

/************************************************************************
* FUNCTION     : GTIEocDataReg()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
#ifdef GTI_PAGE_D_BUILT
void GTIEocDataReg(GTI_XCVR_INFO *GTISysPtr, GTIEOC_INFO *infoPtr, GTIEOC_CMD *hostPtr)
#else
void GTIEocDataReg(GTIEOC_INFO *infoPtr, GTIEOC_CMD *hostPtr)
#endif
{
    GTIEOC_REG_TABLE *reg = (GTIEOC_REG_TABLE *) GTIEocRegInfo;
    GTI_BYTE i;

    switch (hostPtr->tx.EocCmd)
    {
    case GTI_EOC_CMD_VPP1:
    case GTI_EOC_CMD_WRITEREG0:
    case GTI_EOC_CMD_WRITEREG1:
    case GTI_EOC_CMD_WRITEREG2:
    case GTI_EOC_CMD_WRITEREG3:
    case GTI_EOC_CMD_WRITEREG4:
    case GTI_EOC_CMD_WRITEREG5:
    case GTI_EOC_CMD_WRITEREG6:
    case GTI_EOC_CMD_WRITEREG7:
    case GTI_EOC_CMD_WRITEREG8:
        if (hostPtr->tx.EocLen > 0)
        {
            for ( ; (hostPtr->tx.EocCmd != reg->regID); reg++)
                ;
            for(i=0; i<(hostPtr->tx.EocLen < reg->regLen ?
		hostPtr->tx.EocLen: reg->regLen); i++)
                reg->regData[i] = hostPtr->tx.EocData[i];
            for( ; i<reg->regLen; i++)/*rest fill with zero*/
                reg->regData[i] = 0;
        }
        else
            hostPtr->tx.Status = GTI_EOC_INVALID_LEN;
        break;

    case GTI_EOC_CMD_RESET:
        GTIEocInit(infoPtr);
        break;

#ifdef GTI_PAGE_D_BUILT
    case GTI_EOC_CMD_VPP2:  /*send aoc command to co */
        infoPtr->tick = 0;
        GTIAocProc(GTISysPtr, infoPtr, hostPtr);
        break;
#endif

    default:
        hostPtr->tx.Status = GTI_EOC_INVALID_CMD;
        break;
    }
}

/************************************************************************
* FUNCTION     : GTIEocSpecialAction()
* DESCRIPTION  : Take special action in certain cases
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
GTI_BYTE GTIEocSpecialAction(GTI_XCVR_INFO *GTISysPtr)
{
GTI_WORD   rmtVendorIdStatus[MAX_RMT_VENDOR_ID_STATUS_LEN];
GTI_WORD   rmtVendorRevStatus[GTI_RMT_VENDOR_REV_STATUS_LEN];
GTI_WORD   statusLen=0;

   /* Find remote information - VendorID and VendorRev */
   statusLen = Gti_SStatusXCVR(GTISysPtr, GTI_RMT_VENDOR_REV_STATUS, &(rmtVendorRevStatus[0]),
				  	  GTI_RMT_VENDOR_REV_STATUS_LEN, GTI_DSP_A);
   if (!statusLen)
       return GTI_FALSE;

   /* Possibly newer version of the CO code */
   if (rmtVendorRevStatus[0] != 0x0000)
	   return GTI_FALSE;

   statusLen = Gti_SStatusXCVR(GTISysPtr, GTI_RMT_VENDOR_ID_STATUS, &(rmtVendorIdStatus[0]),
				  	  MAX_RMT_VENDOR_ID_STATUS_LEN, GTI_DSP_A);
   switch (statusLen)
   {
        case MAX_RMT_VENDOR_ID_STATUS_LEN:
        case GTI_RMT_VENDOR_ID_STATUS_LEN:
            /* Is it GSPN VendorID? */
            if (rmtVendorIdStatus[0] == GTI_ID_GLOBESPAN)
                return GTI_TRUE;

            /* If the connection was made for G.DMT, check different VendorID */
            if (rmtVendorIdStatus[0] == 0x4350)
            {
                if (rmtVendorIdStatus[1] == 0x5347)
                {
                    if (rmtVendorIdStatus[2] == 0xB500)
                        return GTI_TRUE;
                }
            }
            break;

        default:
            break;
   }

   return GTI_FALSE;
}


/************************************************************************
* FUNCTION     : GTIDgaspProc()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void GTIDgaspProc(GTI_XCVR_INFO *GTISysPtr)
{
    GTI_BYTE i;

    /* Turn ON the Auto Increment */
    CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
    /* Write the Data to the DSP */
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_OFFSET, GTI_ISRAM );
    for (i=0; i<GTI_EOC_MAX_DGASP_MSG; i++)
    {
    /* Note: Frame 0 (CRC) will be over written by the PCU */
        if (i == 0)
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0xFF, 0xFF);
        /* EOC */
        else
            /* Write Control Synch. Byte */
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                    GTI_EOC_DGASP_MSG_B0, GTI_EOC_DGASP_MSG_B1);
    }
    /* Turn OFF the Auto Increment */
    CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
    /* Set the Flag to say GO */
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_FLAG_OFFSET, GTI_ISRAM );
    WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, GTI_EOC_TXBUFF_FULL);
}

/************************************************************************
* FUNCTION     : Gti_EocProcHost()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void Gti_EocProcHost(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr)
{
    /* Buffer that is stored in the DSP for each Superframe */
    GTI_WORD    rxBuff[GTI_EOC_MAX_NUMOF_MSG];
    GTI_WORD    txBuff[GTI_EOC_MAX_NUMOF_MSG];
    GTI_BYTE    txBuffIndex=0;
    GTI_WORD    i;
    GTIEOC_INFO *eocInfoPtr;
    GTI_WORD    newMsg;
    GTI_WORD    tempMsg=0;
    GTI_BYTE    txAutoIndex=0;
    GTI_WORD    dspState=0;

    /* Get the saved structure for EOC */
    eocInfoPtr = (GTIEOC_INFO *)&GTISysPtr->eocInfo;

    /* Initialize the output parameters */
    hostPtr->rx.AutoLen = 0;
    hostPtr->rx.EocCmd = 0;
    hostPtr->rx.EocLen = 0;
    hostPtr->rx.Status = GTI_EOC_COMPLETE;
    hostPtr->tx.Status = GTI_EOC_COMPLETE;  /* OK */

    for (i=0; i<GTI_EOC_MAX_NUMOF_MSG; i++)
        txBuff[i] = 0;

    if (eocInfoPtr->eocDisabled)
    {
        /* Check to see the if we are in DATA_MODE */
        (void)Gti_SStatusXCVR(GTISysPtr, GTI_OP_STATE, &dspState, sizeof(dspState), 0);
        if ((dspState != GTI_DATA_OP) && (dspState != GTI_BIT_SWAPPING_OP))
            return;

        eocInfoPtr->eocDisabled = GTI_FALSE;

        /* Read the Framing Structure Type from the DSP-PCU */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, 0x6, (GTI_READ_DSP | GTI_PSRAM0W) );
        if (((READ_DSP_WORD(GTISysPtr, GTI_DSP_A)) & 0x600) == 0x600)
        {
            eocInfoPtr->frameType3Found = GTI_TRUE;
            eocInfoPtr->txEocOffset = 5;
        }
        /* Does it require special action from the CPE side? */
        eocInfoPtr->sendCompressedData = GTI_FALSE;
        eocInfoPtr->ignoreReceivedData = GTI_FALSE;
        eocInfoPtr->specialAction = (GTIEocSpecialAction(GTISysPtr)) ? GTI_TRUE : GTI_FALSE;
    }

    if (hostPtr->tx.EocCmd == GTI_EOC_CMD_DGASP) /*dying gasp highest priority*/
    {
        GTIDgaspProc(GTISysPtr);
        hostPtr->tx.EocCmd=0;
        return;
    }

    /* **** RX **** */
    /* Read the RX Flag */
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_RXBUFF_FLAG_OFFSET, (GTI_READ_DSP | GTI_ISRAM) );
    if (READ_DSP_WORD(GTISysPtr, GTI_DSP_A) == GTI_EOC_RXBUFF_FULL)
    {
        /* Turn ON the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);

	/* check if it's okay to tx before processing */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_FLAG_OFFSET, (GTI_READ_DSP | GTI_ISRAM) );
        if (READ_DSP_WORD(GTISysPtr, GTI_DSP_A) != GTI_EOC_TXBUFF_EMPTY)
	{
            return; /* not okay */
	}

        /* Read the Data from the DSP */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_RXBUFF_OFFSET, (GTI_READ_DSP | GTI_ISRAM) );
        for(i=0; i<GTI_EOC_MAX_NUMOF_MSG; i++)
            rxBuff[i] = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);

        /* Turn OFF the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
        /* Reset the RX Flag to empty Buffer */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_RXBUFF_FLAG_OFFSET, GTI_ISRAM );
        WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, GTI_EOC_RXBUFF_EMPTY);

        /* ***** */
        /* Process the RX Information */
        for (i=0; i<GTI_EOC_MAX_NUMOF_MSG; i++)
        {
            /* NOT (crc, ib[0-2], or Synch_Byte) */
            if( !((i == 0) || (i == GTI_EOC_FRAME_34) ||
                (rxBuff[i] == GTI_EOC_SYNCH_CONTROL) ||
                ((eocInfoPtr->frameType3Found) && (i>GTI_EOC_FRAME_34))) )
            {
                /* Only EOC Message to be processed */
                newMsg = rxBuff[i];

                /* Check, if the overhead of the eoc is there */
                if ( (newMsg & GTI_EOC_OVERHEAD_MASK) != GTI_EOC_OVERHEAD_MASK )
                {
                    eocInfoPtr->rxErrCnt++;
                }
                else if( !((newMsg & GTI_EOC_ADDRESS_MASK)==GTI_EOC_ATUR_ADDRESS) )
                {
                    eocInfoPtr->rxErrCnt++;
                }
                /* Check if this is an autonomous message */
                else if ( !(newMsg & GTI_EOC_AUTONOMOUS_MASK) )
                {
                    /* Store the AUTONOMOUS MESSAGE Into the Data Structure */
                    hostPtr->rx.AutoData[hostPtr->rx.AutoLen++]=GTI_EOC_M_INFO_FIELD(newMsg);
                }
                /* Compare the new message(2Byte) with lastRxEocMsg */
                else if (newMsg == eocInfoPtr->lastRxEocMsg)
                {
                    eocInfoPtr->nIdentEocMsg++;
                    if (eocInfoPtr->nIdentEocMsg == GTI_EOC_MAGIC_NUM)
                    {
                        /* Execute the incoming message */
                        tempMsg = GTIEocExecCmd(GTISysPtr, hostPtr, newMsg);
                        if (tempMsg)
                            eocInfoPtr->txEocMsg = tempMsg;
                    }
                    txBuff[ (txBuffIndex++) ] = eocInfoPtr->txEocMsg;
                }
                else
                {
                    eocInfoPtr->nIdentEocMsg=1;
                    eocInfoPtr->lastRxEocMsg = eocInfoPtr->txEocMsg = newMsg;
                    txBuff[ (txBuffIndex++) ] = eocInfoPtr->txEocMsg;  /* Echo */
                }
            } /* if */
        } /* for */
    }

    /* take any specialAction */
    if (eocInfoPtr->specialAction)
    {
        if (eocInfoPtr->sendCompressedData)
        {
            tempMsg = GTI_EOC_M_MAKE_MSG( GTI_EOC_ATUR_ADDRESS,
                    GTI_EOC_DATA_FIELD, GTI_EOC_ODD_PARITY,
                    (eocInfoPtr->regData[eocInfoPtr->regIndex]) );
            eocInfoPtr->regIndex++;
            txBuff[ (txBuffIndex++) ] = tempMsg;
            txBuff[ (txBuffIndex++) ] = tempMsg;
            txBuff[ (txBuffIndex++) ] = tempMsg;

            tempMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
                    GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
                    GTI_EOC_CMD_EOD);
            txBuff[ (txBuffIndex++) ] = tempMsg;
            txBuff[ (txBuffIndex++) ] = tempMsg;
            txBuff[ (txBuffIndex++) ] = tempMsg;

            tempMsg = GTI_EOC_M_MAKE_MSG( GTI_EOC_ATUR_ADDRESS,
                    GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
                    GTI_EOC_CMD_RTN);
            txBuff[ (txBuffIndex++) ] = tempMsg;
            txBuff[ (txBuffIndex++) ] = tempMsg;
            txBuff[ (txBuffIndex++) ] = tempMsg;

            eocInfoPtr->state = GTI_EOC_STATE_IDLE;
            /* Turn OFF one flag and turn another one ON */
            eocInfoPtr->sendCompressedData = GTI_FALSE;
            eocInfoPtr->ignoreReceivedData = GTI_TRUE;
        }
        else if (eocInfoPtr->ignoreReceivedData)
            txBuffIndex=0; /* Ignore any received data and therefore do not transmit */
    }

#ifdef GTI_PAGE_D_BUILT
    /* ???(MAY BE) DEBUG ONLY */
    if (hostPtr->tx.EocCmd)
        GTIEocDataReg(GTISysPtr, eocInfoPtr, hostPtr);
    else if (eocInfoPtr->tick)
        GTIAocProc(GTISysPtr, eocInfoPtr, hostPtr);
#else
    if (hostPtr->tx.EocCmd)
        GTIEocDataReg(eocInfoPtr, hostPtr);
#endif
    /* ???(MAY BE) DEBUG ONLY */

    /* ***** SANITY CHECK ***** */
    /* Is there something to transmit? */
    if (!( txBuffIndex || hostPtr->tx.AutoLen ))
        return;
    if (hostPtr->tx.AutoLen > GTI_EOC_MAX_AUTONOMOUS_LEN)
    {
        hostPtr->tx.Status = (GTI_WORD)((hostPtr->tx.Status) ? GTI_EOC_ERROR : GTI_EOC_INVALID_LEN);
        txAutoIndex = hostPtr->tx.AutoLen;   /* Do not transmit */
    }

    /* ***** TX ***** */
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_FLAG_OFFSET, (GTI_READ_DSP | GTI_ISRAM) );
    if (READ_DSP_WORD(GTISysPtr, GTI_DSP_A) == GTI_EOC_TXBUFF_EMPTY)
    {
        /* Turn ON the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
        /* Write the Data to the DSP */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_OFFSET, GTI_ISRAM );
        for (i=0; i<GTI_EOC_MAX_NUMOF_MSG; i++)
        {
        /* Note: Frame 0 (CRC), Frame 1 (IB7:0), Frame 34 (IB15:8), and
            Frame 35 (IB23:16) will be over written by the PCU */
            if ( (i == 0) || (i == GTI_EOC_FRAME_34) )
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0xFF, 0xFF);
            /* TEMP FIX */
            else if (i < eocInfoPtr->txEocOffset)
            {
                /* Write Control Synch. Byte */
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                    (GTI_EOC_SYNCH_CONTROL & 0xFF),
                    ((GTI_EOC_SYNCH_CONTROL >> 8) & 0xFF) );
            }
            /* TEMP FIX */
            else if((eocInfoPtr->frameType3Found) && (i>GTI_EOC_FRAME_34))
            {
                ; /* Do not Write Anything */
            }
            else
            {
                /* Write EOC command to the DSP */
                if ( txBuffIndex )
                {
                /* NOTE: NEED TO be careful here because we know that we will not be tx-ing
                    more than 3 command at a time */
                    WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                        /* TEMP FIX */
                        (GTI_BYTE)(txBuff [i- eocInfoPtr->txEocOffset] & 0xFF),
                        (GTI_BYTE)((txBuff[i- eocInfoPtr->txEocOffset] >> 8) & 0xFF) );
                    /* TEMP FIX */
                    txBuffIndex--;
                }
                /* Write the AUTONOMOUS Message to the DSP */
                else if (txAutoIndex < hostPtr->tx.AutoLen)
                {
                    WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                        (GTI_BYTE)(GTI_EOC_AUTONOMOUS_MSG_CP | ((hostPtr->tx.AutoData[txAutoIndex]&0x01)<<7)),
                        (GTI_BYTE)(hostPtr->tx.AutoData[txAutoIndex] | GTI_EOC_OVERHEAD_B1));
                    txAutoIndex++;
                }
                /* Write Control Synch. Byte */
                else
                {
                    WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A,
                        (GTI_EOC_SYNCH_CONTROL & 0xFF),
                        ((GTI_EOC_SYNCH_CONTROL >> 8) & 0xFF) );
                }
            }
        }

      UPDATE_DSP(GTISysPtr);

        /* Turn OFF the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
        /* Set the Flag to say GO */
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_TXBUFF_FLAG_OFFSET, GTI_ISRAM );
        WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, GTI_EOC_TXBUFF_FULL);
    }
}

/************************************************************************
* GTIEocStateIdle
************************************************************************/
GTI_WORD GTIEocStateIdle(GTI_XCVR_INFO *GTISysPtr,
                         GTIEOC_CMD *hostPtr,
                         GTIEOC_FIELDS *fields)
{
    GTIEOC_INFO *infoPtr;
    GTIEOC_REG_TABLE *reg = (GTIEOC_REG_TABLE *) GTIEocRegInfo;
    GTI_WORD retEocMsg=0;
    GTI_BYTE bTemp;

    GTI_BYTE rStandard;
#ifdef GTI_USB
    GTI_WORD wValue;
    GTI_BYTE value;
#endif /* GTI_USB */
    /* Get the saved structure for EOC */
    infoPtr = (GTIEOC_INFO *)&GTISysPtr->eocInfo;

    if (infoPtr->specialAction)
    {
        /* We only expect SNR margin read */
        if (fields->info != GTI_EOC_CMD_READREG7) /* 0x4F d<->u Read SNR Margin */
            return 0;

        infoPtr->sendCompressedData = GTI_TRUE;
        infoPtr->ignoreReceivedData = GTI_FALSE;
    }

    /* Should be able to Rx any Messages */
    switch( fields->info )
    {
    case GTI_EOC_CMD_HOLD:       /* 0x01 d<->u Hold State */
        /* Do Nothing */
        break;

    case GTI_EOC_CMD_RTN:        /* 0xF0 d<->u Return To Normal */
        if (infoPtr->latch)
        {
            WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_OFFSET, GTI_PSRAM0W );
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_DISABLE, 0);
            UPDATE_DSP(GTISysPtr);

            infoPtr->latch = GTI_FALSE;
        }
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_REQCOR:     /* 0x07 d<->u Request Corrupt CRC */
        hostPtr->rx.EocCmd = fields->info;
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_OFFSET, GTI_PSRAM0W );
        WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_ENABLE, 0);
        UPDATE_DSP(GTISysPtr);

        infoPtr->latch = GTI_TRUE;
        break;

    case GTI_EOC_CMD_REQEND:     /* 0x08 d<->u Request End of Corrupt CRC */
        hostPtr->rx.EocCmd = fields->info;
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_OFFSET, GTI_PSRAM0W );
        WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_DISABLE, 0);
        UPDATE_DSP(GTISysPtr);

        infoPtr->latch = GTI_FALSE;
        break;

    case GTI_EOC_CMD_NOTCOR:     /* 0x0B d<->u Notify Corrupt CRC */
    case GTI_EOC_CMD_NOTEND:     /* 0x0D d<->u Notify End of Corrupt CRC */


        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_GNTPDN:

        hostPtr->rx.Status = GTI_EOC_STATUS_GNTPDN;
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_REJPDN:
   	    hostPtr->rx.Status = GTI_EOC_STATUS_REJPDN;
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_SLFTEST:    /* 0x02 d<->u Self-Test */
    case GTI_EOC_CMD_REQTPU:     /* 0x13 d<->u Req Test Parameter Update */
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_WRITEREG4:  /* 0x29 d<->u Write Vendor Discretionary */
        infoPtr->regId = fields->info;
        infoPtr->regData = (GTI_BYTE *)&(eocDataReg.vendorDisc1[0]);
        infoPtr->regIndex = 0;
        infoPtr->regLength = GTI_EOC_VEN_DISC1_LEN;
        infoPtr->state = GTI_EOC_STATE_WRITE;
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_WRITEREG5:  /* 0x2A d<->u Write Vendor Discretionary */
        infoPtr->regId = fields->info;
        infoPtr->regData = (GTI_BYTE *)&(eocDataReg.vendorDisc2[0]);
        infoPtr->regIndex = 0;
        infoPtr->regLength = GTI_EOC_VEN_DISC2_LEN;
        infoPtr->state = GTI_EOC_STATE_WRITE;
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_WRITEREGA:
        infoPtr->regId = fields->info;
        infoPtr->regData = (GTI_BYTE *)&(eocDataReg.registryA[0]);
        infoPtr->regIndex = 0;
        infoPtr->regLength = GTI_EOC_REGA_LEN;
        infoPtr->state = GTI_EOC_STATE_WRITE;
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_VPP1:
        infoPtr->regId = fields->info;
        infoPtr->regData = (GTI_BYTE *)&(eocDataReg.vendorProp[0]);
        infoPtr->regIndex = 0;
        infoPtr->regLength = GTI_EOC_VEN_PROP_LEN;
        infoPtr->state = GTI_EOC_STATE_WRITE;
        hostPtr->rx.EocCmd = fields->info;
        break;

    case GTI_EOC_CMD_READREG0:   /* 0x40 d<->u Read VendorID */
        hostPtr->rx.EocCmd = fields->info;
        infoPtr->regId = fields->info;
        for (; (fields->info != reg->regID); reg++)
            ;
        infoPtr->regData = (GTI_BYTE *)reg->regData;

        rStandard = GET_HOST_DB_B(GTISysPtr, GTI_SELCTD_STANDARD);
        infoPtr->regLength =(GTI_BYTE)(((rStandard == GTI_G_LITE_STANDARD) ||
	(rStandard == GTI_G_DMT_STANDARD) ||
	(rStandard == GTI_HS_ADSL_STANDARD) ||
	(rStandard == GTI_CENT_LEGACY_LITE) ||
	(rStandard == GTI_CENT_LEGACY_DMT) ) ? GTI_EOC_VENDOR_LEN : 2);
        infoPtr->regIndex = 0;  /* Which byte of register to send */
        infoPtr->state = GTI_EOC_STATE_READ;
        break;

    case GTI_EOC_CMD_READREG6:   /* 0x4C d<->u Read Line Attenuation */
#ifdef GTI_USB
        if(SStatusXCVR(GTISysPtr, GTI_ATTENUATION_STATUS, &wValue, GTI_ATTENUATION_STATUS_LEN, GTI_DSP_A) )
            eocDataReg.lineAtten[ 0 ]  = (GTI_BYTE)(wValue & 0x00ff);
        else
            eocDataReg.lineAtten[ 0 ]  = 0xFF;
#endif /* GTI_USB */
        hostPtr->rx.EocCmd = fields->info;
        infoPtr->regId = fields->info;
        for (; (fields->info != reg->regID); reg++)
            ;
        infoPtr->regData = (GTI_BYTE *)reg->regData;
        infoPtr->regLength = reg->regLen;
        infoPtr->regIndex = 0;  /* Which byte of register to send */
        infoPtr->state = GTI_EOC_STATE_READ;
        break;

    case GTI_EOC_CMD_READREG7:   /* 0x4F d<->u Read SNR Margin */
#ifdef GTI_USB
        if(SStatusXCVR(GTISysPtr, GTI_LCL_SNR_MARGIN, &value, GTI_LCL_SNR_MARGIN_LEN, GTI_DSP_A) )
            eocDataReg.snrMargin[ 0 ]  = value;
	else
            eocDataReg.snrMargin[ 0 ]  = 0x00;
#endif /* GTI_USB */
        hostPtr->rx.EocCmd = fields->info;
        infoPtr->regId = fields->info;
        for (; (fields->info != reg->regID); reg++)
            ;
        infoPtr->regData = (GTI_BYTE *)reg->regData;
        infoPtr->regLength = reg->regLen;
        infoPtr->regIndex = 0;  /* Which byte of register to send */
        infoPtr->state = GTI_EOC_STATE_READ;
        break;

    case GTI_EOC_CMD_VPP0:
    case GTI_EOC_CMD_READREG1:   /* 0x43 d<->u Read Revision Number */
    case GTI_EOC_CMD_READREG2:   /* 0x45 d<->u Read Serial Number */
    case GTI_EOC_CMD_READREG3:   /* 0x46 d<->u Read Self-Test Result */
#if ( !(defined(GTI_DSPVIKING) && defined(GTI_HOSTVSC)) )
    case GTI_EOC_CMD_READREG4:   /* 0x49 d<->u Read Vendor Discretionary */
#endif
    case GTI_EOC_CMD_READREG5:   /* 0x4A d<->u Read Vendor Discretionary */
    case GTI_EOC_CMD_READREG8:   /* 0x51 d<->u Read ATU-R Configuration */
    case GTI_EOC_CMD_READREGA:   /* 0x54 d<->u Read Registry A Power Management*/

        hostPtr->rx.EocCmd = fields->info;
        infoPtr->regId = fields->info;
        for (; (fields->info != reg->regID); reg++)
            ;
        infoPtr->regData = (GTI_BYTE *)reg->regData;
        infoPtr->regLength = reg->regLen;
        infoPtr->regIndex = 0;  /* Which byte of register to send */
        infoPtr->state = GTI_EOC_STATE_READ;
        break;

#if (defined(GTI_DSPVIKING) && defined(GTI_HOSTVSC) )
    case GTI_EOC_CMD_READREG4:   /* 0x49 d<->u Read Vendor Discretionary */
        /* fill the cumulative error seconds counter value */
        eocDataReg.vendorDisc1[5] = (GTI_BYTE) (gu32ErrorSeconds & 0x000000FF);
        eocDataReg.vendorDisc1[6] = (GTI_BYTE) ((gu32ErrorSeconds >> 8) & 0x000000FF);
        eocDataReg.vendorDisc1[7] = (GTI_BYTE) ((gu32ErrorSeconds >> 16) & 0x000000FF);
        eocDataReg.vendorDisc1[8] = (GTI_BYTE) ((gu32ErrorSeconds >> 24) & 0x000000FF);

        /* Update the current interval error seconds counter value */
        eocDataReg.vendorDisc1[9] = (GTI_BYTE) (gsDSLCurrIntervalStats.u32ErrSecs & 0x000000FF);
        eocDataReg.vendorDisc1[10] = (GTI_BYTE) ((gsDSLCurrIntervalStats.u32ErrSecs >> 8) & 0x000000FF);

        /* Update the current day error seconds counter value */
        eocDataReg.vendorDisc1[11] = (GTI_BYTE) (gsDSLCurrDayStats.u32ErrSecs & 0x000000FF);
        eocDataReg.vendorDisc1[12] = (GTI_BYTE) ((gsDSLCurrDayStats.u32ErrSecs >> 8) & 0x000000FF);
        eocDataReg.vendorDisc1[13] = (GTI_BYTE) ((gsDSLCurrDayStats.u32ErrSecs >> 16) & 0x000000FF);
        eocDataReg.vendorDisc1[14] = (GTI_BYTE) ((gsDSLCurrDayStats.u32ErrSecs >> 24) & 0x000000FF);

        /* Update the previous day error seconds counter value */
        eocDataReg.vendorDisc1[15] = (GTI_BYTE) (gsDSLPrevDayStats.u32ErrSecs & 0x000000FF);
        eocDataReg.vendorDisc1[16] = (GTI_BYTE) ((gsDSLPrevDayStats.u32ErrSecs >> 8) & 0x000000FF);
        eocDataReg.vendorDisc1[17] = (GTI_BYTE) ((gsDSLPrevDayStats.u32ErrSecs >> 16) & 0x000000FF);
        eocDataReg.vendorDisc1[18] = (GTI_BYTE) ((gsDSLPrevDayStats.u32ErrSecs >> 24) & 0x000000FF);

        hostPtr->rx.EocCmd = fields->info;
        infoPtr->regId = fields->info;
        for (; (fields->info != reg->regID); reg++)
            ;
        infoPtr->regData = (GTI_BYTE *)reg->regData;
        infoPtr->regLength = reg->regLen;
        infoPtr->regIndex = 0;  /* Which byte of register to send */
        infoPtr->state = GTI_EOC_STATE_READ;
        break;
#endif /* DSPVIKING && embedded host */



    default:
        /* Send UTC */
        bTemp = GTI_EOC_CMD_UTC;
        retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
            GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
            bTemp);
        /* NOTE: This should be GTIEOC_STATE_UTC */
        infoPtr->state = GTI_EOC_STATE_IDLE;
        break;
    }

    return retEocMsg;
}

#ifdef GTI_SUPPORT_LINE_MONITORING
/*
 * GTILMCalculate - This function calls the functions required to fill the EOC buffer
 *    with line attenuation, SNR, and Noise (per bin) information.
 */
int GTILMCalculate(GTI_XCVR_INFO *GTISysPtr,unsigned char *buffer)
{
    extern GTI_WORD GTI_CONST_QUAL GTI_ADDRESS_QUAL Avrg_Margin_Trans[];
    int i,j;
    int SNRmargin;
    GTI_WORD statbuffer[256];
    unsigned char codingGain;

    for(i=0;i<GTI_SIZE_OF_LINE_MONITORING_RESP;i++)     /* fill the buffer with unavailable data */
    {
        buffer[i] = (unsigned char)0xff;
    }

    if(Gti_SStatusXCVR(GTISysPtr,GTI_LCL_CODING_GAIN,&codingGain,sizeof(codingGain),GTI_DSP_A) != sizeof(codingGain))
        return(-1);

    if(Gti_SStatusXCVR(GTISysPtr,GTI_SNR_MARGIN_PER_BIN,statbuffer,sizeof(statbuffer),GTI_DSP_A) != sizeof(statbuffer))
        return(-1);

    /* translate array of words in unsigned linear format to signed log format */
    for(i=0;i<256;i++)
    {
        if(statbuffer[i] != 0)       /* zero in the statbuffer indicates data is unavailable */
        {
            for(SNRmargin=-31,j=0;statbuffer[i]<Avrg_Margin_Trans[j];j++,SNRmargin++);  /* linear to log conversion */
            SNRmargin += codingGain;                /* coding gain wasn't taken into account, add it in here */
            buffer[i+GTI_SNR_MARGIN_PER_BIN_OFFSET]=(SNRmargin < 0) ? ((unsigned char)(SNRmargin * -1))&0x80 :
                    (unsigned char)SNRmargin;       /* convert from local sign convention to sign + magnitude */
        }
    }

    return(0);
}

/*
 * GTIEocProcessExtendedWrite -
 */
void GTIEocProcessExtendedWrite(GTI_XCVR_INFO *GTISysPtr,GTIEOC_CMD *hostPtr)
{
    unsigned char i,j;
    GTIEOC_REG_TABLE *reg = (GTIEOC_REG_TABLE *) GTIEocRegInfo;

    if(isExtended)      /* if we are in extended mode, then use the write to increment to the next page */
    {

        if(extOffset == GTI_SIZE_OF_LINE_MONITORING_RESP)
        {
            GTILMCalculate(GTISysPtr,extBuffer);
            extOffset = 0;
        }
        else
        {
            extOffset += 32;                                   /* update the pointer */
        }

        for (; (reg->regID != GTI_EOC_CMD_READREG4); reg++)   /* Find the entry in the table for register 4 */
            ;
        reg->regData = &extBuffer[extOffset];

    }
    else if(hostPtr->rx.EocLen == 32)
    {
        /* check to see if sequence is in the payload */
        for(i=0,j=1;((hostPtr->rx.EocData[i] == j) && (i < 32));i++,j+=3);

        if(i == 32)     /* if it matched */
        {
            for (; (reg->regID != GTI_EOC_CMD_READREG4); reg++)   /* Find the entry in the table for register 4 */
                ;

            /*
             *  Setup the response for the first read, first 16 bytes are ones complement of
             *  same sequence.
             */
            for(i=0,j=1;i<17;i++,j+=3)
                reg->regData[i] = ~j;

            reg->regData[17] = GTI_EXT_EOC_PROTOCOL_VERSION;
            reg->regData[18] = GTI_NUMBER_OF_EXT_EOC_PAGES;

            for(i=19;i<32;i++)
                reg->regData[i] = 0;

            extOffset = GTI_SIZE_OF_LINE_MONITORING_RESP;
            isExtended = GTI_TRUE;

        }
    }

}
#endif /* GTI_SUPPORT_LINE_MONITERING */


/************************************************************************
* GTIEocStateWrite
************************************************************************/
GTI_WORD GTIEocStateWrite(GTI_XCVR_INFO *GTISysPtr,
                          GTIEOC_CMD *hostPtr,
                          GTIEOC_FIELDS *fields)
{
    GTIEOC_INFO *infoPtr;
    GTI_WORD retEocMsg=0;
    GTI_BYTE i, bTemp;

    /* Get the saved structure for EOC */
    infoPtr = (GTIEOC_INFO *)&GTISysPtr->eocInfo;

    if (fields->isOpcode)
    {
        switch (fields->info)
        {
          /* Rx only Data and EOD Message */
          case GTI_EOC_CMD_EOD:

            /* Write Data to the register specified */
            for(i=0; i<infoPtr->regLength; i++)
                hostPtr->rx.EocData[i] = infoPtr->regData[i];
            hostPtr->rx.EocCmd = infoPtr->regId;
            hostPtr->rx.EocLen = infoPtr->regLength;
            infoPtr->state = GTI_EOC_STATE_IDLE;

#ifdef GTI_SUPPORT_LINE_MONITORING
            /* Check for extended protocol */
            if(infoPtr->regId == GTI_EOC_CMD_WRITEREG4)
                GTIEocProcessExtendedWrite(GTISysPtr,hostPtr);
#endif /* GTI_SUPPORT_LINE_MONITORING */

            break;

          case GTI_EOC_CMD_HOLD:
            break;

          default:
            /* Send UTC */;
            bTemp = GTI_EOC_CMD_UTC;
            retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
                GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
                bTemp);
            /* NOTE: This should be GTI_EOC_STATE_UTC */
            infoPtr->state = GTI_EOC_STATE_IDLE;
            break;
        }
    }
    else
    {
        /* This is DATA....WRITE ONLY */
        if (infoPtr->regIndex < infoPtr->regLength)
        {
            infoPtr->regData[infoPtr->regIndex] = fields->info;
            infoPtr->regIndex++;
        }
        else
        {
            /* Send EOD */;
            bTemp = GTI_EOC_CMD_EOD;
            retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
                GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
                bTemp);

            for(i=0; i<infoPtr->regLength; i++)
                hostPtr->rx.EocData[i] = infoPtr->regData[i];
            hostPtr->rx.EocCmd = infoPtr->regId;
            hostPtr->rx.EocLen = infoPtr->regLength;
            infoPtr->state = GTI_EOC_STATE_IDLE;
        }
    }
    return retEocMsg;
}

/************************************************************************
* GTIEocStatePreRead
************************************************************************/
GTI_WORD GTIEocStatePreRead(GTI_XCVR_INFO *GTISysPtr,
                            GTIEOC_CMD *hostPtr,
                            GTIEOC_FIELDS *fields)
{
    GTIEOC_INFO *infoPtr;
    GTI_WORD retEocMsg=0;
    GTI_BYTE bTemp;

    NOT_USED(hostPtr);

    /* Get the saved structure for EOC */
    infoPtr = (GTIEOC_INFO *)&GTISysPtr->eocInfo;
    bTemp = fields->info; /*Echo back */

    if (fields->isOpcode)
    {
        switch(fields->info)
        {
        case GTI_EOC_CMD_NEXT:
            infoPtr->state = GTI_EOC_STATE_READ;
            break;

        case GTI_EOC_CMD_HOLD:
        case GTI_EOC_CMD_RTN:
            infoPtr->state = GTI_EOC_STATE_IDLE;
            break;

        default:
            infoPtr->state = GTI_EOC_STATE_IDLE;
            bTemp = GTI_EOC_CMD_UTC;
            break;
        }
    }
    retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
            GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY, bTemp);

    return retEocMsg;
}

/************************************************************************
* GTIEocStateRead
************************************************************************/
GTI_WORD GTIEocStateRead(GTI_XCVR_INFO *GTISysPtr,
                         GTIEOC_CMD *hostPtr,
                         GTIEOC_FIELDS *fields)
{
    GTIEOC_INFO *infoPtr;
    GTI_WORD retEocMsg=0;
    GTI_BYTE bTemp;

    NOT_USED(hostPtr);

    /* Get the saved structure for EOC */
    infoPtr = (GTIEOC_INFO *)&GTISysPtr->eocInfo;

    /* Is it OPCODE? */
    if (fields->isOpcode)
    {
        switch (fields->info)
        {
        case GTI_EOC_CMD_NEXT:
            /* Send Data */
            if (infoPtr->regIndex < infoPtr->regLength)
            {
                retEocMsg = GTI_EOC_M_MAKE_MSG( GTI_EOC_ATUR_ADDRESS,
                    GTI_EOC_DATA_FIELD, (fields->parity<<5),
                    (infoPtr->regData[infoPtr->regIndex]) );
                infoPtr->regIndex++;
            }
            else
            {
                /* Send End of Data */
                bTemp = GTI_EOC_CMD_EOD;
                retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
                    GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
                    bTemp);
                /* Do not change the state */
            }
            break;

        case GTI_EOC_CMD_RTN:
            /* Remove any latches */
            if (infoPtr->latch)
            {
                WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_OFFSET, GTI_PSRAM0W );
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, GTI_EOC_REQCOR_DISABLE, 0);
               UPDATE_DSP(GTISysPtr);

                infoPtr->latch = GTI_FALSE; /* FLASE Remove latch */
            }
            infoPtr->state = GTI_EOC_STATE_IDLE;
            break;

        case GTI_EOC_CMD_HOLD:
            /* Save any Latches */
            infoPtr->state = GTI_EOC_STATE_IDLE;
            break;

        default:
            /* Send UTC */;
            bTemp = GTI_EOC_CMD_UTC;
            retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
                GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
                bTemp);
            /* NOTE: This should be GTI_EOC_STATE_UTC */
            infoPtr->state = GTI_EOC_STATE_IDLE;
            break;
        }
    }
    else
    {
        /* Send UTC */;
        bTemp = GTI_EOC_CMD_UTC;
        retEocMsg = GTI_EOC_M_MAKE_MSG(GTI_EOC_ATUR_ADDRESS,
            GTI_EOC_OPCODE_FIELD, GTI_EOC_ODD_PARITY,
            bTemp);
        /* NOTE: This should be GTI_EOC_STATE_UTC */
        infoPtr->state = GTI_EOC_STATE_IDLE;
    }

    return retEocMsg;
}

/************************************************************************
* GTIEocExecCmd
************************************************************************/
GTI_WORD GTIEocExecCmd
(
                       GTI_XCVR_INFO *GTISysPtr,
                       GTIEOC_CMD *hostPtr,
                       GTI_WORD eocMsg)
{
    GTIEOC_FIELDS  eocFields;

    /* Get EOC Message Fields */
    eocFields.addr = GTI_EOC_M_ADDR_FIELD(eocMsg);
    eocFields.isOpcode = GTI_EOC_M_OPCODE_FIELD(eocMsg);
    eocFields.parity = GTI_EOC_M_PARITY_FIELD(eocMsg);
    eocFields.isMsg = GTI_EOC_M_MSG_FIELD(eocMsg);
    eocFields.info = GTI_EOC_M_INFO_FIELD(eocMsg);

    switch( GTISysPtr->eocInfo.state )
    {
    case GTI_EOC_STATE_IDLE: /* 0 */
        return ( GTIEocStateIdle(GTISysPtr, hostPtr, &eocFields) );

    case GTI_EOC_STATE_WRITE:      /* 2 */
        return ( GTIEocStateWrite(GTISysPtr, hostPtr, &eocFields) );

    case GTI_EOC_STATE_PREREAD:    /* 3 */
        return ( GTIEocStatePreRead(GTISysPtr, hostPtr, &eocFields) );

    case GTI_EOC_STATE_READ:       /* 4 */
        return ( GTIEocStateRead(GTISysPtr, hostPtr, &eocFields) );

    case GTI_EOC_STATE_UTC:
    case GTI_EOC_STATE_LPR:
    case GTI_EOC_STATE_PREWRITE:
    default:
        return ( 0 );
    }
}

#else /*XDP EOC*/

GTI_WORD GTIEocRegLenPos(GTIEOC_CMD *hostPtr, GTI_BYTE *regLen, GTI_BYTE *regDefaultLen)
{
	GTI_WORD regPos=0;
	GTIEOC_REG_TABLE *reg = (GTIEOC_REG_TABLE *) GTIEocRegInfo;

	for ( ; (hostPtr->tx.EocCmd != reg->regID); reg++)
   		regPos += reg->regLen;
	*regLen = (hostPtr->tx.EocLen < reg->regLen ?
                hostPtr->tx.EocLen: reg->regLen);
    	*regDefaultLen = reg->regLen;
	return regPos;
}

/************************************************************************
* FUNCTION     : GTIEocDataReg()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/

void GTIEocDataReg(GTI_XCVR_INFO *GTISysPtr, GTIEOC_INFO *infoPtr, GTIEOC_CMD *hostPtr)
{
    GTI_BYTE i, regLen, regDefaultLen;
	GTI_WORD regPos;

    switch (hostPtr->tx.EocCmd)
    {
    case GTI_EOC_CMD_VPP1:
    case GTI_EOC_CMD_WRITEREG0:
    case GTI_EOC_CMD_WRITEREG1:
    case GTI_EOC_CMD_WRITEREG2:
    case GTI_EOC_CMD_WRITEREG3:
    case GTI_EOC_CMD_WRITEREG4:
    case GTI_EOC_CMD_WRITEREG5:
    case GTI_EOC_CMD_WRITEREG6:
    case GTI_EOC_CMD_WRITEREG7:
    case GTI_EOC_CMD_WRITEREG8:
    case GTI_EOC_CMD_VPP3:
        if (hostPtr->tx.EocLen > 0)
        {
            regPos = GTIEocRegLenPos(hostPtr, &regLen, &regDefaultLen) +
                GTI_HOST_XREG_TABLE_LOC;
            /* Turn ON the Auto Increment */
            CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AP);
            if(regPos > 0xff) /*cross page boundary */
                WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, (regPos-256), GTI_XSRAM1);
            else
                WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, regPos, GTI_XSRAM0); 
            for(i=0; i<regLen; i++) 
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, hostPtr->tx.EocData[i], 0);
            for( ; i<regDefaultLen; i++)/*rest fill with zero*/
               WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, 0);
            /* Turn OFF the Auto Increment */
            CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
        }
        else
            hostPtr->tx.Status = GTI_EOC_INVALID_LEN;
        break;

    case GTI_EOC_CMD_RESET:
        /* Turn ON the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AP);
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_XCURRENT_STATE_LOC
            , GTI_XSRAM0 );
        for( i=0; i<5; i++)
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, 0);
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
        GTIEocInit(infoPtr);
        break;

#ifdef GTI_PAGE_D_BUILT
    case GTI_EOC_CMD_VPP2:  /*send aoc command to co */
        infoPtr->tick = 0;
        GTIAocProc(GTISysPtr, infoPtr, hostPtr);
        break;
#endif

    default:
        hostPtr->tx.Status = GTI_EOC_INVALID_CMD;
        break;
    }
}


/************************************************************************
* FUNCTION     : Gti_EocProcXdp()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void Gti_EocProcXdp(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr)


{
    GTIEOC_INFO *eocInfoPtr;
    GTI_WORD    dspState=0;

    /* Get the saved structure for EOC */
    eocInfoPtr = (GTIEOC_INFO *)&GTISysPtr->eocInfo;

    /* Initialize the output parameters */
    hostPtr->rx.AutoLen = 0;
    hostPtr->rx.EocCmd = 0;
    hostPtr->rx.EocLen = 0;
    hostPtr->rx.Status = GTI_EOC_COMPLETE;
    hostPtr->tx.Status = GTI_EOC_COMPLETE;  /* OK */
    if (eocInfoPtr->eocDisabled)
    {
        /* Check to see the if we are in DATA_MODE */
        (void)Gti_SStatusXCVR(GTISysPtr, GTI_OP_STATE, &dspState, sizeof(dspState), 0);
        if (dspState != GTI_DATA_OP)
            return;
        eocInfoPtr->eocDisabled = GTI_FALSE;
    }
#ifdef GTI_PAGE_D_BUILT
    if (hostPtr->tx.EocCmd)
        GTIEocDataReg(GTISysPtr, eocInfoPtr, hostPtr);
    else if (eocInfoPtr->tick)
        GTIAocProc(GTISysPtr, eocInfoPtr, hostPtr);
#else
    if (hostPtr->tx.EocCmd)
        GTIEocDataReg(GTISysPtr, eocInfoPtr, hostPtr);
#endif
}
#endif /* GTI_EOC_XDP */
#else
/************************************************************************
* FUNCTION     : Gti_EocProcBis()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void Gti_EocProcBis(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr)
{
    GTIEOC_INFO *eocInfo;
    GTI_OH_STATUS ohStatus;
    GTI_WORD    dspState=0;

    /* Get the saved structure for EOC */
    eocInfo = (GTIEOC_INFO *)&GTISysPtr->eocInfo;
    hostPtr->rx.EocOHCmd[0] = 0;
    hostPtr->rx.EocCmd = 0;
    hostPtr->rx.EocLen = 0;
    hostPtr->rx.AutoLen = 0;
    if (eocInfo->eocDisabled)
    {
        /* Check to see the if we are in DATA_MODE */
        if (!Gti_SStatusXCVR(GTISysPtr, GTI_OP_STATE, &dspState,
            sizeof(dspState), 0))
            return;

        if (dspState == GTI_DATA_OP)
        {
            Gti_OhReadRegIndex(GTISysPtr);
            eocInfo->eocDisabled = GTI_FALSE;          
        }
        else
            return;
    }
    Gti_OhReadStatus(GTISysPtr, hostPtr, &ohStatus);
    /* response received */
    if (ohStatus.rspFlag)
        Gti_OhReadResp(GTISysPtr, hostPtr, eocInfo, &ohStatus);
    /* write overhead data */
    if (!Gti_OhWriteReg(GTISysPtr, hostPtr, eocInfo))
        /* send overhead command*/
        Gti_OhSendCommand(GTISysPtr, hostPtr, eocInfo, &ohStatus);    
    /* Return the correct status */
    hostPtr->rx.Status = eocInfo->status;
}

/************************************************************************
* FUNCTION     : Gti_OhWriteReg()
* DESCRIPTION  :
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
GTI_BYTE Gti_OhWriteReg(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr, 
    GTIEOC_INFO *infoPtr)
{
    GTI_BYTE iLoop=0, iLoop2=0, regLen, regFound = GTI_FALSE,
        regFound2 = GTI_FALSE, retFlag = GTI_FALSE;
    if (hostPtr->tx.EocOHCmd[0] == GTI_OH_CMD_GSPN)
    {
        switch (hostPtr->tx.EocOHCmd[1])
        {
            case GTI_OH_CMD_WRITE_ID:
            case GTI_OH_CMD_WRITE_AUX_ID:
            case GTI_OH_CMD_WRITE_STR:
            case GTI_OH_CMD_WRITE_LATN:
            case GTI_OH_CMD_WRITE_SNRM:
            case GTI_OH_CMD_WRITE_MULTI_TP:
                while (!regFound && iLoop < GTI_OH_TOTAL_WRITE_REG )
                {
                    regFound = (hostPtr->tx.EocOHCmd[1] == GTIOhWriteReg[iLoop].ohWriteCmd);
                    if (!regFound)
                        iLoop++;
                }
                if(!regFound)
                    hostPtr->tx.Status = GTI_EOC_INVALID_CMD;
                else
                {
                    hostPtr->rx.AutoData[0] = hostPtr->tx.EocOHCmd[0];
                    hostPtr->rx.AutoData[1] = hostPtr->tx.EocOHCmd[1];
                    while (!regFound2 && iLoop2 < GTI_OH_TOTAL_NUM_REG )
                    {
                        regFound2 = (GTIOhWriteReg[iLoop].ohCmd[0] == ohRegInfo[iLoop2].ohCmd[0]
                            && GTIOhWriteReg[iLoop].ohCmd[1] == ohRegInfo[iLoop2].ohCmd[1]
                            && GTIOhWriteReg[iLoop].ohCmd[2] == ohRegInfo[iLoop2].ohCmd[2]);
                        if (!regFound2)
                            iLoop2++;
                    }
                    if (!regFound2)
                        hostPtr->tx.Status = GTI_EOC_ERROR;
                    else
                    {
                        if (hostPtr->tx.EocLen > 0)
                        {
                            if (hostPtr->tx.EocLen%2)
                                hostPtr->tx.EocData[hostPtr->tx.EocLen++] = 0x00;
                            
                            regLen = ( hostPtr->tx.EocLen > (ohRegInfo[iLoop2].ohLen*2) ?
                                ohRegInfo[iLoop2].ohLen : (hostPtr->tx.EocLen/2) );
                            /* Turn ON the Auto Increment */
                            CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
                            WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, ohRegInfo[iLoop2].ohLoc, GTI_XSRAM0 );
                            for(iLoop=0; iLoop<regLen; iLoop++)
                                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, hostPtr->tx.EocData[iLoop*2],
                                hostPtr->tx.EocData[iLoop*2+1]);
                            for( ; iLoop<ohRegInfo[iLoop2].ohLen; iLoop++)/*rest fill with zero*/
                                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0, 0);
                            /* Turn OFF the Auto Increment */
                            CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
                            for(iLoop=0; iLoop<3; iLoop++)	
                                hostPtr->rx.EocOHCmd[iLoop] = hostPtr->tx.EocOHCmd[iLoop];
                            hostPtr->tx.Status = GTI_EOC_COMPLETE;
                            hostPtr->rx.Status = GTI_EOC_COMPLETE;                
                        }
                        else
                        {
                            hostPtr->tx.Status = GTI_EOC_INVALID_LEN;
                            hostPtr->rx.Status = GTI_EOC_INVALID_LEN;
                        }
                    }    
                }
                break;

            case GTI_OH_CMD_GSPN_RESET:
                WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_OH_BUSY_LOC, GTI_PSRAM0W );
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x00, 0x00);
                WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_HDLC_FRAME_SEND_LOC, GTI_PSRAM0W );
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x00, 0x00);
                WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_RCV_OH_RESP_LOC, GTI_PSRAM0W );
                WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x00, 0x00);
                //GTIEocInit(infoPtr);
                infoPtr->status = GTI_EOC_COMPLETE;
                for(iLoop=0; iLoop<3; iLoop++)	
                    hostPtr->rx.EocOHCmd[iLoop] = hostPtr->tx.EocOHCmd[iLoop];
                hostPtr->tx.Status = GTI_EOC_COMPLETE;
                hostPtr->rx.Status = GTI_EOC_COMPLETE;                
                break;
    
            default:
                hostPtr->tx.Status = GTI_EOC_INVALID_CMD;
                hostPtr->rx.Status = GTI_EOC_INVALID_CMD;
        };
        hostPtr->tx.EocOHCmd[0] = 0x00;
        hostPtr->rx.EocCmd = 0xe0;
        retFlag = GTI_TRUE;
    }
    return retFlag;
}
/************************************************************************
* FUNCTION     : Gti_OhRespNack()
* DESCRIPTION  : Check if response is NACK
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/

GTI_BYTE Gti_OhRespNack(GTIEOC_INFO *eocInfo, GTI_BYTE respNack)
{
    GTI_BYTE iLoop = 0, iLoop2 = 0, gbFlag = GTI_FALSE, gbFlag2 = GTI_FALSE;

    while((iLoop < GTI_OH_TOTAL_NACK_REG) && (!gbFlag))
    {
        gbFlag = (eocInfo->hostReqCmd == GTIOhRespNack[iLoop].ohCmd);
        if (!gbFlag)
            iLoop++;
        else
        {
            while( (iLoop2 < GTIOhRespNack[iLoop].totalNack) && (!gbFlag2))
            {
                gbFlag2 = (GTIOhRespNack[iLoop].respNack[iLoop2] == respNack);
                if (!gbFlag2)
                    iLoop2++;
            }
        }
    }
    return gbFlag2;
}

/************************************************************************
* FUNCTION     : Gti_OhReadResp()
* DESCRIPTION  : Read response from pcu
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void Gti_OhReadResp(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr,
			GTIEOC_INFO *eocInfo, GTI_OH_STATUS *ohStatus)
{

    int iLoop;
    GTI_WORD wTemp, regLen;

    regLen = (ohStatus->rcvLen > GTI_OH_MAX_DATA_LEN ? GTI_OH_MAX_DATA_LEN
        : ohStatus->rcvLen);

    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_RX_HDLC_PAYLOAD_LOC,
               (GTI_READ_DSP | GTI_PSRAM0W));
    wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
    if (Gti_OhRespNack(eocInfo, HIBYTE(wTemp)))
    {
        hostPtr->rx.Status = GTI_EOC_UTC;
        eocInfo->status = GTI_EOC_UTC;
    }
    else
    {
        hostPtr->rx.Status = GTI_EOC_COMPLETE;
        eocInfo->status = GTI_EOC_COMPLETE;
    }
    if (regLen > 0)
    {
        /* Turn ON Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_RX_HDLC_PAYLOAD2_LOC,
            (GTI_READ_DSP | GTI_PSRAM0W));
        for(iLoop=0; iLoop<DIVBYTWO(regLen); iLoop++)
        {
            wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
            hostPtr->rx.EocData[iLoop*2] =  LOBYTE(wTemp);
            hostPtr->rx.EocData[iLoop*2+1] = HIBYTE(wTemp);
        }
        /* Turn OFF the Auto Increment */
        CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
    }

    hostPtr->rx.EocOHCmd[0] = eocInfo->hostReqCmd;
    hostPtr->rx.EocOHCmd[1] = eocInfo->hostReqOHCmd1;
    hostPtr->rx.EocOHCmd[2] = eocInfo->hostReqOHCmd2;
    hostPtr->rx.EocLen = regLen;
    hostPtr->rx.EocCmd = 0xe0;
    eocInfo->hostReqCmd = 0;    
    /* reset flag */
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_RCV_OH_RESP_LOC, GTI_PSRAM0W);
    WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x00, 0x00);
}

/************************************************************************
* FUNCTION     : Gti_OhPcuReadStatus()
* DESCRIPTION  : Read status from pcu
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/
void Gti_OhReadStatus(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr,
    GTI_OH_STATUS *ohStatus)
{
    GTI_WORD wTemp;

    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_OH_BUSY_LOC,
                   (GTI_READ_DSP | GTI_PSRAM0W));
    wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
    ohStatus->busyFlag = LOBYTE(wTemp);
    ohStatus->txLock = HIBYTE(wTemp);
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_RCV_OH_RESP_LOC,
                   (GTI_READ_DSP | GTI_PSRAM0W));
    wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
    ohStatus->rspFlag = LOBYTE(wTemp);
    if(ohStatus->rspFlag)
    {
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_HDLC_SIZE_LOC,
                   (GTI_READ_DSP | GTI_PSRAM0W));
        wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
        ohStatus->rcvLen = ((HIBYTE(wTemp)>1) ? (HIBYTE(wTemp) - 2) : 0);
    }
    if((hostPtr->tx.EocOHCmd[0]) && (hostPtr->tx.EocOHCmd[0] != GTI_OH_CMD_GSPN)
        && (!ohStatus->txLock) && (!ohStatus->busyFlag))
    {
        /* set oh tx lock */	
        WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_OH_BUSY_LOC, GTI_PSRAM0W);
        WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x00, 0x01);
    }
}
/************************************************************************
* FUNCTION     : Gti_OhReadRegIndex()
* DESCRIPTION  : Send overhead command
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/

void Gti_OhReadRegIndex(GTI_XCVR_INFO *GTISysPtr)
{
    GTI_WORD wTemp;
    int iLoop;
    /* Turn ON the Auto Increment */
    CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_INDEX_TABLE_LOC,
        (GTI_READ_DSP | GTI_XSRAM0) );
    for(iLoop=0; iLoop<GTI_OH_TOTAL_NUM_REG; iLoop++)
    {
        wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
        ohRegInfo[iLoop].ohCmd[0] = (GTI_BYTE) (wTemp & 0xFF);
        ohRegInfo[iLoop].ohCmd[1] = (GTI_BYTE) ((wTemp>>8) & 0xFF);
        wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
        ohRegInfo[iLoop].ohCmd[2] = (wTemp & 0xFF) ? (GTI_BYTE) ((wTemp>>8) & 0xFF) : 0;
        wTemp = READ_DSP_WORD(GTISysPtr, GTI_DSP_A);
        ohRegInfo[iLoop].ohLen = (GTI_BYTE) (wTemp & 0xFF);
        ohRegInfo[iLoop].ohLoc = (GTI_BYTE) (((wTemp>>8) & 0xFF) + 
                GTI_HOST_REG_TABLE_LOC);
    }
    /* Turn OFF the Auto Increment */
    CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI); 
}
/************************************************************************
* FUNCTION     : Gti_OhSendCommand()
* DESCRIPTION  : Send overhead command
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/

void Gti_OhSendCommand(GTI_XCVR_INFO *GTISysPtr, GTIEOC_CMD *hostPtr,
    GTIEOC_INFO *eocInfo, GTI_OH_STATUS *ohStatus)
{
    int iLoop, iHdlcSize = 4;

    if (hostPtr->tx.EocOHCmd[0])
    {
        if (Gti_OhValidStatCmd(hostPtr, eocInfo, ohStatus))
        {
            /* Turn ON the Auto Increment */
            CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_AI);
            /*write opcode in pcu buf & send */
            WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_HDLC_PAYLOAD_LOC,
                GTI_PSRAM0W);
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, hostPtr->tx.EocOHCmd[0], 
                hostPtr->tx.EocOHCmd[1] );
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, hostPtr->tx.EocOHCmd[2], 0x22);
            /* Turn OFF the Auto Increment */
            CONFIGURE_DSP(GTISysPtr, GTI_DSP_A, GTI_NO_AI);
            /* write tx hdlc size */	
            WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_HDLC_SIZE_LOC,
                GTI_PSRAM0W);
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, iHdlcSize, 0x00);
            /* set to go frame send and initiate new command*/
            WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_HDLC_FRAME_SEND_LOC,
                GTI_PSRAM0W);            
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x01, 0x01);

            eocInfo->hostReqCmd = hostPtr->tx.EocOHCmd[0];
            eocInfo->hostReqOHCmd1 = hostPtr->tx.EocOHCmd[1];
            eocInfo->hostReqOHCmd2 = hostPtr->tx.EocOHCmd[2];
            eocInfo->status = GTI_EOC_BUSY;
            hostPtr->rx.Status = GTI_EOC_BUSY;
            hostPtr->tx.Status = GTI_EOC_COMPLETE;
        }
        hostPtr->tx.EocOHCmd[0] = 0x00;
        hostPtr->tx.EocCmd = 0x00;
        if(hostPtr->tx.Status != GTI_EOC_COMPLETE && !ohStatus->txLock)
        {
            /* reset oh tx lock  */
            WRITE_DSP_ADDR(GTISysPtr, GTI_DSP_A, GTI_HOST_TX_OH_BUSY_LOC, GTI_PSRAM0W);
            WRITE_DSP_WORD(GTISysPtr, GTI_DSP_A, 0x00, 0x00);
        }
        
    }
}
/************************************************************************
* FUNCTION     : Gti_OhValidStatCmd()
* DESCRIPTION  : Verify tx command sent by the host
*              :
* INPUT        :
* OUTPUT       : None
* RETURN       : None
************************************************************************/

GTI_BYTE Gti_OhValidStatCmd(GTIEOC_CMD *hostPtr, GTIEOC_INFO *eocInfo,
    GTI_OH_STATUS *ohStatus)
{
    GTI_BYTE gbFlag = GTI_TRUE;

    if ((eocInfo->status != GTI_EOC_BUSY) && (!ohStatus->txLock) && 
        (!ohStatus->busyFlag) )
    {
        switch(hostPtr->tx.EocOHCmd[0])
        {
            case GTI_OH_CMD_OLR:
                switch(hostPtr->tx.EocOHCmd[1])
                {
                    case GTI_OH_CMD_OLR_TYPE1:
                    case GTI_OH_CMD_OLR_TYPE2:
                    case GTI_OH_CMD_OLR_TYPE3:
                        break;
                    default:
                        gbFlag = GTI_FALSE;
                }
                break;
                
            case GTI_OH_CMD_EOC:
                switch(hostPtr->tx.EocOHCmd[1])
                {
                    case GTI_OH_CMD_EOC_UTP:
                        break;
                    default:
                        gbFlag = GTI_FALSE;
                }
                break;

            case GTI_OH_CMD_TIME:
                gbFlag = GTI_FALSE;
                break;

            case GTI_OH_CMD_INVENTORY:
                switch(hostPtr->tx.EocOHCmd[1])
                {
                    case GTI_OH_CMD_INV_ID:
                    case GTI_OH_CMD_INV_AUX_ID:
                    case GTI_OH_CMD_INV_STR:
                    case GTI_OH_CMD_INV_PMD:
                    case GTI_OH_CMD_INV_PMS_TC:
                    case GTI_OH_CMD_INV_TPS_TC:
                        break;
                    default:
                        gbFlag = GTI_FALSE;
                }
                break;

            case GTI_OH_CMD_CPR:
                switch(hostPtr->tx.EocOHCmd[1])
                {
                    case GTI_OH_CMD_CPR_PMD:
                    case GTI_OH_CMD_CPR_PMS_TC:
                    case GTI_OH_CMD_CPR_TPS_TC:
                        break;
                    default:
                        gbFlag = GTI_FALSE;
                }
                break;

            case GTI_OH_CMD_MCR:     /* Management counter read */
                if (hostPtr->tx.EocOHCmd[1] != GTI_OH_CMD_MCR_READ)
                    gbFlag = GTI_FALSE;
                break;

            case GTI_OH_CMD_PM:     /* Power management */
                switch(hostPtr->tx.EocOHCmd[1])
                {
                    case GTI_OH_CMD_PM_TYPE1:
                    case GTI_OH_CMD_PM_TYPE2:
                    case GTI_OH_CMD_PM_TYPE3:
                        break;
                    default:
                        gbFlag = GTI_FALSE;
                }
                break;

            case GTI_OH_CMD_CEOC:     /* Clear EOC */
                if (hostPtr->tx.EocOHCmd[1] != GTI_OH_CMD_CEOC_SEND)
                    gbFlag = GTI_FALSE;
                break;

            case GTI_OH_CMD_NSF:     /* Non-standard facility */
                if (hostPtr->tx.EocOHCmd[1] != GTI_OH_CMD_NSF_SEND)
                    gbFlag = GTI_FALSE;
                break;

            case GTI_OH_CMD_TPR:     /* Test parameters read */
                switch(hostPtr->tx.EocOHCmd[1])
                {
                    case GTI_OH_CMD_TPR_SINGLE:
                        switch(hostPtr->tx.EocOHCmd[2])
                        {
                            case GTI_OH_CMD_TPR_SGL_CTF:
                            case GTI_OH_CMD_TPR_SGL_QLN:
                            case GTI_OH_CMD_TPR_SGL_SNR:
                            case GTI_OH_CMD_TPR_SGL_MP:
                            case GTI_OH_CMD_TPR_SGL_LATN:
                            case GTI_OH_CMD_TPR_SGL_SATN:
                            case GTI_OH_CMD_TPR_SGL_SNRM:
                            case GTI_OH_CMD_TPR_SGL_ATTNDR:
                            case GTI_OH_CMD_TPR_SGL_NACTATP:
                            case GTI_OH_CMD_TPR_SGL_FACTATP:     
                                break;
                            default:
                                gbFlag = GTI_FALSE;
                        }
                        break;
                    case GTI_OH_CMD_TPR_MULTIPLE_PLUS:
                        gbFlag = ((hostPtr->tx.EocData[0]<<8 + hostPtr->tx.EocData[1])
                            <= GTI_OH_MULTIPLE_MAX_SC);
                        break;
                    case GTI_OH_CMD_TPR_MULTIPLE:                        
                    case GTI_OH_CMD_TPR_NEXT:
                        break;
                    default:
                        gbFlag = GTI_FALSE;
                }
                break;

            case GTI_OH_CMD_NSF_LP:	/* Non-standard facility low priority */
                break;

            case GTI_OH_CMD_GSPN:
                break;
                
             default:
                gbFlag = GTI_FALSE;
        };
    }
    else
    {
        hostPtr->tx.Status = GTI_EOC_BUSY;
        gbFlag = GTI_FALSE;
    }
    return gbFlag;
}

#endif /* GTI_PAGE_I_BUILT */


