/* Copyright (C) 1996-2003 GlobeSpanVirata, Inc. */

/*
 * @(#)gti_yat.c	1.18.7.3
*/

#include "gti.h"

#define GTI_SKIP_SAS_LABELS

#ifdef GTI_PAGE_A_BUILT
#include "gtipsasa.h"
#endif
#ifdef GTI_PAGE_B_BUILT
#include "gtipsasb.h"
#endif
#ifdef GTI_PAGE_C_BUILT
#include "gtipsasc.h"
#endif
#ifdef GTI_PAGE_D_BUILT
#include "gtipsasd.h"
#endif
#ifdef GTI_PAGE_E_BUILT
#include "gtipsase.h"
#endif

#undef GTI_SKIP_SAS_LABELS

/* Tables not used if XDMA or XDP */
#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)

#ifdef __BORLANDC__
#pragma option -zESTARTUP_TABLE -zFSPECIAL
#endif

/* The followng tables are the Startup Look Up tables that are used in gtiparam.c */

/******************************************** Page A *********************************************/

#ifdef GTI_PAGE_A_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_a[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCoHVY_a_PAGE_CMD,   GTI_startDmtToneCpHVY_a_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDisHVY_a_PAGE_CMD,       GTI_abortCpDisHVY_a_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_abortCoDisHVY_a_PAGE_CMD,       GTI_abortCpDisHVY_a_PAGE_CMD,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecRevTstHVY_a_PAGE_CMD,     GTI_CpSpecRevTstHVY_a_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_TestRsMemory_a_PAGE_CMD,        GTI_TestRsMemory_a_PAGE_CMD,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTstHVY_a_PAGE_CMD,     GTI_CpSpecMedTstHVY_a_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_CoSpecPilotTstHVY_a_PAGE_CMD,   GTI_CpSpecPilotTstHVY_a_PAGE_CMD,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_COFastRetrain_a_PAGE_CMD,       GTI_CPFastRetrain_a_PAGE_CMD,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_COProfMngt_a_PAGE_CMD,          GTI_CPProfMngt_a_PAGE_CMD,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_CoSpecCoPBinTstHVY_a_PAGE_CMD,  GTI_CpSpecCoPBinTstHVY_a_PAGE_CMD,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_CPBitSwapping_a_PAGE_CMD,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_CoSpecCpPBinTstHVY_a_PAGE_CMD,  GTI_CpSpecCpPBinTstHVY_a_PAGE_CMD,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_a_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* After Jup Calibration        0 */ {GTI_StartAfterJupCalibration_a_PAGE_CMD,        GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,    GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};

#endif /* Page A */

#ifdef GTI_PAGE_B_BUILT
/******************************************** Page B *********************************************/

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_b[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCo_b_PAGE_CMD,      GTI_startDmtToneCp_b_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDis_b_PAGE_CMD,          GTI_abortCpDis_b_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTest_b_PAGE_CMD,          GTI_CpSpecTest_b_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTst_b_PAGE_CMD,        GTI_CpSpecMedTst_b_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_b_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jupiter Calib                0 */ {GTI_StartAnnexCAfterJupCali_b_PAGE_CMD,    GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* End B  */

#ifdef GTI_PAGE_C_BUILT

/******************************************** Page C *********************************************/

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_c[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+------------------------- LABELS -----------------------*/
    /* ---------------------------------+------------ CO --------------+-------- CP -------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_a_startALpbk_c_PAGE_CMD,        GTI_a_startALpbk_c_PAGE_CMD,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_a_startDLpbk_c_PAGE_CMD,        GTI_a_startDLpbk_c_PAGE_CMD,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_downLdTstCOM_c_PAGE_CMD,        GTI_downLdTstCOM_c_PAGE_CMD,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_AtmLoopBackCOM_c_PAGE_CMD,      GTI_AtmLoopBackCOM_c_PAGE_CMD,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_TestDriversCOM_c_PAGE_CMD,      GTI_TestDriversCOM_c_PAGE_CMD,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_JupTxFltCali_c_PAGE_CMD,        GTI_JupTxFltCali_c_PAGE_CMD,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_SpecCRevTstRX_c_PAGE_CMD,       GTI_SpecCRevTstRX_c_PAGE_CMD,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_SpecCPBinTstRX_c_PAGE_CMD,      GTI_SpecCPBinTstRX_c_PAGE_CMD,
};

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)
/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_c_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jump To Jupiter calibration  0 */ {GTI_JupTxFltCali_c_PAGE_CMD,      GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif

#endif /* Page "C" */

#ifdef GTI_PAGE_D_BUILT

/******************************************** Page D *********************************************/

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_d[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCoHVY_d_PAGE_CMD,   GTI_startDmtToneCpHVY_d_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDisHVY_d_PAGE_CMD,       GTI_abortCpDisHVY_d_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_abortCoDisHVY_d_PAGE_CMD,       GTI_abortCpDisHVY_d_PAGE_CMD,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecRevTstHVY_d_PAGE_CMD,     GTI_CpSpecRevTstHVY_d_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTstHVY_d_PAGE_CMD,     GTI_CpSpecMedTstHVY_d_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_CoSpecPilotTstHVY_d_PAGE_CMD,   GTI_CpSpecPilotTstHVY_d_PAGE_CMD,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_COFastRetrain_d_PAGE_CMD,       GTI_CPFastRetrain_d_PAGE_CMD,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_CPProfMngt_d_PAGE_CMD,
    /* GTI_SPECTRUM_C_PBIN_REQ      30 */   GTI_CoSpecCoPBinTstHVY_d_PAGE_CMD,  GTI_CpSpecCoPBinTstHVY_d_PAGE_CMD,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_CPBitSwapping_d_PAGE_CMD,
    /* GTI_SPECTRUM_R_PBIN_REQ      32 */   GTI_CoSpecCpPBinTstHVY_d_PAGE_CMD,  GTI_CpSpecCpPBinTstHVY_d_PAGE_CMD,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_d_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Comment about usage          0 */ {GTI_StartAfterJupCalibration_d_PAGE_CMD,   GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* Page "D" */

/******************************************** Page E *********************************************/

#ifdef GTI_PAGE_E_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_e[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCo_e_PAGE_CMD,      GTI_startDmtToneCp_e_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDis_e_PAGE_CMD,          GTI_abortCpDis_e_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_abortCoDis_e_PAGE_CMD,          GTI_abortCpDis_e_PAGE_CMD,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTest_e_PAGE_CMD,          GTI_CpSpecTest_e_PAGE_CMD, 
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,        		GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTst_e_PAGE_CMD,        GTI_CpSpecMedTst_e_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_e_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Comment about usage          0 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* Page "E" */

/******************************************** Page F *********************************************/

#ifdef GTI_PAGE_F_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_f[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCoHVY_f_PAGE_CMD,      GTI_startDmtToneCpHVY_f_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDisHVY_f_PAGE_CMD,       GTI_abortCpDisHVY_f_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_abortCoDisHVY_f_PAGE_CMD,       GTI_abortCpDisHVY_f_PAGE_CMD,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecRevTstHVY_f_PAGE_CMD,     GTI_CpSpecRevTstHVY_f_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,        		GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTstHVY_f_PAGE_CMD,     GTI_CpSpecMedTstHVY_f_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_CoSpecPilotTstHVY_f_PAGE_CMD,   GTI_CpSpecPilotTstHVY_f_PAGE_CMD,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_CoSpecCoPBinTstHVY_f_PAGE_CMD,  GTI_CpSpecCpPBinTstHVY_f_PAGE_CMD,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_COBitSwapping_f_PAGE_CMD,       GTI_CPBitSwapping_f_PAGE_CMD,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_CpSpecCpPBinTstHVY_f_PAGE_CMD,  GTI_CpSpecCpPBinTstHVY_f_PAGE_CMD,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_CoSpecRevTstHVY_f_PAGE_CMD,     GTI_CpSpecRevTstHVY_f_PAGE_CMD,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_US_BS_REQ                37 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    38 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)
/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_f_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Comment about usage          0 */ {GTI_StartHSAfterAfeCalib_f_PAGE_CMD,             GTI_PAGE_NONE},
    /* Continue HS after xdp eoc code load   1 */ {GTI_StartHSAfterXEocLoad_f_PAGE_CMD,    GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                        GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif
#endif /* Page "F" */

/******************************************** Page G *********************************************/

#ifdef GTI_PAGE_G_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_g[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCo_g_PAGE_CMD,      GTI_startDmtToneCp_g_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDis_g_PAGE_CMD,          GTI_abortCpDis_g_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTest_g_PAGE_CMD,          GTI_CpSpecTest_g_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTst_g_PAGE_CMD,        GTI_CpSpecMedTst_g_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_US_BS_REQ                37 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    38 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_g_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jupiter Calib                0 */ {GTI_StartAnnexCAfterJupCali_g_PAGE_CMD,    GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* End G  */




/******************************************** Page H *********************************************/

#ifdef GTI_PAGE_H_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_h[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCo_h_PAGE_CMD,      GTI_startDmtToneCp_h_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDis_h_PAGE_CMD,          GTI_abortCpDis_h_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTest_h_PAGE_CMD,          GTI_CpSpecTest_h_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTst_h_PAGE_CMD,        GTI_CpSpecMedTst_h_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_US_BS_REQ                37 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    38 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_h_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jupiter Calib                0 */ {GTI_StartAnnexCAfterJupCali_h_PAGE_CMD,    GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* End H  */




/******************************************** Page I *********************************************/

#ifdef GTI_PAGE_I_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_i[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCoHVY_i_PAGE_CMD,      GTI_startDmtToneCpHVY_i_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDisHVY_i_PAGE_CMD,          GTI_abortCpDisHVY_i_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTestHVY_i_PAGE_CMD,          GTI_CpSpecRevTstHVY_i_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTstHVY_i_PAGE_CMD,        GTI_CpSpecMedTstHVY_i_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_US_BS_REQ                37 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    38 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_i_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jupiter Calib                0 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* End I  */


/******************************************** Page J *********************************************/

#ifdef GTI_PAGE_J_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_j[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCo_j_PAGE_CMD,      GTI_startDmtToneCp_j_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDis_j_PAGE_CMD,          GTI_abortCpDis_j_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTest_j_PAGE_CMD,          GTI_CpSpecTest_j_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTst_j_PAGE_CMD,        GTI_CpSpecMedTst_j_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_US_BS_REQ                37 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    38 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_j_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jupiter Calib                0 */ {GTI_StartAnnexCAfterJupCali_j_PAGE_CMD,    GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* End J  */



#ifdef GTI_HOST_SASSTATUS

#ifdef GTI_PAGE_A_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_a[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_RxGain_a_PAGE_CMD,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_BertError_a_PAGE_CMD,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_RxBytes_a_PAGE_CMD,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_TxBytes_a_PAGE_CMD,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_Counters_a_PAGE_CMD,
    /* GTI_FAILURES                 62 */   GTI_Failures_a_PAGE_CMD,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_DummyStatus_a_PAGE_CMD,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_UtopiaCellDrop_a_PAGE_CMD,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_RSFrameCounter_a_PAGE_CMD,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_AtmCellCounter_a_PAGE_CMD,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_IdleBertStatus_a_PAGE_CMD,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_BitSwapCount_a_PAGE_CMD,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_OverlapStatus_a_PAGE_CMD,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_LclTxPower_a_PAGE_CMD,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page A */


#ifdef GTI_PAGE_B_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_b[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page B */




#ifdef GTI_PAGE_C_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_c[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_LastFail_status_c_PAGE_CMD,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_OPState_status_c_PAGE_CMD,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_XmitPower_c_PAGE_CMD,
    /* GTI_START_PROGRESS           9  */   GTI_StartProgress_status_c_PAGE_CMD,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_WatchDog_status_c_PAGE_CMD,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_RmtVendorId_c_PAGE_CMD,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_RmtVendorRevStatus_c_PAGE_CMD,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_ActualConfiguration_c_PAGE_CMD,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_LclCodingGain_c_PAGE_CMD,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_AttenuationStatus_c_PAGE_CMD,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_LclFwRevNum_c_PAGE_CMD,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_RmtTxPower_c_PAGE_CMD,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_FastRetrainStatus_c_PAGE_CMD,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_ReservedStatus0_c_PAGE_CMD,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_ReservedStatus1_c_PAGE_CMD,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_UpStreamMargin_c_PAGE_CMD,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page C */




#ifdef GTI_PAGE_D_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_d[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_RxGain_d_PAGE_CMD,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_BertError_d_PAGE_CMD,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_RxBytes_d_PAGE_CMD,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_TxBytes_d_PAGE_CMD,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_Counters_d_PAGE_CMD,
    /* GTI_FAILURES                 62 */   GTI_Failures_d_PAGE_CMD,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_DummyStatus_d_PAGE_CMD,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_UtopiaCellDrop_d_PAGE_CMD,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_RSFrameCounter_d_PAGE_CMD,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_AtmCellCounter_d_PAGE_CMD,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_IdleBertStatus_d_PAGE_CMD,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_BitSwapCount_d_PAGE_CMD,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_OverlapStatus_d_PAGE_CMD,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_LclTxPower_d_PAGE_CMD,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page D */




#ifdef GTI_PAGE_E_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_e[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page e */




#ifdef GTI_PAGE_F_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_f[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_RxGain_f_PAGE_CMD,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_BertError_f_PAGE_CMD,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_RxBytes_f_PAGE_CMD,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_TxBytes_f_PAGE_CMD,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_Counters_f_PAGE_CMD,
    /* GTI_FAILURES                 62 */   GTI_Failures_f_PAGE_CMD,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_UtopiaCellDrop_f_PAGE_CMD,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_RSFrameCounter_f_PAGE_CMD,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_AtmCellCounter_f_PAGE_CMD,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_IdleBertStatus_f_PAGE_CMD,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_OverlapStatus_f_PAGE_CMD,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page F */




#ifdef GTI_PAGE_G_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_g[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page G */




#ifdef GTI_PAGE_H_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_h[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page H */




#ifdef GTI_PAGE_I_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_i[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page I */




#ifdef GTI_PAGE_J_BUILT
GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_j[GTI_MAX_STATUS_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL --------------------------*/
    /* GTI_FW_REL                   0  */   GTI_EMPTY_ACTION,
    /* GTI_LAST_FAILED_STATUS       1  */   GTI_EMPTY_ACTION,
    /* *********************        2  */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_ERROR            3  */   GTI_EMPTY_ACTION, 
    /* GTI_OP_STATE                 4  */   GTI_EMPTY_ACTION,
    /* GTI_RECEIVER_GAIN            5  */   GTI_EMPTY_ACTION,
    /* GTI_RS_BYTES                 6  */   GTI_EMPTY_ACTION,
    /* GTI_DSP_VERSION              7  */   GTI_EMPTY_ACTION,
    /* GTI_XMIT_POWER               8  */   GTI_EMPTY_ACTION,
    /* GTI_START_PROGRESS           9  */   GTI_EMPTY_ACTION,
    /* GTI_WATCHDOG_TIMER           10 */   GTI_EMPTY_ACTION,
    /* *******************          11 */   GTI_EMPTY_ACTION,
    /* GTI_BERT_ERROR               12 */   GTI_EMPTY_ACTION,
    /* *******************          13 */   GTI_EMPTY_ACTION,
    /* *******************          14 */   GTI_EMPTY_ACTION,
    /* *******************          15 */   GTI_EMPTY_ACTION,
    /* *******************          16 */   GTI_EMPTY_ACTION,
    /* *******************          17 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_ID_STATUS     18 */   GTI_EMPTY_ACTION,
    /* *******************          19 */   GTI_EMPTY_ACTION,
    /* *******************          20 */   GTI_EMPTY_ACTION,
    /* *******************          21 */   GTI_EMPTY_ACTION,
    /* *******************          22 */   GTI_EMPTY_ACTION,
    /* *******************          23 */   GTI_EMPTY_ACTION,
    /* *******************          24 */   GTI_EMPTY_ACTION,
    /* *******************          25 */   GTI_EMPTY_ACTION,
    /* *******************          26 */   GTI_EMPTY_ACTION,
    /* *******************          27 */   GTI_EMPTY_ACTION,
    /* *******************          28 */   GTI_EMPTY_ACTION,
    /* *******************          29 */   GTI_EMPTY_ACTION,
    /* *******************          30 */   GTI_EMPTY_ACTION,
    /* *******************          31 */   GTI_EMPTY_ACTION,
    /* *******************          32 */   GTI_EMPTY_ACTION,
    /* *******************          33 */   GTI_EMPTY_ACTION,
    /* *******************          34 */   GTI_EMPTY_ACTION,
    /* *******************          35 */   GTI_EMPTY_ACTION,
    /* *******************          36 */   GTI_EMPTY_ACTION,
    /* *******************          37 */   GTI_EMPTY_ACTION,
    /* *******************          38 */   GTI_EMPTY_ACTION,
    /* *******************          39 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_VENDOR_REV_STATUS    40 */   GTI_EMPTY_ACTION,
    /* *******************          41 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_UP           42 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_DN           43 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN       44 */   GTI_EMPTY_ACTION,
    /* *******************          45 */   GTI_EMPTY_ACTION,
    /* *******************          46 */   GTI_EMPTY_ACTION,
    /* *******************          47 */   GTI_EMPTY_ACTION,
    /* GTI_RX_BYTES_STATUS          48 */   GTI_EMPTY_ACTION,
    /* GTI_TX_BYTES_STATUS          49 */   GTI_EMPTY_ACTION,
    /* *******************          50 */   GTI_EMPTY_ACTION,
    /* *******************          51 */   GTI_EMPTY_ACTION,
    /* *******************          52 */   GTI_EMPTY_ACTION,
    /* *******************          53 */   GTI_EMPTY_ACTION,
    /* *******************          54 */   GTI_EMPTY_ACTION,
    /* *******************          55 */   GTI_EMPTY_ACTION,
    /* *******************          56 */   GTI_EMPTY_ACTION,
    /* *******************          57 */   GTI_EMPTY_ACTION,
    /* *******************          58 */   GTI_EMPTY_ACTION,
    /* *******************          59 */   GTI_EMPTY_ACTION,
    /* *******************          60 */   GTI_EMPTY_ACTION,
    /* GTI_COUNTERS                 61 */   GTI_EMPTY_ACTION,
    /* GTI_FAILURES                 62 */   GTI_EMPTY_ACTION,
    /* GTI_ACTUAL_CONFIGURATION     63 */   GTI_EMPTY_ACTION,
    /* *******************          64 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_SNR_MARGIN           65 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_CODING_GAIN          66 */   GTI_EMPTY_ACTION,
    /* GTI_ATTENUATION_STATUS       67 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_FW_REV_NUM           68 */   GTI_EMPTY_ACTION,
    /* *******************          69 */   GTI_EMPTY_ACTION,
    /* *******************          70 */   GTI_EMPTY_ACTION,
    /* *******************          71 */   GTI_EMPTY_ACTION,
    /* *******************          72 */   GTI_EMPTY_ACTION,
    /* *******************          73 */   GTI_EMPTY_ACTION,
    /* *******************          74 */   GTI_EMPTY_ACTION,
    /* *******************          75 */   GTI_EMPTY_ACTION,
    /* *******************          76 */   GTI_EMPTY_ACTION,
    /* *******************          77 */   GTI_EMPTY_ACTION,
    /* *******************          78 */   GTI_EMPTY_ACTION,
    /* *******************          79 */   GTI_EMPTY_ACTION,
    /* *******************          80 */   GTI_EMPTY_ACTION,
    /* *******************          81 */   GTI_EMPTY_ACTION,
    /* *******************          82 */   GTI_EMPTY_ACTION,
    /* GTI_DUMMY_STATUS             83 */   GTI_EMPTY_ACTION,
    /* GTI_UTOPIA_CELL_DROP_COUNTER 84 */   GTI_EMPTY_ACTION,
    /* GTI_RS_FRAME_COUNTER         85 */   GTI_EMPTY_ACTION,
    /* GTI_ATM_CELL_COUNTER         86 */   GTI_EMPTY_ACTION,
    /* GTI_RMT_TX_POWER_STATUS      87 */   GTI_EMPTY_ACTION,
    /* *******************          88 */   GTI_EMPTY_ACTION,
    /* *******************          89 */   GTI_EMPTY_ACTION,
    /* *******************          90 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_1_64     91 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_64_128   92 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_128_192  93 */   GTI_EMPTY_ACTION,
    /* GTI_RX_TEST_RESULTS_192_256  94 */   GTI_EMPTY_ACTION,
    /* GTI_IDLE_BERT_STATUS         95 */   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_STATUS      96 */   GTI_EMPTY_ACTION,
    /* *******************          97 */   GTI_EMPTY_ACTION,
    /* *******************          98 */   GTI_EMPTY_ACTION,
    /* *******************          99 */   GTI_EMPTY_ACTION,
    /* *******************         100 */   GTI_EMPTY_ACTION,
    /* *******************         101 */   GTI_EMPTY_ACTION,
    /* *******************         102 */   GTI_EMPTY_ACTION,
    /* *******************         103 */   GTI_EMPTY_ACTION,
    /* *******************         104 */   GTI_EMPTY_ACTION,
    /* GTI_LBUS_FW_VERSION         105 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_0_STATUS       106 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_1_STATUS       107 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_2_STATUS       108 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_3_STATUS       109 */   GTI_EMPTY_ACTION,
    /* GTI_RESERVED_4_STATUS       110 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAP_COUNT          111 */   GTI_EMPTY_ACTION,
    /* GTI_LINE_DATA_STATUS        112 */   GTI_EMPTY_ACTION,
    /* GTI_PM_DATA_STATUS          113 */   GTI_EMPTY_ACTION,
    /* GTT_UPSTREAM_MARGIN_STATUS  114 */   GTI_EMPTY_ACTION,
    /* *******************         115 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_ANNEX_C_MODE        116 */   GTI_EMPTY_ACTION,
    /* GTI_OVERLAP_STATUS          117 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_UP     118 */   GTI_EMPTY_ACTION,
    /* GTI_BIT_LOADING_NEXT_DN     119 */   GTI_EMPTY_ACTION,
    /* GTI_MEAN_SQ_NEXT_ERROR      120 */   GTI_EMPTY_ACTION,
    /* GTI_SNR_MARGIN_PER_BIN_NEXT 121 */   GTI_EMPTY_ACTION,
    /* GTI_LCL_XMIT_POWER_STATUS   122 */   GTI_EMPTY_ACTION,
    /* GTI_AFE_VERSION             123 */   GTI_EMPTY_ACTION,
    /* GTI_PSD_MASK_MODE_STATUS    124 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_RESULTS_STATUS  125 */   GTI_EMPTY_ACTION,
    /* GTI_INSTALL_ANNEX_STATUS    126 */   GTI_EMPTY_ACTION,
    /* GTI_PARAMETRIC_RESULTS_STATUS   127 */   GTI_EMPTY_ACTION,
    /* GTI_US_BIT_SWAP_COUNT       128 */   GTI_EMPTY_ACTION,
};

#endif /* Page J */

#endif /* GTI_HOST_SASSTATUS */




#ifdef __BORLANDC__
#pragma option -zE* -zF*
#endif


#endif /* Tables not used if XDMA or XDP */




