/*
 * @(#)gtiram.c	1.12
 */

/******  TSM  Application Code - (C) Copyright 1995-2002 by GlobeSpan  ******/
/****************************************************************************/

/****************************************************************************/
/*********************** READ THIS ALL APLICATIONS **************************/
/****************************************************************************/
/*     ALL GTI ROUTINES CALLED BY CUSTOMERS HAVE REQUIRED INPUT WHICH       */
/*     IS THE ADDRESS of the GTI_XCVR_INFO STRUCTURE BEING USED.            */
/****************************************************************************/

/****************************************************************************/
/**************** Multi XCVR with 1 Controller READ THIS ********************/
/****************************************************************************/
/*  Instructions for modifications to use one controller for more then      */
/*  one XCVR system                                                         */
/*  1) file gtiram.c                                                        */
/*     In Mult XCVR systems declare the Command structure                   */
/*     (GTI_XCVR_INFO xxyyzz) as local variables in                         */
/*     the routine that calls:                                              */
/*          ExecuteXCVR, ParamXCVR, Param...                                */
/*                                                                          */
/*  2) file gtiinit.c                                                       */
/*     Every Command Struct (GTI_XCVR_INFO xxyyzz)                          */
/*     used must be initialized once.                                       */
/*     This is done be calling GTIInit(&xxyyzz).                            */
/*     Where xxyyzz is the address of a GTI_XCVR_INFO                       */
/*     structure                                                            */
/*                                                                          */
/*  3) usage                                                                */
/*     Pass GTI routines the Address of the Command Struct                  */
/*     being used for that XCVR.                                            */
/*     i.e. ExecuteXCVR(&xxyyzz)                                            */
/*                                                                          */
/*  4) It is the responsibility of the customer to insure                   */
/*     the drivers (WriteBlock....) are accessing the                       */
/*     correct XCVR System                                                  */
/****************************************************************************/

#include "gti.h"

/* Customer Global Variables */
GTI_XCVR_INFO  GTI_GLOBAL_QUAL  GTIXcvr[GTI_TOTAL_NUM_OF_XCVRS];
GTI_CHIP_INFO  GTI_GLOBAL_QUAL  GTIChip[GTI_MAX_CHIPS_PER_SYSTEM];
GTI_CUST_INFO  GTI_GLOBAL_QUAL  GTICust[GTI_MAX_CHIPS_PER_SYSTEM];
#if defined(GTI_USE_DMAXFR) ||  defined(GTI_USE_XDPXFR)
GTI_LBUS_INFO  GTI_GLOBAL_QUAL  GTILbus[GTI_MAX_BUSES_PER_SYSTEM];
#endif
GTI_SYST_INFO  GTI_GLOBAL_QUAL  GtiSystemDB;

#ifdef GTI_PROD_DMT
#include "gti_eoc.h"

/*GTIOH_REG_INFO  ohRegInfo[GTI_OH_MAX_NUM_REG];  Used for Overhead Data Registers (BIS) - wait for BIS merge!!! */
GTIEOC_DATA_REG eocDataReg; /* Used for EOC Data Registers (T1.413) */

#if defined(GTI_USE_GLOBAL_BUFFER_FOR_LARGE_STATUS)
GTI_BYTE g_bBinsStatusBuffer[GTI_BINS_STATUS_BUFF_LEN]; /* Used for 512 Bits/Bin status */
#endif

#endif  /* GTI_DMT */

#ifdef GTI_TRACE
/* Trace */
GTI_WORD History[3][GTI_SIZE_OF_TRACE];

GTI_WORD HistPnt;
GTI_WORD SASStop_line;
GTI_BYTE SASStop_baud;
GTI_BYTE SASStop_hip;
GTI_BYTE SASStop_enable;
#endif

#ifdef GTI_BUILD_DSP_SEPERATE
GTI_CONST_QUAL GTI_BYTE GTI_ADDRESS_QUAL *BinaryBaseAddress;
#endif

#ifndef GTI_DEBUG_WHIP
/* if HIP is not implemented - remove these variables */
GTI_BYTE GTI_GLOBAL_QUAL HIP_Mail[GTI_MAX_HIP_LENGTH];
GTI_BYTE GTI_GLOBAL_QUAL HIP_Param[5];

#else

/************************* WHIP variables *******************************/
GTI_BYTE  WhipCurrentSessionID ;
GTI_BYTE  WhipMessageID ;

#ifndef GTI_USE_INTERNAL_TARGET
GTI_DWORD WhipMessagesReceived ;
GTI_WORD  WhipLastSOMidx;
GTI_DWORD WhipRexmtCounter;

GTI_BYTE  Whip_state;

GTI_WORD  Whip_rcv_bufidx;
GTI_BYTE  Whip_chksum;
GTI_BYTE  Whip_rcv_buffer[L2_RCV_BUF_MAX];

GTI_BYTE  Whip_xmt_buffer[L2_XMT_BUF_MAX];
GTI_WORD  Whip_xmt_total_idx;
GTI_WORD  Whip_xmt_sentb_idx;
#endif

GTI_BYTE WhipActiveXcvr;
char  WhipTargetName[6];
GTI_XCVR_INFO GTI_GLOBAL_QUAL *WhipGtiXcvrPtr;
GTI_BYTE WhipEocEnabled;

#ifdef GTI_TRACE
WHIP_BRKPNT_DATA Whip_BrkPntData[L2_MAX_BREAKPOINTS];
#endif

#if defined(GTI_TRACE)
GTI_WORD IregData[GTI_IREG_SIZE];
#endif  /* defined(GTI_TRACE) */

#endif
/*************************************************************************/
