#ifndef	GSMODEM_H
#define	GSMODEM_H

#include "Gp.h"


/*
** The following macro definition needs to be changed to 
** match appropriate VENDOR ID / PRODUCT ID. 
** For Globespan Vendor ID is 0x915 and Product ID is 0x02
*/
#define	GS_VENDID_MODEM	0x0915
#define	GS_PRODID_MODEM	0x8102

//
// Vendor specific request code for Anchor Upload/Download
//
// This one is implemented in the core
//
#define ANCHOR_LOAD_INTERNAL  0xA0

//
// This command is not implemented in the core.  Requires firmware
//
#define ANCHOR_LOAD_EXTERNAL  0xA3

//
// VEN_REQUEST_OUT
//
#define	VEN_REQUEST_OUT		0x40

//
// VEN_REQUEST_IN
//
#define	VEN_REQUEST_IN		0xC0

//
// Timeout Values
//
#define	GSFW_8051RESET_TIMEOUT		300
#define	GSFW_EXTLOAD_TIMEOUT		300
#define	GSFW_INTLOAD_TIMEOUT		300
#define	SET_TIMEOUT					3

//
// Maximum number of configurations supported
//
#define	GSFW_NUM_CONFIG_SUPPORTED	1

#define	TRUE	1
#define	FALSE	0

//
// This is the highest internal RAM address for the AN2131Q
//
#define MAX_INTERNAL_ADDRESS  0x1B3F

#define INTERNAL_RAM(address) ((address <= MAX_INTERNAL_ADDRESS) ? 1 : 0)

#define EXTERNAL_RAM(address) ((address > MAX_INTERNAL_ADDRESS) ? 1 : 0)

//
// EZ-USB Control and Status Register.  Bit 0 controls 8051 reset
//
#define CPUCS_REG    0x7F92


#ifndef _BYTE_DEFINED
#define _BYTE_DEFINED
typedef unsigned char BYTE;
#endif // !_BYTE_DEFINED

#ifndef _WORD_DEFINED
#define _WORD_DEFINED
typedef unsigned short WORD;
#endif // !_WORD_DEFINED

int
GSModemInitProtocols( adapter_t  *pAdapter );

#endif	/* GSMODEM_H  */

