/*+I*************************************************************************
 * GlobeSpan definitions
 *
 * Copyright (c) 2000 GlobeSpan Semiconductor Inc. -- http://www.globespan.net
 * All rights reserved.
 * History:
 *   2/5/01 PG: Added support for EOC
 *   7/18/01 PG Bumped the Driver Rev 
 *-I*************************************************************************/
#ifndef GP_H_
#define GP_H_

#define GSI_DRIVER_VERSION  "1.01.0004E"
#define GSI_DRIVER_DATE     "11/30/2004"

#include <GpSnull.h>
#include <atmphy.h>
#include <atmuni.h>
#include <gti.h>
#include <gtistat.h>
#include <gtiextn.h>
#include <gti_rel.h>
#include <gsi_ioctl.h>
#include "usbphy.h"
#include "GpUtil.h"
#include "GpDebug.h"

#define MTAG    "gp"
#ifdef GSI_PULSAR 
//#define DTYPE    "Pulsar-Atlas"
#define DTYPE   "Nova-Slade (ANS)"
#elif defined(QUASAR)
#define DTYPE    "QUASAR-ATLAS"
#endif

#define DBG_USB_SYS         0x00010000L
#define DBG_DSP_SYS         0x00020000L
#define DBG_EEPROM_SYS      0x00040000L
#define DBG_NDIS_SYS        0x00080000L
#define DBG_PHY_SYS         0x00100000L
#define DBG_LAN_SYS         0x00200000L
#define DBG_WAN_SYS         0x00400000L
#define DBG_ALL_ON          0xFFFFFFFFL
#define DBG_SYS_ALL         0xFFFFFFFFL

#define GSI_RX_BUFFER_COUNT         50
#define GSI_TX_BUFFER_COUNT         50

#define GSI_RETRAIN_LIMIT           20

#define GSI_XCVR_1      0
#define GSI_NUM_XCVR    1

#define GSI_MAC_ADDRESS_LENGTH      6


#if DBG
extern const char *DbgIrqStatus(u32 irqStatus);
extern const char *DbgHwAddr(u8 *hwAddr);

#define DBG_TX(A,S)     {if (_DBG_SYS(A,DBG_TRACE_ON)){DBG_PRINT(A,S);}}
#define DBG_RX(A,S)     {if (_DBG_SYS(A,DBG_TRACE_ON)){DBG_PRINT(A,S);}}
#define DBG_PCI(A,S)    {if (_DBG_SYS(A,DBG_TRACE_ON)){DBG_PRINT(A,S);}}
#define DBG_DSP(A,S)    {if (_DBG_SYS(A,DBG_TRACE_ON)){DBG_PRINT(A,S);}}
#define DBG_IOCTL(A,S)  {if (_DBG_SYS(A,DBG_TRACE_ON)){DBG_PRINT(A,S);}}
#else /* DBG */
#define DBG_TX(A,S)
#define DBG_RX(A,S)
#define DBG_PCI(A,S)
#define DBG_DSP(A,S)
#define DBG_IOCTL(A,S)
#endif /* DBG */

#endif /* GP_H_ */


