/*
 * @(#)gti_lbus.h	1.35
 */

/************************************************************************/
/* TSM         Application Code header                                  */
/* (C) Copyright 1999-2003 by GlobeSpan Technologies Inc                */
/************************************************************************/

#ifndef GS_GSOCTDSP_H
#define GS_GSOCTDSP_H

#ifdef GTI_DSPOCTANE

#define GTI_OCT_MAX_XCVRS_PER_CHIP (8/GTI_NUM_CORES_PER_XCVR)

#define GS_MEMSET memset

#define GTI_BUS_MODE    0x00
#define GTI_INT_MODE    0x00

#if defined (INTERR_OD_LOW_ACT)
    #define GTI_INT_POLARITY 0x84  /* Open Drain, Active Low */
#elif defined (INTERR_LOW_ACT)
    #define GTI_INT_POLARITY 0x80  /* Not Open Drain, Active Low */
#elif defined(INTERR_OD_HIGH_ACT)
    #define GTI_INT_POLARITY 0x94  /* Open Drain, Active High */
#elif defined(INTERR_HIGH_ACT)
    #define GTI_INT_POLARITY 0x90  /* Not Open Drain, Active High */
#else
    #define GTI_INT_POLARITY 0x80  /* Open Drain, Active Low */
#endif

#define GTI_RSDRAM       1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */

#define GTI_VNRAM        6    /* 0x06 */

#define GTI_PCURAM0      8    /* 0x08 */
#define GTI_PCURAM1      9    /* 0x09 */
#define GTI_PCURAM2      10   /* 0x0a */
#define GTI_PCURAM3      11   /* 0x0b */
#define GTI_PCURAM4      12   /* 0x0c */
#define GTI_PCURAM5      13   /* 0x0d */
#define GTI_PCURAM6      14   /* 0x0e */
#define GTI_PCURAM7      15   /* 0x0f */

#define GTI_CRAM0        16   /* 0x10 */
#define GTI_CRAM1        17   /* 0x11 */
#define GTI_CRAM2        18   /* 0x12 */
#define GTI_CRAM3        19   /* 0x13 */
#define GTI_CRAM4        20   /* 0x14 */
#define GTI_CRAM5        21   /* 0x15 */

#define GTI_CBROAD       23   /* 0x17 */

#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */

#define GTI_BSRAM        30   /* 0x1e */
#define GTI_TRAM         31   /* 0x1f */

#define GTI_IRAM0        32   /* 0x20 */
#define GTI_IRAM1        33   /* 0x21 */
#define GTI_IRAM2        34   /* 0x22 */
#define GTI_IRAM3        35   /* 0x23 */
#define GTI_IRAM4        36   /* 0x24 */
#define GTI_IRAM5        37   /* 0x25 */
#define GTI_IRAM6        38   /* 0x26 */
#define GTI_IRAM7        39   /* 0x27 */
#define GTI_IRAM8        40   /* 0x28 */
#define GTI_IRAM9        41   /* 0x29 */
#define GTI_IRAMA        42   /* 0x2a */
#define GTI_IRAMB        43   /* 0x2b */
#define GTI_IRAMC        44   /* 0x2c */
#define GTI_IRAMD        45   /* 0x2d */
#define GTI_IRAME        46   /* 0x2e */
#define GTI_IRAMF        47   /* 0x2f */

#define GTI_PSRAM0W      48   /* 0x30 */
#define GTI_PSRAM1W      49   /* 0x31 */
#define GTI_PSRAM2W      50   /* 0x32 */
#define GTI_PSRAM3W      51   /* 0x33 */

                              /* Host mode only supports CRAM16 */
#define GTI_CRAM016      52   /* 0x34 */
#define GTI_CRAM116      53   /* 0x35 */
#define GTI_CRAM216      54   /* 0x36 */
#define GTI_CRAM316      55   /* 0x37 */
#define GTI_CRAM416      56   /* 0x38 */
#define GTI_CRAM516      57   /* 0x3b */

#define GTI_CBROAD16     59   /* 0x17 */

#define GTI_RSRAM0       64   /* 0x40 */
#define GTI_RSRAM1       65   /* 0x41 */
#define GTI_RSRAM2       66   /* 0x42 */
#define GTI_RSRAM3       67   /* 0x43 */
#define GTI_RSRAM4       68   /* 0x44 */
#define GTI_RSRAM5       69   /* 0x45 */
#define GTI_RSRAM6       70   /* 0x46 */
#define GTI_RSRAM7       71   /* 0x47 */
#define GTI_RSRAM8       72   /* 0x48 */
#define GTI_RSRAM9       73   /* 0x49 */
#define GTI_RSRAMA       74   /* 0x4a */
#define GTI_RSRAMB       75   /* 0x4b */
#define GTI_RSRAMC       76   /* 0x4c */
#define GTI_RSRAMD       77   /* 0x4d */
#define GTI_RSRAME       78   /* 0x4e */
#define GTI_RSRAMF       79   /* 0x4f */

#define GTI_XRAM0        80   /* 0x50 */
#define GTI_XRAM1        81   /* 0x51 */
#define GTI_XSRAM0       82   /* 0x52 */
#define GTI_XSRAM1       83   /* 0x53 */
#define GTI_XDPRAM0      80
#define GTI_XDPRAM1      81
#define GTI_XDPSRAM0     82
#define GTI_XDPSRAM1     83

#define GTI_FDPSRAM0     96   /* 0x60 */
#define GTI_FDPSRAM1     97   /* 0x61 */
#define GTI_FDPSRAM2     98   /* 0x62 */
#define GTI_FDPSRAM3     99   /* 0x63 */
#define GTI_FDPSRAM4     100  /* 0x64 */
#define GTI_FDPSRAM5     101  /* 0x65 */
#define GTI_FDPSRAM6     102  /* 0x66 */
#define GTI_FDPSRAM7     103  /* 0x67 */
#define GTI_FDPSRAM8     104  /* 0x68 */
#define GTI_FDPSRAM9     105  /* 0x69 */
#define GTI_FDPSRAMA     106  /* 0x6a */
#define GTI_FDPSRAMB     107  /* 0x6b */
#define GTI_FDPSRAMC     108  /* 0x6c */
#define GTI_FDPSRAMD     109  /* 0x6d */
#define GTI_FDPSRAME     110  /* 0x6e */
#define GTI_FDPSRAMF     111  /* 0x6f */
#define GTI_FDPSRAM10    112  /* 0x70 */
#define GTI_FDPSRAM11    113  /* 0x71 */
#define GTI_FDPSRAM12    114  /* 0x72 */
#define GTI_FDPSRAM13    115  /* 0x73 */

#define GTI_FDPRAM0      118  /* 0x76 */
#define GTI_FDPRAM1      119  /* 0x77 */
#define GTI_FDPRAM2      120  /* 0x78 */
#define GTI_FDPRAM3      121  /* 0x79 */
#define GTI_FDPRAM4      122  /* 0x7a */
#define GTI_FDPRAM5      123  /* 0x7b */

#define GTI_FRAM         124  /* 0x7c */
#define GTI_BRAM         125  /* 0x7d */

                              /* Special 16 bit FDP SRAM access for CP only */
#define GTI_FDPSRAM016     224   /* 0xe0 */
#define GTI_FDPSRAM116     225   /* 0xe1 */
#define GTI_FDPSRAM216     226   /* 0xe2 */
#define GTI_FDPSRAM316     227   /* 0xe3 */
#define GTI_FDPSRAM416     228  /* 0xe4 */
#define GTI_FDPSRAM516     229  /* 0xe5 */
#define GTI_FDPSRAM616     230  /* 0xe6 */
#define GTI_FDPSRAM716     231  /* 0xe7 */
#define GTI_FDPSRAM816     232  /* 0xe8 */
#define GTI_FDPSRAM916     233  /* 0xe9 */
#define GTI_FDPSRAMA16     234  /* 0xea */
#define GTI_FDPSRAMB16     235  /* 0xeb */
#define GTI_FDPSRAMC16     236  /* 0xec */
#define GTI_FDPSRAMD16     237  /* 0xed */
#define GTI_FDPSRAME16     238  /* 0xee */
#define GTI_FDPSRAMF16     239  /* 0xef */
#define GTI_FDPSRAM1016    240  /* 0xf0 */
#define GTI_FDPSRAM1116    241  /* 0xf1 */
#define GTI_FDPSRAM1216    242  /* 0xf2 */
#define GTI_FDPSRAM1316    243  /* 0xf3 */

#define GTI_SPECIAL_FDPSRAM 0x09   /* Special - 16 bit access to 24 bit FDPSRAM */
#define GTI_FDPSRAM16_ADJUST (GTI_FDPSRAM016-GTI_FDPSRAM0)

#if (defined(GTI_CRAM_16BIT))
#define GTI_SPECIAL_CRAM 0x08   /* Special - 16 bit access to 24 bit CRAM */
#define GTI_CRAM16_ADJUST (GTI_CRAM016-GTI_CRAM0)
#endif

#define GTI_NO_AI           0x00
#define GTI_AI              0x08
#define GTI_AP              0x0c
#define GTI_DMA             0x04

#define GTI_READ_BLOCK_MODE GTI_DMA

#define GTI_CORE_0_MSK      0x00
#define GTI_DSP_A_MSK       0x00

#define GTI_CORE_1_MSK      0x10
#define GTI_DSP_B_MSK       0x10

#define GTI_CORE_2_MSK      0x20
#define GTI_DSP_C_MSK       0x20

#define GTI_CORE_3_MSK      0x30
#define GTI_DSP_D_MSK       0x30

#define GTI_CORE_4_MSK      0x40
#define GTI_DSP_E_MSK       0x40

#define GTI_CORE_5_MSK      0x50
#define GTI_DSP_F_MSK       0x50

#define GTI_CORE_6_MSK      0x60
#define GTI_DSP_G_MSK       0x60

#define GTI_CORE_7_MSK      0x70
#define GTI_DSP_H_MSK       0x70

#define GTI_NEXT_CORE_OFFSET  0x10

#define GTI_CORE_RS_MSK     0xc0
#define GTI_CORE_LB_MSK     0xd0
#define GTI_CORE_TOP_MSK    0xe0
#define GTI_CORE_ALL_MSK    0xf0
#define GTI_CORE_BROADCAST_MSK    0xf0

#define GTI_CORE_RESETS     0x00
#define GTI_INT_MASKS_DSP   0x02
#define GTI_MASKTEST_DSP    0x02
#define GTI_INT_MASKS_HOST  0x03
#define GTI_INT_CLEAR_DSP   0x04
#define GTI_INT_CLEAR_HOST  0x05
#define GTI_PCU_INT_MASK    0x06
#define GTI_CONFIG_DSP      0x09

#define GTI_EXT_DATA_DSP    0x0b
#define GTI_ADDL_DSP        0x0c
#define GTI_ADDH_DSP        0x0d
#define GTI_DATAL_DSP       0x0e
#define GTI_DATAH_DSP       0x0f

#define GTI_IPUINT_CLEAR    0x10
#define GTI_IPUINT_MASK     0x10
#define GTI_IRQ_MASK        0x10

#define GTI_IO_CONFIG_BR    0xf8

#define GTI_READ_DSP        0x80

/* Messages from 0x00 to 0xff are reserved for HOST - DSP COMMAND operations */
/*****************************************************************************/
#define GTI_DSP_MSG_INIT_CORE         0x100
#define GTI_DSP_MSG_SET_PARAM         0x101
#define GTI_DSP_MSG_SET_ONE_PARAM     0x102
#define GTI_DSP_MSG_CHECKSUM_TEST     0x103
#define GTI_DSP_MSG_SHUTDOWN          0x105
#define GTI_DSP_MSG_INT_MEM_TEST      0x106
#define GTI_DSP_MSG_CUSTOM_BINS       0x107
#define GTI_DSP_MSG_COMPILE_OPTS      0x108
#define GTI_DSP_MSG_RESET_AFE_CLOCKS  0x109
#define GTI_DSP_MSG_READ_INT_MEMORY   0x2B0

#define WRITE_DSP_BYTE(pXcvrInfo,bId,bReg,bData)                            \
    WriteStarB((GTI_XCVR_INFO *)(pXcvrInfo),                                \
        (GTI_BYTE)(bId),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

#define WRITE_DSP_REG(pXcvrInfo,bReg,bData)                                 \
    WriteStarB((GTI_XCVR_INFO *)(pXcvrInfo),                                \
        (GTI_BYTE)(GTI_DSP_DMA),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

#define WRITE_DSP_WORD(pXcvrInfo,bId,bReg,bData)                            \
    WriteStarW((GTI_XCVR_INFO *)(pXcvrInfo),                                \
        (GTI_BYTE)(bId),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

#define WRITE_DSP_ADDR(pXcvrInfo,bId,bAddrL,bAddrH)                         \
    WriteDspAdd((GTI_XCVR_INFO *)(pXcvrInfo),                               \
        (GTI_BYTE)(bId),(GTI_BYTE)(bAddrL),(GTI_BYTE)(bAddrH))

#define READ_DSP_BYTE(pXcvrInfo,bId,bReg)                                   \
    (GTI_BYTE)ReadStarB((GTI_XCVR_INFO *)(pXcvrInfo),                       \
    (GTI_BYTE)(bId),(GTI_BYTE)(bReg))

#define READ_DSP_WORD(pXcvrInfo,bId)  (GTI_WORD)                            \
    ReadStarW((GTI_XCVR_INFO *)(pXcvrInfo), (GTI_BYTE)(bId))

#define CONFIGURE_DSP(pXcvrInfo,bId,bData)                                  \
    WRITE_DSP_BYTE((pXcvrInfo),(bId), GTI_CONFIG_DSP,                       \
    (GTI_BYTE)(bData)|GTI_BUS_MODE|GTI_INT_MODE)

#define WRITE_DSP_BLOCK(pXcvrInfo,bId,bReg,wLength,pStart)                  \
    WriteStarBlock((GTI_XCVR_INFO *)(pXcvrInfo),                            \
    (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),                  \
    (GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *)(pStart))

#define READ_DSP_REG(pXcvrInfo,bReg)                                        \
    (GTI_BYTE)ReadStarB((GTI_XCVR_INFO *)(pXcvrInfo),                       \
    (GTI_BYTE)(GTI_DSP_DMA),(GTI_BYTE)(bReg))

#define WRITE_DSP_SPECIAL(pSysPtr,bId,bAddrL,bAddrH,bData)      {           \
    WriteDspAdd((GTI_XCVR_INFO *)(pSysPtr),                                 \
        (GTI_BYTE)(bId),(GTI_BYTE)(bAddrL),(GTI_BYTE)(bAddrH));             \
    WriteStarB((GTI_XCVR_INFO *)(pSysPtr),                                  \
        (GTI_BYTE)(bId),(GTI_BYTE)(GTI_EXT_DATA_DSP),(GTI_BYTE)(bData));    \
                                                                    }
 #define READ_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                    \
        ReadStarBlock((GTI_XCVR_INFO *)(pSysPtr),                           \
        (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),              \
        (GTI_BYTE GTI_ADDRESS_QUAL *)(pStart))

#define READ_DSP_EXT_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                 \
        ReadStarBlock((GTI_XCVR_INFO *)(pSysPtr),                           \
        (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),              \
        (GTI_BYTE GTI_ADDRESS_QUAL *)(pStart))

#define READ_DSP_AI_BLOCK(pSysPtr,bId,wLength,pStart)  {                \
        int _nIndex;                                                            \
        GTI_WORD _wData;                                                        \
        GTI_BYTE GTI_ADDRESS_QUAL *pTbl = (GTI_BYTE GTI_ADDRESS_QUAL*)(pStart); \
        for(_nIndex=0;_nIndex<(wLength);_nIndex+=2)                             \
        {                                                                       \
            _wData = READ_DSP_WORD((pSysPtr),(bId));                            \
             pTbl[_nIndex + 0] = (GTI_BYTE)(LOBYTE(_wData));                    \
             pTbl[_nIndex + 1] = HIBYTE(_wData);                                \
        }                                                      }

/* UPDATE_DSP - Trigger a Message to be sent */
#define UPDATE_DSP(pXcvrInfo) {}

#define GTI_XDP_BIG_ENDIAN_MODE 0xffff
#define GTI_XDP_LITTLE_ENDIAN_MODE 0

/* Local Bus configuration ANNEX type (must be a bitmap) */
#define GTI_LB_CONFIG_ANNEX_A       0x01
#define GTI_LB_CONFIG_ANNEX_B       0x02
#define GTI_LB_CONFIG_ANNEX_C       0x04
#define GTI_LB_CONFIG_ANNEX_H       0x08
#define GTI_LB_CONFIG_COMMON_DMT    0x10
#define GTI_LB_CONFIG_HIGH_SPEED    0x20
#define GTI_LB_CONFIG_EREACH        0x40
#define GTI_LB_CONFIG_1010          0x80
#define GTI_LB_CONFIG_BIS           0x100
#define GTI_LB_CONFIG_HS_ANNEX_C    0x200
#define GTI_LB_CONFIG_QUAD          0x400

#define GTI_LB_CONFIG_ANNEX_AUTO    0x8000

#define GTI_LBUS_MAX_PROFILE_PER_CORE   0x2000

#define GTI_FW_LOAD_FIRST           0
#define GTI_FW_LOAD_NEXT            1
#define GTI_FW_LOAD_CANCEL          2

#define GTI_CHKSUM_START            1
#define GTI_CHKSUM_GETRESULT        0


#define GTI_LBUS_MODE_IDLE          0
#define GTI_LBUS_MODE_ZEROUT        1
#define GTI_LBUS_MODE_BOOT          2
#define GTI_LBUS_MODE_PRJHEADER     3
#define GTI_LBUS_MODE_PRJCODE       4
#define GTI_LBUS_MODE_UPDATE_0      5
#define GTI_LBUS_MODE_UPDATE_1      6
#define GTI_LBUS_MODE_UPDATE_2      7
#define GTI_LBUS_MODE_COMPLETE      8
#define GTI_LBUS_MODE_LOADED        9
#define GTI_LBUS_MODE_ACTIVE        10

/**************** Definitions for LBUS in 16 bit words ******************/
#define GTI_LBUS_NUMBER_OF_PROJECTS  32

#define GTI_LBUS_BOOT_INST          0x00
#define GTI_LBUS_BOOT_INST_SIZE     32
#define GTI_LBUS_BOOT_INFO          0x20
#define GTI_LBUS_BOOT_INFO_SIZE     32
#define GTI_LBUS_GNRL_INFO          0x40
#define GTI_LBUS_GNRL_INFO_SIZE     16
#define GTI_LBUS_PROJ_INFO          0x50
#define GTI_LBUS_PROJ_INFO_SIZE     8

#define GTI_LBUS_GNRL_CHKSUM        0x40
#define GTI_LBUS_GNRL_LOCKFL        0x41
#define GTI_LBUS_GNRL_STACK_DATA    0x42

#define GTI_LBUS_BOOT_PROG          0x150

#define GTI_LBUS_BOOT_ID            0
#define GTI_LBUS_BOOT_CHKSUM        1
#define GTI_LBUS_BOOT_LENGTH        2
#define GTI_LBUS_BOOT_VERSION       8
#define GTI_LBUS_BOOT_MKTIME        16

#define GTI_LBUS_PROJ_ID            0
#define GTI_LBUS_PROJ_CHKSUM        1
#define GTI_LBUS_PROJ_LENGTH        2
#define GTI_LBUS_PROJ_HOSTRAM_VER   4
#define GTI_LBUS_PROJ_VERSION       8
#define GTI_LBUS_PROJ_MKTIME        16
#define GTI_LBUS_PROJ_IPU_OFFS      36
#define GTI_LBUS_PROJ_FDP_OFFS      38

/* defines for the core XSRAM */
#define XSRAM_SAS_STATUS    0x01
#define XSRAM_PROFILE_OFFS  0x06
#define XSRAM_PROFILE_PAGE  0x07
#define XSRAM_TRACE_OFFS    0x09
#define XSRAM_TRACE_PAGE    0x0a

#define GTI_TXDP_READY_STATUS 0xFF
#define GTI_XDP_READY_STATUS  0xFF

/* Definitions for Mailbox structure */
#define GTI_MAX_MBOX_SIZE   256

#define GTI_ACTIVE_CORES_BMAP   0x13
#define GTI_XSRAM_PROJ_ID       0x02

#define GTI_XSRAM_ACCESS_MODE 0x22

#define GTI_MSG_BODY_START  0x00

#define GTI_MSG_FLAG        0xF8
#define GTI_MSG_LENGTH      0xF9
#define GTI_MSG_RESULT      0xFA
#define GTI_MSG_FRAME_N     0xFB

#define GTI_MSG_ID_OFFS         0
#define GTI_MSG_LENGTH_OFFS     1
#define GTI_MSG_BODY_OFFS       2

#define GTI_NUM_OF_MSG_ID   0x00

/* Unsolicted  Messages */
#define GTI_UNSOLI_MSG_FLAG 0xF0
#define GTI_UNSOLI_MSG_LEN 0xF1
#define GTI_UNSOLI_MSG_ID 0xF2

#define GTI_UNSOLI_MSG_BODY 0xF2
#define GTI_UNSOLI_MSG_OP_STATE 0xF2
#define GTI_UNSOLI_MSG_PRJ_TYPE 0xF3
#define GTI_UNSOLI_MSG_ALARM_BMP 0xF4

#define GTI_UNSOLI_MSG_BMAP 0x20
#define GTI_RESUMED_XCVR_BMAP 0x21

#define GTI_UNSOLI_MSG_OPSTATE_CHANGED 0x204
#define GTI_UNSOLI_MSG_ALARM 0x301
#define GTI_UNSOLI_MSG_ERROR 0x301

/* Definitions for the Local Bus and RS configurations */

#define GTI_LBUS_CONFIG_REG     0xbd
#define GTI_RS_CONFIG_REG       0xbf

#define GTI_CONFIGURATION_AUTO  0x000
#define GTI_CONFIGURATION_FIXED 0x400

#define GTI_LBUS_16_BIT_WIDE    0x01
#define GTI_LBUS_8_BIT_WIDE     0x00

#define GTI_LBUS_WAIT_STATES_0  0x00
#define GTI_LBUS_WAIT_STATES_1  0x08
#define GTI_LBUS_WAIT_STATES_2  0x10
#define GTI_LBUS_WAIT_STATES_3  0x18
#define GTI_LBUS_WAIT_STATES_4  0x20
#define GTI_LBUS_WAIT_STATES_5  0x28
#define GTI_LBUS_WAIT_STATES_6  0x30
#define GTI_LBUS_WAIT_STATES_7  0x38

#define GTI_MEM_CONFIG_4_x_256kb  0x00
#define GTI_MEM_CONFIG_4_x_512kb  0x01
#define GTI_MEM_CONFIG_2_x_2mb    0x02
#define GTI_MEM_CONFIG_1_x_4mb    0x03

#define GTI_MEM_CONFIG_4_x_256kw  0x00
#define GTI_MEM_CONFIG_4_x_512kw  0x01
#define GTI_MEM_CONFIG_2_x_1mw    0x02
#define GTI_MEM_CONFIG_1_x_2mw    0x03

/* define the LBUS configuration here */

#define GTI_LBUS_CONFIGURATION (GTI_MEM_CONFIG_1_x_4mb | GTI_LBUS_WAIT_STATES_3 | GTI_CONFIGURATION_AUTO)

#define GTI_READY_BIT_FAIL            0x09


typedef struct _GTI_LBUS_INFO
{
    GTI_WORD  wStatus;
    GTI_DWORD dwCurrentAdr;
    GTI_DWORD dwCurrentLbAdr;
    GTI_WORD  wBootId;
    GTI_WORD  wBootChksum;
    GTI_WORD  wBootLength;
    GTI_WORD  wParamVersion;
    GTI_WORD  wLoadAck;
    GTI_BYTE  bMode;
    GTI_BYTE  bReloadBoot;
    GTI_BYTE  bBootVer[8];
    GTI_WORD  wProjChksum;
    GTI_DWORD dwProjLength;
    GTI_DWORD dwProjAddr;
    GTI_DWORD dwNextProjAddr;
    GTI_DWORD dwDescAddr;
    GTI_WORD  wProjId;
    GTI_BYTE  bProjVer[8];
    GTI_WORD  wLoadedAnnexBmp;
    GTI_WORD  bLbConfiguration;
    GTI_WORD  wTotalChkSum;
    GTI_WORD  wExpectedChkSum;
    GTI_WORD  wFileChkSum;
    GTI_DWORD dwBufferIdx;
    GTI_DWORD dwTotalLoadedSize;
    GTI_DWORD dwMaxSize;
    GTI_DWORD dwHostRamVer;
#ifndef GS_INCLUDE_API_CODE
    GTI_WORD  wLbusID;
#ifdef GTI_USE_XDPXFR
    GTI_DSP_TBL_ELEMENT pFwImageDb[GTI_MAX_BIN_XDMA_TABLES];
    GTI_WORD  wFwImageCurTbl;
#endif
    struct _GTI_SYST_INFO *pSystInfo;
#endif
}   GTI_LBUS_INFO;

/****************************************** Function prototypes **************************************/

GTI_WORD Gti_ReadDspMsg(GTI_XCVR_INFO*, GTI_WORD *, GTI_WORD *, GTI_WORD);
GTI_WORD Gti_IsDspHostCompatible(GTI_XCVR_INFO* );
GTI_WORD Gti_IsDspUnsoliMsgReady(GTI_XCVR_INFO*, GTI_WORD *);
GTI_WORD Gti_ReadDspUnsoliMsg( GTI_XCVR_INFO*, GTI_WORD *, GTI_WORD);
void Gti_ActivateReadyLine(GTI_CHIP_INFO *, GTI_WORD);
void Gti_LocalBusDspLoadInit( GTI_XCVR_INFO*);

#endif
#endif
