/*
 * @(#)gtidsp.h	1.20
 */

/* (C) Copyright 1996-2003 by GlobeSpan Technologies Inc */

/* DSP Chip Specific # defines */

#ifndef  INCLUDE_FILE_GTIDSP_H
#define  INCLUDE_FILE_GTIDSP_H

#ifdef GTI_ISOS
#define INTERR_OD_LOW_ACT
#endif

#ifdef GTI_DEBUG /* Internal Globespan Usage */
#include "p3hw.h"
#include "extern.h"
#include "global.h"
#endif

/* This file is not used for OCTANE package, where gsoctdsp.h is used */
#ifndef GTI_DSPOCTANE

/* NOVA DSP */
#ifdef GTI_DSPMULTI  /* Nova ONLY */

#define GTI_VENRAM       1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */

#define GTI_PCURAM0      8    /* 0x08 */
#define GTI_PCURAM1      9    /* 0x09 */
#define GTI_PCURAM2      10   /* 0x0a */
#define GTI_PCURAM3      11   /* 0x0b */
#define GTI_PSRAM0W      12   /* 0x0c */
#define GTI_PSRAM1W      13   /* 0x0d */

#define GTI_CRAM0        16   /* 0x10 */
#define GTI_CRAM1        17   /* 0x11 */
#define GTI_CRAM2        18   /* 0x12 */
#define GTI_CRAM3        19   /* 0x13 */
#define GTI_CRAM4        20   /* 0x14 */
#define GTI_CRAM5        21   /* 0x15 */

#define GTI_CBROAD       23   /* 0x17 */

#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */

#define GTI_BSRAM        30   /* 0x1e */
#define GTI_TRAM         31   /* 0x1f */


#define GTI_IRAM0        32   /* 0x20 */
#define GTI_IRAM1        33   /* 0x21 */

#define GTI_IRAM2        34   /* 0x22 */
#define GTI_RSRAM0       34   /* 0x22 */

#define GTI_IRAM3        35   /* 0x23 */
#define GTI_RSRAM1       35   /* 0x23 */

#define GTI_IRAM4        36   /* 0x24 */
#define GTI_RSRAM2       36   /* 0x24 */

#define GTI_IRAM5        37   /* 0x25 */
#define GTI_RSRAM3       37   /* 0x25 */

#define GTI_IRAM6        38   /* 0x26 */
#define GTI_RSRAM4       38   /* 0x26 */

#define GTI_IRAM7        39   /* 0x27 */
#define GTI_RSRAM5       39   /* 0x27 */

#define GTI_IRAM8        40   /* 0x28 */
#define GTI_RSRAM6       40   /* 0x28 */

#define GTI_IRAM9        41   /* 0x29 */
#define GTI_RSRAM7       41   /* 0x29 */

#define GTI_IRAMA        42   /* 0x2a */
#define GTI_RSRAM8       42   /* 0x2a */

#define GTI_IRAMB        43   /* 0x2b */
#define GTI_RSRAM9       43   /* 0x2b */

#define GTI_IRAMC        44   /* 0x2c */
#define GTI_RSRAMA       44   /* 0x2c */

#define GTI_IRAMD        45   /* 0x2d */
#define GTI_RSRAMB       45   /* 0x2d */

#define GTI_IRAME        46   /* 0x2e */
#define GTI_RSRAMC       46   /* 0x2e */

#define GTI_IRAMF        47   /* 0x2f */
#define GTI_RSRAMD       47   /* 0x2f */

#define GTI_CRAM016      48   /* 0x30  Real address - 0x20 gtixcvr.c */
#define GTI_CRAM116      49   /* 0x31 */
#define GTI_CRAM216      50   /* 0x32 */
#define GTI_CRAM316      51   /* 0x33 */
#define GTI_CRAM416      52   /* 0x34 */
#define GTI_CRAM516      53   /* 0x35 */
#define GTI_CBROAD16     55   /* 0x37 */

#define GTI_FDPSRAM0       80   /* 0x50 */
#define GTI_FDPSRAM1       81   /* 0x51 */
#define GTI_FDPSRAM2       82   /* 0x52 */
#define GTI_FDPSRAM3       83   /* 0x53 */
#define GTI_FDPSRAM4       84   /* 0x54 */
#define GTI_FDPSRAM5       85   /* 0x55 */
#define GTI_FDPSRAM6       86   /* 0x56 */
#define GTI_FDPSRAM7       87   /* 0x57 */

#define GTI_FDPSRAM8       112  /* 0x70 */
#define GTI_FDPSRAM9       113  /* 0x71 */
#define GTI_FDPSRAMA       114  /* 0x72 */
#define GTI_FDPSRAMB       115  /* 0x73 */
#define GTI_FDPSRAMC       116  /* 0x74 */
#define GTI_FDPSRAMD       117  /* 0x75 */
#define GTI_FDPSRAME       118  /* 0x76 */
#define GTI_FDPSRAMF       119  /* 0x77 */

#define GTI_FDPRAM0        120  /* 0x78 */
#define GTI_FDPRAM1        121  /* 0x79 */
#define GTI_FDPRAM2        122  /* 0x7a */
#define GTI_FDPRAM3        123  /* 0x7b */

#define GTI_FRAM          124  /* 0x7c */
#define GTI_BRAM          125  /* 0x7d */

                              /* Special 16 bit FDP SRAM access for CP only */
#define GTI_FDPSRAM016     208   /* 0xd0 */
#define GTI_FDPSRAM116     209   /* 0xd1 */
#define GTI_FDPSRAM216     210   /* 0xd2 */
#define GTI_FDPSRAM316     211   /* 0xd3 */
#define GTI_FDPSRAM416     212  /* 0xd4 */
#define GTI_FDPSRAM516     213  /* 0xd5 */
#define GTI_FDPSRAM616     214  /* 0xd6 */
#define GTI_FDPSRAM716     215  /* 0xd7 */
#define GTI_FDPSRAM816     240  /* 0xf0 */
#define GTI_FDPSRAM916     241  /* 0xf1 */
#define GTI_FDPSRAMA16     242  /* 0xf2 */
#define GTI_FDPSRAMB16     243  /* 0xf3 */
#define GTI_FDPSRAMC16     244  /* 0xf4 */
#define GTI_FDPSRAMD16     245  /* 0xf5 */
#define GTI_FDPSRAME16     246  /* 0xf6 */
#define GTI_FDPSRAMF16     247  /* 0xf7 */

#define GTI_FDPSRAM16_ADJUST (GTI_FDPSRAM016-GTI_FDPSRAM0)
#define GTI_SPECIAL_FDPSRAM 0x09   /* Special - 16 bit access to 24 bit FDPSRAM */

/*^L*/
#elif defined (GTI_DSPFRAMER_B1)
                /* Gemini V2 DSP */

#define GTI_VENRAM       1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */

#define GTI_PCURAM0      8    /* 0x08 */
#define GTI_PCURAM1      9    /* 0x09 */
#define GTI_PCURAM2      10   /* 0x0a */
#define GTI_PCURAM3      11   /* 0x0b */
#define GTI_PSRAM0W      12   /* 0x0c */
#define GTI_PSRAM1W      13   /* 0x0d */
#define GTI_PSRAM0W_V3   14   /* 0x0e */
#define GTI_PSRAM1W_V3   15   /* 0x0e */

#define GTI_CRAM0        16   /* 0x10 */
#define GTI_CRAM1        17   /* 0x11 */
#define GTI_CRAM2        18   /* 0x12 */
#define GTI_CRAM3        19   /* 0x13 */
#define GTI_CRAM4        20   /* 0x14 */
#define GTI_CRAM5        21   /* 0x15 */

#define GTI_CBROAD       23   /* 0x17 */

#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */

#define GTI_BSRAM        30   /* 0x1e */
#define GTI_TRAM         31   /* 0x1f */
#define GTI_BSRAM16      62   /* 0x3e */


#define GTI_IRAM0        32   /* 0x20 */
#define GTI_IRAM1        33   /* 0x21 */

#define GTI_IRAM2        34   /* 0x22 */
#define GTI_RSRAM0       34   /* 0x22 */

#define GTI_IRAM3        35   /* 0x23 */
#define GTI_RSRAM1       35   /* 0x23 */

#define GTI_IRAM4        36   /* 0x24 */
#define GTI_RSRAM2       36   /* 0x24 */

#define GTI_IRAM5        37   /* 0x25 */
#define GTI_RSRAM3       37   /* 0x25 */

#define GTI_IRAM6        38   /* 0x26 */
#define GTI_RSRAM4       38   /* 0x26 */

#define GTI_IRAM7        39   /* 0x27 */
#define GTI_RSRAM5       39   /* 0x27 */

#define GTI_IRAM8        40   /* 0x28 */
#define GTI_RSRAM6       40   /* 0x28 */

#define GTI_IRAM9        41   /* 0x29 */
#define GTI_RSRAM7       41   /* 0x29 */

#define GTI_IRAMA        42   /* 0x2a */
#define GTI_RSRAM8       42   /* 0x2a */

#define GTI_IRAMB        43   /* 0x2b */
#define GTI_RSRAM9       43   /* 0x2b */

#define GTI_IRAMC        44   /* 0x2c */
#define GTI_RSRAMA       44   /* 0x2c */

#define GTI_IRAMD        45   /* 0x2d */
#define GTI_RSRAMB       45   /* 0x2d */

#define GTI_IRAME        46   /* 0x2e */
#define GTI_RSRAMC       46   /* 0x2e */

#define GTI_IRAMF        47   /* 0x2f */
#define GTI_RSRAMD       47   /* 0x2f */


#define GTI_CRAM016      48   /* 0x30  Real address - 0x20 gtixcvr.c */
#define GTI_CRAM116      49   /* 0x31 */
#define GTI_CRAM216      50   /* 0x32 */
#define GTI_CRAM316      51   /* 0x33 */
#define GTI_CRAM416      52   /* 0x34 */
#define GTI_CRAM516      53   /* 0x35 */
#define GTI_CBROAD16     55   /* 0x37 */

#define GTI_FRAM         124  /* 0x7c */
#define GTI_BRAM         125  /* 0x7d */

/*^L*/
#elif defined (GTI_DSPFRAMER_C1)
                /* Gemini V3 DSP */

#define GTI_VENRAM       1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */

#define GTI_PCURAM0      8    /* 0x08 */
#define GTI_PCURAM1      9    /* 0x09 */
#define GTI_PCURAM2      10   /* 0x0a */
#define GTI_PCURAM3      11   /* 0x0b */
#define GTI_PCURAM4      12   /* 0x0b */
#define GTI_PCURAM5      13   /* 0x0b */
#define GTI_PSRAM0W      14   /* 0x0c */
#define GTI_PSRAM1W      15   /* 0x0d */

#define GTI_CRAM0        16   /* 0x10 */
#define GTI_CRAM1        17   /* 0x11 */
#define GTI_CRAM2        18   /* 0x12 */
#define GTI_CRAM3        19   /* 0x13 */
#define GTI_CRAM4        20   /* 0x14 */
#define GTI_CRAM5        21   /* 0x15 */

#define GTI_CBROAD       23   /* 0x17 */

#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */

#define GTI_BSRAM        30   /* 0x1e */
#define GTI_TRAM         31   /* 0x1f */
#define GTI_BSRAM16      62   /* 0x3e */


#define GTI_IRAM0        32   /* 0x20 */
#define GTI_IRAM1        33   /* 0x21 */

#define GTI_IRAM2        34   /* 0x22 */
#define GTI_RSRAM0       34   /* 0x22 */

#define GTI_IRAM3        35   /* 0x23 */
#define GTI_RSRAM1       35   /* 0x23 */

#define GTI_IRAM4        36   /* 0x24 */
#define GTI_RSRAM2       36   /* 0x24 */

#define GTI_IRAM5        37   /* 0x25 */
#define GTI_RSRAM3       37   /* 0x25 */

#define GTI_IRAM6        38   /* 0x26 */
#define GTI_RSRAM4       38   /* 0x26 */

#define GTI_IRAM7        39   /* 0x27 */
#define GTI_RSRAM5       39   /* 0x27 */

#define GTI_IRAM8        40   /* 0x28 */
#define GTI_RSRAM6       40   /* 0x28 */

#define GTI_IRAM9        41   /* 0x29 */
#define GTI_RSRAM7       41   /* 0x29 */

#define GTI_IRAMA        42   /* 0x2a */
#define GTI_RSRAM8       42   /* 0x2a */

#define GTI_IRAMB        43   /* 0x2b */
#define GTI_RSRAM9       43   /* 0x2b */

#define GTI_IRAMC        44   /* 0x2c */
#define GTI_RSRAMA       44   /* 0x2c */

#define GTI_IRAMD        45   /* 0x2d */
#define GTI_RSRAMB       45   /* 0x2d */

#define GTI_IRAME        46   /* 0x2e */
#define GTI_RSRAMC       46   /* 0x2e */

#define GTI_IRAMF        47   /* 0x2f */
#define GTI_RSRAMD       47   /* 0x2f */


#define GTI_CRAM016      48   /* 0x30  Real address - 0x20 gtixcvr.c */
#define GTI_CRAM116      49   /* 0x31 */
#define GTI_CRAM216      50   /* 0x32 */
#define GTI_CRAM316      51   /* 0x33 */
#define GTI_CRAM416      52   /* 0x34 */
#define GTI_CRAM516      53   /* 0x35 */
#define GTI_CBROAD16     55   /* 0x37 */

#define GTI_FRAM         124  /* 0x7c */
#define GTI_BRAM         125  /* 0x7d */

/*^L*/
#elif (defined (GTI_DSPQUAD) || defined(GTI_DSPPCI))
/* Trinity or Pulsar */

#define GTI_VENRAM       1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */

#define GTI_PCURAM0      8    /* 0x08 */
#define GTI_PCURAM1      9    /* 0x09 */
#define GTI_PCURAM2      10   /* 0x0a */
#define GTI_PCURAM3      11   /* 0x0b */
#define GTI_PCURAM4      12   /* 0x0c */
#define GTI_PCURAM5      13   /* 0x0d */

#define GTI_CRAM0      16   /* 0x10 */
#define GTI_CRAM1      17   /* 0x11 */
#define GTI_CRAM2      18   /* 0x12 */
#define GTI_CRAM3      19   /* 0x13 */
#define GTI_CRAM4      20   /* 0x14 */
#define GTI_CRAM5      21   /* 0x15 */

#define GTI_CBROAD     23   /* 0x17 */

#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */

#define GTI_BSRAM        30   /* 0x1e */
#define GTI_TRAM         31   /* 0x1f */


#define GTI_IRAM0        32   /* 0x20 */
#define GTI_IRAM1        33   /* 0x21 */

#define GTI_IRAM2        34   /* 0x22 */
#define GTI_RSRAM0       34   /* 0x22 */

#define GTI_IRAM3        35   /* 0x23 */
#define GTI_RSRAM1       35   /* 0x23 */

#define GTI_IRAM4        36   /* 0x24 */
#define GTI_RSRAM2       36   /* 0x24 */

#define GTI_IRAM5        37   /* 0x25 */
#define GTI_RSRAM3       37   /* 0x25 */

#define GTI_IRAM6        38   /* 0x26 */
#define GTI_RSRAM4       38   /* 0x26 */

#define GTI_IRAM7        39   /* 0x27 */
#define GTI_RSRAM5       39   /* 0x27 */

#define GTI_IRAM8        40   /* 0x28 */
#define GTI_RSRAM6       40   /* 0x28 */

#define GTI_IRAM9        41   /* 0x29 */
#define GTI_RSRAM7       41   /* 0x29 */

#define GTI_IRAMA        42   /* 0x2a */
#define GTI_RSRAM8       42   /* 0x2a */

#define GTI_IRAMB        43   /* 0x2b */
#define GTI_RSRAM9       43   /* 0x2b */

#define GTI_IRAMC        44   /* 0x2c */
#define GTI_RSRAMA       44   /* 0x2c */

#define GTI_IRAMD        45   /* 0x2d */
#define GTI_RSRAMB       45   /* 0x2d */

#define GTI_IRAME        46   /* 0x2e */
#define GTI_RSRAMC       46   /* 0x2e */

#define GTI_IRAMF        47   /* 0x2f */
#define GTI_RSRAMD       47   /* 0x2f */

#define GTI_CRAM016      48   /* 0x30  Real address - 0x20 gtixcvr.c */
#define GTI_CRAM116      49   /* 0x31 */
#define GTI_CRAM216      50   /* 0x32 */
#define GTI_CRAM316      51   /* 0x33 */
#define GTI_CRAM416      52   /* 0x34 */
#define GTI_CRAM516      53   /* 0x35 */
#define GTI_CBROAD16     55   /* 0x37 */

#define GTI_PSRAM0W      64   /* 0x40 */
#define GTI_PSRAM1W      65   /* 0x41 */

#define GTI_FDPSRAM0       80   /* 0x50 */
#define GTI_FDPSRAM1       81   /* 0x51 */
#define GTI_FDPSRAM2       82   /* 0x52 */
#define GTI_FDPSRAM3       83   /* 0x53 */
#define GTI_FDPSRAM4       84   /* 0x54 */
#define GTI_FDPSRAM5       85   /* 0x55 */
#define GTI_FDPSRAM6       86   /* 0x56 */
#define GTI_FDPSRAM7       87   /* 0x57 */

#define GTI_FDPSRAM8       112  /* 0x70 */
#define GTI_FDPSRAM9       113  /* 0x71 */
#define GTI_FDPSRAMA       114  /* 0x72 */
#define GTI_FDPSRAMB       115  /* 0x73 */
#define GTI_FDPSRAMC       116  /* 0x74 */
#define GTI_FDPSRAMD       117  /* 0x75 */
#define GTI_FDPSRAME       118  /* 0x76 */
#define GTI_FDPSRAMF       119  /* 0x77 */

#define GTI_FDPRAM0        120  /* 0x78 */
#define GTI_FDPRAM1        121  /* 0x79 */
#define GTI_FDPRAM2        122  /* 0x7a */
#define GTI_FDPRAM3        123  /* 0x7b */

#define GTI_FRAM           124  /* 0x7c */
#define GTI_BRAM           125  /* 0x7d */

                              /* Special 16 bit FDP SRAM access for CP only */
#define GTI_FDPSRAM016     208   /* 0xd0 */
#define GTI_FDPSRAM116     209   /* 0xd1 */
#define GTI_FDPSRAM216     210   /* 0xd2 */
#define GTI_FDPSRAM316     211   /* 0xd3 */
#define GTI_FDPSRAM416     212  /* 0xd4 */
#define GTI_FDPSRAM516     213  /* 0xd5 */
#define GTI_FDPSRAM616     214  /* 0xd6 */
#define GTI_FDPSRAM716     215  /* 0xd7 */
#define GTI_FDPSRAM816     240  /* 0xf0 */
#define GTI_FDPSRAM916     241  /* 0xf1 */
#define GTI_FDPSRAMA16     242  /* 0xf2 */
#define GTI_FDPSRAMB16     243  /* 0xf3 */
#define GTI_FDPSRAMC16     244  /* 0xf4 */
#define GTI_FDPSRAMD16     245  /* 0xf5 */
#define GTI_FDPSRAME16     246  /* 0xf6 */
#define GTI_FDPSRAMF16     247  /* 0xf7 */

#define GTI_FDPSRAM16_ADJUST (GTI_FDPSRAM016-GTI_FDPSRAM0)
#define GTI_SPECIAL_FDPSRAM 0x09   /* Special - 16 bit access to 24 bit FDPSRAM */

/*^L*/
#elif defined (GTI_DSPVIKING)


#define GTI_RSDRAM       1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */

#define GTI_VNRAM        6    /* 0x06 */

#ifdef GTI_DSPVIKING
#define GTI_VREG0  28    /* 32 Bit Top SAP memory - really =8 */
#define GTI_VREG1  29    /* 32 Bit Top SAP memory - really =9 */
#define GTI_VREG_ADJUST  20
#define GTI_SPECIAL_VREG  20    /* Unique size so can program top VREG */
#endif

#define GTI_PCURAM0      8    /* 0x08 */
#define GTI_PCURAM1      9    /* 0x09 */
#define GTI_PCURAM2      10   /* 0x0a */
#define GTI_PCURAM3      11   /* 0x0b */
#define GTI_PCURAM4      12   /* 0x0c */
#define GTI_PCURAM5      13   /* 0x0d */
#define GTI_PCURAM6      14   /* 0x0e */
#define GTI_PCURAM7      15   /* 0x0f */

#define GTI_CRAM0        16   /* 0x10 */
#define GTI_CRAM1        17   /* 0x11 */
#define GTI_CRAM2        18   /* 0x12 */
#define GTI_CRAM3        19   /* 0x13 */
#define GTI_CRAM4        20   /* 0x14 */
#define GTI_CRAM5        21   /* 0x15 */

#define GTI_CBROAD       23   /* 0x17 */

#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */

#define GTI_BSRAM        30   /* 0x1e */
#define GTI_TRAM         31   /* 0x1f */

#define GTI_IRAM0        32   /* 0x20 */
#define GTI_IRAM1        33   /* 0x21 */
#define GTI_IRAM2        34   /* 0x22 */
#define GTI_IRAM3        35   /* 0x23 */
#define GTI_IRAM4        36   /* 0x24 */
#define GTI_IRAM5        37   /* 0x25 */
#define GTI_IRAM6        38   /* 0x26 */
#define GTI_IRAM7        39   /* 0x27 */
#define GTI_IRAM8        40   /* 0x28 */
#define GTI_IRAM9        41   /* 0x29 */
#define GTI_IRAMA        42   /* 0x2a */
#define GTI_IRAMB        43   /* 0x2b */
#define GTI_IRAMC        44   /* 0x2c */
#define GTI_IRAMD        45   /* 0x2d */
#define GTI_IRAME        46   /* 0x2e */
#define GTI_IRAMF        47   /* 0x2f */

#define GTI_PSRAM0W      48   /* 0x30 */
#define GTI_PSRAM1W      49   /* 0x31 */
#define GTI_PSRAM2W      50   /* 0x32 */
#define GTI_PSRAM3W      51   /* 0x33 */

                              /* Host mode only supports CRAM16 */
#define GTI_CRAM016      52   /* 0x34 */
#define GTI_CRAM116      53   /* 0x35 */
#define GTI_CRAM216      54   /* 0x36 */
#define GTI_CRAM316      55   /* 0x37 */
#define GTI_CRAM416      56   /* 0x38 */
#define GTI_CRAM516      57   /* 0x3b */

#define GTI_CBROAD16     59   /* 0x17 */

#define GTI_RSRAM0       64   /* 0x40 */
#define GTI_RSRAM1       65   /* 0x41 */
#define GTI_RSRAM2       66   /* 0x42 */
#define GTI_RSRAM3       67   /* 0x43 */
#define GTI_RSRAM4       68   /* 0x44 */
#define GTI_RSRAM5       69   /* 0x45 */
#define GTI_RSRAM6       70   /* 0x46 */
#define GTI_RSRAM7       71   /* 0x47 */
#define GTI_RSRAM8       72   /* 0x48 */
#define GTI_RSRAM9       73   /* 0x49 */
#define GTI_RSRAMA       74   /* 0x4a */
#define GTI_RSRAMB       75   /* 0x4b */
#define GTI_RSRAMC       76   /* 0x4c */
#define GTI_RSRAMD       77   /* 0x4d */
#define GTI_RSRAME       78   /* 0x4e */
#define GTI_RSRAMF       79   /* 0x4f */

#define GTI_XRAM0        80   /* 0x50 */
#define GTI_XRAM1        81   /* 0x51 */
#define GTI_XSRAM0       82   /* 0x52 */
#define GTI_XSRAM1       83   /* 0x53 */
#define GTI_XDPRAM0      80
#define GTI_XDPRAM1      81
#define GTI_XDPSRAM0     82
#define GTI_XDPSRAM1     83

#define GTI_FDPSRAM0     96   /* 0x60 */
#define GTI_FDPSRAM1     97   /* 0x61 */
#define GTI_FDPSRAM2     98   /* 0x62 */
#define GTI_FDPSRAM3     99   /* 0x63 */
#define GTI_FDPSRAM4     100  /* 0x64 */
#define GTI_FDPSRAM5     101  /* 0x65 */
#define GTI_FDPSRAM6     102  /* 0x66 */
#define GTI_FDPSRAM7     103  /* 0x67 */
#define GTI_FDPSRAM8     104  /* 0x68 */
#define GTI_FDPSRAM9     105  /* 0x69 */
#define GTI_FDPSRAMA     106  /* 0x6a */
#define GTI_FDPSRAMB     107  /* 0x6b */
#define GTI_FDPSRAMC     108  /* 0x6c */
#define GTI_FDPSRAMD     109  /* 0x6d */
#define GTI_FDPSRAME     110  /* 0x6e */
#define GTI_FDPSRAMF     111  /* 0x6f */
#define GTI_FDPSRAM10    112  /* 0x70 */
#define GTI_FDPSRAM11    113  /* 0x71 */
#define GTI_FDPSRAM12    114  /* 0x72 */
#define GTI_FDPSRAM13    115  /* 0x73 */

#define GTI_FDPRAM0      118  /* 0x76 */
#define GTI_FDPRAM1      119  /* 0x77 */
#define GTI_FDPRAM2      120  /* 0x78 */
#define GTI_FDPRAM3      121  /* 0x79 */
#define GTI_FDPRAM4      122  /* 0x7a */
#define GTI_FDPRAM5      123  /* 0x7b */

#define GTI_FRAM         124  /* 0x7c */
#define GTI_BRAM         125  /* 0x7d */

                              /* Special 16 bit FDP SRAM access for CP only */
#define GTI_FDPSRAM016     224   /* 0xe0 */
#define GTI_FDPSRAM116     225   /* 0xe1 */
#define GTI_FDPSRAM216     226   /* 0xe2 */
#define GTI_FDPSRAM316     227   /* 0xe3 */
#define GTI_FDPSRAM416     228  /* 0xe4 */
#define GTI_FDPSRAM516     229  /* 0xe5 */
#define GTI_FDPSRAM616     230  /* 0xe6 */
#define GTI_FDPSRAM716     231  /* 0xe7 */
#define GTI_FDPSRAM816     232  /* 0xe8 */
#define GTI_FDPSRAM916     233  /* 0xe9 */
#define GTI_FDPSRAMA16     234  /* 0xea */
#define GTI_FDPSRAMB16     235  /* 0xeb */
#define GTI_FDPSRAMC16     236  /* 0xec */
#define GTI_FDPSRAMD16     237  /* 0xed */
#define GTI_FDPSRAME16     238  /* 0xee */
#define GTI_FDPSRAMF16     239  /* 0xef */
#define GTI_FDPSRAM1016    240  /* 0xf0 */
#define GTI_FDPSRAM1116    241  /* 0xf1 */
#define GTI_FDPSRAM1216    242  /* 0xf2 */
#define GTI_FDPSRAM1316    243  /* 0xf3 */

#define GTI_FDPSRAM16_ADJUST (GTI_FDPSRAM016-GTI_FDPSRAM0)
#define GTI_SPECIAL_FDPSRAM 0x09   /* Special - 16 bit access to 24 bit FDPSRAM */


/*^L*/
#elif (defined (GTI_DSPFRAMER) || defined(GTI_DSPSTAR))
/* STAR  or Gemini V1 DSP */

#define GTI_PCURAM0      1    /* 0x01 */
#define GTI_VRAM         2    /* 0x02 */
#define GTI_LRAM         3    /* 0x03 */
#define GTI_IREGA        4    /* 0x04 */
#define GTI_ISRAM        5    /* 0x05 */
#define GTI_IRAM0        6    /* 0x06 */
#define GTI_IRAM1        7    /* 0x07 */
#define GTI_RSRAM0       8    /* 0x08 */
#define GTI_RSRAM1       9    /* 0x09 */
#define GTI_RSRAM2       10   /* 0x0a */
#define GTI_RSRAM3       11   /* 0x0b */
#define GTI_RSRAM4       12   /* 0x0c */
#define GTI_RSRAM5       13   /* 0x0d */
#define GTI_RSRAM6       14   /* 0x0e */
#define GTI_RSRAM7       15   /* 0x0f */
#define GTI_CRAM0        16   /* 0x10 */
#define GTI_CRAM1        17   /* 0x11 */
#define GTI_CRAM2        18   /* 0x12 */
#define GTI_CRAM3        19   /* 0x13 */
#define GTI_CRAM4        20   /* 0x14 */
#define GTI_CRAM5        21   /* 0x15 */
#define GTI_CBROAD       23   /* 0x17 */
#define GTI_DRAM0        24   /* 0x18 */
#define GTI_DRAM2        25   /* 0x19 */
#define GTI_DRAM4        26   /* 0x1a */
#define GTI_DBROAD       27   /* 0x1b */
#define GTI_BSRAM        30   /* 0x1e */
#define GTI_BSRAM16      62   /* 0x3e */
#define GTI_TRAM         31   /* 0x1f */
#define GTI_PCURAM1      33   /* 0x21 */
#define GTI_PSRAMW       65   /* 0x41 */
#define GTI_PSRAM0W      65   /* 0x41 */

#define GTI_CRAM016      48   /* 0x30  Real address - 0x20 gtixcvr.c */
#define GTI_CRAM116      49   /* 0x31 */
#define GTI_CRAM216      50   /* 0x32 */
#define GTI_CRAM316      51   /* 0x33 */
#define GTI_CRAM416      52   /* 0x34 */
#define GTI_CRAM516      53   /* 0x35 */
#define GTI_CBROAD16     55   /* 0x37 */

#define GTI_PSRAMB       97   /* 0x61 */

#define GTI_FRAM         124  /* 0x7c */
#define GTI_BRAM         125  /* 0x7d */

#else  /* No supported DSP specified */
#endif /* */

#if (defined(GTI_CRAM_16BIT))
#define GTI_SPECIAL_CRAM 0x08   /* Special - 16 bit access to 24 bit CRAM */
#define GTI_CRAM16_ADJUST (GTI_CRAM016-GTI_CRAM0)
#endif

#if defined(GTI_DSPQUAD)

/* The DSP name was confusing so changing to CORE */
#define GTI_CORE_0_MSK           0x00
#define GTI_DSP_A_MSK            0x00

#define GTI_CORE_1_MSK           0x10
#define GTI_DSP_B_MSK            0x10

#define GTI_CORE_2_MSK           0x20
#define GTI_DSP_C_MSK            0x20

#define GTI_CORE_3_MSK           0x30
#define GTI_DSP_D_MSK            0x30

#define GTI_CORE_0123_MSK        0x40
#define GTI_DSP_ABCD_MSK         0x40

#define GTI_NEXT_CORE_OFFSET     0x10


/*************************************/
/* Define for DSP Host Interface     */
/*************************************/
#define GTI_GCR_DSP           0x00
#define GTI_DMA_SUSPEND_DSP   0x01
#define GTI_DMA_INTERRUP_DSP  0x02
#define GTI_PCU_INTERRUP_DSP  0x03
#define GTI_PCU_CLR_DSP       0x04

#define GTI_INTERRUP_DSP      0x08
#define GTI_CONFIG_DSP        0x09
#define GTI_MASKTEST_DSP      0x0a
#define GTI_EXT_DATA_DSP      0x0b
#define GTI_ADDL_DSP          0x0c
#define GTI_ADDH_DSP          0x0d
#define GTI_DATAL_DSP         0x0e
#define GTI_DATAH_DSP         0x0f

#define GTI_GLOBAL_60         0x60
#define GTI_GLOBAL_61         0x61
#define GTI_GLOBAL_62         0x62
#define GTI_GLOBAL_63         0x63
#define GTI_GLOBAL_64         0x64
#define GTI_GLOBAL_65         0x65

#define GTI_GLOBAL_70         0x70
#define GTI_GLOBAL_71         0x71
#define GTI_GLOBAL_72         0x72
#define GTI_GLOBAL_73         0x73
#define GTI_GLOBAL_74         0x74
#define GTI_GLOBAL_75         0x75
#define GTI_GLOBAL_76         0x76
#define GTI_GLOBAL_77         0x77
#define GTI_GLOBAL_78         0x78
#define GTI_GLOBAL_79         0x79
#define GTI_GLOBAL_7A         0x7a
#define GTI_GLOBAL_7B         0x7b
#define GTI_GLOBAL_7C         0x7c
#define GTI_GLOBAL_7D         0x7d

#elif (defined(GTI_DSPVIKING) )

#ifdef GTI_DSPTURBO

#if defined(GS_INCLUDE_GROUCHO)
#define GTI_CORE_TOP_MSK      0x00

#define GTI_CORE_0_MSK        0x80
#define GTI_CORE_A_MSK        0x80
#define GTI_DSP_A_MSK         0x80

#define GTI_CORE_1_MSK        0x100
#define GTI_CORE_B_MSK        0x100
#define GTI_DSP_B_MSK         0x100

#define GTI_CORE_AB_MSK       0x180

#else  /* !GROUCHO */

#define GTI_CORE_TOP_MSK      0x00

#define GTI_CORE_0_MSK        0x30
#define GTI_CORE_A_MSK        0x30
#define GTI_DSP_A_MSK         0x30

#define GTI_CORE_1_MSK        0x50
#define GTI_CORE_B_MSK        0x50
#define GTI_DSP_B_MSK         0x50

#define GTI_CORE_AB_MSK       0x70

#endif /* ! GROUCHO */

#else
#define GTI_CORE_0_MSK        0x00
#define GTI_CORE_TOP_MSK      0x00
#endif


#define GTI_PCU_CLR_DSP       0x04   /* Clear PCU/IPU interrupt   */
#define GTI_INTERRUP_DSP      0x04   /* Detect Core/PCU interrupt */
#define GTI_INT_CLEAR_DSP     0x04

#define GTI_PCU_INTERRUP_DSP  0x02   /* Mask interrupts */
#define GTI_INT_MASKS_DSP     0x02
#define GTI_MASKTEST_DSP      0x02   /* Old Core name for Mask register */
#define GTI_PCU_INT_MASK      0x03   /* CUI Mask only */

#define GTI_INT_CLEAR_HOST    0x11
#define GTI_INT_MASKS_HOST    0x12   /* Host interface Status registers */

#define GTI_INT_HOST_IO_DSP   0x13   /* OD and Polarity */

#define GTI_CONFIG_DSP        0x14

#define GTI_EXT_DATA_DSP      0x1b
#define GTI_ADDL_DSP          0x1c
#define GTI_ADDH_DSP          0x1d
#define GTI_DATAL_DSP         0x1e
#define GTI_DATAH_DSP         0x1f

#define GTI_IPUINT_CLEAR      0x10  /* Clear Interrupt request from IPU*/
#define GTI_IPUINT_MASK       0x10  /* Set IPU interrupt */
#if ( defined(GTI_DSPMONACO) || defined(GTI_DSPTURBO) )
#define GTI_IRQ_MASK          0xef  /* Enable IPU */
#else
#define GTI_IRQ_MASK          0x10  /* Same name as other DSP's */
#endif

#else

#define GTI_CORE_0_MSK         0x08
#define GTI_CORE_A_MSK         0x08
#define GTI_DSP_A_MSK          0x08

#define GTI_CORE_1_MSK         0x10
#define GTI_CORE_B_MSK         0x10
#define GTI_DSP_B_MSK          0x10

#define GTI_CORE_01_MSK        0x18
#define GTI_CORE_AB_MSK        0x18
#define GTI_DSP_AB_MSK         0x18

#define GTI_DSP_A_ADDL        0x0c
#define GTI_DSP_A_ADDH        0x0d
#define GTI_DSP_A_DATAL       0x0e
#define GTI_DSP_A_DATAH       0x0f

#define GTI_DSP_B_ADDL        0x14
#define GTI_DSP_B_ADDH        0x15
#define GTI_DSP_B_DATAL       0x16
#define GTI_DSP_B_DATAH       0x17

#define GTI_DSP_AB_ADDL       0x1c
#define GTI_DSP_AB_ADDH       0x1d
#define GTI_DSP_AB_DATAL      0x1e
#define GTI_DSP_AB_DATAH      0x1f


/*************************************/
/* Define for DSP Host Interface     */
/*************************************/
#define GTI_INTERRUP_DSP  0x00
#define GTI_CONFIG_DSP    0x01
#define GTI_MASKTEST_DSP  0x02
#define GTI_EXT_DATA_DSP  0x03
#define GTI_ADDL_DSP      0x04
#define GTI_ADDH_DSP      0x05
#define GTI_DATAL_DSP     0x06
#define GTI_DATAH_DSP     0x07

#define GTI_GCR_DSP           0x00
#define GTI_DMA_SUSPEND_DSP   0x01
#define GTI_DMA_INTERRUP_DSP  0x02
#define GTI_PCU_INTERRUP_DSP  0x03
#define GTI_PCU_CLR_DSP       0x04
#define GTI_GLOBAL_INTERRUP_DSP 0x05

#endif
/*Interrupt Status Clear Address=0*/
#define GTI_WrFF           0x40  /* Clear write FIFO Interrupts*/
#define GTI_RdFF           0x10  /* Clear read FIFO Interrupts*/
#define GTI_IPURQST        0x04  /* Clear Interrupt request from IPU*/
#define GTI_BERQST         0x08  /* Clear Interrupt request from BE*/

/*Configuration Address=1*/
#define GTI_PC_PRIOR       0x01  /* Program Code Section Access Priority*/
#define GTI_RT_PRIOR       0x02  /* Real Time Section Access PRiority*/
#define GTI_NMPX           0x10  /* Non-Multiplex Bus*/
#define GTI_RDSTAT         0x20  /* Read Control for Address 0*/
#define GTI_INTE           0x40  /* Interrupt Output Enable,  high Active*/
#define GTI_INTP           0x80  /* "                Polarity*/

/******************************************/
/* Set Mode to Multiplex or Non-multiplex */
/******************************************/
#if (defined(GTI_DSPMULTI) || defined(GTI_DSPQUAD) || defined(GTI_DSPPCI) || defined(GTI_DSPVIKING) )
#define GTI_BUS_MODE       0x00  /* Not Used */
#else

#ifdef NMPX
#define GTI_BUS_MODE       0x10  /* Non-Multiplex Bus*/
#else
#define GTI_BUS_MODE       0x00  /* Multiplex Bus*/
#endif

#endif

#if ( defined(GTI_DSPMULTI) || defined(GTI_DSPPCI) )
/*************************************************************************/
/* NOVA                                                                  */
/* Choices :                                                             */
/* Must select one of the following:                                     */
/* INTERR_OD_LOW_ACT - Open Drain. Must have external pull up resister   */
/* INTERR_OD_HIGH_ACT -Open Drain. Must have external pull down resister */
/* INTERR_NOT_OD_LOW_ACT -Not Open Drain. Active Low.                    */
/* INTERR_NOT_OD_HIGH_ACT -Not Open Drain. Active High.                  */
/*************************************************************************/

#ifdef NMPX      /* Non-Multiplex bus */
    #ifdef INTERR_OD_LOW_ACT
        #define GTI_INT_POLARITY 0x0d  /* Open Drain, Active Low */
    #elif defined(INTERR_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x1d  /* Open Drain, Active High */
    #elif defined(INTERR_NOT_OD_LOW_ACT)
        #define GTI_INT_POLARITY 0x01  /* Not Open Drain, Active Low */
    #elif defined(INTERR_NOT_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x11  /* Not Open Drain, Active High */
    #else
        /* Default is Active Low Not Open Drain */
        #define GTI_INT_POLARITY 0x01  /* Not Open Drain, Active Low */
    #endif

#else            /* Multiplex bus */
    #ifdef INTERR_OD_LOW_ACT
        #define GTI_INT_POLARITY 0x2d  /* Open Drain, Active Low */
    #elif defined(INTERR_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x3d  /* Open Drain, Active High */
    #elif defined(INTERR_NOT_OD_LOW_ACT)
        #define GTI_INT_POLARITY 0x21  /* Not Open Drain, Active Low */
    #elif defined(INTERR_NOT_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x31  /* Not Open Drain, Active High */
    #else
        /* Default is Active Low Not Open Drain */
        #define GTI_INT_POLARITY 0x21  /* Not Open Drain, Active Low */
    #endif
#endif


#define GTI_INT_MODE 0x00

#elif defined(GTI_DSPVIKING)
    /*************************************************************************/
    /* Viking/Monaco/Turbo                                                   */
    /* Choices :                                                             */
    /* Must select one of the following:                                     */
    /* INTERR_OD_LOW_ACT - Open Drain. Must have external pull up resister   */
    /* INTERR_OD_HIGH_ACT -Open Drain. Must have external pull down resister */
    /* INTERR_LOW_ACT - Open Drain. Must have external pull up resister      */
    /* INTERR_HIGH_ACT -Open Drain. Must have external pull down resister    */
    /*************************************************************************/

    #if defined (INTERR_OD_LOW_ACT)
        #define GTI_INT_POLARITY 0x80  /* Open Drain, Active Low */
    #elif defined (INTERR_LOW_ACT)
        #define GTI_INT_POLARITY 0x84  /* Not Open Drain, Active Low */
    #elif defined(INTERR_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x90  /* Open Drain, Active High */
    #elif defined(INTERR_HIGH_ACT)
        #define GTI_INT_POLARITY 0x94  /* Not Open Drain, Active High */
    #else
        /* Default is Active Low Not Open Drain */
        #define GTI_INT_POLARITY 0x84  /* Open Drain, Active Low */
    #endif

#define GTI_INT_MODE 0x00

#elif defined(GTI_DSPQUAD)
    /*************************************************************************/
    /* FORTE                                                                 */
    /* Choices :                                                             */
    /* Must select one of the following:                                     */
    /* INTERR_OD_LOW_ACT - Open Drain. Must have external pull up resister   */
    /* INTERR_OD_HIGH_ACT -Open Drain. Must have external pull down resister */
    /* INTERR_LOW_ACT - Open Drain. Active Low "                          "  */
    /* INTERR_HIGH_ACT -Open Drain. Active High"                          "  */
    /* INTERR_NOT_OD_LOW_ACT - Not Open Drain. Active Low                    */
    /* INTERR_NOT_OD_HIGH_ACT -Not Open Drain. Active High                   */
    /*************************************************************************/

    #if defined (INTERR_OD_LOW_ACT)
        #define GTI_INT_POLARITY 0x0d  /* Open Drain, Active Low */
    #elif defined (INTERR_LOW_ACT)
        #define GTI_INT_POLARITY 0x0d  /* Open Drain, Active Low */
    #elif defined (INTERR_NOT_OD_LOW_ACT)
        #define GTI_INT_POLARITY 0x0c  /* Non Open Drain, Active Low */
    #elif defined(INTERR_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x0f  /* Open Drain, Active High */
    #elif defined(INTERR_HIGH_ACT)
        #define GTI_INT_POLARITY 0x0f  /* Open Drain, Active High */
    #elif defined(INTERR_NOT_OD_HIGH_ACT)
        #define GTI_INT_POLARITY 0x0e  /* Non Open Drain, Active High */
    #else
        /* Default is Active Low Non Open Drain */
#ifdef GTI_DEBUG
        #define GTI_INT_POLARITY 0x0e  /* Non Open Drain, Active High */
#else
        #define GTI_INT_POLARITY 0x0c  /* Non Open Drain, Active Low */
#endif
    #endif

    #define GTI_INT_MODE 0x00


#elif (defined(GTI_DSPFRAMER_B1) || defined(GTI_DSPFRAMER_C1))

/* GEMINI V2 - B1 */
/* GEMINI V3 - C1 */
/*************************************************/
/* Set Interrupt Mode and Polarity               */
/* INTERR_DSP_LOW_ACTIVE - Else Active High      */
/* Must select one of the following:             */
/* INTERR_OD -Open Drain.                        */
/*************************************************/
#ifdef INTERR_DSP_LOW_ACTIVE
#define GTI_DSP_INT_POLARITY 0x00     /* DSP DMA Hreg 5 */
#else
#define GTI_DSP_INT_POLARITY 0x08
#endif


#ifdef INTERR_OD
#define GTI_OD_MODE 0x04
#else
#define GTI_OD_MODE 0x00
#endif


#define GTI_INT_MODE 0x00
#define GTI_INT_POLARITY 0x00         /* DSP DMA Hreg 0 */

#elif defined(GTI_DSPFRAMER)

/* GEMINI */
/* Gemini */
/*************************************************/
/* Set Interrupt Mode and Polarity               */
/* INTERR_DSP_LOW_ACTIVE - Else Active High     */
/* Must select one of the following:             */
/* INTERR_OD -Open Drain.                        */
/*************************************************/
/* GTI_INT_MODE                                  */
/* 0x00 = Disabled                               */
/* 0x80 = Enabled                                */
/*************************************************/
#ifdef INTERR_DSP_LOW_ACTIVE
#define GTI_INT_POLARITY 0x00
#define GTI_DSP_INT_POLARITY 0x00
#else
#define GTI_INT_POLARITY 0x10
#define GTI_DSP_INT_POLARITY 0x10
#endif

#define GTI_INT_MODE 0x80

#ifdef INTERR_OD
#define GTI_OD_MODE 0x04
#else
#define GTI_OD_MODE 0x00
#endif

#else

/* STAR */
/*************************************************/
/* Set Interrupt Mode and Polarity               */
/* INTERR_DSP_LOW_ACTIVE - Else Active High     */
/* GTI_INT_MODE                                  */
/* 0x00 = Disabled                               */
/* 0xc0 = Enabled and High Active                */
/* 0x80 = Enabled and Low Active                 */
/*************************************************/
#ifdef INTERR_DSP_LOW_ACTIVE
#define GTI_INT_POLARITY 0x00
#else
#define GTI_INT_POLARITY 0x40
#endif

#define GTI_INT_MODE (0x80|GTI_INT_POLARITY)

#endif

/******************************************/

#define GTI_NO_AI          0x00  /* Normal Access*/
#define GTI_AI             0x08  /* Auto Increment */
#define GTI_AP             0x0c  /* Auto page    */

#if ( defined(GTI_DSPMONACO) || defined(GTI_DSPTURBO) )
#define GTI_DMA            0x1c  /* DMA mode     */
#else
#define GTI_DMA            0x04  /* DMA mode     */
#endif

#if defined(GTI_DSPVIKING)
    #define GTI_READ_BLOCK_MODE GTI_DMA
#else
    #define GTI_READ_BLOCK_MODE GTI_AP
    #define GTI_IRQ_MASK  0xf7
#endif
                             /*Mask and Test Register Address=2*/
#define GTI_IPURESET       0x02  /*Reset IPU*/
#define GTI_BRQ_MASK       0xfb  /* Interrupt Request from BE*/
#define GTI_RBF_MASK       0xef  /* Read FIFO Buffer is Full*/
#define GTI_RDA_MASK       0xdf  /* Read FIFO Data Available*/
#define GTI_WBF_MASK       0xbf  /* Write FIFO Buffer is Full */
#define GTI_WBE_MASK       0x7f  /* Write FIFO Buffer Empty*/
                                 /*Address High Byte Address=5*/
#define GTI_READ_DSP      0x80

#if defined(GTI_USE_DRIVERS_MACROS)
    #define READ_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart) {                   \
          GTI_WORD _nLimit;                                                     \
          GTI_BYTE GTI_ADDRESS_QUAL * _dptr;                                    \
          _dptr = (GTI_BYTE GTI_ADDRESS_QUAL *)pStart;                          \
          for(_nLimit=0;_nLimit<wLength;_nLimit++)                              \
          {                                                                     \
              *_dptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_DATAL_DSP);                \
              *_dptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_DATAH_DSP);                \
          }                                                                     \
                                                            }

    #define READ_DSP_AI_BLOCK(pSysPtr,bId,bReg,wLength,pStart) {                \
          GTI_WORD _nLimit;                                                     \
          GTI_BYTE GTI_ADDRESS_QUAL * _dptr;                                    \
          _dptr = (GTI_BYTE GTI_ADDRESS_QUAL *)pStart;                          \
          for(_nLimit=0;_nLimit<wLength;_nLimit++)                              \
          {                                                                     \
              *_dptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_DATAL_DSP);                \
              *_dptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_DATAH_DSP);                \
          }                                                                     \
                                                            }

    #define READ_DSP_EXT_BLOCK(pSysPtr,bId,bReg,wLength,pStart) {               \
          GTI_WORD _nLim;                                                       \
          GTI_BYTE GTI_ADDRESS_QUAL* _dtptr;                                    \
          _dtptr = (GTI_BYTE GTI_ADDRESS_QUAL *)pStart;                         \
          for(_nLim=0;_nLim<wLength;_nLim++)                                    \
          {                                                                     \
              *_dtptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_EXT_DATA_DSP);            \
              *_dtptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_DATAL_DSP);               \
              *_dtptr++=READ_DSP_BYTE(pSysPtr,bId,GTI_DATAH_DSP);               \
          }                                                                     \
                                                           }


#if defined(GTI_DSPQUAD)
    #define WRITE_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                    \
        GTI_POKE_BLOCK(((bReg)|(pSysPtr)->dsp_B_cs),(wLength),                  \
        (GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *)(pStart))

    #define WRITE_DSP_BYTE(pSysPtr,bId,bReg,bData)                              \
        GTI_POKE_BYTE(((bReg)|(pSysPtr)->dsp_B_cs),(GTI_BYTE)(bData));

    #define WRITE_DSP_REG(pSysPtr,bReg,bData)                                   \
        GTI_POKE_BYTE((bReg),(GTI_BYTE)(bData));

    #define CONFIGURE_DSP(pSysPtr,bId,bData)                                    \
        WRITE_DSP_BYTE((pSysPtr),(bId), GTI_CONFIG_DSP,                         \
        (GTI_BYTE)(bData)|GTI_BUS_MODE|GTI_INT_MODE);

    #define WRITE_DSP_ADDR(pSysPtr,bId,bAddrL,bAddrH)                           \
        GTI_POKE_BYTE(((pSysPtr)->dsp_B_cs|GTI_ADDL_DSP),(GTI_WORD)(bAddrL));   \
        GTI_POKE_BYTE(((pSysPtr)->dsp_B_cs|GTI_ADDH_DSP),(GTI_WORD)(bAddrH));

    #define WRITE_DSP_WORD(pSysPtr,bId,bDataL, bDataH)                          \
        GTI_POKE_BYTE(((pSysPtr)->dsp_B_cs|GTI_DATAL_DSP),(GTI_WORD)(bDataL));  \
        GTI_POKE_BYTE(((pSysPtr)->dsp_B_cs|GTI_DATAH_DSP),(GTI_WORD)(bDataH));

    #define READ_DSP_BYTE(pSysPtr,bId,bReg)                                     \
        (GTI_BYTE)GTI_PEEK_BYTE(((bReg)|(pSysPtr)->dsp_B_cs))

    #define READ_DSP_WORD(pSysPtr,bId)  (GTI_WORD)                              \
       (GTI_WORD)((GTI_PEEK_BYTE(((GTI_WORD)                                    \
       ((pSysPtr)->dsp_B_cs|GTI_DATAL_DSP)))) |                                 \
       (GTI_WORD)(((GTI_WORD)(GTI_PEEK_BYTE(((GTI_WORD)                         \
       ((pSysPtr)->dsp_B_cs|GTI_DATAH_DSP)))))<<0x08))

    #define READ_DSP_REG(pSysPtr,bReg)                                          \
        (GTI_BYTE)GTI_PEEK_BYTE((bReg))

    /* UPDATE_DSP - Trigger a Message to be sent */
    #define UPDATE_DSP(pSysPtr) {}

    /* Special access to internal memory                         */
    #define WRITE_DSP_SPECIAL(pSysPtr,bId,bAddrL,bAddrH,bData)    {             \
        GTI_POKE_BYTE(((pSysPtr)->dsp_B_cs|GTI_ADDL_DSP),(GTI_WORD)(bAddrL));   \
        GTI_POKE_BYTE(((pSysPtr)->dsp_B_cs|GTI_ADDH_DSP),(GTI_WORD)(bAddrH));   \
        GTI_POKE_BYTE(((GTI_EXT_DATA_DSP)|(pSysPtr)->dsp_B_cs),(GTI_BYTE)(bData)); \
                                                                  }
#elif ( defined(GTI_DSPMULTI) || defined(GTI_DSPPCI)  )

    #define WRITE_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)    {               \
        GTI_WORD _nLimit;                                                       \
        GTI_BYTE _bReg = GTI_CORE_0_MSK | bReg ;                                \
        GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *_srcPtr;                         \
        _srcPtr = (GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *)(pStart);            \
        for(_nLimit = 0; _nLimit < (wLength); _nLimit++)                        \
            GTI_POKE_BYTE(_bReg, *(_srcPtr+_nLimit));         }

    #define WRITE_DSP_BYTE(pSysPtr,bId,bReg,bData)                              \
        GTI_POKE_BYTE(((bReg)|GTI_CORE_0_MSK),(GTI_BYTE)(bData))                \

    #define WRITE_DSP_REG(pSysPtr,bReg,bData)                                   \
        GTI_POKE_BYTE((bReg),(GTI_BYTE)(bData))

    #define CONFIGURE_DSP(pSysPtr,bId,bData)                                    \
        WRITE_DSP_BYTE((pSysPtr),(bId), GTI_CONFIG_DSP,                         \
        (GTI_BYTE)(bData)|GTI_BUS_MODE|GTI_INT_MODE)

    #define WRITE_DSP_ADDR(pSysPtr,bId,bAddrL,bAddrH)                           \
        GTI_POKE_BYTE((GTI_CORE_0_MSK|GTI_ADDL_DSP),(GTI_WORD)(bAddrL));        \
        GTI_POKE_BYTE((GTI_CORE_0_MSK|GTI_ADDH_DSP),(GTI_WORD)(bAddrH));

    #define WRITE_DSP_WORD(pSysPtr,bId,bDataL, bDataH)                          \
        GTI_POKE_BYTE((GTI_CORE_0_MSK|GTI_DATAL_DSP),(GTI_WORD)(bDataL));       \
        GTI_POKE_BYTE((GTI_CORE_0_MSK|GTI_DATAH_DSP),(GTI_WORD)(bDataH));

    #define READ_DSP_BYTE(pSysPtr,bId,bReg)                                     \
        (GTI_BYTE) ((bId != GTI_DSP_DMA) ?                                      \
        (GTI_BYTE)GTI_PEEK_BYTE(((bReg)|GTI_CORE_0_MSK)) :                      \
        (GTI_BYTE)GTI_PEEK_BYTE(((bReg))))

    #define READ_DSP_WORD(pSysPtr,bId)  (GTI_WORD)                              \
        (GTI_WORD)((GTI_PEEK_BYTE(((GTI_WORD)                                   \
        (GTI_CORE_0_MSK|GTI_DATAL_DSP)))) |                                     \
        (GTI_WORD)(((GTI_WORD)(GTI_PEEK_BYTE(((GTI_WORD)                        \
        (GTI_CORE_0_MSK|GTI_DATAH_DSP)))))<<0x08))

    #define READ_DSP_REG(pSysPtr,bReg)                                          \
        (GTI_BYTE)GTI_PEEK_BYTE((bReg))

    /* UPDATE_DSP - Trigger a Message to be sent */
    #define UPDATE_DSP(pSysPtr) {}

    /* Special access to internal memory                         */
    #define WRITE_DSP_SPECIAL(pSysPtr,bId,bAddrL,bAddrH,bData)   {              \
        GTI_POKE_BYTE((GTI_CORE_0_MSK|GTI_ADDL_DSP),(GTI_WORD)(bAddrL));        \
        GTI_POKE_BYTE((GTI_CORE_0_MSK|GTI_ADDH_DSP),(GTI_WORD)(bAddrH));        \
        GTI_POKE_BYTE(((GTI_EXT_DATA_DSP)|GTI_CORE_0_MSK),(GTI_BYTE)(bData));   \
                                                                 }
#endif
#elif defined(GTI_USE_CUSTOMER_DEFINED_IO)

    /******* Use the customer defined way of I/O, using the i/o functions ******/

    #define WRITE_DSP_BYTE(pSysPtr,bId,bReg,bData)                              \
        Gti_SetByteDspIO((pSysPtr),                                             \
        (GTI_BYTE)(bId),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

    #define WRITE_DSP_REG(pSysPtr,bReg,bData)                                   \
        Gti_SetRegDspIO((pSysPtr),                                              \
        (GTI_BYTE)(GTI_DSP_DMA),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

    #define WRITE_DSP_WORD(pSysPtr,bId,bDataL,bDataH)                           \
        Gti_SetWordDspIO((pSysPtr),                                             \
        (GTI_BYTE)(bId),(GTI_BYTE)(bDataL),(GTI_BYTE)(bDataH))

    #define WRITE_DSP_ADDR(pSysPtr,bId,bAddrL,bAddrH)                           \
        Gti_SetAddrDspIO((pSysPtr),                                             \
        (GTI_BYTE)(bId),(GTI_BYTE)(bAddrL),(GTI_BYTE)(bAddrH))

    #define READ_DSP_BYTE(pSysPtr,bId,bReg)                                     \
        (GTI_BYTE)Gti_GetByteDspIO((pSysPtr), (GTI_BYTE)(bId),                  \
        (GTI_BYTE)(bReg))

    #define READ_DSP_WORD(pSysPtr,bId)                                          \
        (GTI_WORD) Gti_GetWordDspIO((pSysPtr), (GTI_BYTE)(bId))

    #define CONFIGURE_DSP(pSysPtr,bId,bData)                                    \
        Gti_ConfigureDspIO((pSysPtr),(GTI_BYTE)(bId),(GTI_BYTE)(bData))

    #define WRITE_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                    \
        Gti_SetBlockDspIO((pSysPtr),                                            \
        (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),                  \
        (GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *)(pStart))

    #define READ_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                          \
        Gti_GetBlockDspIO((pSysPtr),(GTI_BYTE)bId,                              \
        (GTI_WORD)(wLength), (GTI_BYTE *)(pStart))

    #define READ_DSP_EXT_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                      \
        Gti_GetExtBlockDspIO((pSysPtr),(GTI_BYTE)bId,                           \
        (GTI_WORD)(wLength), (GTI_BYTE *)(pStart))

    #define READ_DSP_REG(pSysPtr,bReg)                                          \
        (GTI_BYTE)Gti_GetRegDspIO((pSysPtr),(GTI_BYTE)(bReg))

    /* Trigger a Message to be sent */
    #define UPDATE_DSP(pSysPtr) Gti_UpdateDspIO((pSysPtr))

    /* Special access to internal memory                         */
    #define WRITE_DSP_SPECIAL(pSysPtr,bId,bAddrL,bAddrH,bData)                  \
        Gti_SetSpecialDspIO( (pSysPtr), (GTI_BYTE)(bId),                        \
         (GTI_BYTE)(bAddrL), (GTI_BYTE)(bAddrH), (GTI_BYTE)(bData) )
#else

    /********* Use the OLD standard way of I/O, using driver functions *****/

#if defined(GTI_DSPVIKING)

    #define READ_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                     \
        ReadStarBlock((GTI_XCVR_INFO *)(pSysPtr),                               \
        (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),                  \
        (GTI_BYTE GTI_ADDRESS_QUAL *)(pStart))

#ifdef GTI_HOSTVSC
    #define READ_DSP_EXT_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                 \
            ReadStarExtBlock((GTI_XCVR_INFO *)(pSysPtr),                           \
            (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),              \
            (GTI_BYTE GTI_ADDRESS_QUAL *)(pStart))
#else

    #define READ_DSP_EXT_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                 \
            ReadStarBlock((GTI_XCVR_INFO *)(pSysPtr),                           \
            (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),              \
            (GTI_BYTE GTI_ADDRESS_QUAL *)(pStart))
#endif

    #define READ_DSP_AI_BLOCK(pSysPtr,bId,wLength,pStart)  {                    \
        int _nIndex;                                                            \
        GTI_WORD _wData;                                                        \
        GTI_BYTE GTI_ADDRESS_QUAL *pTbl = (GTI_BYTE GTI_ADDRESS_QUAL*)(pStart); \
        for(_nIndex=0;_nIndex<(wLength);_nIndex+=2)                             \
        {                                                                       \
            _wData = READ_DSP_WORD((pSysPtr),(bId));                            \
             pTbl[_nIndex + 0] = (GTI_BYTE)(LOBYTE(_wData));                    \
             pTbl[_nIndex + 1] = HIBYTE(_wData);                                \
        }                                                   }

#else

    #define READ_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)  {                  \
        int _nIndex;                                                            \
        GTI_WORD _wData;                                                        \
        GTI_BYTE GTI_ADDRESS_QUAL *pTbl = (GTI_BYTE GTI_ADDRESS_QUAL*)(pStart); \
        for(_nIndex=0;_nIndex<(wLength);_nIndex+=2)                             \
        {                                                                       \
            _wData = READ_DSP_WORD((pSysPtr),(bId));                            \
             pTbl[_nIndex + 0] = (GTI_BYTE)(LOBYTE(_wData));                    \
             pTbl[_nIndex + 1] = HIBYTE(_wData);                                \
        }                                                   }

    #define READ_DSP_AI_BLOCK(pSysPtr,bId,wLength,pStart)  {                    \
        int _nIndex;                                                            \
        GTI_WORD _wData;                                                        \
        GTI_BYTE GTI_ADDRESS_QUAL *pTbl = (GTI_BYTE GTI_ADDRESS_QUAL*)(pStart); \
        for(_nIndex=0;_nIndex<(wLength);_nIndex+=2)                             \
        {                                                                       \
            _wData = READ_DSP_WORD((pSysPtr),(bId));                            \
             pTbl[_nIndex + 0] = (GTI_BYTE)(LOBYTE(_wData));                    \
             pTbl[_nIndex + 1] = HIBYTE(_wData);                                \
        }                                                   }

    #define READ_DSP_EXT_BLOCK(pSysPtr,bId,bReg,wLength,pStart) {               \
        int _nIndex;                                                            \
        GTI_WORD _wExBlData;                                                    \
        GTI_BYTE GTI_ADDRESS_QUAL *_pByteBuff = (GTI_BYTE GTI_ADDRESS_QUAL *)pStart;    \
        for(_nIndex=0;_nIndex<(wLength);_nIndex+=3)                             \
        {                                                                       \
            _pByteBuff[_nIndex+0]=READ_DSP_BYTE((pSysPtr),(bId),GTI_EXT_DATA_DSP);  \
            _wExBlData=READ_DSP_WORD((pSysPtr),(bId));                          \
            _pByteBuff[_nIndex+1]=(GTI_BYTE)(LOBYTE(_wExBlData));               \
            _pByteBuff[_nIndex+2]=HIBYTE(_wExBlData);                           \
            DELAY_GTI_PROCESS(2);                                               \
        }                                               }
#endif

    #define WRITE_DSP_BYTE(pSysPtr,bId,bReg,bData)                              \
        WriteStarB((GTI_XCVR_INFO *)(pSysPtr),                                  \
            (GTI_BYTE)(bId),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

    #define WRITE_DSP_REG(pSysPtr,bReg,bData)                                   \
        WriteStarB((GTI_XCVR_INFO *)(pSysPtr),                                  \
            (GTI_BYTE)(GTI_DSP_DMA),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

    #define WRITE_DSP_WORD(pSysPtr,bId,bReg,bData)                              \
        WriteStarW((GTI_XCVR_INFO *)(pSysPtr),                                  \
            (GTI_BYTE)(bId),(GTI_BYTE)(bReg),(GTI_BYTE)(bData))

    #define WRITE_DSP_ADDR(pSysPtr,bId,bAddrL,bAddrH)                           \
        WriteDspAdd((GTI_XCVR_INFO *)(pSysPtr),                                 \
            (GTI_BYTE)(bId),(GTI_BYTE)(bAddrL),(GTI_BYTE)(bAddrH))

    #define READ_DSP_BYTE(pSysPtr,bId,bReg)                                     \
        (GTI_BYTE)ReadStarB((GTI_XCVR_INFO *)(pSysPtr),                         \
        (GTI_BYTE)(bId),(GTI_BYTE)(bReg))

    #define READ_DSP_WORD(pSysPtr,bId)  (GTI_WORD)                              \
        ReadStarW((GTI_XCVR_INFO *)(pSysPtr), (GTI_BYTE)(bId))

    #define CONFIGURE_DSP(pSysPtr,bId,bData)                                    \
        WRITE_DSP_BYTE((pSysPtr),(bId), GTI_CONFIG_DSP,                         \
        (GTI_BYTE)(bData)|GTI_BUS_MODE|GTI_INT_MODE)

    #define WRITE_DSP_BLOCK(pSysPtr,bId,bReg,wLength,pStart)                    \
        WriteStarBlock((GTI_XCVR_INFO *)(pSysPtr),                              \
        (GTI_BYTE)(bId), (GTI_BYTE)(bReg),(GTI_WORD)(wLength),                  \
        (GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *)(pStart))

    #define READ_DSP_REG(pSysPtr,bReg)                                          \
        (GTI_BYTE)ReadStarB((GTI_XCVR_INFO *)(pSysPtr),                         \
        (GTI_BYTE)(GTI_DSP_DMA),(GTI_BYTE)(bReg))

    /* UPDATE_DSP - Trigger a Message to be sent */
    #define UPDATE_DSP(pSysPtr) {}

    /* Special access to internal memory                         */
    #define WRITE_DSP_SPECIAL(pSysPtr,bId,bAddrL,bAddrH,bData)      {           \
        WriteDspAdd((GTI_XCVR_INFO *)(pSysPtr),                                 \
            (GTI_BYTE)(bId),(GTI_BYTE)(bAddrL),(GTI_BYTE)(bAddrH));             \
        WriteStarB((GTI_XCVR_INFO *)(pSysPtr),                                  \
            (GTI_BYTE)(bId),(GTI_BYTE)(GTI_EXT_DATA_DSP),(GTI_BYTE)(bData));    \
                                                                    }
#endif

    /* Get Word size in #of Bytes for DSP Ram Specified */
    #define GET_DSP_WORD_BYTES(bAddrH) Gti_GetWordSize((bAddrH))

    /* Get Is Access Read   */
    #define IS_DSP_ACCESS_READ(bAddrH)                                          \
         (GTI_BYTE)( (((bAddrH)&0x80) != 0x00 ) ?                               \
         (GTI_BYTE)(GTI_TRUE) :                                                 \
         (GTI_BYTE)(GTI_FALSE) )

#endif /* GTI_DSPOCTANE */
#endif /* INCLUDE_FILE_GTIDSP_H */
