/*
  @(#)gtiparam.h	1.116.3.20
*/

/***********************************************************************/
/* DMT Phase 3 Application Code-(C) Copyright 1998-2002 by GTI         */
/* This File contains code going to GTI customers                      */
/***********************************************************************/


/***********************************************************************/
/*        !!!!!!!READ THIS WHEN ADDING PARAMETERS (ITEMS)!!!!!!        */
/***********************************************************************/
/* When adding items you MUST increase GTI_NUM_OF_CMD*                 */
/* This is the total number of items i.e. Items 0->5  GTI_NUM_OF* = 6  */
/* Also change dmthvy.tsf file.                                        */
/* Also add #defines for list of llegal values                         */
/***********************************************************************/

/* In AC_CPE Mode need to include this file in 2 Passes */

#ifndef GTI_SECOND_PASS

#define GTI_NUM_OF_CMD_PARAMETERS              0x52
#define GTI_NUM_OF_ATU_C_CMD_PARAMETERS        0x52
#define GTI_NUM_OF_ATU_R_CMD_PARAMETERS        0x2b

/* Type Def for Command/Parameter Array */
struct PARAM_XCVR_ARRAY
{
    GTI_BYTE length;  /* Number of items in array */
    GTI_WORD item[GTI_NUM_OF_CMD_PARAMETERS];
};

#endif


#if( defined(GTI_SECOND_PASS) || (!defined(GTI_AC_CPE)) )

#ifndef  INCLUDE_FILE_GTIPARAM_H
#define  INCLUDE_FILE_GTIPARAM_H

/* Table Structures */
struct CMDPOINT
{
    GTI_WORD start;
    GTI_BYTE table_sw;
};

/**************** Defines for items in PARAM_XCVR_ARRAY ****************/

#define  GTI_ACTION_ITEM                       0x00     /* CO & CP */
#define  GTI_MODE_ITEM                         0x01     /* CO & CP */
#define  GTI_INITIATE_ITEM                     0x02     /* CO & CP */
#define  GTI_DATA_INTERFACE_TYPE_ITEM          0x03     /* CO & CP */
#define  GTI_TRELLIS_ITEM                      0x04     /* CO & CP */
#define  GTI_EC_FDM_ITEM                       0x05     /* CO & CP */
#define  GTI_STANDARD_ITEM                     0x06     /* CO & CP */

#define  GTI_MAX_BITS_PER_BIN_ITEM             0x07     /* CO & CP */
#define  GTI_TX_START_BIN_ITEM                 0x08     /* CO & CP */
#define  GTI_TX_END_BIN_ITEM                   0x09     /* CO & CP */
#define  GTI_LINE_DR_STBY_ITEM                 0x0a     /* CO & CP */
#define  GTI_RX_START_BIN_ITEM                 0x0b     /* CO & CP */
#define  GTI_RX_END_BIN_ITEM                   0x0c     /* CO & CP */
#define  GTI_RX_BIN_ADJUST_ITEM                0x0d     /* CO & CP */

#define  GTI_TX_POWER_ATTENUATION_ITEM         0x0e     /* CO & CP */

#define  GTI_NTR_ITEM                          0x0f     /* CO & CP */

#define  GTI_PMODE_ITEM                        0x10     /* CO & CP  Pilot Mode???  CPonly???*/
#define  GTI_CODING_GAIN_ITEM                  0x11     /* CO & CP */
#define  GTI_TONE_ORDERING_ITEM                0x12     /* CO & CP */

#define  GTI_FRAMING_STRUCTURE_ITEM            0x13     /* CO & CP */
#define  GTI_UTOPIA_L2_TX_ADDR_ITEM            0x14     /* CO&CP 0-0x1c even number */
#define  GTI_UTOPIA_L2_RX_ADDR_ITEM            0x15     /* CO&CP 0-0x1c even number */
#define  GTI_CLOCK_TYPE_ITEM                   0x16     /* CO & CP */

#define  GTI_VENDOR_ID_ITEM                    0x17     /* CO & CP */
#define  GTI_VENDOR_REV_SHORT_ITEM             0x18     /* CO & CP */
#define  GTI_EXPANDED_EXCHANGE_ITEM            0x19     /* CO & CP */
#define  GTI_ESCAPE_FAST_RETRAIN_ITEM          0x1a     /* CO &CP  */

#define  GTI_FAST_RETRAIN_ENABLE_ITEM          0x1b     /* CO &CP  */

#define  GTI_BIT_SWAP_ITEM                     0x1c     /* CO & CP */
#define  GTI_US_BIT_SWAP_ITEM                  0x1d     /* CO & CP */
#define  GTI_ERASE_PROFILES_ITEM               0x1e     /* CO & CP */
#define  GTI_TRIGGER_MODE_ITEM                 0x1f     /* CO & CP */

#define  GTI_ANNEX_TYPE_ITEM                   0x20     /* CO & CP */
#define  GTI_ANNEX_C_MODE_ITEM                 0x21     /* CO & CP */
#define  GTI_ANNEX_C_PILOT_TONE_ITEM           0x22     /* CO & CP */
#define  GTI_TX_BIN_ADJUST_ITEM                0x23     /* ANNEX C, CO & CP */

                                                        /* START CP ONLY ITEMS */
#define  GTI_PILOT_TONE_REQUEST_ITEM           0x24     /* CP Only */
#define  GTI_MAX_DOWN_RATE_ITEM                0x25     /* CP Only */
#define  GTI_DUAL_LATENCY_ITEM                 0x26     /* CP Only */
#define  GTI_HW_REV_ITEM                       0x27     /* CP Only */
#define  GTI_CUTBACK_ITEM                      0x28     /* CP Only */
#define  GTI_ANNEX_CH_OFFSET_TTR_R_ITEM        0x29     /* CP Only */
#define  GTI_MAX_D_CP_ITEM                     0x2a     /* CP Only */


                                                        /* START CO ONLY ITEMS */
#define  GTI_MARGIN_UP_ITEM                    0x24     /* CO Only */
#define  GTI_MARGIN_DOWN_ITEM                  0x25     /* CO Only */
#define  GTI_BIT_RATE_MODE_ITEM                0x26     /* CO Only */

#define  GTI_SPD1_AS0_BYTES_ITEM               0x27     /* CO Only */
#define  GTI_SPD1_AS0_LATENCY_ITEM             0x28     /* CO Only */
#define  GTI_SPD1_AS1_BYTES_ITEM               0x29     /* CO Only */
#define  GTI_SPD1_AS1_LATENCY_ITEM             0x2a     /* CO Only */
#define  GTI_SPD1_LS0_BYTES_ITEM               0x2b     /* CO Only */
#define  GTI_SPD1_LS0_LATENCY_ITEM             0x2c     /* CO Only */
#define  GTI_SPD1_LS1_BYTES_ITEM               0x2d     /* CO Only */
#define  GTI_SPD1_LS1_LATENCY_ITEM             0x2e     /* CO Only */
#define  GTI_SPD2_AS0_BYTES_ITEM               0x2f     /* CO Only */
#define  GTI_SPD2_AS1_BYTES_ITEM               0x30     /* CO Only */
#define  GTI_SPD2_LS0_BYTES_ITEM               0x31     /* CO Only */
#define  GTI_SPD2_LS1_BYTES_ITEM               0x32     /* CO Only */
#define  GTI_SPD3_AS0_BYTES_ITEM               0x33     /* CO Only */
#define  GTI_SPD3_AS1_BYTES_ITEM               0x34     /* CO Only */
#define  GTI_SPD3_LS0_BYTES_ITEM               0x35     /* CO Only */
#define  GTI_SPD3_LS1_BYTES_ITEM               0x36     /* CO Only */
#define  GTI_SPD4_AS0_BYTES_ITEM               0x37     /* CO Only */
#define  GTI_SPD4_AS1_BYTES_ITEM               0x38     /* CO Only */
#define  GTI_SPD4_LS0_BYTES_ITEM               0x39     /* CO Only */
#define  GTI_SPD4_LS1_BYTES_ITEM               0x3a     /* CO Only */

#define GTI_RS_FAST_OVRHD_DOWN_ITEM            0x3b     /* CO Only */
#define GTI_RS_INT_DELAY_DOWN_ITEM             0x3c     /* CO Only */
#define GTI_RS_INT_CORRECTION_DOWN_ITEM        0x3d     /* CO Only */
#define GTI_RS_FAST_OVRHD_UP_ITEM              0x3e     /* CO Only */
#define GTI_RS_INT_DELAY_UP_ITEM               0x3f     /* CO Only */
#define GTI_RS_INT_CORRECTION_UP_ITEM          0x40     /* CO Only */

#define GTI_RESERVED_ITEM                      0x41     /* CO Only */
#define GTI_ADI_2X_ITEM                        0x42     /* CO Only */

#define GTI_REMOTE_DATA_INTERFACE_ITEM         0x43     /* CO Only */
#define GTI_ALCTL_US_VER_ITEM                  0x44     /* CO Only */

#define GTI_ANNEX_CH_TTR_EDGE_DETECT_ITEM       0x45     /* CO Only */
#define GTI_ANNEX_CH_TTR_SYNC_ITEM              0x46     /* CO Only */
#define GTI_ANNEX_CH_TTR_DCS_OFFSET_ITEM        0x47     /* CO Only */
#define GTI_ANNEX_CH_OFFSET_TTR_C_ITEM          0x48     /* CO Only */

#define GTI_MAX_D_CO_ITEM                      0x49     /* CO Only */
#define GTI_GSI_RESERVED1_ITEM                 0x4a     /* CO Only */
#define GTI_GSI_RESERVED2_ITEM                 0x4b     /* CO Only */
#define GTI_GSI_RESERVED3_ITEM                 0x4c     /* CO Only */
#define GTI_GSI_RESERVED4_ITEM                 0x4d     /* CO Only */
#define GTI_USE_CUSTOM_BINS_ITEM               0x4e     /* CO Only */
#define GTI_MAX_MARGIN_ITEM                    0x4f     /* CO only */
#define GTI_HW_PWR_RED_ITEM                    0x50     /* CO only */
#define GTI_FULL_RETRAIN_ENABLE_ITEM           0x51     /* CO only */


/********************************************************************/
/* What follows are input Paramater values for Gti_SetParamXCVR     */
/* Gti_SetParamXCVR is product specific code.                       */
/********************************************************************/

/***********************************************/
/*          ACTION                             */
/***********************************************/
#define GTI_STARTUP_REQ         0
#define GTI_TEST_REQ            1
#define GTI_ABORT_REQ           2
#define GTI_DISCONNECT_REQ      3
#define GTI_SPECTRUM_REVERB_REQ 5
#define GTI_ANALOG_LB_REQ       6
#define GTI_DIGITAL_LB_REQ      7
#define GTI_DOWNLOAD_REQ        8
#define GTI_RS_MEM_TEST_REQ     9
#define GTI_ATM_LP_REQ          10
#define GTI_BERT_START_REQ      19
#define GTI_BERT_STOP_REQ       20
#define GTI_DRIVERS_TEST_REQ    23
#define GTI_SPECTRUM_MEDLEY_REQ 26
#define GTI_SPECTRUM_PILOT_REQ  27
#define GTI_FAST_RETRAIN_REQ    28
#define GTI_PROF_MNGT_REQ       29
#define GTI_SPECTRUM_C_MTPR_REQ   30
#define GTI_BIT_SWAPPING_REQ    31
#define GTI_SPECTRUM_R_MTPR_REQ   32
#define GTI_SPECTRUM_JUPITER_TX_REQ     34
#define GTI_SPECTRUM_REVERB_RX_REQ      35
#define GTI_SPECTRUM_C_MTPR_RX_REQ      36

#define GTI_MAX_ACTION_REQ_NUMBER   37
#define GTI_MAX_YAT_TABLE_SIZE      5

#define GTI_EMPTY_ACTION        0xffffffff

/* For Compatibility Only */
#define GTI_SPECTRUM_R_PBIN_REQ      GTI_SPECTRUM_R_MTPR_REQ
#define GTI_SPECTRUM_C_PBIN_REQ      GTI_SPECTRUM_C_MTPR_REQ

/***********************************************/
/*            MODE                             */
/***********************************************/
#define GTI_CO                  0
#define GTI_ATU_C               0
#define GTI_CPE                 1
#define GTI_ATU_R               1

/***********************************************/
/*      INITIATE                               */
/***********************************************/
#define GTI_INITIATE_PN         0x80
#define GTI_WAIT_PN             0x00
#define GTI_C_TONE              0x01
#define GTI_DEFAULT_INITIATE    0xf0
#define GTI_NO_CHANGE_INITIATE  0xff

/***********************************************/
/*      Data Interface Type                    */
/***********************************************/
#define GTI_SERIAL_FRAMING      0
#define GTI_UTOPIA_L1_FRAMING   1
#define GTI_UTOPIA_L2_FRAMING   2
#define GTI_SERIAL_ATM_FRAMING  3
#define GTI_UTOPIA_L2_TEST      4
#define GTI_BERT_TEST_FRAMING   5

#define GTI_NO_CHANGE_FRAMER_TYPE  0xff

/***********************************************/
/*      Trellis  Modes                         */
/***********************************************/
#define GTI_TRELLIS_DISABLE 0
#define GTI_TRELLIS_ENABLE 0x8000
#define GTI_TRELLIS_LITE_ONLY_DISABLE 0xf000

/***********************************************/
/*      EC or FDM  Mode                         */
/***********************************************/
#define GTI_EC_MODE  0                    /* Bypass TX filter */
#define GTI_FDM_MODE 1                    /* Use TX filter    */
#define GTI_FDM_NO_ANALOG_FILT 2          /* Annex C Use Tx Filter */
#define GTI_LDSL_TX_MODE  4               /* CP and CO use special TX filters */
#define GTI_LDSL_Gi_MODE  5               /* CP uses special TX filter. CO uses boosted Gi */
                                         /* Following values are only used for Testing */
                                         /* Values should bo "ORed" together           */
#define GTI_RX_MUX_CO_CAP         0xa000
#define GTI_TX_MUX_CO_UNUSED      0xb000
#define GTI_TX_MUX_CO_DMT_FULL    0xe000
#define GTI_TX_MUX_CO_DMT_ATTEN   0xf000

#define GTI_TX_ON_LINE_DRIVER     0x0800
#define GTI_TX_OFF_LINE_DRIVER    0x0c00

#define GTI_CUSTOMER_PIN_OFF      0x0080
#define GTI_CUSTOMER_PIN_ON       0x00c0


/***********************************************/
/*      Standard Mode                          */
/***********************************************/
#define GTI_T1_413_STANDARD     0
#define GTI_G_LITE_STANDARD     1
#define GTI_G_DMT_STANDARD      2
#define GTI_ALCTL14_STANDARD    3
#define GTI_MULTIMODE_STANDARD  4
#define GTI_ADI_STANDARD        5
#define GTI_ALCTL_STANDARD      6
#define GTI_UAWG_STANDARD       7
#define GTI_G_DMT_AUTO_STANDARD      8
#define GTI_T1_413_AUTO_STANDARD       9
#define GTI_STILL_ALCTL14_STANDARD    0x80  /* For internal GSI use ONLY */
#define GTI_CENT_LITE_STANDARD  0x11
#define GTI_ADIAnnB_STANDARD	0x12
#define GTI_CENT_LEGACY_LITE    0x11
#define GTI_CENT_LEGACY_DMT     0x12
#define GTI_CENT_FULL_RATE      0x12

#define GTI_TIAnnB_STANDARD	0x13
#define GTI_ALCTAnnB_STANDARD   0x14
#define GTI_ALCT41AnnB_STANDARD  0x15
#define GTI_ADICSCOAnnB_STANDARD 0x16
#define GTI_RESERVE_STANDARD	0x19
#define GTI_HS_ADSL_STANDARD    0x30

/***********************************************/
/*      Vendor IDs                             */
/***********************************************/
#define GTI_RMT_VENDORID_ALCTL1     0x4342
#define GTI_RMT_VENDORID_ALCTL2     0x414c

/***********************************************/
/*      Max Bits Per Bin                       */
/*  Range 2->15                                */
/***********************************************/

/***********************************************/
/*      TX Start Bin                           */
/***********************************************/

/***********************************************/
/*      TX End Bin                             */
/***********************************************/

/***********************************************/
/*      Line Driver Stand By                   */
/***********************************************/
#define GTI_LINE_DR_STDBY_DISABLE  0
#define GTI_LINE_DR_STDBY_ENABLE   1

/***********************************************/
/*      RX Start Bin                           */
/***********************************************/

/***********************************************/
/*      RX End Bin                             */
/***********************************************/

/***********************************************/
/*      RX Bin Adjust                          */
/***********************************************/
#define GTI_RX_BIN_DISABLE  0
#define GTI_RX_BIN_ENABLE   0x3
#define GTI_RX_BIN_GDMTHS   0xe0
#define GTI_RX_BIN_QUICKERSTART 0xe1
#define GTI_NO_CHANGE_BIN_ADJUST 0xff

/***********************************************/
/*      TX power  Attenuation                  */
/***********************************************/
#define GTI_0DB_TX_PWR     0x00
#define GTI_POINT1DB_TX_PWR     0x0d
#define GTI_POINT2DB_TX_PWR     0x0e
#define GTI_POINT3DB_TX_PWR     0x0f
#define GTI_POINT4DB_TX_PWR     0x10
#define GTI_POINT5DB_TX_PWR     0x11
#define GTI_POINT6DB_TX_PWR     0x12
#define GTI_POINT7DB_TX_PWR     0x13
#define GTI_POINT8DB_TX_PWR     0x14
#define GTI_POINT9DB_TX_PWR     0x15
#define GTI_1DB_TX_PWR     0x01
#define GTI_2DB_TX_PWR     0x02
#define GTI_3DB_TX_PWR     0x03
#define GTI_4DB_TX_PWR     0x04
#define GTI_5DB_TX_PWR     0x05
#define GTI_6DB_TX_PWR     0x06
#define GTI_7DB_TX_PWR     0x07
#define GTI_8DB_TX_PWR     0x08
#define GTI_9DB_TX_PWR     0x09
#define GTI_10DB_TX_PWR    0x0a
#define GTI_11DB_TX_PWR    0x0b
#define GTI_12DB_TX_PWR    0x0c

/***********************************************/
/*      NTR      Modes                         */
/***********************************************/
#define GTI_NTR_DISABLE 0
#define GTI_NTR_ENABLE 1

/***********************************************/
/*      Pmode                                  */
/* Think its Pilot for data                    */
/* CP Only ???                                 */
/***********************************************/
#define GTI_ENABLE_PMODE        0x1
#define GTI_DISABLE_PMODE       0x0

/***********************************************/
/*      Coding Gain                            */
/* Parametric Testing                          */
/* When doing GTI_SPECTRUM_REVERB_RX_REQ       */
/* Coding Gain = 2->512 (power of 2)           */
/* Reccommended 256 -loopback                  */
/*              1 - Receive Only               */
/***********************************************/
#define GTI_0DB_CODING_GAIN     0x0000
#define GTI_1DB_CODING_GAIN     0x1000
#define GTI_2DB_CODING_GAIN     0x2000
#define GTI_3DB_CODING_GAIN     0x3000
#define GTI_4DB_CODING_GAIN     0x4000
#define GTI_5DB_CODING_GAIN     0x5000
#define GTI_6DB_CODING_GAIN     0x6000
#define GTI_7DB_CODING_GAIN     0x7000
#define GTI_AUTO_CODING_GAIN    0xff00

/***********************************************/
/*      Tone Ordering                          */
/***********************************************/
#define GTI_ENABLE_TONE_ORDERING  0x0000  /* Customers should use this value!!!!*/
#define GTI_DISABLE_TONE_ORDERING 0xffff

/***********************************************/
/*      Framing Structure                      */
/***********************************************/
#define GTI_FRAMING_TYPE_0 0x0000
#define GTI_FRAMING_TYPE_1 0x0001
#define GTI_FRAMING_TYPE_2 0x0002
#define GTI_FRAMING_TYPE_3 0x0003  /* Customers should use this value!!!! */

/***********************************************/
/*      UTOPIA Addr                            */
/* 0->0x1c - Even Number                       */
/***********************************************/

/***********************************************/
/*      Clock Type                              */
/***********************************************/
#define GTI_CLOCK_OSCILLATOR    0x00
#define GTI_CLOCK_CRYSTAL       0x04

#define GTI_NO_CHANGE_CLOCK_TYPE 0xff

/***********************************************/
/*      Vendor ID                              */
/* GlobeSpan number or customer number         */
/***********************************************/
#define GTI_ID_GLOBESPAN 0x39

/***********************************************/
/*      Vendor Rev Short                       */
/* GlobeSpan number or customer number         */
/***********************************************/
#define GTI_REVSHRT_GLOBESPAN 0x00

/***********************************************/
/*      Expanded Exchnage                      */
/***********************************************/
#define GTI_EXPANDED_EXCHANGE   0x8000
#define GTI_SHORT_EXCHANGE      0x00

/***********************************************/
/*  Escape to Fast Retrain                     */
/***********************************************/
#define GTI_ESCAPE_ENABLE       0x01
#define GTI_ESCAPE_DISABLE      0x00

/***********************************************/
/*      Fast Retrain Enable                    */
/***********************************************/
#define GTI_ENABLE_FAST_RETRAIN  0x00
#define GTI_DISABLE_FAST_RETRAIN 0x8000

/***********************************************/
/*        Bit Swap Enable                       */
/***********************************************/
#define GTI_BIT_SWAP_DISABLE        0x0
#define GTI_BIT_SWAP_ENABLE         0x8000
#define GTI_US_BIT_SWAP_DISABLE     0x0
#define GTI_US_BIT_SWAP_ENABLE      0x8000

/***********************************************/
/*      Erase Profiles                         */
/***********************************************/
#define GTI_ERASE_PROFILES  0x8000
#define GTI_NO_ERASE_PROFILES  0x0

/***********************************************/
/*      Fast Retrain Trigger Mode              */
/*  Those values should be logically OR-ed     */
/*  to obtain a combined trigger condition     */
/*  e.g. 0x03 will trigger if Local OR Remote  */
/*  CRC errors are detected                    */
/***********************************************/
#define GTI_DISABLE_TGR            0x00
#define GTI_LOC_CRC_TGR            0x01
#define GTI_RMT_CRC_TGR            0x02
#define GTI_SNR_INC_TGR            0x04
#define GTI_SNR_DEC_TGR            0x08
#define GTI_OFF_HK_TGR             0x10
#define GTI_ON_HK_TGR              0x20
#define GTI_OFFHK_AND_LOCCRC_TGR   0x40


/***********************************************/
/*      ANNEX Type                             */
/***********************************************/
#define GTI_TYPE_NULL        0xff
#define GTI_TYPE_ANNEX_A     0x00
#define GTI_ANNEX_A_ENABLE   0x00
#define GTI_TYPE_ANNEX_B     0x03
#define GTI_ANNEX_B_ENABLE   0x03
#define GTI_TYPE_ANNEX_C     0x01
#define GTI_ANNEX_C_ENABLE   0x01
#define GTI_TYPE_ANNEX_H     0x04
#define GTI_ANNEX_H_ENABLE   0x04
#define GTI_TYPE_HIGH_SPEED     0x05
#define GTI_HIGH_SPEED_ENABLE   0x05
#define GTI_TYPE_EREACH          0x06
#define GTI_TYPE_EREACH_ENABLE   0x06
#define GTI_TYPE_COMMON          0x02
#define GTI_COMMON_ENABLE        0x02
#ifdef GTI_AC_CPE
#define GTI_TYPE_AC          0xAC
#endif

/***********************************************/
/*      ANNEX C Mode                           */
/* Annex C Fext/Dual Bitmap                    */
/***********************************************/
#define GTI_ANNEX_C_FBM        0x00
#define GTI_ANNEX_C_DBM        0x01

/************************************************/
/*      ANNEX C PILOT TONE                      */
/* Annex C Disable Pilot Tone During Next Period*/
/************************************************/
#define GTI_PILOT_NEXT_ENABLE    0x00
#define GTI_PILOT_NEXT_DISABLE   0x01

/************************************************/
/*      TX Bin Adjust                           */
/************************************************/
#define GTI_TX_BIN_ENABLE    0x01
#define GTI_TX_BIN_DISABLE   0x00


/*************************************************/
/* START CP Only PARAMETERS                      */
/*************************************************/


/***********************************************/
/*      Pilot Tone Request                     */
/* CP Only                                     */
/***********************************************/
#define GTI_ENABLE_PILOT_TONE   0x00
#define GTI_DISABLE_PILOT_TONE  0xffff

/***********************************************/
/*       Max Down Rate                         */
/* CP Only                                     */
/* Range of values 0-0xff                      */
/***********************************************/
#define GTI_AUTO_DOWN_RATE   0x00   

/***********************************************/
/*      Dual Latency Capability                */
/* CP Only                                     */
/***********************************************/
#define  GTI_DISABLE_DUAL_LATENCY 0x0
#define  GTI_ENABLE_DUAL_LATENCY  0x1

/***********************************************/
/* ANNEX C OFFSET TTR R Offset                 */
/* CP Only                     */
/***********************************************/
#define GTI_TTR_R_OFFSET_0    0x00
#define GTI_TTR_R_OFFSET_42   0x2a

/************************************************/
/* Defines for GTI_HW_REV_ITEM                  */
/* CP Only                                      */
/************************************************/
#define GTI_HW_REV_ZERO                0
#define GTI_HW_REV_ONE                 1
#define GTI_HW_REV_TWO                 2
#define GTI_HW_REV_THREE               3

/************************************************/
/* Defines for GTI_CUTBACK_ITEM                 */
/* CP Only                                      */
/************************************************/
#define GTI_CUTBACK_DISABLE            0
#define GTI_CUTBACK_ENABLE             1

/************************************************/
/* Defines for GTI_MAX_D_CP_ITEM                */
/* CP  Only                                     */
/************************************************/
#define GTI_MAX_D_CP_64    0x0000
#define GTI_MAX_D_CP_128   0x1000
#define GTI_MAX_D_CP_256   0x2000
/***********************************************/

/*************************************************/
/* START CO Only PARAMETERS                      */
/*************************************************/


/***********************************************/
/*      margin                                 */
/* CO Only                                     */
/***********************************************/
#define GTI_0DB_MARGIN_DMT    0x00
#define GTI_1DB_MARGIN_DMT    0x01
#define GTI_2DB_MARGIN_DMT    0x02
#define GTI_3DB_MARGIN_DMT    0x03
#define GTI_4DB_MARGIN_DMT    0x04
#define GTI_5DB_MARGIN_DMT    0x05
#define GTI_6DB_MARGIN_DMT    0x06
#define GTI_7DB_MARGIN_DMT    0x07
#define GTI_8DB_MARGIN_DMT    0x08
#define GTI_9DB_MARGIN_DMT    0x09
#define GTI_10DB_MARGIN_DMT   0x0a
#define GTI_11DB_MARGIN_DMT   0x0b
#define GTI_12DB_MARGIN_DMT   0x0c
#define GTI_13DB_MARGIN_DMT   0x0d
#define GTI_14DB_MARGIN_DMT   0x0e
#define GTI_15DB_MARGIN_DMT   0x0f

#define GTI_NO_CHANGE_MARGIN  0xff

/***********************************************/
/*      Bit Rate Mode                          */
/* CO Only                                     */
/***********************************************/
#define GTI_4_SPEEDS_RATE  0
#define GTI_ADAPTIVE_RATE  0x8000
#define GTI_OPT_MARG_MODE  0x8001

/***********************************************/
/*      Latency Mode                           */
/* CO Only                                     */
/***********************************************/
#define GTI_INTERLEAVE_BUFFER   0
#define GTI_FAST_BUFFER         1

/***********************************************/
/*      RS Parameters                          */
/* CO Only                                     */
/***********************************************/
/* GTI_RS_FAST_OVRHD_DOWN_ITEM and GTI_RS_FAST_OVRHD_UP_ITEM */
#define GTI_RS_FAST_OVRHD_50_PERCENT  1
#define GTI_RS_FAST_OVRHD_25_PERCENT  2
#define GTI_RS_FAST_OVRHD_12_PERCENT  3
#define GTI_RS_FAST_OVRHD_06_PERCENT  4
#define GTI_RS_FAST_OVRHD_03_PERCENT  5
#define GTI_RS_FAST_OVRHD_02_PERCENT  6
#define GTI_RS_FAST_OVRHD_01_PERCENT  7

/* GTI_RS_INT_DELAY_DOWN_ITEM and  GTI_RS_INT_DELAY_UP_ITEM */
#define GTI_RS_INT_DELAY_250US    0 /* Annex C Only */
#define GTI_RS_INT_DELAY_500US    1 /* Annex C Only */
#define GTI_RS_INT_DELAY_1MS      2 /* 1 mili sec */
#define GTI_RS_INT_DELAY_2MS      3
#define GTI_RS_INT_DELAY_4MS      4
#define GTI_RS_INT_DELAY_8MS      5
#define GTI_RS_INT_DELAY_16MS     6
#define GTI_RS_INT_DELAY_32MS     7
#define GTI_RS_INT_DELAY_64MS     8
                                         /* For annex C Only! */
#define GTI_RS_INT_DEPTH_1        0x8000 /* Down and Up */
#define GTI_RS_INT_DEPTH_2        0x8001 /* Down and Up */
#define GTI_RS_INT_DEPTH_4        0x8002 /* Down and Up */
#define GTI_RS_INT_DEPTH_8        0x8003 /* Down and Up */
#define GTI_RS_INT_DEPTH_16       0x8004 /* Down Only */
#define GTI_RS_INT_DEPTH_32       0x8005 /* Down Only */
#define GTI_RS_INT_DEPTH_64       0x8006 /* Down Only */

/* GTI_RS_INT_CORRECTION_DOWN_ITEM and GTI_RS_INT_CORRECTION_UP_ITEM */
#define GTI_RS_INT_CORRECT_NO_CONSTRAIN   0
#define GTI_RS_INT_CORRECT_NORMAL         1
#define GTI_RS_INT_CORRECT_ENHANCED       2

#define GTI_RS_INT_CORRECT_15US   0 /* Annex C only */
#define GTI_RS_INT_CORRECT_30US   1 /* Annex C only */
#define GTI_RS_INT_CORRECT_64US   2 /* Annex C only */

#define GTI_RS_INT_CORRECT_125US  3
#define GTI_RS_INT_CORRECT_250US  4
#define GTI_RS_INT_CORRECT_500US  5
#define GTI_RS_INT_CORRECT_1MS    6 /* 1 mili sec */
#define GTI_RS_INT_CORRECT_2MS    7
#define GTI_RS_INT_CORRECT_4MS    8

#define GTI_DISABLE_RS            0xf


/***********************************************/
/*      RESERVED                               */
/* CO Only                                     */
/***********************************************/
#define GTI_RESERVED_DEFAULT     0x0
#define GTI_RESERVED_US_BIN_SHUT 0x1

/***********************************************/
/*      ADI 2X                                 */
/* CO Only                                     */
/***********************************************/
#define GTI_STANDARD_ADI_2X      0x1
#define GTI_NONSTANDARD_ADI_2X   0x0

/***********************************************/
/*      Remote Data Interface Type             */
/* CO Only                                     */
/***********************************************/
#define GTI_REMOTE_SERIAL_FRAMING      0
#define GTI_REMOTE_NORMAL_FRAMING      1
#define GTI_REMOTE_SERIAL_ATM_FRAMING  3

/***********************************************/
/*      Annex C TTR Edge Detect                */
/* CO Only                                     */
/***********************************************/
#define GTI_TTR_ED_DISABLE          0x00
#define GTI_TTR_ED_ENABLE_400       0x01
#define GTI_TTR_ED_ENABLE_AMI       0x03

/***********************************************/
/*      Annex C TTR Sync Detect                */
/* Annex C synch. to TTR Mode                  */
/* CO Only                                     */
/***********************************************/
#define GTI_TTR_S_DISABLE             0x00
#define GTI_TTR_S_ENABLE_8K_REFCK     0x83
#define GTI_TTR_S_ENABLE_32K_REFCK    0x84
#define GTI_TTR_S_ENABLE_64K_REFCK    0x85
#define GTI_TTR_S_ENABLE_28704_XTALI  0x03


/***********************************************/
/* ANNEX C TTR DCS Offset                      */
/* CO Only                                     */
/* Range = 0->0x0ac7                           */
/***********************************************/
#define GTI_TTR_DCS_OFFSET_0    0x00


/***********************************************/
/* ANNEX C OFFSET TTR C                        */
/* Annex C TTR C Offset                        */
/* CO Only                                     */
/***********************************************/
#define GTI_TTR_C_OFFSET_0    0x00
#define GTI_TTR_C_OFFSET_55   0x37
/************************************************/
/* CO ONLY                                      */
/* Defines for GTI_ALCTL_US_VER_ITEM            */
/************************************************/
#define GTI_ALCTL_US_NEW              0
#define GTI_ALCTL_US_OLD              1
#define GTI_ALCTL_US_UNKNOWN          2 /* left for compatibility */
#define GTI_ALCTL_US_NORMAL           2 /* same as UNKNOWN        */

/************************************************/
/* CO ONLY                                      */
/* Defines for GTI_MAX_D_CO_ITEM                */
/************************************************/
#define GTI_MAX_D_CO_64    0x0000
#define GTI_MAX_D_CO_128   0x1000
#define GTI_MAX_D_CO_256   0x2000

/***********************************************/
/*      GSI_RESERVED(1,2,3 or 4)               */
/* CO Only                                     */
/***********************************************/
#define GTI_GSI_RESERVED_AUTO      0x0

/************************************************/
/*                 CP Only                      */
/*      Vendor Rev Long Length in Bytes         */
/* GlobeSpan number or customer number          */
/************************************************/

#define  GTI_REVLNG_GLOBESPAN_LENGTH 0x4 /* CP Only */
#define  GTI_REVLNG_NO_CHANGE        0xff

/***************END COMMAND PARAMETER LIST********************************/

                       /********************************************/
                       /* Per Bin Status                           */
                       /********************************************/
                       /* We can use stack or debug memory         */
                       /* for this status                          */
                       /* Default is stack                         */
                       /********************************************/
#if defined(GTI_USE_GLOBAL_BUFFER_FOR_LARGE_STATUS)
#define GTI_MAX_NUMBER_OF_BINS 512
#else
#define GTI_MAX_NUMBER_OF_BINS 256
#endif
 
#define GTI_BINS_STATUS_BUFF_LEN (GTI_MAX_NUMBER_OF_BINS * 6)


/***********************************************/
/*      Stream Direction                       */
/***********************************************/
#define GTI_UP_STREAM      0x00
#define GTI_DOWN_STREAM    0x01


/***********************************************/
/* Defines for ParamInterface                  */
/***********************************************/
#define GTI_RISING_EDGE     0x00
#define GTI_FALLING_EDGE    0x01
#define GTI_DEFAULT_EDGE    0xff

#define GTI_DISABLE_RXDATA  0xf7
#define GTI_ENABLE_RXDATA   0x08

/**********************************************/
/* Defines for PAramSetIO                     */
/**********************************************/
#define GTI_SERIAL_IO       0x01
#define GTI_LEVEL1_IO       0x02
#define GTI_LEVEL2_IO       0x03
#define GTI_GLUELESS_SAR_IO 0x04




/*********************END COMMAND PARAMATER LIST***********************/

#define GTI_CH_A    0
#define GTI_CH_B    1

/********************Drivers IO Testing ******************************/
#define GTI_HREG_FAIL_TEST       0x01
#define GTI_ID_FAIL_TEST         0x02
#define GTI_BLOCK_READ_FAIL_TEST 0x03
#define GTI_DMA_ID_FAIL_TEST     0x04

/********************Parametric Testing ******************************/
                               /* Memory location to poll for test status in FDPSRAM 0*/
                               /* (should be same as coRxAddr in IPU)           */
                               /* Should use symbol created from compile !!!!!  */
#define GTI_TEST_RX_ADDR    0x8A
#define GTI_TEST_POLL_VALUE 0x05  /* Value to poll the DSP Addr above,signifies test is done */

#ifndef NULL
#define NULL    ((void *)0)
#endif

/* Valid Test Results */
#define GTI_TEST_BUSY     0
#define GTI_TEST_DONE     1
#define GTI_TEST_PASS     2
#define GTI_TEST_FAIL     3
#define GTI_TEST_ERROR    4
#define GTI_TEST_NSTATES  5


/******** Prototype Param Subroutines ***********/
void Gti_CreateSpeedMsg(GTI_BYTE *, GTI_WORD *);
void Gti_CreateSpeedMsgLite(GTI_BYTE*, GTI_WORD *);

void Gti_CreateSpeed_23(struct PARAM_XCVR_ARRAY *);

GTI_WORD
Gti_rsFastKCalc(GTI_BYTE *lclParamDB,
            GTI_BYTE bStreamDir,
            GTI_BYTE bFrmStruct,
            GTI_WORD wOvrHead,
            GTI_WORD wKfInput,
            GTI_WORD wRSOutput);

GTI_WORD
Gti_rsIntKCalc( GTI_BYTE *lclParamDB,
            GTI_BYTE bStreamDir,
            GTI_BYTE bFrmStruct,
            GTI_BYTE bStandard,
            GTI_BYTE bRmtInterface,
            GTI_WORD wCeInput,
            GTI_WORD wDeInput,
            GTI_WORD wKiInput,
            GTI_WORD wDMaxInput,
            GTI_WORD wRSOutput,
            GTI_WORD wSOutput,
            GTI_WORD wDOutput);

GTI_WORD
Gti_rsFastKCalcAnnC(GTI_BYTE *lclParamDB,
            GTI_BYTE bFrmStruct,
            GTI_WORD wOvrHead,
            GTI_WORD wKfInput,
            GTI_WORD wRSOutput);

GTI_WORD
Gti_rsIntKCalcAnnC( GTI_BYTE *lclParamDB,
            GTI_BYTE bStreamDir,
            GTI_BYTE bFrmStruct,
            GTI_BYTE bRmtInterface,
            GTI_WORD wCeInput,
            GTI_WORD wDeInput,
            GTI_WORD wKiInput,
            GTI_WORD wDMaxInput,
            GTI_WORD wRSOutput,
            GTI_WORD wSOutput,
            GTI_WORD wDOutput);
GTI_WORD
Gti_rsIntKCalcLITE( GTI_BYTE *lclParamDB,
                GTI_WORD wCeInput,
                GTI_WORD wDeInput,
                GTI_WORD wKiInput,
                GTI_WORD wDMaxInput,
                GTI_WORD wRSOutput,
                GTI_WORD wSOutput,
                GTI_WORD wDOutput);

void Gti_ParamSetIO ( GTI_XCVR_INFO *, GTI_WORD);

GTI_WORD Gti_TestIODrivers( GTI_XCVR_INFO *pXcvrInfo );

GTI_WORD Gti_SelectBinUsage( GTI_XCVR_INFO *, GTI_BYTE *);
#ifdef GTI_TRACE
void Gti_ResetTraceBuffer(void);
#endif


/**************Prototypes for Parametric Testing API's**********************/
GTI_WORD Gti_Rcv_Linearity(GTI_XCVR_INFO *pSysInfo, void *pRcvPwr,
                           GTI_WORD wSNRThrshold,
                           GTI_WORD wNotchBin);

GTI_WORD Gti_Rcv_Filter(GTI_XCVR_INFO *pSysInfo, void *pRcvPwr,
                        void *pRcvBins, GTI_WORD wBinLength,
                        void *pRcvMin, void *pRcvMax, GTI_WORD wRefLength);

GTI_WORD Gti_Rcv_Power_Per_Bin(GTI_XCVR_INFO *pSysInfo, void *pRcvPwr);

GTI_WORD Gti_Total_Idle_Noise(GTI_XCVR_INFO *pSysInfo, void *pRcvPwr,
                              GTI_WORD wBinStart, GTI_WORD wBinEnd,
                              GTI_DWORD wPwrThrshld );

GTI_WORD Gti_Per_Bin_Idle_Noise(GTI_XCVR_INFO *pSysInfo, void *pRcvPwr,
                                GTI_WORD wBinStart, GTI_WORD wBinEnd,
                                GTI_DWORD wNoiseThrshld );

GTI_WORD Gti_Hybrid_Loss(GTI_XCVR_INFO *pSysInfo, void *pRcvPwr,
                         GTI_WORD wTestStart, GTI_WORD wTestEnd,
                         void *pHybMin, void *pHybMax, GTI_WORD wRefLength);

#define TEST_RCV_LINEARITY      0
#define TEST_RCV_FILTER         1
#define TEST_RCV_PWR_PBIN       2
#define TEST_TOTAL_IDLE_NOISE   3
#define TEST_PBIN_IDLE_NOISE    4
#define TEST_HYBRID_LOSS        5
#define TEST_TOTAL_STATES       6

#define GTI_TEST_DSP_NOTHING    0
#define GTI_TEST_DSP_1ST_TIME   1
#define GTI_TEST_DSP_2ND_TIME   2

/*************End Parametric Prototypes *********************************/

/************* Ringing *****************************/
#define GTI_RING_OFF 0
#define GTI_RING_ON  1
void Gti_IndicateEvent( GTI_XCVR_INFO *, GTI_WORD );

/************* Auto CP Max Down Rate        *****************************/
GTI_WORD GtiAdjustAutoRate(GTI_XCVR_INFO *);
#define GTI_AUTO_CP_WINDOW_SIZE   0x295c    /* 3min in SF counts */
#define GTI_AUTO_CP_MIN_RATE_TO_ADJUST 0x18 /* 768k              */
#define GTI_AUTO_CP_MIN_ERROR_PER_MINUTE 0x02

#define GTI_AUTO_CP_ENABLE_FIRST_TIME  0x02
#define GTI_AUTO_CP_ENABLE             0x01
#define GTI_AUTO_CP_DISABLE            0x00


/************* Fallback Feature Definitions *****************************/
#ifdef GTI_AC_CPE

/* Timeouts */
#define GTI_AC_ANNEX_A_TRAINING_WAIT        15       /* 15 secs */
#define GTI_AC_ANNEX_C_TRAINING_WAIT        15       /* 15 secs */
#define GTI_AC_ANNEX_A_CNFRM_TRN_WAIT       5        /*  5 secs */
#define GTI_AC_ANNEX_A_DATA_WAIT            45       /* 45 secs */
#define GTI_AC_ANNEX_C_DATA_WAIT            60       /* 60 secs */

/* States */
#define GTI_AC_IDLE_STATE                  0
#define GTI_AC_ANNEX_A_DETECT_STATE        1
#define GTI_AC_ANNEX_A_CNFRM_TRN_STATE     2
#define GTI_AC_ANNEX_A_ATTEMPT_STATE       3
#define GTI_AC_ANNEX_C_DETECT_STATE        4
#define GTI_AC_ANNEX_C_ATTEMPT_STATE       5
#define GTI_AC_FINAL_ANNEX_A_STATE         6
#define GTI_AC_FINAL_ANNEX_C_STATE         7
#define GTI_AC_ERROR_STATE                 50

#define GTI_LAST_FAILED_ANNEX_A_MAGIC      0x47
#define GTI_LAST_FAILED_ANNEX_C_MAGIC      0x40

#define GTI_AC_INIT    1
#define GTI_AC_ABORT   3

/* Prototypes */
void GtiACInit(GTI_XCVR_INFO *, GTI_WORD);
GTI_WORD Gti_CheckMode(GTI_XCVR_INFO *);
GTI_WORD GtiACTimeElapsed(GTI_WORD, GTI_WORD);
void GtiACMemcpy(void *, void *, GTI_WORD);
void GtiACSetAnnexCParams(struct PARAM_XCVR_ARRAY *);

#endif
/************* Fallback Feature Definitions End *************************/

#ifdef GTI_DSPQUAD
void Gti_UtopiaEnableOddAddress( GTI_XCVR_INFO *);
#endif

GTI_WORD GTI_Set_Defaults(struct PARAM_XCVR_ARRAY *, GTI_WORD);

struct GTI_REG_INIT
{
    /* Which Register Space - DMA, A or B */
    GTI_BYTE  reg_space;
    GTI_BYTE  reg_num;
    GTI_BYTE  value_high;
    GTI_BYTE  value_low;
};

void Gti_RegInit(GTI_XCVR_INFO *,
             struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL * );

#endif
#else /* ! Second Pass */
#define GTI_SECOND_PASS
#endif
