/*
 * @(#)gtistat.h	1.29
 */

/* (C) Copyright 1996-2003 by GlobeSpan Technologies Inc */

#ifndef  INCLUDE_FILE_GTISTAT_H
#define  INCLUDE_FILE_GTISTAT_H

/*  Data types for the statuses */
typedef struct _GTI_LINE_DATA_STATUS_TYPE
{
    GTI_WORD adslAtucInvVendorID;
    GTI_WORD adslAtucInvVersionNumber;
    GTI_WORD adslCurrSnrMgn;
    GTI_WORD adslAtucCurrAtn;
    GTI_WORD adslAtucCurrStatus;
    GTI_WORD adslAtucTxPowerAttenuation;
    GTI_WORD adslAtucNoTxBins;
    GTI_WORD adslAturCurrAtn;
    GTI_WORD adslAturCurrStatus;
    GTI_WORD adslAturCurrOutputPwr;
    GTI_WORD adslAtucChanInterleaveDelay;
    GTI_WORD adslAtucChanCurrAs0TxRate;
    GTI_WORD adslAtucCrcBlockLength;
    GTI_WORD adslAturChanInterleaveDelay;
    GTI_WORD adslAturChanCurrLs0TxRate;
    GTI_WORD adslAturCrcBlockLength;
} GTI_LINE_DATA_STATUS_TYPE;

typedef struct _GTI_PM_DATA_STATUS_TYPE
{
    GTI_WORD adslAtucChanReceivedBlks;
    GTI_WORD adslAtucChanTransmittedBlks;
    GTI_WORD adslAtucChanCorrectedBlksI;
    GTI_WORD adslAtucChanCorrectedBlksF;
    GTI_WORD adslAtucChanUncorrectBlksI;
    GTI_WORD adslAtucChanUncorrectBlksF;
    GTI_WORD adslAturChanReceivedBlks;
    GTI_WORD adslAturChanTransmittedBlks;
    GTI_WORD adslAturChanCorrectedBlksI;
    GTI_WORD adslAturChanCorrectedBlksF;
    GTI_WORD adslAturChanUncorrectBlksI;
    GTI_WORD adslAturChanUncorrectBlksF;
    GTI_WORD adslAtucPerfStatFastR;
    GTI_WORD adslAtucPerfStatFailedFastR;
    GTI_WORD adslAtucPerfStatSesL;
    GTI_WORD adslAtucPerfStatUasL;
    GTI_WORD adslAturPerfStatSesL;
    GTI_WORD adslAturPerfStatUasL;
    GTI_WORD adslAtucPerfStatErrS;
    GTI_WORD adslAturPerfStatErrS;
} GTI_PM_DATA_STATUS_TYPE;

/*********************START DEFINES FOR STATUS  ***********************/

/********************************************/
/* Defines for requested STATUS information */
/********************************************/
/* Types of Status  Location 0              */
#define GTI_FW_REL                          0   /* 0x00 */
#ifdef GTI_HOSTVSC                              /* Viking - Embeded Host */
#define GTI_FW_REL_LEN                      8
#else
#define GTI_FW_REL_LEN                      5
#endif

#define GTI_LAST_FAILED_STATUS              1   /* 0x01 */
#define GTI_LAST_FAILED_STATUS_LEN          2

#define GTI_MEAN_SQ_ERROR                   3   /* 0x03 */
#define GTI_MEAN_SQ_ERROR_LEN               2   /* non DMT and non RADSL only */

#define GTI_OP_STATE                        4   /* 0x04 */
#define GTI_OP_STATE_LEN                    2

#define GTI_RECEIVER_GAIN                   5   /* 0x05 */
#define GTI_RECEIVER_GAIN_LEN               4

#define GTI_RS_BYTES                        6   /* 0x06 */
#define GTI_RS_BYTES_LEN                    2

#define GTI_DSP_VERSION                     7   /* 0x07 */
#define GTI_DSP_VERSION_LEN                 1

#define GTI_DSPQUAD_VERSION                 GTI_DSP_VERSION
#define GTI_DSPQUAD_VERSION_LEN             GTI_DSP_VERSION_LEN

#define GTI_XMIT_POWER                      8   /* 0x08 */
#define GTI_XMIT_POWER_LEN                  4

#define GTI_START_PROGRESS                  9   /* 0x09 */
#define GTI_START_PROGRESS_LEN              2

#define GTI_WATCHDOG_TIMER                  10  /* 0x0a */
#define GTI_WATCHDOG_TIMER_LEN              2

#define GTI_TSM_REL                         11  /* 0x0b */
#define GTI_TSM_REL_LEN                     5

#define GTI_BERT_ERROR                      12  /* 0x0c */
#define GTI_BERT_ERROR_LEN                  4

#define GTI_RMT_VENDOR_ID_STATUS            18  /* 0x12 */
#define GTI_RMT_VENDOR_ID_G_LITE_STATUS_LEN 8
#define GTI_RMT_VENDOR_ID_G_DMT_STATUS_LEN  8
#define GTI_RMT_VENDOR_ID_HS_ADSL_STATUS_LEN 8
#define GTI_RMT_VENDOR_ID_STATUS_LEN        2

#define GTI_RMT_VENDOR_REV_STATUS           40  /* 0x28 */  /* DMT */
#define GTI_RMT_VENDOR_REV_STATUS_LEN       2

#define GTI_BIT_LOADING_UP                  42  /* 0x2A */  /* DMT */
#define GTI_BIT_LOADING_UP_LEN              64

#define GTI_BIT_LOADING_DN                  43  /* 0x2B */  /* DMT */
#define GTI_BIT_LOADING_DN_LEN              -   /* not used */

#define GTI_SNR_MARGIN_PER_BIN              44  /* 0x2C */  /* DMT */
#define GTI_SNR_MARGIN_PER_BIN_LEN          -   /* not used */

#define GTI_RX_BYTES_STATUS                 48  /* 0x30 */  /* DMT */
#define GTI_RX_BYTES_STATUS_LEN             1

#define GTI_TX_BYTES_STATUS                 49  /* 0x31 */  /* DMT */
#define GTI_TX_BYTES_STATUS_LEN             1

#define GTI_PILOT_TONE_INDEX_STATUS         50  /* 0x32 */
#define GTI_PILOT_TONE_INDEX_STATUS_LEN     2

#define GTI_COUNTERS                        61  /* 0x3d */  /* DMT */
#define GTI_COUNTERS_LEN                    44

#define GTI_FAILURES                        62  /* 0x3e */  /* DMT */
#define GTI_FAILURES_LEN                    28

#define GTI_ACTUAL_CONFIGURATION            63  /* 0x3f */  /* DMT */
#define GTI_ACTUAL_CONFIGURATION_LEN        38

#define GTI_LCL_SNR_MARGIN                  65  /* 0x41 */  /* DMT */
#define GTI_LCL_SNR_MARGIN_LEN              1

#define GTI_LCL_CODING_GAIN                 66  /* 0x42 */  /* DMT */
#define GTI_LCL_CODING_GAIN_LEN             1

#define GTI_ATTENUATION_STATUS              67  /* 0x43 */  /* DMT */
#define GTI_ATTENUATION_STATUS_LEN          2

#define GTI_LCL_FW_REV_NUM                  68  /* 0x44 */  /* DMT */
#define GTI_LCL_FW_REV_NUM_LEN              1
#define GTI_LCL_FW_REV_NUM_VALUE            1

#define GTI_DUMMY_STATUS                    83  /* 0x53 */  /* RADSL */
#define GTI_DUMMY_STATUS_LEN                2

#define GTI_UTOPIA_CELL_DROP_COUNT          84  /* 0x54 */  /* DMT & ALL HMS UTOPIA  - !SHDSL*/
#define GTI_UTOPIA_CELL_DROP_COUNT_LEN      2

#define GTI_RS_FRAME_COUNTER                85  /* 0x55 */  /* DMT */
#define GTI_RS_FRAME_COUNTER_LEN            4

#define GTI_ATM_CELL_COUNTER                86  /* 0x56 */  /* DMT */
#if defined(GTI_DSPOCTANE) && defined(GTI_BUILD_CO)
#define GTI_ATM_CELL_COUNTER_LEN            8
#else
#define GTI_ATM_CELL_COUNTER_LEN            4
#endif

#define GTI_RMT_TX_POWER_STATUS             87  /* 0x57 */
#define GTI_RMT_TX_POWER_STATUS_LEN         2   /* DMT */

#define GTI_STATUS_REQUEST                  88
#define GTI_STATUS_REQUEST_LEN              2

#define GTI_RX_TEST_RESULTS_1_64            91
#define GTI_RX_TEST_RESULTS_64_128          92
#define GTI_RX_TEST_RESULTS_128_192         93
#define GTI_RX_TEST_RESULTS_192_256         94
#define GTI_RX_TEST_RESULTS_LEN             256

#define GTI_IDLE_BERT_STATUS                95   /* 0x5f */ /* DMT */
#define GTI_IDLE_BERT_STATUS_LEN            4

#define GTI_FAST_RETRAIN_STATUS             96   /* 0x60 */ /* DMT */
#define GTI_FAST_RETRAIN_STATUS_LEN         6

#define GTI_STATUS_RESULT                   97   /* 0x61 */
#define GTI_STATUS_RESULT_LEN               2

#define GTI_STATUS_SAS_POINTER              98   /* 0x62 */
#define GTI_STATUS_SAS_POINTER_LEN          2

#define GTI_CLOCK_SYNCH_STATUS              99   /* 0x63 */
#define GTI_CLOCK_SYNCH_STATUS_LEN          2

#define GTI_LBUS_FW_VERSION                 105 /* 0x69*/  /* DMT & RADSL with XDMA */

#define GTI_RESERVED_0_STATUS               106 /* 0x6a */
#define GTI_RESERVED_0_STATUS_LEN           2
#define GTI_RESERVED_1_STATUS               107 /* 0x6b */
#define GTI_RESERVED_1_STATUS_LEN           2
#define GTI_RESERVED_2_STATUS               108 /* 0x6c */
#define GTI_RESERVED_2_STATUS_LEN           2
#define GTI_RESERVED_3_STATUS               109 /* 0x6d */
#define GTI_RESERVED_3_STATUS_LEN           2
#define GTI_RESERVED_4_STATUS               110 /* 0x6e */
#define GTI_RESERVED_4_STATUS_LEN           2

#define GTI_BIT_SWAP_COUNT                  111 /* 0x6f DMT */
#define GTI_BIT_SWAP_COUNT_LEN              2

#define GTI_LINE_DATA_STATUS                112 /* 0x70 DMT */
#define GTI_LINE_DATA_STATUS_LEN            sizeof(GTI_LINE_DATA_STATUS_TYPE)

#define GTI_PM_DATA_STATUS                  113 /* 0x71 DMT */
#define GTI_PM_DATA_STATUS_LEN              sizeof(GTI_PM_DATA_STATUS_TYPE)

#define GTI_UPSTREAM_MARGIN_STATUS          114 /* 0x72 DMT */
#define GTI_UPSTREAM_MARGIN_STATUS_LEN       1   /*return 1 byte*/

/*                                          115   CP  US Bit SWAP */

#define GTI_LCL_ANNEX_C_MODE                116   /* 0x74 */ /* DMT */
#define GTI_LCL_ANNEX_C_MODE_LEN            1

#define GTI_OVERLAP_STATUS                  117   /* 0x75 */ /* DMT */
#define GTI_OVERLAP_STATUS_LEN              1

#define GTI_BIT_LOADING_NEXT_UP             118   /* 0x76 */  /* DMT */
#define GTI_BIT_LOADING_NEXT_UP_LEN         32

#define GTI_BIT_LOADING_NEXT_DN             119   /* 0x77 */  /* DMT */
#define GTI_BIT_LOADING_NEXT_DN_LEN         -    /* not used */

#define GTI_MEAN_SQ_NEXT_ERROR              120  /* 0x78 */
#define GTI_MEAN_SQ_NEXT_ERROR_LEN          2    /* non DMT and non RADSL only */

#define GTI_SNR_MARGIN_PER_BIN_NEXT         121  /* 0x79 */  /* DMT */
#define GTI_SNR_MARGIN_PER_BIN_NEXT_LEN     -    /* not used */

#define GTI_LCL_XMIT_POWER_STATUS           122  /* 0x7a */
#define GTI_LCL_XMIT_POWER_STATUS_LEN       4    /* DMT */

#define GTI_AFE_VERSION                     123   /* 0x7b */
#define GTI_AFE_VERSION_LEN                 1

#define GTI_PSD_MASK_MODE_STATUS            124   /* 0x7c */
#define GTI_PSD_MASK_MODE_STATUS_LEN        2

#ifdef GTI_INSTALL_ANNEX_CO
#define GTI_INSTALL_RESULTS_STATUS          125   /* 0x7d */
#define GTI_INSTALL_RESULTS_STATUS_LEN      sizeof(GTI_AC_INFO)

#define GTI_INSTALL_ANNEX_STATUS            126   /* 0x7e */
#define GTI_INSTALL_ANNEX_STATUS_LEN        4
#endif

#if defined(GTI_USE_GLOBAL_BUFFER_FOR_LARGE_STATUS) && defined(GTI_DEBUG)
#define GTI_PARAMETRIC_RESULTS_STATUS       127   /* 0x7f */
#define GTI_PARAMETRIC_RESULTS_STATUS_LEN   240
#endif

#if defined(GTI_BUILD_CO)
#define GTI_US_BIT_SWAP_COUNT               177   /* 0xB1 DMT */
#else
#define GTI_US_BIT_SWAP_COUNT               115   /* 0xB1 DMT */
#endif
#define GTI_US_BIT_SWAP_COUNT_LEN           2


#define GTI_CMD_RESULT                      0xf0
#define GTI_ACTION_REQUEST_STATUS           0xf0
#define GTI_INTERNAL_SAS                    0xf0
#define GTI_INTERNAL_SAS_LEN                1
#define GTI_ACTION_REQUEST_STATUS_LEN       1

#define GTI_MAX_STATUS_TABLE_SIZE       129
#define GTI_SIZE_OF_STATUS_PNTR         4

                       /*********************************/
                       /* Defines for Status FW REL     */
                       /* See Interface Control Doc     */
                       /* Table StatusXCVR Fields       */
                       /*********************************/

                       /******************************************/
                       /* Defines for Status Last Fail           */
                       /* See Interface Control Doc              */
                       /* Table Values of GTI_LAST_FAILED_STATUS */
                       /******************************************/

/* CP comand to CO or CO command to CP                  */
#define GTI_MODE_ILLEGAL             0xf00d
#define GTI_CP_VER_ILLEGAL          0xf00a

/* CO only. Fix Bit. CP dosn't support requested option */
#define GTI_CP_OPTION_ILLEGAL        0xf00b
#define GTI_RESERVED_ILLEGAL         0xf000

                       /******************************************/
                       /* Defines for OP State                   */
                       /* Array Position 0                       */
                       /******************************************/
#define GTI_IDLE_OP             0x00
#define GTI_DATA_OP             0x01
#define GTI_STBY_OP             0x02
#define GTI_BOOTUP_LOAD         0x08
#define GTI_BOOTUP_LOAD_DONE    0x09
#define GTI_HANDSHAKE_OP        0x10
#define GTI_CARRIERDETECT_OP    0x10
#define GTI_PMMS                0x14
#define GTI_LB_SPECTRUM_TEST    0x15
#define GTI_TRAINING_OP         0x18
#define GTI_STBY_CONFIG_OP      0x19
#define GTI_FRAMER_SYNC_OP      0x1a
#define GTI_FAST_RETRAIN_IN_PROGRESS_OP     0x1b
#define GTI_ESCAPE_OP           0x1c


#define GTI_LL_TEST_OP                     0x80   /* Analogue Local Loopback */
#define GTI_LL_HYBRID_TEST_OP              0x80   /* Analogue Local Loopback */
#define GTI_LL_SLADE_TEST_OP               0x81   /* Analogue Local Loopback */
#define GTI_CL_TEST_OP                     0x82   /* Core Loop Back - used for Remote Loopbacks */
#define GTI_DL_TEST_OP                     0x83   /* Digital Local Loopback */

#define GTI_TX_TEST_OP                     0x84   /* Test Spectrum Test     */
#define GTI_TX_4PT_TEST_OP                 0x84   /* Test Spectrum Test     */
#define GTI_TX_2PT_TEST_OP                 0x85   /* Test Spectrum Test     */
#define GTI_TX_DOWN_TEST_OP                0x84   /* Test Down Spectrum Test  HDSL2   */
#define GTI_TX_UP_TEST_OP                  0x85   /* Test Up   Spectrum Test  HDSL2   */

#define GTI_LEVEL_P_3_TEST_OP              0x86   /* Test Level             */
#define GTI_LEVEL_P_1_TEST_OP              0x87   /* Test Level       */
#define GTI_LEVEL_M_1_TEST_OP              0x88   /* Test Level       */
#define GTI_LBUS_CHCK_TEST_OP              0x89   /* Test Level       */
#define GTI_DOWN_LOAD_TST_OP               0x8a   /* Test Code Download */
#define GTI_FRAMER_LL_TEST_OP              0x8b   /* Framer Local Loop Test */
#define GTI_FRAMER_RL_TEST_OP              0x8c   /* Framer Remote Loop Test */
#define GTI_FRAMER_LL_RL_TEST_OP           0x8d   /* Framer Local/Remote Loop Test */



                                      /* OP States that require Host Action */
                                      /* Go Here                            */
                                      /* DMT Only OP STATES */
#define GTI_HOST_REQ_MSK        0x20  /* Mask to see if OP_SATE = Host Action Required */
#define GTI_FAST_RETRAIN_OP     0x21
#define GTI_PROF_MNGT_OP        0x22
#define GTI_BIT_SWAPPING_OP     0x23

#define GTI_RESERVED_1      0x40   /* Reserved */
/* The above RMT status indications require the HOST processor */
/* to iniate the indicated action                              */

                       /******************************************/
                       /* Defines for OP State                   */
                       /* Array Position 1                       */
                       /******************************************/
#define GTI_BERT_TEST 0x01

                       /******************************************/
                       /* Defines for RS Bytes                   */
                       /* See Interface Control Doc              */
                       /* GTI_RS_BYTES for data information      */
                       /******************************************/

                       /******************************************/
                       /* Defines for Start Progress             */
                       /* See Interface Control Doc              */
                       /* Table Values of GTI_START_PROGRESS     */
                       /******************************************/

                       /******************************************/
                       /* Defines for WatchDog Timer             */
                       /* See Interface Control Doc              */
                       /* GTI_WATCHDOG_TIMER                     */
                       /******************************************/
#define GTI_WATCHDOG_SET_VALUE  0x0053
#define GTI_WATCHDOG_CLR_VALUE  0x0000

                       /******************************************/
                       /* Defines for BERT Error                 */
                       /* See Interface Control Doc              */
                       /* GTI_BERT_ERROR                         */
                       /******************************************/

/******************************************/
/* Defines for DMT                        */
/******************************************/

                       /********************************************/
                       /* Defines for GTI_ACTUAL_CONFIGURATION     */
                       /* Define for each element in the response. */
                       /********************************************/
#define GTI_FRAMING_OVERHEAD_ACTUAL   0x00 /* a value from 0-3                          */
#define GTI_TRELLIS_ACTUAL            0x01 /* GTI_TRELLIS_DISABLE or GTI_TRELLIS_ENABLE */
#define GTI_AS0_BYTES_ACTUAL          0x02 /* number of AS0 bytes                       */
#define GTI_AS0_LATENCY_ACTUAL        0x03 /* GTI_INTERLEAVE_BUFFER or GTI_FAST_BUFFER  */
#define GTI_AS1_BYTES_ACTUAL          0x04 /* number of AS1 bytes                       */
#define GTI_AS1_LATENCY_ACTUAL        0x05 /* GTI_INTERLEAVE_BUFFER or GTI_FAST_BUFFER  */
#define GTI_LS0_BYTES_ACTUAL          0x06 /* number of LS0 bytes                       */
#define GTI_LS0_LATENCY_ACTUAL        0x07 /* GTI_INTERLEAVE_BUFFER or GTI_FAST_BUFFER  */
#define GTI_LS1_BYTES_ACTUAL          0x08 /* number of LS1 bytes                       */
#define GTI_LS1_LATENCY_ACTUAL        0x09 /* GTI_INTERLEAVE_BUFFER or GTI_FAST_BUFFER  */
#define GTI_FAST_R_UP_ACTUAL          0x0a /* Redundant bytes for the Fast buffer       */
#define GTI_INTERLEAVE_S_UP_ACTUAL    0x0b /* S value for Interleaved buffer            */
#define GTI_INTERLEAVE_D_UP_ACTUAL    0x0c /* Interleave depth                          */
#define GTI_INTERLEAVE_R_UP_ACTUAL    0x0d /* Redundant bytes for the Interleave buffer */
#define GTI_FAST_R_DOWN_ACTUAL        0x0e /* Redundant bytes for the Fast buffer       */
#define GTI_INTERLEAVE_S_DOWN_ACTUAL  0x0f /* S value for Interleaved buffer            */
#define GTI_INTERLEAVE_D_DOWN_ACTUAL  0x10 /* Interleave depth                          */
#define GTI_INTERLEAVE_R_DOWN_ACTUAL  0x11 /* Redundant bytes for the Interleave buffer */
#define GTI_SELECTED_STANDARD_ACTUAL  0x12 /* Selected standard buffer                  */

/* BIS #defines */
#define GTI_BIS_L0_UP_ACTUAL          0x00
#define GTI_BIS_B0_UP_ACTUAL          0x01
#define GTI_BIS_M0_UP_ACTUAL          0x02
#define GTI_BIS_T0_UP_ACTUAL          0x03
#define GTI_BIS_R0_UP_ACTUAL          0x04
#define GTI_BIS_D0_UP_ACTUAL          0x05
#define GTI_BIS_L0_DN_ACTUAL          0x06
#define GTI_BIS_B0_DN_ACTUAL          0x07
#define GTI_BIS_M0_DN_ACTUAL          0x08
#define GTI_BIS_T0_DN_ACTUAL          0x09
#define GTI_BIS_R0_DN_ACTUAL          0x0a
#define GTI_BIS_D0_DN_ACTUAL          0x0b


                       /***************************************************/
                       /* Defines for GTI_COUNTERS                        */
                       /* Define for each element in the response.        */
                       /* All counter cleared each time status is issued. */
                       /***************************************************/
#define GTI_LOCAL_RSI_COUNTER         0x00 /* Interleaved RS Corrected bytes            */
#define GTI_LOCAL_RSF_COUNTER         0x01 /* Fast RS Corrected bytes                   */
#define GTI_LOCAL_CRSI_COUNTER        0x02 /* Interleaved symbols with CRC errors       */
#define GTI_LOCAL_CRSF_COUNTER        0x03 /* Fast symbols with CRC errors              */
#define GTI_LOCAL_SEF_COUNTER         0x04 /* Count of Severely errored frames          */
#define GTI_LOCAL_LOS_COUNTER         0x05 /* Count of Loss of signal frames            */
#define GTI_LOCAL_NCDI_COUNTER        0x06 /* No Cell delineation (counts until in sync */
                                           /* for the first time) Interleaved           */
#define GTI_LOCAL_NCDF_COUNTER        0x07 /* No Cell delineation (counts until in sync */
                                           /* for the first time) Fast                  */
#define GTI_LOCAL_OCDI_COUNTER        0x08 /* Out of Cell delineation (only counts      */
                                           /* if has been in sync) Interleaved          */
#define GTI_LOCAL_OCDF_COUNTER        0x09 /* Out of Cell delineation (only counts      */
                                           /* if has been in sync) Fast                 */
#define GTI_LOCAL_HECI_COUNTER        0x0a /* Header Error Check Counter Interleaved    */
#define GTI_LOCAL_HECF_COUNTER        0x0b /* Header Error Check Counter Fast           */
#define GTI_REMOTE_CRSI_COUNTER       0x0c /* Interleaved symbols with CRC errors       */
#define GTI_REMOTE_RSI_COUNTER        0x0d /* Interleaved RS Corrected bytes            */
#define GTI_REMOTE_CRSF_COUNTER       0x0e /* Fast symbols with CRC errors              */
#define GTI_REMOTE_RSF_COUNTER        0x0f /* Fast RS Corrected bytes                   */
#define GTI_REMOTE_LOS_COUNTER        0x10 /* Count of Loss of signal frames            */
#define GTI_REMOTE_SEF_COUNTER        0x11 /* Count of Severely errored frames          */
#define GTI_REMOTE_NCDI_COUNTER       0x12 /* No Cell delineation (counts until in sync */
                                           /* for the first time) Interleaved           */
#define GTI_REMOTE_NCDF_COUNTER       0x13 /* No Cell delineation (counts until in sync */
                                           /* for the first time) Fast                  */
#define GTI_REMOTE_HECI_COUNTER       0x14 /* Header Error Check Counter Interleaved    */
#define GTI_REMOTE_HECF_COUNTER       0x15 /* Header Error Check Counter Fast           */

#define GTI_LOCAL_ESI_COUNTER         0x16 /* ES-L Counter - Interleaved */
#define GTI_LOCAL_ESF_COUNTER         0x17 /* ES-L Counter - Fast */
#define GTI_LOCAL_SESI_COUNTER        0x18 /* SES-L Counter - Interleaved */
#define GTI_LOCAL_SESF_COUNTER        0x19 /* SES-L Counter - Fast */
#define GTI_LOCAL_UASI_COUNTER        0x1a /* UAS-L Counter - Interleaved */
#define GTI_LOCAL_UASF_COUNTER        0x1b /* UAS-L Counter - Fast */

                       /*************************************************/
                       /* Defines for GTI_FAILURES                      */
                       /* Define for each element in the response.      */
                       /* Non-Zero value for the overall indicates that */
                       /* there is at least one failure.  The other     */
                       /* locations are counters.  If they count above  */
                       /* 127, then there is a failure.  If the problem */
                       /* goes away, the counters automatically reset   */
                       /* to 0.                                         */
                       /*************************************************/
#define GTI_OVERALL_FAILURE           0x00 /* non-zero if there any failures            */
#define GTI_LOCAL_LOS_FAILURE         0x01 /* Count of Loss of signal frames            */
#define GTI_LOCAL_SEF_FAILURE         0x02 /* Count of Severely errored frames          */
#define GTI_LOCAL_NCDI_FAILURE        0x03 /* Count of NCDI (see counters)              */
#define GTI_LOCAL_NCDF_FAILURE        0x04 /* Count of NCDF (see counters)              */
#define GTI_LOCAL_LCDI_FAILURE        0x05 /* Count of Loss of Cell Delineation I       */
#define GTI_LOCAL_LCDF_FAILURE        0x06 /* Count of Loss of Cell Delineation F       */
#define GTI_REMOTE_POW_FAILURE        0x07 /* Count of dying gasp frames (CO only)      */
#define GTI_REMOTE_LOS_FAILURE        0x08 /* Count of Loss of signal frames            */
#define GTI_REMOTE_SEF_FAILURE        0x09 /* Count of Severely errored frames          */
#define GTI_REMOTE_NCDI_FAILURE       0x0a /* Count of NCDI (see counters)              */
#define GTI_REMOTE_NCDF_FAILURE       0x0b /* Count of NCDF (see counters)              */
#define GTI_REMOTE_LCDI_FAILURE       0x0c /* Count of Loss of Cell Delineation I       */
#define GTI_REMOTE_LCDF_FAILURE       0x0d /* Count of Loss of Cell Delineation F       */


/* Defines for GTI_DOH_DETECT_STATUS                */
/****************************************************/
#define GTI_DOH_DETECTED              0x01
#define GTI_DOH_NOT_DETECTED          0x00

                       /********************************************/
                       /* Defines for GTI_IDLE_BERT_STATUS         */
                       /* Define for each element in the response. */
                       /********************************************/
#define GTI_IDLE_BERT_BERT_ERRORS     0x00
#define GTI_IDLE_BERT_CELLS           0x01

                       /********************************************/
                       /* Defines for GTI_FAST_RETRAIN_STATUS      */
                       /* Define for each element in the response. */
                       /********************************************/
#define GTI_FAST_RETRAIN_RESULT_STATUS            0x00 /* See ..RETRAIN_STATUS below */
#define GTI_FAST_RETRAIN_TX_PROFILE_STATUS        0x01 /* Number of profile used*/
#define GTI_FAST_RETRAIN_RX_PROFILE_STATUS        0x02 /* Number of profile used*/

                       /* GTI_FAST_RETRAIN_RESULT_STATUS */
#define GTI_FULL_RETRAIN                          0x00   /* Full Startup */
#define GTI_FAST_RETRAIN_TRUNCATE                 0x01   /* Partial Fast retrain */
#define GTI_FAST_RETRAIN_UNKNOWN_PROFILE          0x02   /* Full Startup */
#define GTI_FAST_RETRAIN_COMPLETE                 0x03   /* Fast Retrain Complete */
#define GTI_FAST_RETRAIN_ESCAPE                   0x04   /* Fast Retrain during Full startup */
#define GTI_FAST_RETRAIN_NO_ACTIVITY              0xffff /* No activity since last read */

                       /********************************************/
                       /* Defines for GTI_DSPQUAD_VERSION          */
                       /********************************************/
#define GTI_DSP_QUAD_VER_20   0x01
#define GTI_DSP_QUAD_VER_21   0x02
#define GTI_DSP_QUAD_VER_31   0x03
#define GTI_DSP_QUAD_VER_40   0x04
                       /********************************************/
                       /* Defines for GTI_DSP_VERSION              */
                       /********************************************/
#define GTI_DSP_MONACO_VER_1_0  0x20
#define GTI_DSP_MONACO_VER_1_1  0x21
#define GTI_DSP_TURBO_VER_1_0   0x40
#define GTI_DSP_TURBO_VER_1_1   0x41
#define GTI_DSP_VIKING_VER_1_1  0x80
#define GTI_DSP_VIKING_VER_1_2  0x81
#define GTI_DSP_VIKING_VER_1_X  0x83
#define GTI_DSP_VIKING_VER_B0   0x82
#define GTI_DSP_VIKING_VER_B_X  0x84


                       /********************************************/
                       /* Defines for GTI_PSD_MASK_MODE_STATUS     */
                       /********************************************/
#define GTI_PSD_ADSL_MODE    0x0000
#define GTI_PSD_HS_M1_MODE   0x0003
#define GTI_PSD_HS_M2_MODE   0x0004


                       /* Defines for doing Handling "S" values in Actual Configuration */
#define GTI_NOT_SPECIAL_S        0x0000
#define GTI_SPECIAL_S_ONE_THIRD  0x8003 /* S= 1/3 */
#define GTI_S_FRACTION_MASK      0x8000

/*********************END   DEFINES FOR STATUS  ***********************/

#endif /* INCLUDE_FILE_GTISTAT_H */
