/*
    @(#)gtiusdef.h	1.11
*/

/****************** (C) Copyright 1996-2002 by GlobeSpan Inc ****************/
/****************************************************************************/

#ifndef  INCLUDE_FILE_GTIUSDEF_H
#define  INCLUDE_FILE_GTIUSDEF_H

#ifdef GTI_USB
#include "usb_msg.h"
#endif
/********************** Internal use #defines *******************************/
#ifdef GTI_ISOS
#include "timelib.h"
#endif
/********************** USER MODIFIED DEFINES *******************************/

/* Storage classes and specifiers */

/* GTI_ADDRESS_QUAL - storage class specifiers for pointers */

#if(!defined(GTI_USE_INTERNAL_TARGET) && defined(GTI_DEBUG))
    #define GTI_ADDRESS_QUAL far                   /* for Globespan testing */
#else
    #define GTI_ADDRESS_QUAL                       /* USER setting */
#endif

#define GTI_CONST_BYTE_ORDER  GTI_CONST_QUAL GTI_BYTE
#define GTI_CONST_QUAL  const
#define GTI_GLOBAL_QUAL
#define GTI_LOCAL_QUAL

/* #defines for INSTALL mode only */
#define GTI_AC_CHK_FREQ                5       /*Frequency of Gti_CheckMode called */
#define GTI_MAX_INSTALL_ATTEMPT_TIME   90      /* Not recommended to change!! */

/* Compiler options for structure packing */
/* Structure packing is required for whip messages */
/* Set GTI_DISABLE_PRAGMA_PACK if you cannot use the pack() pragma */
/*    then use a storage specifier or compiler command line option */
/* #define GTI_DISABLE_PRAGMA_PACK   */

#if defined(GTI_DISABLE_PRAGMA_PACK)
#define GTI_PACKED_QUAL  __packed            /* set your storage specifier  */
#else
#define GTI_PACKED_QUAL
#endif


/* GTI_MAX_XFR_BLOCK_SIZE defines the maximum size in bytes of one block    */
/* that can be transferred between the HOST and DSP.                        */

#define GTI_MAX_XFR_BLOCK_SIZE      0x1c00

#ifndef GTI_DEBUG

/* If the DMA Local Bus is not used, set the GTI_TOTAL_BUSES_NUMBER and     */
/* GTI_MAX_CHIPS_PER_LBUS to 1 (default)                                    */
    #define GTI_MAX_CHIPS_PER_SYSTEM   1 /* Number of Chipsets used in sytstem. */
    #define GTI_MAX_BUSES_PER_SYSTEM   1 /* Number of Local Busses for DMA use. */

#endif

/* Define the starting address of the Read Write portion of the local bus.  */
/* If the whole Local bus is used as RAM, leave it a default value          */

#ifndef GS_USE_LEGACY
#define GTI_LBUS_RW_START_ADDR      0x40000
#endif

/************************** DRIVERS MACROS **********************************/
/* Define hardware specific driver macros here. These macros should define  */
/* the DSP byte access method as well as the block access.                  */
/* Define the  macros instead of the 'extern' functions here.               */
/*                                                                          */
#ifndef GTI_DEBUG
    extern void GTI_POKE_BYTE(GTI_WORD, GTI_BYTE);
    extern GTI_BYTE GTI_PEEK_BYTE(GTI_WORD);
    extern void GTI_POKE_BLOCK(GTI_WORD, GTI_WORD, GTI_BYTE *);
#endif

/****************************************************************************/
/* Define your delay API here.                                              */
/* The input parameter is a delay time in microseconds                      */
/*                                                                          */
#ifndef GS_USE_LEGACY
#ifndef GTI_ISOS
#define DELAY_GTI_PROCESS(a) {  \
        volatile int _delIdxA;  \
        for(_delIdxA=0; _delIdxA<a; _delIdxA++) {}; }
#else
#define DELAY_GTI_PROCESS(a)  timer_us_wait( a )  /* Used by Globespan */
#endif
#endif /* GS_USE_LEGACY */

/******************** STANDARD MEMORY-MAPPED I/O ****************************/
/* Use these macros for fast access to devices which are memory-mapped      */
/* and can be accessed using a char pointer                                 */
/* Instructions:                                                            */
/*    1. define GTI_USE_STD_IO_MACROS to enable these macros                */
/*    2. Keep the pBaseAddr pointer in your CUST_INFO / CUST_XCVR_INFO      */
/*    3. Initialize pBaseAddr to chip address right AFTER Gti_BuildChip()   */
/*       is called and BEFORE Gti_BuildXCVR() is called                     */
/****************************************************************************/

/* #define GTI_USE_STD_IO_MACROS */
#if defined(GTI_USE_STD_IO_MACROS)

typedef volatile unsigned char GTI_ADDRESS_QUAL *GTI_CHIP_ADDRESS;
#endif

/************************** CUSTOMER INFORMATION ****************************/
/* These structures are used to store I/O related info needed by customer   */
/* drivers. Passed to BuildChip, copied to Xcvr by BuildXcvr                */
/* NOTE: the customer must allocate memory for these structures and         */
/* manage its contents.                                                     */
/****************************************************************************/

typedef struct _GTI_CUST_INFO
{
#if defined(GTI_USE_STD_IO_MACROS)
    GTI_CHIP_ADDRESS pChipReg;        /* KEEP for memory-mapped standard IO */
#else
    GTI_CS_ADDRESS csBaseAddr;        /* KEEP for compatibility mode IO */
#endif
    /* Place anything here that you need for your I/O driver implementation */
    /* FOR EXAMPLE: Chip level information */
    GTI_CS_ADDRESS csReset;
    GTI_CS_ADDRESS csFrmrAddr;
}   GTI_CUST_INFO;

typedef struct _GTI_CUST_XCVR_INFO
{
#if defined(GTI_USE_STD_IO_MACROS)
    GTI_CHIP_ADDRESS pXcvrReg;        /* KEEP for memory-mapped standard IO */
#endif
#if defined(GTI_USE_STD_IO_MACROS)

#endif
#ifdef GTI_USB
   GTI_MSG_LAYER_INFO *msgInfo;
	GTI_STATUS_BLOCK  *status;
   GTI_WORD            actionItem;
#endif

    /* Place anything transceiver-specific here that you need  */
    /* I/O driver implementation */
    GTI_WORD wFutureUse;
}   GTI_CUST_XCVR_INFO;


#endif  /* INCLUDE_FILE_GTIUSDEF_H */
