#ifndef OAM_H									// only define these values once
#define OAM_H

#ifdef  _NTDDK_
#include "ndis.h"
#elif defined(linux)
#include "GpSnull.h"
#endif

#include "debug.h"
#include "atmuni.h"

/* OAM Function type */
#define LOOPREQ				        0x18        // Fault Management and Loopback dec value
#define OAM_AIS                        0x10        // AIS = Alarm Indication Signal
#define OAM_RDI                        0x11        // RDI = Remote Defect Indicator

#define CRC10POLY			            0x633       // CRC10 Polynomial hex value

#define OAM_F4_CELL_SEGMENT_VCI		3
#define OAM_F4_CELL_END2END_VCI		4
#define ATM_PTI_101					10			// Payload type for F5 cell (end-to-end)
#define ATM_PTI_100					8			// Payload type for F5 cell (segment)

BOOLEAN 
Process_Loopback (PATM_CELL_RCV atmCell,		// loopback processing prototype
				  PATM_UNI_STATS Stats,
                 PUCHAR need2Send,
                 PATM_UNI AtmUni,
                 PATM_UNI_VC AtmUniVc);

#ifdef  OAM_C
static BOOLEAN
ChkCRC10 (PUCHAR info);							// Check CRC10 prototype

static USHORT
CalcCRC10 (PUCHAR info);						// Calc CRC10 prototype
#endif //OAM_C

void
Generate_Loopback_Cell (PATM_CELL_TXFR atmCell,  // Generate loopback cell prototype
						UCHAR   Vpi, 
						USHORT  Vci);

void
OAMCreateCell (PATM_CELL_TXFR atmCell,
               UCHAR   type,
               UCHAR   Vpi,
               USHORT  Vci,
               UCHAR   pti,
               UCHAR   *reservePtr);
               
void 
Copy_Loopback (PATM_UNI_VC AtmUniVc,            // Copies rcv cell to txfr buffer
               PATM_CELL_TXFR atmCellTxfr,		
			   PATM_CELL_RCV atmCellRcv);

#endif											// end OAM_H definition
