#ifndef RFC2364_H
#define RFC2364_H

#ifdef _NTDDK_
#include <ndis.h>
#include "usb100.h"
#include "common.h"
#include "debug.h"
#include "atmusb.h"
#include "tapi.h"
#include "usbcpl.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h> 
#include "ansihelp.h"
#ifdef PPPOE_MINIPORT
#include "rfc2516.h"
#endif /* PPPOE_MINIPORT */
#elif defined(linux)
#include "GpSnull.h"
#include "Gp.h"
#endif

#define RFC2364_MAX_SDU_SIZE        2048
#define MAX_CONNECTIONS             1

BOOLEAN
Rfc2364Initialize( PATM_USB_INSTANCE Instance ,
                  	ATM_PHY_BIND 			PhyBind,
        	ATM_PHY_DEVICE_HANDLE	PhyDeviceHandle );


USHORT Rfc2364Encapsulate(PATM_USB_INSTANCE Instance , PUCHAR pData,   ULONG Size );

void Rfc2364LinkStatusChange(
	PATM_USB_INSTANCE	Instance,
	ATM_PHY_LINK_STATE	LinkState,
	ULONG				UpstreamRate,
	ULONG				DownstreamRate,
	USHORT              COType
);

void Rfc2364Shutdown( PATM_USB_INSTANCE Instance);
NDIS_STATUS Rfc2364DeleteVc(
              	PATM_USB_INSTANCE	Instance,
            	UINT 		VPI,
	            UINT 		VCI
              );

NDIS_STATUS 
Rfc2364CreateVc(
	PATM_USB_INSTANCE	Instance,
PATM_USB_INSTANCE_CALL  Call
    );

void Rfc2364ReceiveData (
   PATM_USB_INSTANCE   Instance,
   ATM_UNI_USER_HANDLE NotUsed,
   PXFER_DATA_BUFFER   Buffer,
   UCHAR               CpcsUu,
   UCHAR               Cpi
);

void
Rfc2364IndicateReceivedData(
	PATM_USB_INSTANCE	    Instance,
    PXFER_DATA_BUFFER		Buffer,
    ATM_UNI_HANDLE          AtmUniVc
);

void Rfc2364SendComplete(
           PATM_USB_INSTANCE   Instance,
           ATM_UNI_USER_HANDLE NotUsed,
           PNDIS_PACKET        NdisPkt);


#ifdef _NTDDK_
NDIS_STATUS Rfc2364Send(
		       IN NDIS_HANDLE         MacBindingHandle,
		       IN NDIS_HANDLE         CallContext,
		       IN PNDIS_WAN_PACKET    NdisWanPkt
		       );
#elif defined(linux)
NDIS_STATUS Rfc2364Send(
		       IN NDIS_HANDLE         MacBindingHandle,
		       IN NDIS_HANDLE         CallContext,
		       IN PNDIS_PACKET       NdisPkt
		       );
#endif // linux


NDIS_STATUS Rfc2364SetInformation(
                           IN PATM_USB_INSTANCE Instance,
                           IN NDIS_OID Oid,
                           IN PVOID InformationBuffer,
                           IN ULONG InformationBufferLength,
                           OUT PULONG BytesRead,
                           OUT PULONG BytesNeeded
                           );


NDIS_STATUS Rfc2364QueryInformation(
                           IN PATM_USB_INSTANCE Instance,
                           IN NDIS_OID Oid,
                           IN PVOID InformationBuffer,
                           IN ULONG InformationBufferLength,
                           OUT PULONG BytesWritten,
                           OUT PULONG BytesNeeded
                           );

void Rfc2364ReceiveNotify(
           PATM_USB_INSTANCE  Instance,
           PXFER_DATA_BUFFER   Buffer);

#endif
