/*
  %W%
*/
/* **************************************************************************
** FILE NAME:      usb_msg.h
** DESCRIPTION:    A header file supports usb_msg.c
** FILE CREATOR:   KPatel
** ************************************************************************** */

#ifndef  INCLUDE_FILE_USBMSG_H 
#define  INCLUDE_FILE_USBMSG_H

#include "gti_whip.h"
#include "gtistat.h"

#define GTI_ACCESS_TYPE_FIELD      0x0C
#define GTI_MAX_MSG_BUFFER_SIZE    4098

typedef struct
{
   GTI_WORD opState;
   GTI_WORD startProgress;
   GTI_WORD xmitPwr;
   GTI_BYTE txByteStatus;
   GTI_BYTE rxByteStatus;
   GTI_WORD counters[ ((GTI_COUNTERS_LEN)/(sizeof(GTI_WORD))) ];
   GTI_WORD failures[ ((GTI_FAILURES_LEN)/(sizeof(GTI_WORD))) ];
   GTI_WORD flag;
   GTI_WORD lockTimerFR;
   GTI_WORD flagCounter;
//#if defined (ANNEXA) || defined (ANNEXB)
   GTI_BYTE TxbTotalBinsEx[3];
   GTI_BYTE RxbTotalBinsEx[3];
//#elif defined (ANNEXC)
    GTI_BYTE TxbTotalBinsFext[3]; //fbm && dbm
    GTI_BYTE RxbTotalBinsFext[3]; //fbm && dbm
    GTI_BYTE TxbTotalBinsNext[3]; //dbm
    GTI_BYTE RxbTotalBinsNext[3]; //dbm
//#endif //ANNEXA

   GTI_BYTE fdpram6[0x100][3]; /* Number of addresse location times 20 bits (3 bytes) */
   GTI_BYTE fdpram7[0x100][3];
   GTI_BYTE fdpramc[0x100][3];
    GTI_BYTE iramd[0x100][2];    //GTI_IRAMD       45   /*0x2d  */ for FBM and DBM
    GTI_BYTE irame[0x100][2];    //GTI_IRAME        46   /*0x2e  */ for DBM   
    GTI_BYTE fdprama[0x100][3];   //GTI_FDPSRAMA       114  /*0x72  */ FBM & DBM downstream
    GTI_BYTE fdprame[0x100][3];   //GTI_FDPSRAME       118  /*0x76  */ DBM downstream 
    GTI_BYTE fdpramf[0x100][3];   //GTI_FDPSRAMF       119  /*0x77  */ FBM & DBM Upstream
	GTI_BYTE isram[0x100][2];     //GTI_ISRAM          5      0x05
	GTI_BYTE psram0w[0x100][2];    //GTI_PSRAM0W       12     0xC

   GTI_WORD FramingStructure;
   GTI_BYTE startupFlag;   /* Flag to indicate startup request */
   GTI_WORD isIpuReady;    /* is IPU ready for more download? */
   GTI_WORD getNextState;  /* Where the download should start */
   GTI_WORD Reserved[24]; 
   GTI_WORD BitSwapCounter;
} GTI_STATUS_BLOCK;


typedef struct _GTI_MSG_LAYER_INFO
{
   GTI_BYTE type;                               /* type of command/buffer */
   GTI_WORD value;                              /* Configuration and word size */
   GTI_WORD index;                              /* High address and low address */
   GTI_BYTE dataBuff[GTI_MAX_MSG_BUFFER_SIZE];  /* Pointer to buffer provided by the Host */
   GTI_WORD currIdx;                            /* Pointer to the current location in the buffer */
   GTI_BYTE cfgData;                            /* Store the configuration value for the config register */
   GTI_BYTE cfgId;
   int      readLen;
   GTI_BYTE State;
   GTI_BYTE DspAccess;
   void     *pUsbPhy;     /* Instance pointer save for Host */
   void     *pDslEx;      /* Pointer for EOC */
} GTI_MSG_LAYER_INFO;

void Gti_SetTypeDspIO(void *pSysPtr, GTI_BYTE bType);

/****************************************************************************
*                                MACRO
*****************************************************************************
*/
#define  M_REG_OFFSET(id)  ((id == GTI_DSP_DMA) ? 0x0 : GTI_OFFSET_REG);

void Gti_SetProccessToSleep(unsigned int msSleepTime);
void Gti_TraceErrors(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );

void Gti_TraceErrorsStateNull(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );
void Gti_TraceErrorsStateConfig(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );
void Gti_TraceErrorsStateAddr(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );
void Gti_TraceErrorsStateWriteBlock(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );
void Gti_TraceErrorsStateReadBlock(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );
void Gti_TraceErrorsStateWriteReg(GTI_MSG_LAYER_INFO *pMsgInfo , unsigned int nNewState );

/* ************************************************ */
#define ML_SET_MSG(pMsgPtr)                    gsiSetMsg(pMsgPtr);
#define ML_SEND_MSG(pSysPtr)                   UPDATE_DSP(pSysPtr);
#define SEND_DSP_MSG(pSysPtr)                  gtiSendMsg(pSysPtr);
#define SET_DSP_MSG_TYPE(pSysPtr,  wType)      Gti_SetTypeDspIO(pSysPtr, wType);
#define SLEEP_PROCCESS(sleep_time)             Gti_SetProccessToSleep( sleep_time );     
#define TRACE_ERRORS(pMsgInfo , nNewState)     Gti_TraceErrors( pMsgInfo , nNewState);

/* **************************************************************************
**                             DATA_DECLARATION
** ************************************************************************** */
#define GTI_INVALID_LEN            0

#define GTI_ML_STATE_NULL          0
#define GTI_ML_STATE_CONFIG        1
#define GTI_ML_STATE_ADDR          2
#define GTI_ML_STATE_WRITE_BLOCK   3
#define GTI_ML_STATE_READ_BLOCK    4
#define GTI_ML_STATE_WRITE_REG     5
#define GTI_ML_STATE_READ_REG      6

#define GTI_ML_AI_MASK             0x0C 

/* **************************************************************************
**                             FUNCTION DECLARATION
** ************************************************************************** */

/* Primitives--Type of Command */
#define GTI_WRITE_REG_REQ          0xD0
#define GTI_WRITE_AI_BLOCK_REQ     0xD1
#define GTI_WRITE_DMA_BLOCK_REQ    0xD2
/* 0xD3, 0xD4, and 0xD5 are reserved */
#define GTI_FASTREAD_REG_REQ       0xD6
#define GTI_FASTREAD_MEM_REQ       0xD7
#define GTI_INDICATE_DATAMODE      0xD8
#define GTI_INDICATE_RESTART       0xD9
#define GTI_INDICATE_RESET         0xDA
#define GTI_INDICATE_POLL          0xDB
#define GTI_START_INTERRUPT_SCAN   0xDC
#define GTI_WRITE_SUPER_FRAME      0xDD
#ifdef EEPROM
#define GTI_READ_EEPROM            0xDE
#define GTI_WRITE_EEPROM           0xDF
#endif //EEPROM
#define GTI_LOOPBACK_MODE          0xE0
#define GTI_ISO_BANDWIDTH          0xE1  
#define GTI_USB_LOOPBACK_MODE      0xE2
#define GTI_SET_LOW_SUSPEND_CURRENT  0xEA  


#ifdef QUASAR
#define  GTI_DOWNLOAD_CODE             0xE1 
#define  GTI_GET_RT_VERSION            0xE8 
#define  GTI_GET_BC_VERSION            0xE9 
#endif


#ifdef QUASAR
#define    GTI_VERSION_SIZE         0x07
#define EEP_ADDR_HIGH               0x07
#define EEP_ADDR_LOW                0x00    //Eeprom address 0x0600
#endif


/* Size of the buffer for the USB packet */
#define GTI_USB_BLOCK_SIZE         0x1000

#define GTI_OFFSET_REG             0x08
#define GTI_OUT                    GTI_FALSE
#define GTI_IN                     GTI_TRUE

#endif /* INCLUDE_FILE_USBMSG_H */
