/************************************************************************
 *    FILE NAME      : usbcpl.h                                         *
 *    REVISION       : 1                                                *
 *    DESCRIPTION    : This header is used for Control Panel Interface  *
 *                                                                      *
 *    COMMENT        : This file was renamed from gsicpl.h              *
 *                                                                      *
 * (C) Copyright 1998-2002 by GlobespanVirata Inc                       *
 *                                                                      *
 * ******************************************************************** *

 * 1. Initial version after some minimal unit test
  ************************************************************************/

#ifndef GSICPL_H
#define GSICPL_H

#include "gtistat.h"
#include "usbphy.h"

#ifdef NEW_CPL_INTERFACE
#include "DrvIntf.h"
#endif

#ifdef _NTDDK_
#define PDSLPTR_SYMBOLIC_STRING		NDIS_STRING_CONST("\\DosDevices\\ADSLUSB")
#define PDSLPTR_DEVICE_STRING		NDIS_STRING_CONST("\\Device\\ADSLUSB")
#define PDSLPTR_SYMBOLIC_NAME		L"\\DosDevices\\ADSLUSB"
#define PDSLPTR_DEVICE_NAME			L"\\Device\\ADSLUSB"
#define GSPN_SIGNATURE				0x4E505347


#define PDSLPTR_SYMBOLIC_NAME0		L"\\DosDevices\\ADSLUSB"
#define PDSLPTR_DEVICE_NAME0		L"\\Device\\ADSLUSB"

#define PDSLPTR_SYMBOLIC_NAME1		L"\\DosDevices\\ADSLUSB1"
#define PDSLPTR_DEVICE_NAME1		L"\\Device\\ADSLUSB1"





#define UCHAR   unsigned char
#define USHORT  unsigned short
#define ULONG   unsigned long
#define SHORT   short
#define UINT    unsigned int
#define PVOID   void *

#endif // _NTDDK_

#ifdef EEPROMv2
#define MAX_EEPROM_SIZE   1024  //max size in serial byte terms
#endif//EEPROMv2
/************************************************************************
*                             DATA TYPES
*************************************************************************
*/

typedef struct  _GSIDSL_CONFIGU
{
	unsigned short	standard;
	unsigned short maxDownRate;
    unsigned short Rfc1483Mode;
	unsigned short vpi;
	unsigned short vci;

} GSIDSL_CONFIGU, *PGSIDSL_CONFIGU;

typedef struct  _GSIDSL_EEPROM
{
	UCHAR	zeroByte;
	UCHAR	vendorIdLow;
	UCHAR	vendorIdHigh;
	UCHAR	productIdLow;
	UCHAR	productIdHigh;
	UCHAR	releaseLow;
	UCHAR	releaseHigh;
	UCHAR	macAddr0; // MAC address byte 0
	UCHAR	macAddr1;
	UCHAR	macAddr2;
	UCHAR	macAddr3;
	UCHAR	macAddr4;
	UCHAR	macAddr5;
#ifdef EEPROMv2
	UCHAR   usbPower; //bus powered or hub powered.
	UCHAR   busCurrent; //expected current drawn
	UCHAR	eepromSize; //in long words => MAX_EEPROM_SIZE/4 = upto 256.
	UCHAR	proprietaryImage[MAX_EEPROM_SIZE/4 - 16]; //magic# 16: total # of preceding bytes in this structure
#endif//EEPROMv2

} GSIDSL_EEPROM, *PGSIDSL_EEPROM;

typedef struct  _GSIDRIVER_SETTINGS_CO
{
	USHORT	 unit;
	USHORT	 command;		 /* GTI_STARTUP_REQ etc.					 */
	USHORT	 mode;			 /* Indicate CO or CP						 */
	USHORT	 initiate;
	USHORT	 dataInterface;	 /* serial data stream or ATM or None		 */
	USHORT	 trellis;		 /* Enable or Disable						 */
	USHORT	 ecFdm;			 /* Echo cancellation or FDM				 */
	USHORT	 standard;		 /* T1.413 or G.lite						 */
	USHORT	 dwnmargin;		 /* CO side, GTI_0DB_MARGIN_DMT				 */
	USHORT	 upmargin;		 /* CO side, GTI_0DB_MARGIN_DMT				 */
	USHORT	 bitRateMode;	 /* CO side, GTI_ADAPTIVE_RATE etc.			 */

	USHORT	 spd1As0Bytes;	 /* CO side, GTI_64_PER_SYMBOL etc.			 */
	USHORT	 spd1As0Latency; /* CO side, GTI_INTERLEAVED_LATENCY etc.	 */
	USHORT	 spd1As1Bytes;
	USHORT	 spd1As1Latency;
	USHORT	 spd1Ls0Bytes;
	USHORT	 spd1Ls0Latency;
	USHORT	 spd1Ls1Bytes;
	USHORT	 spd1Ls1Latency;

	USHORT	 spd2As0Bytes;	 /* CO side, GTI_64_PER_SYMBOL etc.			 */
	USHORT	 spd2As0Latency; /* CO side, GTI_INTERLEAVED_LATENCY etc.	 */
	USHORT	 spd2As1Bytes;
	USHORT	 spd2As1Latency;
	USHORT	 spd2Ls0Bytes;
	USHORT	 spd2Ls0Latency;
	USHORT	 spd2Ls1Bytes;
	USHORT	 spd2Ls1Latency;

	USHORT	 spd3As0Bytes;	 /* CO side, GTI_64_PER_SYMBOL etc.			 */
	USHORT	 spd3As0Latency; /* CO side, GTI_INTERLEAVED_LATENCY etc.	 */
	USHORT	 spd3As1Bytes;
	USHORT	 spd3As1Latency;
	USHORT	 spd3Ls0Bytes;
	USHORT	 spd3Ls0Latency;
	USHORT	 spd3Ls1Bytes;
	USHORT	 spd3Ls1Latency;

	USHORT	 spd4As0Bytes;	 /* CO side, GTI_64_PER_SYMBOL etc.			 */
	USHORT	 spd4As0Latency; /* CO side, GTI_INTERLEAVED_LATENCY etc.	 */
	USHORT	 spd4As1Bytes;
	USHORT	 spd4As1Latency;
	USHORT	 spd4Ls0Bytes;
	USHORT	 spd4Ls0Latency;
	USHORT	 spd4Ls1Bytes;
	USHORT	 spd4Ls1Latency;

	USHORT   rsFastOhDown;
	USHORT   rsDelayDown;
	USHORT   rsCorrectionDown;
	USHORT   rsFastOhUp;
	USHORT   rsDelayUp;
	USHORT   rsCorrectionUp;
	USHORT	 clockType;		 /* GTI_CLOCK_CRYSTAL etc.					 */
	USHORT   maxBitsPerBin;
	USHORT   txStartBin;
	USHORT   txEndBin;
	USHORT   txBinAdjust;
	USHORT   rxStartBin;
	USHORT   rxEndBin;
	USHORT   rxBinAdjust;
	USHORT   txPowerAttenuation;
	USHORT   vendorId;
	USHORT   vendorRev;
	USHORT	 utopiaL2TxAddr;
	USHORT	 utopiaL2RxAddr;
	USHORT	 ntr;
	USHORT	 atuRPilotForData;
	USHORT	 codingGain;
	USHORT	 framingStruct;
	USHORT	 toneOrdering;
	USHORT	 toneRequest;
	USHORT	 expandedExchange;

}  GSIDRIVER_SETTINGS_CO, *PGSIDRIVER_SETTINGS_CO;

typedef struct  _GSIDRIVER_SETTINGS
{
	USHORT	 standard;
	USHORT	 trellis;
	USHORT   txPowerAttenuation;
	USHORT	 codingGain;
	USHORT   maxBitsPerBin;
	USHORT   txStartBin;
	USHORT   txEndBin;
	USHORT   txBinAdjust;
	USHORT   rxStartBin;
	USHORT   rxEndBin;
	USHORT   rxBinAdjust;
	USHORT	 framingStruct;
	USHORT	 expandedExchange;
	USHORT	 clockType;
#ifdef ANNEXC
    USHORT	 annexCMode;
#endif // ANNEXC
}  GSIDRIVER_SETTINGS, *PGSIDRIVER_SETTINGS;

typedef struct _GSICPL_STRUCT
{
   USHORT	lineCodeType;		 /* ADAPTER_TYPE_CAP or ADAPTER_TYPE_DMT	  */
   UCHAR	xcvrType;
   UCHAR	driverType;
   USHORT	standard;			 /* read from driver settings				  */
   UCHAR    opState;
   USHORT   lastFail;

   ULONG    numXmitPackets;
   ULONG    numRcvdPackets;
   UCHAR	driverVersion[33];
   UCHAR    firmware[5];
   UCHAR	dspVersion;
   USHORT	rmtVendorIdStatus;
   USHORT	rmtVendorRevStatus;

   USHORT	startProgress;
   USHORT   actualConfig[22];
   SHORT	attenuation;
   //USHORT	lclAttenuation;
   char	lclSnrMargin;
   USHORT	counters[22];		 /* Auto-clearing counters:(L & R)fec-F,fec-I */
   USHORT	failures[14];
   //USHORT	cellDropCounter;

   UCHAR StatusEx;
   USHORT	snrMarginPerBin[256];
   UCHAR	bitLoadCoDwnCpUp[256];
   UCHAR	bitLoadCoUpCpDwn[32];

   UCHAR	txBytes;
   UCHAR	rxBytes;

   UCHAR    bertMode;            /* BERT mode */
   USHORT   bertErrors;			 /* BERT errors */

   USHORT	xcvrOpState;
   ULONG	nPktSent;
   ULONG	nPktRcvd;
   ULONG	nBadPdu;
   ULONG	numErrBytes;

   ATM_STATISTICS   atmStats;
   UCHAR whichAnnexC; //1- AnnexC ,2 - not AnnexC
   UCHAR annexCMode;           //fbm == 0 , DBM == 1
} GSICPL_STRUCT,*PGSICPL_STRUCT;

#ifdef _NTDDK_
typedef struct  _GSICPL_GLOBALS
{
    ULONG GspnSignature;

	PDRIVER_OBJECT		DriverObject;
	PDEVICE_OBJECT		DeviceObject;
	NDIS_STRING			symbolicNameUniString;
	NDIS_STRING			deviceNameUniString;
} GSICPL_GLOBALS, *PGSICPL_GLOBALS;
#endif // _NTDDK_

#ifdef ICONDATA
// data structure used b/w gsiIcon and driver
typedef struct _GSICON_STRUCT
{
	USHORT	 opState;
	UCHAR	 driverVersion[33];
	UCHAR    firmware[5];
    ULONG    numXmitPackets;
	ULONG    numRcvdPackets;

} GSICON_STRUCT, *PGSICON_STRUCT;
#endif //ICONDATA


//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//
#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)

//
// Define the method codes for how buffers are passed for I/O and FS controls
//
#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

//
// Define the access check value for any access
//
//
// The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
// ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
// constants *MUST* always be in sync.
//
#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS          ( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS         ( 0x0002 )    // file & pipe

typedef struct _DEVSPECIFICGSTRUCT
{
   UINT		            command;
   UINT		            inBufLength;
   UINT		            outBufLength;
   PVOID                pInBuffer;
   PVOID                pOutBuffer;
   GSICPL_STRUCT	    cplParams;
   GSIDRIVER_SETTINGS   cplSettings;
   GSIDSL_CONFIGU		configU;
   GSIDSL_EEPROM		eeprom;
  // USHORT				snrMarginPerBin[256];
  // UCHAR				bitLoadCoDwnCpUp[256];
   //UCHAR				bitLoadCoUpCpDwn[32];
   //char					lclSnrMargin;

} DEVSPECIFICMSGSTRUCT,*LPDEVSPECIFICMSGSTRUCT;

//////////////////////////////////////////////////////////////////////
/************************************************************************
*                             CONSTANTS
*************************************************************************
*/
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
#define FILE_DEVICE_PDSLPTR  0x0000CBFD

// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
#define PDSLPTR_IOCTL_BASE  0x800

/************************************************************************
*                          DATA DECLARATIONS
*************************************************************************
*/

/************************************************************************
*                              MACROS
*************************************************************************
*/

// Define the Padslester IOCTLs.  There are two forms for these defines:
// the NT ioctl name and the Padslester ioctl name.  The Padslester ioctl
// names come from pvioctl.h
#define IOCTL_PDSLPTR_NNN(offset, method, access) \
    (ULONG) CTL_CODE(FILE_DEVICE_PDSLPTR, PDSLPTR_IOCTL_BASE + (offset), \
           (method), (access))

#define IOCTL_PDSLPTR_LOAD_DATA \
               IOCTL_PDSLPTR_NNN(0, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
//#define IOCTL_PDSLPTR_LOAD_DATA	50000
#define IOCTL_PDSLPTR_SET_DATA \
               IOCTL_PDSLPTR_NNN(1, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_RETRAIN \
               IOCTL_PDSLPTR_NNN(2, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_DISCONNECT \
               IOCTL_PDSLPTR_NNN(3, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_BERT_START \
               IOCTL_PDSLPTR_NNN(4, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_BERT_STOP \
               IOCTL_PDSLPTR_NNN(5, METHOD_BUFFERED, FILE_ANY_ACCESS)


#define IOCTL_PDSLPTR_SPEC_REVERB_START \
 IOCTL_PDSLPTR_NNN(6, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_SPEC_MEDLEY_START \
 IOCTL_PDSLPTR_NNN(28, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_SPEC_PILOT_START \
 IOCTL_PDSLPTR_NNN(29, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_SPEC_R_START \
 IOCTL_PDSLPTR_NNN(30, METHOD_BUFFERED, FILE_ANY_ACCESS)


#define IOCTL_GSIDSL_WHIP_MSG \
               IOCTL_PDSLPTR_NNN(7, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_ADAPTER_CONFIG \
               IOCTL_PDSLPTR_NNN(8, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_DGLB_START \
               IOCTL_PDSLPTR_NNN(17, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_DGLB_DATA \
               IOCTL_PDSLPTR_NNN(18, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_SET_CONFIGU \
               IOCTL_PDSLPTR_NNN(19, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_GET_CONFIGU \
               IOCTL_PDSLPTR_NNN(20, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#ifdef EEPROM
#define IOCTL_GSIDSL_READ_EEPROM \
               IOCTL_PDSLPTR_NNN(21, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_WRITE_EEPROM \
               IOCTL_PDSLPTR_NNN(22, METHOD_BUFFERED, FILE_ANY_ACCESS)
#endif

#define IOCTL_SNR_MARGIN_PER_BIN \
			   IOCTL_PDSLPTR_NNN(23, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_LCL_SNR_MARGIN \
				IOCTL_PDSLPTR_NNN(24, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_DOWN_BIT_LOADING_PER_BIN \
				IOCTL_PDSLPTR_NNN(25, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_UP_BIT_LOADING_PER_BIN \
				IOCTL_PDSLPTR_NNN(26, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_LOAD_ICONDATA \
				IOCTL_PDSLPTR_NNN(33, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_CLEARATMCNT \
                IOCTL_PDSLPTR_NNN(34, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_GETATMSTATISTICS \
				IOCTL_PDSLPTR_NNN(35, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_F4F5_LOOPBACK \
                IOCTL_PDSLPTR_NNN(36, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_GSIDSL_F4F5_LOOPBACK2 \
                IOCTL_PDSLPTR_NNN(37, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_SPAWN_DRIVER_THREADS \
                IOCTL_PDSLPTR_NNN(40, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PDSLPTR_IF_QUASAR \
	IOCTL_PDSLPTR_NNN(46, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#ifdef ANNEXC
#define IOCTL_SNR_MARGIN_PER_BIN_NEXT \
	IOCTL_PDSLPTR_NNN(38, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_DOWN_BIT_LOADING_PER_BIN_NEXT \
	IOCTL_PDSLPTR_NNN(39, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_UP_BIT_LOADING_PER_BIN_NEXT \
	IOCTL_PDSLPTR_NNN(44, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
#endif //ANNEXC

#define IOCTL_RFC1577_GET_ARP        0x0801
#define IOCTL_RFC1577_DELETE_ARP     0x0802

#define CONTROL_CODE_GET_EOC        0x0901
#define CONTROL_CODE_SEND_DG        0x0902

/************************************************************************
                        FUNCTION DECLARATIONS
**************************************************************************/

void CardLoadData(PUSB_PHY UsbPhy, IN PVOID outBuff);
void GsiSetAdapterData(PUSB_PHY Adapter, PGSIDRIVER_SETTINGS inBuf);
void GsiGetAdapterData(PUSB_PHY Adapter, PGSIDRIVER_SETTINGS outBuf);
void GsiSetConfigUData(PUSB_PHY Adapter, PGSIDSL_CONFIGU inBuf);
void GsiGetConfigUData(PATM_USB_INSTANCE Instance, PGSIDSL_CONFIGU outBuf);
void GetIconData(PUSB_PHY UsbPhy, PVOID outBuff);

#ifdef EEPROM
#include "gti.h"
#if EEPROMv2
//void writeEEPROM(GTI_USB_TRANSFER_BLOCK txfrblock, UCHAR *writeBuffer, USHORT noBytes, USHORT startAddr);
//void readEEPROM(GTI_USB_TRANSFER_BLOCK txfrblock, USHORT noBytes, USHORT startAddr);
#endif//EEPROMv2
#endif

#ifdef LAN_MINIPORT
void GetRfc1577Entries(PVOID UsbPhy ,PQUERY_ARP_BUFFER pArpBuffer );
void DeleteRfc1577Entry(PVOID UsbPhy ,Rfc1577Status_t  *pArpBuffer );
#endif

//////////////////////////////////////////////////////////////////////

#ifdef _NTDDK_
NTSTATUS GsiSendIrpSynchronously
(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
);

NTSTATUS GsiDispatchPnpComplete
(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
);

PVOID GsiMmMapLockedPages
(
    IN PMDL irpMdl
);
#endif // _NTDDK_
void GetGTIStatus( PUSB_PHY UsbPhy, UINT status );

#endif                                                /* GSICPL_H */





