/************************************************************************
 * FILE NAME   : usbcpl.c                                               *
 * DESCRIPTION :                                                        *
 *                                                                      *
 * COMMENT     : This file was renamed from gsicpl.c                    *
 *                                                                      *
 * (C) Copyright 1998-2002 by GlobespanVirata Inc                       *
 ************************************************************************/


#ifdef _NTDDK_
#include "ndis.h"
#include "usb100.h"
#include "usbdi.h"
#include "usbdlib.h"
#endif // _NTDDK_
#include "common.h"
#include "debug.h"
#include "atmphy.h"
#include "usbphy.h"
#include "atmuni.h"
#include "usbcpl.h"
#include "atmusb.h"
#include "version.h"
#include "dsl.h"
#ifdef _NTDDK_
#include "gatmioctl.h"
#endif // _NTDDK_
#if defined(LAN_MINIPORT) || defined(GSI_LAN)
#include "api1577.h"
#include "rfc1577.h"
#endif

#if defined(linux)
#include <Gp.h>
#include <gsi_ioctl.h>
#include <asm/uaccess.h>

#define DBG_PPP_IOCTL

inline int my_verify_area(int type, const void * addr, unsigned long size)
{
	return access_ok(type,addr,size) ? 0 : -EFAULT;
}

#ifdef DBG_PPP_IOCTL
#include <linux/if.h>
#include <linux/ppp_defs.h>
#include <linux/socket.h>
#include <linux/if_ppp.h>
#endif // DBG_PPP_IOCTL

#endif // linux

#ifdef EEPROM
#define    EEPROM_SIZE         sizeof(GSIDSL_EEPROM)
#endif /* EEPROM */


#if defined (LAN_MINIPORT) || defined(GSI_LAN)
#define PRODUCT_STRING          "LanUsb"
#elif defined (WAN_MINIPORT) || defined(GSI_WAN)
#define PRODUCT_STRING          "WanUsb"
#elif defined (ATM_MINIPORT)
#define PRODUCT_STRING          "AtmUsb"
#endif

#define VER_DRIVERVERSION_STR   PRODUCT_STRING

extern PATM_USB_INSTANCE gInstance;
extern void UsbPhyCplReq(PUSB_PHY UsbPhy, UCHAR request);
#ifdef WINHIP
extern VOID CancelWhipMessageIrp( IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp );
extern VOID CancelAllPendingWhipMessageIrp( PUSB_PHY pUsbPhy );
#endif

#ifdef NEW_CPL_INTERFACE
void IoctlQueryCmd(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr);
void IoctlSetCmd(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr);
void USBCPLQueryDSPStatus(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr);
void USBCPLQueryDSPParam(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr);
void USBCPLQueryDrvStatus(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr);
#endif //NEW_CPL_INTERFACE

#ifdef _NTDDK_
extern PDRIVER_DISPATCH gNdisMajorFunction[IRP_MJ_MAXIMUM_FUNCTION + 1];

void WriteConfigReg(PUSB_PHY UsbPhy);

extern void atmGetInfoStatus(
    PVOID           AtmUni,
    ULONG           *txPacket,
    ULONG           *rxPacket);

NTSTATUS GsiDispatch
(
	PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp
);
#endif // _NTDDK_

#if defined(LAN_MINIPORT) || defined(GSI_LAN)
#include "rfc1483.h"
#define	LAN_TYPE			2
#endif //LAN_MINIPORT

extern GTI_WORD Gti_SStatusXCVR_USB(GTI_XCVR_INFO *pSys,
            GTI_WORD nStatusType,
            void *pStatus,
            GTI_WORD nLength,
            GTI_BYTE nChanID );

#ifdef _NTDDK_

#ifdef GSIREG
typedef struct _XCVR_REGTAB_ENTRY {
   NDIS_STRING RegVarName;             // variable name text
   UINT        FieldOffset;            // offset to instance field loaded
   UINT        FieldSize;              // size (in bytes) of the field
   UINT        Default;                // default value to use
} XCVR_REGTAB_ENTRY, *PXCVR_REGTAB_ENTRY;

//------------------------------------------------------------------------------
//
// MK_REGTAB_ENTRY
//    declares a structure of type REGTAB_ENTRY
//
//    reg_name  : name of the variable in the registry
//    var_name  : variable in instance structure to receive registry entry
//    min       : minimum permissible value, test will be (min <= var)
//    max       : maximum permissible value, test will be (var <= max)
//    def       : a default value if the value is not present
//
//------------------------------------------------------------------------------
#define MK_XCVR_REGENTRY(reg_name, var_name, def)              \
{                                                                  \
    NDIS_STRING_CONST (reg_name),                                  \
    FIELD_OFFSET( USB_PHY, var_name),                              \
    FIELD_SIZE( USB_PHY, var_name),                                \
    def                                                            \
}
//------------------------------------------------------------------------------
// Global Registry Parameters Table
//
//      This table contains a list of all of the configuration parameters
//      that the driver supports.  The driver will attempt to find these
//      parameters in the registry and use the registry value for these
//      parameters.  If the parameter is not found in the registry, then the
//      default value is used.
//------------------------------------------------------------------------------
#pragma warning(disable:4057)       // NDIS_STRING_CONST generates tons with /W4
XCVR_REGTAB_ENTRY XcvrRegTable [ ] = {

MK_XCVR_REGENTRY("OsType",         OsType,                                     OS_WIN_2K),
MK_XCVR_REGENTRY("IsoMaxBWLimit",  IsoMaxBWLimit,                              USB_ISO_RATE_DEFAULT),
MK_XCVR_REGENTRY("MaxDownRateEn",  maxDownRateEnable,                          0),
MK_XCVR_REGENTRY("MaxDownRate",    maxDownRate,                                0x1FFF),
MK_XCVR_REGENTRY("oldAutoMode",    autoMode,                                   AUTOMODE_DISABLE),
MK_XCVR_REGENTRY("SelectStandard", SelectStandard,                             SELECT_STANDARD_DISABLE),
MK_XCVR_REGENTRY("RetrainEnable",  RetrainEnable,                              RETRAIN_ENABLE),
MK_XCVR_REGENTRY("MaxCrcErrorsPerSecThreshold", MaxCrcErrorsPerSecThreshold,   DEFAULT_MAX_CRC_ERRORS_PER_SEC_THRESHOLD),
MK_XCVR_REGENTRY("DownstreamRateToMaxCrcErrorsPerMinDivider",DownstreamRateToMaxCrcErrorsPerMinDivider,DEFAULT_DOWNSTREAM_RATE_TO_MAX_CRC_ERRORS_PER_MIN_DIVIDER),
MK_XCVR_REGENTRY("Win2kSurpriseRemoval", Win2kSurpriseRemoval,                 WIN2K_SURPRISE_REMOVAL_NOT_OK),
MK_XCVR_REGENTRY("EocVendorIdHigh", EocVendorIdHigh,                           DEFAULT_EOC_VENDOR_ID_HIGH),
MK_XCVR_REGENTRY("EocVendorIdLow", EocVendorIdLow,                             DEFAULT_EOC_VENDOR_ID_LOW),
MK_XCVR_REGENTRY("DataDelay", DataDelay,                                       0),
MK_XCVR_REGENTRY("LowSuspendCurrent", LowSuspendCurrent ,                      0),


#ifdef GTI_DMT
#ifdef ANNEXA
MK_XCVR_REGENTRY("Action",         xcvr[0].item[GTI_ACTION_ITEM],              GTI_STARTUP_REQ),
MK_XCVR_REGENTRY("Mode",           xcvr[0].item[GTI_MODE_ITEM],                GTI_ATU_R),
MK_XCVR_REGENTRY("Initiate",       xcvr[0].item[GTI_INITIATE_ITEM],            GTI_DEFAULT_INITIATE),
MK_XCVR_REGENTRY("DataInterface",  xcvr[0].item[GTI_DATA_INTERFACE_TYPE_ITEM], GTI_UTOPIA_L1_FRAMING),
MK_XCVR_REGENTRY("Trellis",        xcvr[0].item[GTI_TRELLIS_ITEM],             GTI_TRELLIS_ENABLE),
MK_XCVR_REGENTRY("EcFdm",          xcvr[0].item[GTI_EC_FDM_ITEM],              GTI_FDM_MODE),
MK_XCVR_REGENTRY("Standard",       xcvr[0].item[GTI_STANDARD_ITEM],            GTI_MULTIMODE_STANDARD),
MK_XCVR_REGENTRY("MaxBitsPerBin",  xcvr[0].item[GTI_MAX_BITS_PER_BIN_ITEM],    0xE), /* 14 */
MK_XCVR_REGENTRY("TxStartBin",     xcvr[0].item[GTI_TX_START_BIN_ITEM],        0x06),
MK_XCVR_REGENTRY("TxEndBin",       xcvr[0].item[GTI_TX_END_BIN_ITEM],          0x1F),
MK_XCVR_REGENTRY("LineDrvStby",    xcvr[0].item[GTI_LINE_DR_STBY_ITEM],        GTI_LINE_DR_STDBY_DISABLE),
MK_XCVR_REGENTRY("RxStartBin",     xcvr[0].item[GTI_RX_START_BIN_ITEM],        0x20),
MK_XCVR_REGENTRY("RxEndBin",       xcvr[0].item[GTI_RX_END_BIN_ITEM],          0xFF),
MK_XCVR_REGENTRY("RxBinAdjust",    xcvr[0].item[GTI_RX_BIN_ADJUST_ITEM],       GTI_RX_BIN_DISABLE),
MK_XCVR_REGENTRY("TxPowerAttnu",   xcvr[0].item[GTI_TX_POWER_ATTENUATION_ITEM],GTI_0DB_TX_PWR),
MK_XCVR_REGENTRY("Ntr",            xcvr[0].item[GTI_NTR_ITEM],                 GTI_NTR_DISABLE),
MK_XCVR_REGENTRY("Pmode",          xcvr[0].item[GTI_PMODE_ITEM],               GTI_DISABLE_PMODE),
MK_XCVR_REGENTRY("CodingGain",     xcvr[0].item[GTI_CODING_GAIN_ITEM],         GTI_AUTO_CODING_GAIN),
MK_XCVR_REGENTRY("ToneOrdering",   xcvr[0].item[GTI_TONE_ORDERING_ITEM],       GTI_ENABLE_TONE_ORDERING),
MK_XCVR_REGENTRY("FramingStruct",  xcvr[0].item[GTI_FRAMING_STRUCTURE_ITEM],   GTI_FRAMING_TYPE_3),
MK_XCVR_REGENTRY("UtopiaL2TxAddr", xcvr[0].item[GTI_UTOPIA_L2_TX_ADDR_ITEM],   0x0),
MK_XCVR_REGENTRY("UtopiaL2RxAddr", xcvr[0].item[GTI_UTOPIA_L2_RX_ADDR_ITEM],   0x0),
MK_XCVR_REGENTRY("ClockType",      xcvr[0].item[GTI_CLOCK_TYPE_ITEM],          GTI_CLOCK_CRYSTAL),
MK_XCVR_REGENTRY("VendorId",       VendorId,                                   GTI_ID_GLOBESPAN),
MK_XCVR_REGENTRY("VendorRev",      xcvr[0].item[GTI_VENDOR_REV_SHORT_ITEM],    0x0),
MK_XCVR_REGENTRY("ExpandedExchange",xcvr[0].item[GTI_EXPANDED_EXCHANGE_ITEM],  GTI_EXPANDED_EXCHANGE),
MK_XCVR_REGENTRY("EscFastRetrain", xcvr[0].item[GTI_ESCAPE_FAST_RETRAIN_ITEM], GTI_ESCAPE_DISABLE),
MK_XCVR_REGENTRY("FastRetrainEn",  xcvr[0].item[GTI_FAST_RETRAIN_ENABLE_ITEM], GTI_DISABLE_FAST_RETRAIN),
MK_XCVR_REGENTRY("BitSwap",        xcvr[0].item[GTI_BIT_SWAP_ITEM],            GTI_BIT_SWAP_ENABLE),
MK_XCVR_REGENTRY("USBitSwap",      xcvr[0].item[GTI_US_BIT_SWAP_ITEM],         GTI_US_BIT_SWAP_DISABLE),
MK_XCVR_REGENTRY("EraseProfile",   xcvr[0].item[GTI_ERASE_PROFILES_ITEM],      GTI_NO_ERASE_PROFILES),
MK_XCVR_REGENTRY("LocalTrigger",   xcvr[0].item[GTI_TRIGGER_MODE_ITEM],        GTI_DISABLE_TGR),
MK_XCVR_REGENTRY("AnnexType",      xcvr[0].item[GTI_ANNEX_TYPE_ITEM],          GTI_ANNEX_A_ENABLE),
MK_XCVR_REGENTRY("AnnexCMode",     xcvr[0].item[GTI_ANNEX_C_MODE_ITEM],        GTI_ANNEX_C_FBM),
MK_XCVR_REGENTRY("AnnexCPilotTone",xcvr[0].item[GTI_ANNEX_C_PILOT_TONE_ITEM],  GTI_PILOT_NEXT_ENABLE),
MK_XCVR_REGENTRY("TxBinAdjust",    xcvr[0].item[GTI_TX_BIN_ADJUST_ITEM],       GTI_TX_BIN_ENABLE),
MK_XCVR_REGENTRY("PilotToneReq",   xcvr[0].item[GTI_PILOT_TONE_REQUEST_ITEM],  GTI_ENABLE_PILOT_TONE),
MK_XCVR_REGENTRY("DualLatency",    xcvr[0].item[GTI_DUAL_LATENCY_ITEM],        GTI_DISABLE_DUAL_LATENCY),
#ifndef MONACO
MK_XCVR_REGENTRY("HWRev",          xcvr[0].item[GTI_HW_REV_ITEM],              GTI_HW_REV_ZERO),
MK_XCVR_REGENTRY("CutBack",        xcvr[0].item[GTI_CUTBACK_ITEM],             GTI_CUTBACK_ENABLE),
#else
MK_XCVR_REGENTRY("HWRev",          xcvr[0].item[GTI_HW_REV_ITEM],              GTI_HW_REV_ONE),
MK_XCVR_REGENTRY("CutBack",        xcvr[0].item[GTI_CUTBACK_ITEM],             GTI_CUTBACK_DISABLE ),
#endif
MK_XCVR_REGENTRY("AnnexChOffsetTtr",xcvr[0].item[GTI_ANNEX_CH_OFFSET_TTR_R_ITEM],GTI_TTR_R_OFFSET_0),

#ifdef QUASAR
MK_XCVR_REGENTRY("MaxD",           xcvr[0].item[GTI_MAX_D_CP_ITEM],            GTI_MAX_D_CP_64),
#else
MK_XCVR_REGENTRY("MaxD",           xcvr[0].item[GTI_MAX_D_CP_ITEM],            GTI_MAX_D_CP_256)
#endif // QUASAR

#endif // ANNEXA
#ifdef ANNEXB
MK_XCVR_REGENTRY("Action",         xcvr[0].item[GTI_ACTION_ITEM],              GTI_STARTUP_REQ),
MK_XCVR_REGENTRY("Mode",           xcvr[0].item[GTI_MODE_ITEM],                GTI_ATU_R),
MK_XCVR_REGENTRY("Initiate",       xcvr[0].item[GTI_INITIATE_ITEM],            GTI_DEFAULT_INITIATE),
MK_XCVR_REGENTRY("DataInterface",  xcvr[0].item[GTI_DATA_INTERFACE_TYPE_ITEM], GTI_UTOPIA_L1_FRAMING),
MK_XCVR_REGENTRY("Trellis",        xcvr[0].item[GTI_TRELLIS_ITEM],             GTI_TRELLIS_ENABLE),
MK_XCVR_REGENTRY("EcFdm",          xcvr[0].item[GTI_EC_FDM_ITEM],              GTI_FDM_MODE),
MK_XCVR_REGENTRY("Standard",       xcvr[0].item[GTI_STANDARD_ITEM],            GTI_G_DMT_STANDARD),
MK_XCVR_REGENTRY("MaxBitsPerBin",  xcvr[0].item[GTI_MAX_BITS_PER_BIN_ITEM],    0xE), /* 14 */
MK_XCVR_REGENTRY("TxStartBin",     xcvr[0].item[GTI_TX_START_BIN_ITEM],        0x20),
MK_XCVR_REGENTRY("TxEndBin",       xcvr[0].item[GTI_TX_END_BIN_ITEM],          0x3f),
MK_XCVR_REGENTRY("LineDrvStby",    xcvr[0].item[GTI_LINE_DR_STBY_ITEM],        GTI_LINE_DR_STDBY_DISABLE),
MK_XCVR_REGENTRY("RxStartBin",     xcvr[0].item[GTI_RX_START_BIN_ITEM],        0x40),
MK_XCVR_REGENTRY("RxEndBin",       xcvr[0].item[GTI_RX_END_BIN_ITEM],          0xFF),
MK_XCVR_REGENTRY("RxBinAdjust",    xcvr[0].item[GTI_RX_BIN_ADJUST_ITEM],       GTI_RX_BIN_DISABLE),
MK_XCVR_REGENTRY("TxPowerAttnu",   xcvr[0].item[GTI_TX_POWER_ATTENUATION_ITEM],GTI_0DB_TX_PWR),
MK_XCVR_REGENTRY("Ntr",            xcvr[0].item[GTI_NTR_ITEM],                 GTI_NTR_DISABLE),
MK_XCVR_REGENTRY("Pmode",          xcvr[0].item[GTI_PMODE_ITEM],               GTI_ENABLE_PMODE),
MK_XCVR_REGENTRY("CodingGain",     xcvr[0].item[GTI_CODING_GAIN_ITEM],         GTI_AUTO_CODING_GAIN),
MK_XCVR_REGENTRY("ToneOrdering",   xcvr[0].item[GTI_TONE_ORDERING_ITEM],       GTI_ENABLE_TONE_ORDERING),
MK_XCVR_REGENTRY("FramingStruct",  xcvr[0].item[GTI_FRAMING_STRUCTURE_ITEM],   GTI_FRAMING_TYPE_3),
MK_XCVR_REGENTRY("UtopiaL2TxAddr", xcvr[0].item[GTI_UTOPIA_L2_TX_ADDR_ITEM],   0x0),
MK_XCVR_REGENTRY("UtopiaL2RxAddr", xcvr[0].item[GTI_UTOPIA_L2_RX_ADDR_ITEM],   0x0),
MK_XCVR_REGENTRY("ClockType",      xcvr[0].item[GTI_CLOCK_TYPE_ITEM],          GTI_CLOCK_CRYSTAL),
MK_XCVR_REGENTRY("VendorId",       VendorId,                                   GTI_ID_GLOBESPAN),
MK_XCVR_REGENTRY("VendorRev",      xcvr[0].item[GTI_VENDOR_REV_SHORT_ITEM],    0x0),
MK_XCVR_REGENTRY("ExpandedExchange",xcvr[0].item[GTI_EXPANDED_EXCHANGE_ITEM],  GTI_EXPANDED_EXCHANGE),
MK_XCVR_REGENTRY("EscFastRetrain", xcvr[0].item[GTI_ESCAPE_FAST_RETRAIN_ITEM], GTI_ESCAPE_DISABLE),
MK_XCVR_REGENTRY("FastRetrainEn",  xcvr[0].item[GTI_FAST_RETRAIN_ENABLE_ITEM], GTI_DISABLE_FAST_RETRAIN),
MK_XCVR_REGENTRY("BitSwap",        xcvr[0].item[GTI_BIT_SWAP_ITEM],            GTI_BIT_SWAP_ENABLE),
MK_XCVR_REGENTRY("USBitSwap",      xcvr[0].item[GTI_US_BIT_SWAP_ITEM],         GTI_US_BIT_SWAP_DISABLE),
MK_XCVR_REGENTRY("EraseProfile",   xcvr[0].item[GTI_ERASE_PROFILES_ITEM],      GTI_NO_ERASE_PROFILES),
MK_XCVR_REGENTRY("LocalTrigger",   xcvr[0].item[GTI_TRIGGER_MODE_ITEM],       GTI_DISABLE_TGR),
MK_XCVR_REGENTRY("AnnexType",   xcvr[0].item[GTI_ANNEX_TYPE_ITEM],             GTI_TYPE_ANNEX_B),
MK_XCVR_REGENTRY("AnnexCMode",     xcvr[0].item[GTI_ANNEX_C_MODE_ITEM],        GTI_ANNEX_C_FBM),
MK_XCVR_REGENTRY("AnnexCPilotTone",xcvr[0].item[GTI_ANNEX_C_PILOT_TONE_ITEM],  GTI_PILOT_NEXT_ENABLE),
MK_XCVR_REGENTRY("TxBinAdjust",    xcvr[0].item[GTI_TX_BIN_ADJUST_ITEM],       GTI_TX_BIN_ENABLE),
MK_XCVR_REGENTRY("PilotToneReq",   xcvr[0].item[GTI_PILOT_TONE_REQUEST_ITEM],  GTI_ENABLE_PILOT_TONE),
MK_XCVR_REGENTRY("DualLatency",    xcvr[0].item[GTI_DUAL_LATENCY_ITEM],        GTI_DISABLE_DUAL_LATENCY),
MK_XCVR_REGENTRY("HWRev",          xcvr[0].item[GTI_HW_REV_ITEM],              GTI_HW_REV_ZERO),
MK_XCVR_REGENTRY("CutBack",        xcvr[0].item[GTI_CUTBACK_ITEM],             GTI_CUTBACK_DISABLE),
MK_XCVR_REGENTRY("AnnexChOffset",  xcvr[0].item[GTI_ANNEX_CH_OFFSET_TTR_R_ITEM],GTI_TTR_R_OFFSET_0),
#ifdef QUASAR
MK_XCVR_REGENTRY("MaxD",           xcvr[0].item[GTI_MAX_D_CP_ITEM],            GTI_MAX_D_CP_64),
#else
MK_XCVR_REGENTRY("MaxD",           xcvr[0].item[GTI_MAX_D_CP_ITEM],            GTI_MAX_D_CP_256)
#endif // QUASAR
#endif // ANNEXB
#ifdef ANNEXC
MK_XCVR_REGENTRY("Action",         xcvr[0].item[GTI_ACTION_ITEM],              GTI_STARTUP_REQ),
MK_XCVR_REGENTRY("Mode",           xcvr[0].item[GTI_MODE_ITEM],                GTI_ATU_R),
MK_XCVR_REGENTRY("Initiate",       xcvr[0].item[GTI_INITIATE_ITEM],            GTI_DEFAULT_INITIATE),
MK_XCVR_REGENTRY("DataInterface",  xcvr[0].item[GTI_DATA_INTERFACE_TYPE_ITEM], GTI_UTOPIA_L1_FRAMING),
//MK_XCVR_REGENTRY("Trellis",        xcvr[0].item[GTI_TRELLIS_ITEM],             GTI_TRELLIS_ENABLE),
MK_XCVR_REGENTRY("EcFdm",          xcvr[0].item[GTI_EC_FDM_ITEM],              GTI_EC_MODE),
MK_XCVR_REGENTRY("Standard",       xcvr[0].item[GTI_STANDARD_ITEM],            GTI_G_DMT_STANDARD),
MK_XCVR_REGENTRY("MaxBitsPerBin",  xcvr[0].item[GTI_MAX_BITS_PER_BIN_ITEM],    0xE), /* 14 */
MK_XCVR_REGENTRY("TxStartBin",     xcvr[0].item[GTI_TX_START_BIN_ITEM],        0x06),
MK_XCVR_REGENTRY("TxEndBin",       xcvr[0].item[GTI_TX_END_BIN_ITEM],          0x1F),
MK_XCVR_REGENTRY("LineDrvStby",    xcvr[0].item[GTI_LINE_DR_STBY_ITEM],        GTI_LINE_DR_STDBY_DISABLE),
MK_XCVR_REGENTRY("RxStartBin",     xcvr[0].item[GTI_RX_START_BIN_ITEM],        0x20),
MK_XCVR_REGENTRY("RxEndBin",       xcvr[0].item[GTI_RX_END_BIN_ITEM],          0xFF),
MK_XCVR_REGENTRY("RxBinAdjust",    xcvr[0].item[GTI_RX_BIN_ADJUST_ITEM],       GTI_RX_BIN_DISABLE),
MK_XCVR_REGENTRY("TxPowerAttnu",   xcvr[0].item[GTI_TX_POWER_ATTENUATION_ITEM],GTI_0DB_TX_PWR),
MK_XCVR_REGENTRY("Ntr",            xcvr[0].item[GTI_NTR_ITEM],                 GTI_NTR_DISABLE),
MK_XCVR_REGENTRY("Pmode",          xcvr[0].item[GTI_PMODE_ITEM],               GTI_ENABLE_PMODE),
MK_XCVR_REGENTRY("CodingGain",     xcvr[0].item[GTI_CODING_GAIN_ITEM],         GTI_AUTO_CODING_GAIN),
MK_XCVR_REGENTRY("ToneOrdering",   xcvr[0].item[GTI_TONE_ORDERING_ITEM],       GTI_ENABLE_TONE_ORDERING),
MK_XCVR_REGENTRY("FramingStruct",  xcvr[0].item[GTI_FRAMING_STRUCTURE_ITEM],   GTI_FRAMING_TYPE_3),
MK_XCVR_REGENTRY("UtopiaL2TxAddr", xcvr[0].item[GTI_UTOPIA_L2_TX_ADDR_ITEM],   0x0),
MK_XCVR_REGENTRY("UtopiaL2RxAddr", xcvr[0].item[GTI_UTOPIA_L2_RX_ADDR_ITEM],   0x0),
MK_XCVR_REGENTRY("ClockType",      xcvr[0].item[GTI_CLOCK_TYPE_ITEM],          GTI_CLOCK_CRYSTAL),
//MK_XCVR_REGENTRY("VendorId",       VendorId,                                   GTI_ID_GLOBESPAN),
//MK_XCVR_REGENTRY("VendorRev",      xcvr[0].item[GTI_VENDOR_REV_SHORT_ITEM],    0x0),
MK_XCVR_REGENTRY("ExpandedExchange",xcvr[0].item[GTI_EXPANDED_EXCHANGE_ITEM],  GTI_EXPANDED_EXCHANGE),
MK_XCVR_REGENTRY("EscFastRetrain", xcvr[0].item[GTI_ESCAPE_FAST_RETRAIN_ITEM], GTI_ESCAPE_DISABLE),
MK_XCVR_REGENTRY("FastRetrainEn",  xcvr[0].item[GTI_FAST_RETRAIN_ENABLE_ITEM], GTI_DISABLE_FAST_RETRAIN),
MK_XCVR_REGENTRY("BitSwap",        xcvr[0].item[GTI_BIT_SWAP_ITEM],            GTI_BIT_SWAP_ENABLE),
MK_XCVR_REGENTRY("USBitSwap",      xcvr[0].item[GTI_US_BIT_SWAP_ITEM],         GTI_US_BIT_SWAP_DISABLE),
MK_XCVR_REGENTRY("EraseProfile",   xcvr[0].item[GTI_ERASE_PROFILES_ITEM],      GTI_NO_ERASE_PROFILES),
MK_XCVR_REGENTRY("LocalTrigger",   xcvr[0].item[GTI_TRIGGER_MODE_ITEM],        GTI_DISABLE_TGR),
MK_XCVR_REGENTRY("AnnexType",      xcvr[0].item[GTI_ANNEX_TYPE_ITEM],          GTI_ANNEX_C_ENABLE),
MK_XCVR_REGENTRY("AnnexCMode",     xcvr[0].item[GTI_ANNEX_C_MODE_ITEM],        GTI_ANNEX_C_DBM),
MK_XCVR_REGENTRY("AnnexCPilotTone",xcvr[0].item[GTI_ANNEX_C_PILOT_TONE_ITEM],  GTI_PILOT_NEXT_DISABLE),
MK_XCVR_REGENTRY("TxBinAdjust",    xcvr[0].item[GTI_TX_BIN_ADJUST_ITEM],       GTI_TX_BIN_ENABLE),
MK_XCVR_REGENTRY("PilotToneReq",   xcvr[0].item[GTI_PILOT_TONE_REQUEST_ITEM],  GTI_ENABLE_PILOT_TONE),
MK_XCVR_REGENTRY("DualLatency",    xcvr[0].item[GTI_DUAL_LATENCY_ITEM],        GTI_DISABLE_DUAL_LATENCY),
MK_XCVR_REGENTRY("HWRev",          xcvr[0].item[GTI_HW_REV_ITEM],              GTI_HW_REV_ZERO),
MK_XCVR_REGENTRY("CutBack",        xcvr[0].item[GTI_CUTBACK_ITEM],             GTI_CUTBACK_ENABLE),
MK_XCVR_REGENTRY("AnnexChOffsetTtr",xcvr[0].item[GTI_ANNEX_CH_OFFSET_TTR_R_ITEM],GTI_TTR_R_OFFSET_42),
#ifdef QUASAR
MK_XCVR_REGENTRY("MaxD",           xcvr[0].item[GTI_MAX_D_CP_ITEM],            GTI_MAX_D_CP_64)
#else
MK_XCVR_REGENTRY("MaxD",           xcvr[0].item[GTI_MAX_D_CP_ITEM],            GTI_MAX_D_CP_256)
#endif // QUASAR

#endif // ANNEXC
#endif /* GTI_DMT */
};
#pragma warning(default:4057)

#define NUM_XCVR_REG_PARAM (sizeof (XcvrRegTable) / sizeof (XCVR_REGTAB_ENTRY))


NTSTATUS
ReadConfigurationFromReg(PUSB_PHY usbPhy)
{
	NDIS_HANDLE ConfigHandle;  // The handle for reading from the registry.
    PATM_USB_INSTANCE	Instance;
    PATM_UNI    AtmUni;
    PNDIS_CONFIGURATION_PARAMETER ReturnedValue; // The value read from the registry.
	NDIS_HANDLE	WrapperConfigurationContext;
	UCHAR i=0;
	NTSTATUS	Status;
    UINT        idx;
    UINT        Value;
    PUCHAR      fieldPtr;


    AtmUni = usbPhy->UserHandle;
    Instance = AtmUni->UserHandle;
    WrapperConfigurationContext = Instance->WrapperConfigurationContext;

   /* first initialize the length of the array */
#ifdef GTI_DMT
   usbPhy->xcvr[0].length = GTI_NUM_OF_ATU_R_CMD_PARAMETERS;
#endif /* GTI_DMT */
#ifdef GTI_CAP
   usbPhy->xcvr[0].length = GTI_NUM_OF_ATU_R_CMD_PARAMATERS;
#endif /* GTI_CAP */

	// Open the configuration registry so we can get our config values.
    NdisOpenConfiguration(&Status,
                           &ConfigHandle,
                           WrapperConfigurationContext);
    if (Status != NDIS_STATUS_SUCCESS)
    {
        DBGPRINT(DBG_PRINT_MODULE_GSICPL, DBG_PRINT_LEVEL_ERR,
                ("NdisOpenConfiguration failed (Status=%X)\n",Status));
		return NDIS_STATUS_FAILURE;
    }

	DBGPRINT(DBG_PRINT_MODULE_NDIS_ALL, DBG_PRINT_LEVEL_TRACE, ("ParseRegistryParametersForDSP\n"));

    // Grovel through the registry parameters and aquire all of the values
    // stored therein.
    for (idx = 0; idx < NUM_XCVR_REG_PARAM; idx++)
    {
       //
       // Get the configuration value for a specific parameter.  Under NT the
       // parameters are all read in as DWORDs.  We support both hexadecimal
		// and decimal notation.
		//
	    NdisReadConfiguration (&Status,
	                           &ReturnedValue,
	                           ConfigHandle,
	                           &XcvrRegTable[idx].RegVarName,
	                           NdisParameterHexInteger);

        // If the parameter was present, then check its value for validity.
        // otherwise leave it at the default value.
        Value = XcvrRegTable[idx].Default;
        if ( NDIS_STATUS_SUCCESS == Status)
        {
            Value = ReturnedValue->ParameterData.IntegerData;
        }

        fieldPtr = ((PUCHAR)usbPhy) + XcvrRegTable[idx].FieldOffset;

        // Store the value in the adapter structure.
        switch (XcvrRegTable[idx].FieldSize)
        {
            case 1:
                *((PUCHAR) fieldPtr) = (UCHAR) Value;
                break;
            case 2:
                *((PUSHORT) fieldPtr) = (USHORT) Value;
                break;
            case 4:
                *((PULONG) fieldPtr) = (ULONG) Value;
                break;
            default:
				DBGPRINT(
					DBG_PRINT_MODULE_NDIS_ALL,
					DBG_PRINT_LEVEL_ERR,
					("Bad field size %d\n", XcvrRegTable[idx].FieldSize));
                break;
        }

		DBGPRINT(DBG_PRINT_MODULE_NDIS_ALL,	DBG_PRINT_LEVEL_TRACE,
	       ("%-15ws 0x%-8X%10s\n",
            XcvrRegTable[idx].RegVarName.Buffer, Value,
            (Value == XcvrRegTable[idx].Default ? "\t(DEFAULT)" : "")
        ));
    }

    /* We should close the registry configuration routine */
    NdisCloseConfiguration (ConfigHandle);

    return NDIS_STATUS_SUCCESS;
}
#endif //GSIREG

/********************************************************************
* Function     : GsiDispatch
* Description  : This function is the entry point for the control panel
*				 applet. It determines the message type and takes the
*				 appropriate action.
*
* Input        : DeviceObject - A pointer to the device data structure
*              : Irp - A pointer to the I/O Request Packet
*
* Output       : None
* Return       : NDIS_STATUS_SUCCESS.
**********************************************************************/
NTSTATUS GsiDispatch(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp)
{
	PIO_STACK_LOCATION	irpStack;
	PVOID				ioBuf;
	PMDL				irpMdl;
	ULONG				inBufLen;
	ULONG				outBufLen;
	ULONG				ioctlCode;
	NTSTATUS			status;
	ULONG				key;
	ULONG				bytesWritten;
	PUSB_PHY            Adapter;
	PATM_USB_INSTANCE	Instance;
	ULONG				returnValue;
	GSICPL_GLOBALS      *pGlobals;
    PATM_UNI		    atmUni;

#ifdef WINHIP
    BOOLEAN             bNeedQueue = FALSE;
#endif
#ifdef NEW_CPL_INTERFACE
GV_INTF_MSG       *inBufPtr;
GV_INTF_MSG       *outBufPtr;
#endif //NEW_CPL_INTERFACE

    if (!gInstance)
	{
		Irp->IoStatus.Status = STATUS_UNSUCCESSFUL;
		return (STATUS_UNSUCCESSFUL);
	}

	Instance    = gInstance;
   Adapter     = Instance->UsbPhyHandle;
#ifndef NDIS_CALLS
	pGlobals	= DeviceObject->DeviceExtension;
	irpStack	= IoGetCurrentIrpStackLocation(Irp);
	ioBuf		= Irp->AssociatedIrp.SystemBuffer;
	irpMdl		= Irp->MdlAddress;

	// Check this IRP for our signature, if not pass it the NDIS dispatch
	if( (DeviceObject->DeviceExtension==NULL) || (pGlobals->GspnSignature != GSPN_SIGNATURE) )
	{
		if(gNdisMajorFunction[irpStack->MajorFunction]!=NULL)
		{
			// Fix for Win98 FE:  handle queries that occur when another device is plugged-in to prevent unload
			if ( irpStack->MajorFunction == IRP_MJ_PNP )
			{
				switch (irpStack->MinorFunction)
				{
                    // In addition to Win98 fix, this case handles surprise removal
   					case IRP_MN_QUERY_CAPABILITIES:
                        DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
							("Intercepting IRP_MJ_PNP and passing down to next driver on stack\n"));

                        // Note this should only be set for Win2k (WHQL hibernate test will fail for WinXP)
                        if ( Adapter->Win2kSurpriseRemoval )
                        {
                            irpStack->Parameters.DeviceCapabilities.Capabilities->SurpriseRemovalOK =
                                (BOOLEAN)Adapter->Win2kSurpriseRemoval;

                            status = GsiSendIrpSynchronously( Adapter->TopOfStackDeviceObject, Irp);

                            // Flag also needs to be set on the way up
                            if (NT_SUCCESS (status))
                                irpStack->Parameters.DeviceCapabilities.Capabilities->SurpriseRemovalOK =
                                    (BOOLEAN)Adapter->Win2kSurpriseRemoval;

                            IoCompleteRequest(Irp, IO_NO_INCREMENT);
                            return status;
                        }
                        else
                        {
						    IoSkipCurrentIrpStackLocation ( Irp);
						    return ( IoCallDriver(Adapter->TopOfStackDeviceObject, Irp) );
                        }
                    break;

					case IRP_MN_QUERY_PNP_DEVICE_STATE:
					case IRP_MN_QUERY_DEVICE_RELATIONS:
					case IRP_MN_QUERY_ID:
						DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
							("Intercepting IRP_MJ_PNP and passing down to next driver on stack\n"));

						IoSkipCurrentIrpStackLocation ( Irp);
						return ( IoCallDriver(Adapter->TopOfStackDeviceObject, Irp) );
					break;

					default:
						return( ((PDRIVER_DISPATCH)gNdisMajorFunction[irpStack->MajorFunction])(DeviceObject, Irp) );
					break;
				} // switch ioctlCode
			}
			else
				return( ((PDRIVER_DISPATCH)gNdisMajorFunction[irpStack->MajorFunction])(DeviceObject, Irp) );
		}
		else
		{
			DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
					("Unhandled dispatch:  passing down to next driver on stack\n"));

			IoSkipCurrentIrpStackLocation ( Irp);
			return ( IoCallDriver(Adapter->TopOfStackDeviceObject, Irp) );
		}
	}
#endif /* !NDIS_CALLS */

	status = STATUS_SUCCESS;
	Irp->IoStatus.Status = STATUS_SUCCESS;

    // Force unhook to wait on event if driver operational at this point
    NdisAcquireSpinLock( &Instance->IrpSpinLock);
    if ( (Instance->Status & ATM_USB_STATUS_HALTING) || (Instance->Status & ATM_USB_STATUS_SUSPENDING) )
    {
       NdisReleaseSpinLock( &Instance->IrpSpinLock);
       IoCompleteRequest(Irp, IO_NO_INCREMENT);
       return status;
    }
    else
    {
        NdisResetEvent( &Instance->IrpEvent);
        NdisReleaseSpinLock( &Instance->IrpSpinLock);
    }

#ifdef NDIS_CALLS
	irpStack	= IoGetCurrentIrpStackLocation(Irp);
	ioBuf		= Irp->AssociatedIrp.SystemBuffer;
	irpMdl		= Irp->MdlAddress;
#endif /* NDIS_CALLS */

	switch (irpStack->MajorFunction)
	{
      case IRP_MJ_CREATE:
      case IRP_MJ_SHUTDOWN:
      case IRP_MJ_CLEANUP:
      case IRP_MJ_CLOSE:
          DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
         ("got IRP_MJ_Xx value = %x\n", irpStack->MajorFunction));
         break;

      case IRP_MJ_DEVICE_CONTROL:

         ioctlCode = irpStack->Parameters.DeviceIoControl.IoControlCode;
         inBufLen  = irpStack->Parameters.DeviceIoControl.InputBufferLength;
         outBufLen = irpStack->Parameters.DeviceIoControl.OutputBufferLength;

         switch (ioctlCode)
         {
            case IOCTL_PDSLPTR_LOAD_DATA: // PV_MMAP
               CardLoadData( Adapter, GsiMmMapLockedPages( irpMdl));
               Irp->IoStatus.Information = sizeof(GSICPL_STRUCT);
               break;

            case IOCTL_PDSLPTR_RETRAIN: /* RESTART */
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
	            ("=>get IOCTL_PDSLPTR_RETRAIN\n "));
               UsbPhyCplReq(Adapter, DSP_RESTART_REQ);
               break;

            case IOCTL_PDSLPTR_DISCONNECT: /* ABORT */
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
	            ("=>get IOCTL_PDSLPTR_DISCONNECT\n"));
               /* This will Drop the DSL line */
               UsbPhyCplReq(Adapter, GTI_ABORT_REQ);
               break;

            case IOCTL_PDSLPTR_SET_DATA:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
	            ("=>get IOCTL_PDSLPTR_SET_DATA\n"));
               GsiSetAdapterData(Adapter, (PGSIDRIVER_SETTINGS)ioBuf);
               break;

            case IOCTL_GSIDSL_ADAPTER_CONFIG:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
	            ("=>get IOCTL_GSIDSL_ADAPTER_CONFIG\n"));
               GsiGetAdapterData(Adapter,(PGSIDRIVER_SETTINGS)GsiMmMapLockedPages( irpMdl));
               Irp->IoStatus.Information = sizeof(GSIDRIVER_SETTINGS);
               break;

			case IOCTL_GSIDSL_SET_CONFIGU:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
						("=>get IOCTL_PDSLPTR_SET_DATA\n"));
               GsiSetConfigUData(Adapter, (PGSIDSL_CONFIGU)ioBuf);
               break;

            case IOCTL_GSIDSL_GET_CONFIGU:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
						("=>get IOCTL_GSIDSL_ADAPTER_CONFIG\n"));
               GsiGetConfigUData(Instance,(PGSIDSL_CONFIGU)GsiMmMapLockedPages( irpMdl));
               Irp->IoStatus.Information = sizeof(GSIDSL_CONFIGU);
               break;

			case IOCTL_GSIDSL_DGLB_START:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
	            ("=>got IOCTL_GSIDSL_DGLB_START\n"));
               if (GetDspState(Adapter) == DSP_PHY_IDLE)
                   UsbPhyCplReq(Adapter, GTI_DIGITAL_LB_REQ);
               break;

			case IOCTL_GSIDSL_DGLB_DATA:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
	            ("=>got IOCTL_GSIDSL_DGLB_DATA\n"));
               /* REMIND LIANSHU THAT I DO NOT NEED THIS COMMAND */
               break;

            case IOCTL_PDSLPTR_SPEC_REVERB_START:
				UsbPhyCplReq(Adapter, GTI_SPECTRUM_REVERB_REQ);
				break;

            case  IOCTL_PDSLPTR_SPEC_MEDLEY_START: //IOCTL_PDSLPTR_SPEC_START:
				UsbPhyCplReq(Adapter, GTI_SPECTRUM_MEDLEY_REQ);
				break;

            case IOCTL_PDSLPTR_SPEC_PILOT_START:
				UsbPhyCplReq(Adapter, GTI_SPECTRUM_PILOT_REQ);
				break;

            case IOCTL_PDSLPTR_SPEC_R_START:
				UsbPhyCplReq(Adapter, GTI_SPECTRUM_R_PBIN_REQ);
				break;

#ifdef EEPROM
			case IOCTL_GSIDSL_READ_EEPROM:
                COPY_MEMORY((PGSIDSL_EEPROM)GsiMmMapLockedPages( irpMdl),&(Adapter->eeprom[0]), EEPROM_SIZE);
				Irp->IoStatus.Information = EEPROM_SIZE;
				break;

			case IOCTL_GSIDSL_WRITE_EEPROM:
               COPY_MEMORY(&(Adapter->eeprom[0]), ioBuf, EEPROM_SIZE);
               SetDspState (Adapter, DSP_PHY_EMPTY, DSP_WRITE_EEPROM_ACTION);
				break;
#endif//EEPROM

            case IOCTL_RFC1577_GET_ARP:

#ifdef LAN_MINIPORT
                GetRfc1577Entries(Adapter ,(PQUERY_ARP_BUFFER)GsiMmMapLockedPages( irpMdl));
                Irp->IoStatus.Information = sizeof(QUERY_ARP_BUFFER);

#endif
                break;

         case IOCTL_RFC1577_DELETE_ARP:

#ifdef LAN_MINIPORT
             DeleteRfc1577Entry(Adapter  , ioBuf );
#endif
              break;

		 case CONTROL_CODE_GET_EOC:
			 COPY_MEMORY(GsiMmMapLockedPages( irpMdl), Adapter->DslHandle , sizeof(EOC_MESSAGES_COMMON) );
			 Irp->IoStatus.Information = sizeof(EOC_MESSAGES_COMMON);
			 break;

		 case CONTROL_CODE_SEND_DG:
			 DslEocSendDyingGasp(Adapter->DslHandle);
			 break;

			case IOCTL_SNR_MARGIN_PER_BIN:
                GetGTIStatus( Adapter, GTI_SNR_MARGIN_PER_BIN);
                Irp->IoStatus.Information = TRUE;
				break;

			case IOCTL_LCL_SNR_MARGIN:
                GetGTIStatus( Adapter, GTI_LCL_SNR_MARGIN);
                Irp->IoStatus.Information = TRUE;
				break;

			case IOCTL_DOWN_BIT_LOADING_PER_BIN:
                GetGTIStatus( Adapter, GTI_BIT_LOADING_DN );
                Irp->IoStatus.Information = TRUE;
				break;

			case IOCTL_UP_BIT_LOADING_PER_BIN:
                GetGTIStatus( Adapter, GTI_BIT_LOADING_UP);
                Irp->IoStatus.Information = TRUE;
				break;

			case IOCTL_PDSLPTR_IF_QUASAR:
				COPY_MEMORY(GsiMmMapLockedPages( irpMdl), &Adapter->ControllerParam , sizeof(CONTROLLER_PARAM) );
				Irp->IoStatus.Information = sizeof( CONTROLLER_PARAM );
				break;


#ifdef ANNEXC
            case IOCTL_SNR_MARGIN_PER_BIN_NEXT:
				GetGTIStatus(Adapter, GTI_SNR_MARGIN_PER_BIN_NEXT);
                Irp->IoStatus.Information = TRUE;
				break;


			case IOCTL_DOWN_BIT_LOADING_PER_BIN_NEXT:

                GetGTIStatus(Adapter, GTI_BIT_LOADING_NEXT_DN );
                Irp->IoStatus.Information = TRUE;
				break;

			case IOCTL_UP_BIT_LOADING_PER_BIN_NEXT:

                GetGTIStatus(Adapter, GTI_BIT_LOADING_NEXT_UP);
                Irp->IoStatus.Information = TRUE;
				break;
#endif //ANNEXC

#ifdef WINHIP

            case IOCTL_GSIDSL_WHIP_MSG:
                // If we are using WHIP disable retrain.
                Adapter->RetrainEnable = FALSE;
                bNeedQueue = IsListEmpty(&Adapter->whipMessageList);

                ExInterlockedInsertTailList(  &Adapter->whipMessageList,&Irp->Tail.Overlay.ListEntry,
                    &Adapter->whipLock);

                IoMarkIrpPending(Irp);
                IoSetCancelRoutine(Irp,CancelWhipMessageIrp);
                DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
                    ("GsiDispatch ==>IOCTL_GSIDSL_WHIP_MSG\n"));

                if( bNeedQueue )
                    SetDspState(Adapter,DSP_PHY_EMPTY,DSP_PROCESS_WHIP_MSG);

                NdisSetEvent( &Instance->IrpEvent);
                return STATUS_PENDING;
                break;

#endif // WINHIP

#ifdef ICONDATA
           case IOCTL_PDSLPTR_LOAD_ICONDATA:
			   DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE,
                    ("\n\nreceived IOCTL_PDSLPTR_LOAD_ICONDATA size %d\n",sizeof(GSICON_STRUCT)));
               GetIconData( Adapter, GsiMmMapLockedPages( irpMdl));
               Irp->IoStatus.Information = sizeof(GSICON_STRUCT);
               break;
#endif //ICONDATA

            case IOCTL_GSIDSL_CLEARATMCNT:
                (Adapter->UserCPLClearATMStats) (Adapter->UserHandle);
                break;

			case IOCTL_GSIDSL_GETATMSTATISTICS:
                (Adapter->UserCPLGetATMStats) (Adapter->UserHandle,
                    GsiMmMapLockedPages( irpMdl)
                    );
                Irp->IoStatus.Information = sizeof(ATM_STATISTICS);
                break;

			case IOCTL_GSIDSL_F4F5_LOOPBACK:
				AtmUniSendF4F5_Loopback	(Adapter->UserHandle, (PLOOPBACK_VPIVCI)ioBuf);
				break;

			case IOCTL_GSIDSL_F4F5_LOOPBACK2:
			   AtmUni_OAM_IF(Adapter->UserHandle, (POAMLOOPBACK_STRUCT)ioBuf);
			   break;

			case IOCTL_SPAWN_DRIVER_THREADS:
				break;

#ifdef NEW_CPL_INTERFACE
           case IOCTL_COMMAND:
               inBufPtr = (GV_INTF_MSG *)ioBuf;
               outBufPtr = (GV_INTF_MSG *)ioBuf;
               switch(inBufPtr->cmdType)
               {
                   case GV_CMD_SET:
                       IoctlSetCmd(Adapter, inBufPtr, outBufPtr);
                       break;

                   case GV_CMD_QUERY:
//                       DbgPrint("Rx-ed CMD_QUERY\n");
                       IoctlQueryCmd(Adapter, inBufPtr, outBufPtr);
                       Irp->IoStatus.Information = SIZE_OF_INTF_HEADER + (outBufPtr->length);
//                       DbgPrint("Finished CMD_QUERY\n");
                       break;

                   case GV_CMD_MULTIQUERY:
                       /* It is not supported */
                       break;

                   default:
                       break;
               }
               break;
#endif //NEW_CPL_INTERFACE

#ifdef USB_WIN_AUTO_CONFIG
            case IOCTL_AUTO_CONFIG:
                if ( Adapter->UserHandle )
                {
                    atmUni = Adapter->UserHandle;
                    Irp->IoStatus.Information = Process_Ac_Request ( atmUni->pAutoConfig, ioBuf,
                                                                     GsiMmMapLockedPages( irpMdl));
                }
            break;
#endif // USB_WIN_AUTO_CONFIG

            default:
               DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_ERR,
	               ("\n\nUnknown ioctlCode: (0x%x)\n\n",  ioctlCode));

               break;
         } // switch ioctlCode
         break;

      default:
         DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_ERR,
            ("PADSLPTR: unknown Major Function\n"));
         status = STATUS_INVALID_PARAMETER;
         break;
   }  // switch irpStack->MajorFunction

   NdisSetEvent( &Instance->IrpEvent);
   IoCompleteRequest(Irp, IO_NO_INCREMENT);
   return status;
}


NTSTATUS
GsiSendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    KEVENT   event;
    NTSTATUS status;

    PAGED_CODE();

    KeInitializeEvent(&event, NotificationEvent, FALSE);
    IoCopyCurrentIrpStackLocationToNext(Irp);

    IoSetCompletionRoutine(Irp,
                           GsiDispatchPnpComplete,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    status = IoCallDriver(DeviceObject, Irp);

    if (status == STATUS_PENDING)
    {
       KeWaitForSingleObject(&event, Executive, KernelMode, FALSE, NULL);
       status = Irp->IoStatus.Status;
    }

    return status;
}


NTSTATUS
GsiDispatchPnpComplete (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT event = (PKEVENT)Context;

    UNREFERENCED_PARAMETER (DeviceObject);
    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    // Take the IRP back so that we can continue using it during the dispatch routine.
    // NB: The dispatch routine will have to call IoCompleteRequest
    return STATUS_MORE_PROCESSING_REQUIRED;
}


PVOID
GsiMmMapLockedPages (
    IN PMDL irpMdl
    )
{
    PVOID   virtualAddress = NULL;
    short   oldfail;


    if ( irpMdl )
    {
        oldfail = irpMdl->MdlFlags & MDL_MAPPING_CAN_FAIL;
        irpMdl->MdlFlags |= MDL_MAPPING_CAN_FAIL;

        virtualAddress = MmMapLockedPages( irpMdl, KernelMode);

        if (!oldfail)
            irpMdl->MdlFlags &= ~MDL_MAPPING_CAN_FAIL;
    }

    return virtualAddress;
}

#elif defined(linux)

/*+F*************************************************************************
 * Function:
 *   gsi_ioctl
 *
 * Description:
 *   Handle internal IOCTL requests to the driver.
 *-F*************************************************************************/
BOOLEAN
GpatmisIoctl(
    adapter_t      *pAdapter,
    int             cmd,
    struct gsi_req *pReq,
    int            *pResult
    )
{
  DBG_FUNC("gsi_ioctl")
    BOOLEAN     handled = TRUE;
    int         status = 0;
    //  PGSIDSL_PANDA_EEPROM pEeprom;

    DBG_ENTER(DbgInfo);
    DBG_PARAMF(DbgInfo, "cmd", ("%s (0x%04x)", DbgIoctlCmd(cmd), cmd));
    DBG_PARAMF(DbgInfo, "pResult", ("(0x%p)", pResult));

    if(cmd == GSI_IOCTL)
	{
    	DBG_PARAMF(DbgInfo, "pReq", ("%s (0x%p)", DbgGsiReq(pReq), pReq));

    	switch (pReq->command)
		{
		case GSI_IOCTL_GET_VERSION:
		  //      DBG_FUNC("GSI_IOCTL_GET_VERSION");
			if (pReq->len < sizeof(pAdapter->version))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(pAdapter->version);
				break;
			}

			if (copy_to_user(pReq->data, &(pAdapter->version),
				sizeof(pAdapter->version)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(pAdapter->version);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_GET_CONFIG:
			if (pReq->len < sizeof(pAdapter->config))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(pAdapter->config);
				break;
			}

			if (copy_to_user(pReq->data, &(pAdapter->config),
				sizeof(pAdapter->config)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(pAdapter->config);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_GET_STATUS:
		{
			gsi_status_t	DevStatus;
			if (pReq->len < sizeof(DevStatus))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(DevStatus);
				break;
			}

			if( pAdapter->UsbPhyHandle )
			{
				DevStatus.u32DspState = ((PUSB_PHY)(pAdapter->UsbPhyHandle))->dspState;
				DevStatus.u32UsbState = ((PUSB_PHY)(pAdapter->UsbPhyHandle))->State;
				DevStatus.u32Modulation = 
					((PUSB_PHY)(pAdapter->UsbPhyHandle))->DspActualTrainingMode;
			}
			else
			{
				DevStatus.u32DspState = DSP_PHY_IDLE;
				DevStatus.u32UsbState = USB_PHY_STATE_HALTED;
				DevStatus.u32Modulation = GTI_MULTIMODE_STANDARD; 
			}
			DevStatus.u32UpRate = pAdapter->UpstreamRate;
			DevStatus.u32DownRate = pAdapter->DownstreamRate;

			if (copy_to_user(pReq->data, &DevStatus,
				sizeof(DevStatus)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(DevStatus);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;
		}

		case GSI_IOCTL_GET_DBG:
		{
			gsi_debug_t	DbgOpts;
			DbgOpts.level = DbgGetDbgPrintLevel();
			DbgOpts.module = DbgGetDbgPrintModule();
			if (pReq->len < sizeof(DbgOpts))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(DbgOpts);
				break;
			}

			if (copy_to_user(pReq->data, &DbgOpts, sizeof(DbgOpts)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(DbgOpts);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			status = 0;
			break;
		}

		case GSI_IOCTL_SET_DBG:
		{
			gsi_debug_t	*pDbgOpts;
			if (pReq->len < sizeof(gsi_debug_t))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(gsi_debug_t);
				break;
			}
			if ((status = my_verify_area(VERIFY_READ, pReq->data, pReq->len)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer 0x%p (%d)!\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(gsi_debug_t);
				break;
			}
			printk("Setting Debug Values\n");
			pDbgOpts = (gsi_debug_t *) pReq->data;
			if( pDbgOpts->SetLevel )
				DbgSetDbgPrintLevel( pDbgOpts->level );
			
			if( pDbgOpts->SetModule )
				DbgSetDbgPrintModule( pDbgOpts->module );

			pReq->result = GSI_IOCTL_SUCCESS;
			break;
		}

		case GSI_IOCTL_GET_STATS:
		{
			ATM_UNI_STATS	atmStats;
			if (pReq->len < sizeof(ATM_UNI_STATS))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(ATM_UNI_STATS);
				break;
			}
			
			AtmUniGetAtmStats( ((PATM_UNI)(pAdapter->AtmUniHandle)),
				&atmStats );

			if (copy_to_user(pReq->data, &atmStats, sizeof(ATM_UNI_STATS)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(ATM_UNI_STATS);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			status = 0;
			break;
		}

		case GSI_IOCTL_CLEAR_STATS:
		{
			AtmUniClearAtmStats( ((PATM_UNI)(pAdapter->AtmUniHandle)) );
			pReq->result = GSI_IOCTL_SUCCESS;
			status = 0;
			break;
		}

		case GSI_IOCTL_RUN_TEST:
		{
			DIAG_STRUCT	*pOamCell;
			OAMLOOPBACK_STRUCT	OamLoopback;

			if (pReq->len < sizeof(DIAG_STRUCT))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(DIAG_STRUCT);
				break;
			}
			if ((status = my_verify_area(VERIFY_READ, pReq->data, pReq->len)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer 0x%p (%d)!\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(DIAG_STRUCT);
				break;
			}
			pOamCell = (DIAG_STRUCT *)pReq->data;
			pReq->result = GSI_IOCTL_SUCCESS;
			switch( pOamCell->TestCase )
			{
			case	1:
				UsbPhyCplReq(pAdapter,GTI_SPECTRUM_REVERB_REQ);
				break;
			case	2:
				UsbPhyCplReq(pAdapter,GTI_SPECTRUM_MEDLEY_REQ);
				break;
			case	3:
				UsbPhyCplReq(pAdapter,GTI_SPECTRUM_PILOT_REQ);
				break;
			case	4:
				UsbPhyCplReq(pAdapter,GTI_SPECTRUM_R_PBIN_REQ);
				break;
			case	5:
			case	6:
			case	7:
			case	8:
				OamLoopback.vpi = pOamCell->vpi;
				OamLoopback.vci = pOamCell->vci;
				OamLoopback.pti = pOamCell->pti;
				AtmUni_OAM_IF( pAdapter->AtmUniHandle, 
					(POAMLOOPBACK_STRUCT)&OamLoopback);
				break;
			default:
				pReq->result = GSI_IOCTL_FAILURE;
				break;
			}

			break;
		}

	// ++EEPROM Read 03/05/01 PG
		case GSI_IOCTL_READ_EEPROM:
		  // DBG_FUNC("GSI_IOCTL_READ_EEPROM")

			if (copy_to_user(pReq->data, &(((PUSB_PHY)(pAdapter->UsbPhyHandle))->eeprom ),
				EEPROM_SIZE) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(((PUSB_PHY)(pAdapter->UsbPhyHandle))->eeprom );
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

	// --EEPROM Read 03/05/01 PG


	// ++EEPROM Write 03/05/01 PG
		case GSI_IOCTL_WRITE_EEPROM:
			if (!capable(CAP_SYS_ADMIN))
			{
				pReq->result = GSI_IOCTL_FAILURE;
				status = -EPERM;
				break;
			}

			if (pReq->len < EEPROM_SIZE)
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = EEPROM_SIZE;
				break;
			}

			if ((status = my_verify_area(VERIFY_READ, pReq->data, pReq->len)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer 0x%p (%d)!\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = EEPROM_SIZE;
				break;
			}

			{
				GSIDSL_EEPROM  *pSCfg, *pDCfg;

				pSCfg = (PGSIDSL_EEPROM)pReq->data;
				pDCfg = (PGSIDSL_EEPROM)&(((PUSB_PHY)(pAdapter->UsbPhyHandle))->eeprom);
				pDCfg->zeroByte				= pSCfg->zeroByte;	
				pDCfg->vendorIdLow			= pSCfg->vendorIdLow;
				pDCfg->vendorIdHigh			= pSCfg->vendorIdHigh;
				pDCfg->productIdLow			= pSCfg->productIdLow;
				pDCfg->productIdHigh		= pSCfg->productIdHigh;
				pDCfg->macAddr0      	    = pSCfg->macAddr0;
				pDCfg->macAddr1      	    = pSCfg->macAddr1;
				pDCfg->macAddr2      	    = pSCfg->macAddr2;
				pDCfg->macAddr3      	    = pSCfg->macAddr3;
				pDCfg->macAddr4      	    = pSCfg->macAddr4;
				pDCfg->macAddr5      	    = pSCfg->macAddr5;
				SetDspState(((PUSB_PHY)(pAdapter->UsbPhyHandle)),DSP_PHY_EMPTY,DSP_WRITE_EEPROM_ACTION);
			}

			pReq->result = GSI_IOCTL_SUCCESS;

			break;

	// --EEPROM Write 03/05/01 PG

		case GSI_IOCTL_SET_CONFIG:
			if (!capable(CAP_SYS_ADMIN))
			{
				pReq->result = GSI_IOCTL_FAILURE;
				status = -EPERM;
				break;
			}

			if (pReq->len < sizeof(gsi_config_t))
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer length (%d)!\n",
					DbgGsiReq(pReq), pReq->len));
				pReq->result = GSI_IOCTL_ERR_LEN;
				pReq->len = sizeof(gsi_config_t);
				break;
			}

			if ((status = my_verify_area(VERIFY_READ, pReq->data, pReq->len)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Invalid buffer 0x%p (%d)!\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(gsi_config_t);
				break;
			}

			{
			gsi_config_t   *pSCfg, *pDCfg;

			pSCfg = (gsi_config_t *) pReq->data;
			pDCfg = &(pAdapter->config);

			pDCfg->gtiStandard         = pSCfg->gtiStandard;
			pDCfg->gtiTrellis          = pSCfg->gtiTrellis;
			pDCfg->gtiTxPowerAtten     = pSCfg->gtiTxPowerAtten;
			pDCfg->gtiCodingGain       = pSCfg->gtiCodingGain;
			pDCfg->gtiMaxBitsPerBin    = pSCfg->gtiMaxBitsPerBin;
			pDCfg->gtiTxStartBin       = pSCfg->gtiTxStartBin;
			pDCfg->gtiTxEndBin         = pSCfg->gtiTxEndBin;
			pDCfg->gtiRxStartBin       = pSCfg->gtiRxStartBin;
			pDCfg->gtiRxEndBin         = pSCfg->gtiRxEndBin;
			pDCfg->gtiRxBinAdjust      = pSCfg->gtiRxBinAdjust;
			pDCfg->gtiFramingStruct    = pSCfg->gtiFramingStruct;
			pDCfg->gtiExpandedExchange = pSCfg->gtiExpandedExchange;
			pDCfg->gtiClockType        = pSCfg->gtiClockType;
			pDCfg->gtiMaxDownRate      = pSCfg->gtiMaxDownRate;

			// Restart the DSP training.
			SetDspState(((PUSB_PHY)(pAdapter->UsbPhyHandle)) , DSP_PHY_RESTART, DSP_INTERRUPT);
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_DISCONNECT:
			if (!capable(CAP_SYS_ADMIN))
			{
				pReq->result = GSI_IOCTL_FAILURE;
				status = -EPERM;
				break;
			}

			// Disconnect the DSP.
			SetDspState(((PUSB_PHY)(pAdapter->UsbPhyHandle)) , DSP_PHY_DISCONNECT, DSP_INTERRUPT);

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_RETRAIN:
			if (!capable(CAP_SYS_ADMIN))
			{
				pReq->result = GSI_IOCTL_FAILURE;
				status = -EPERM;
				break;
			}

			// Restart the DSP training.
			SetDspState(((PUSB_PHY)(pAdapter->UsbPhyHandle)) , DSP_PHY_RESTART, DSP_INTERRUPT);

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_SNR_MARGIN_PER_BIN:
			GetGTIStatus( (PUSB_PHY)(pAdapter->UsbPhyHandle), 
					GTI_SNR_MARGIN_PER_BIN);
			if (copy_to_user(pReq->data, 
						&(((PUSB_PHY)(pAdapter->UsbPhyHandle))->snrMarginPerBin ),
						BINS_DOWN_COUNT * sizeof(USHORT)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(((PUSB_PHY)(pAdapter->UsbPhyHandle))->snrMarginPerBin);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_LCL_SNR_MARGIN:
			GetGTIStatus( (PUSB_PHY)(pAdapter->UsbPhyHandle), 
					GTI_LCL_SNR_MARGIN);
			if (copy_to_user(pReq->data, 
					&(((PUSB_PHY)(pAdapter->UsbPhyHandle))->lclSnrMargin ),
					sizeof(char)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(((PUSB_PHY)(pAdapter->UsbPhyHandle))->lclSnrMargin);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_DOWN_BIT_LOADING_PER_BIN:
			GetGTIStatus( (PUSB_PHY)(pAdapter->UsbPhyHandle), 
					GTI_BIT_LOADING_DN );
			if (copy_to_user(pReq->data, 
					&(((PUSB_PHY)(pAdapter->UsbPhyHandle))->bitLoadCoDwnCpUp ),
					BINS_DOWN_COUNT * sizeof(UCHAR)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(((PUSB_PHY)(pAdapter->UsbPhyHandle))->bitLoadCoDwnCpUp);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_UP_BIT_LOADING_PER_BIN:
			GetGTIStatus( (PUSB_PHY)(pAdapter->UsbPhyHandle), 
					GTI_BIT_LOADING_UP);
			if (copy_to_user(pReq->data, 
					&(((PUSB_PHY)(pAdapter->UsbPhyHandle))->bitLoadCoUpCpDwn ),
					BINS_UP_COUNT * sizeof(UCHAR)) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
					
				pReq->len = sizeof(((PUSB_PHY)(pAdapter->UsbPhyHandle))->bitLoadCoUpCpDwn);
				status = -EFAULT;
				break;
			}

			pReq->result = GSI_IOCTL_SUCCESS;
			break;

		case GSI_IOCTL_PDSLPTR_IF_QUASAR:
			if (copy_to_user(pReq->data, 
					&(((PUSB_PHY)(pAdapter->UsbPhyHandle))->ControllerParam) , 
					sizeof(CONTROLLER_PARAM) ) != 0)
			{
				DBG_IOCTL(DbgInfo, ("%s: Data copy to user failed! 0x%p (%d)\n",
					DbgGsiReq(pReq), pReq->data, pReq->len));
				pReq->result = GSI_IOCTL_FAILURE;
				pReq->len = sizeof(CONTROLLER_PARAM);
				status = -EFAULT;
			}
			pReq->result = GSI_IOCTL_SUCCESS;
			break;


		default:
		  //      DBG_FUNC("DEFAULT")
			status = -EOPNOTSUPP;
			handled = FALSE;
			break;
		}
    }	//GSI_IOCTL
	else
	{
	    status = -EOPNOTSUPP;
	    handled = FALSE;

	}

    if (pResult != NULL)
    {
        *pResult = status;
    }

    DBG_RETURNF(DbgInfo, ("%s", handled ? "Handled" : "Not Handled"));
    return handled;
}

/*+F**********************************
 * Description:
 *   Convert the IOCTL request value to a character string
 *-F*************************************************************************/
const char *
DbgIoctlCmd(
    unsigned int    cmd
    )
{
    static char *cmdName;

    struct {
        int     value;
        char   *name;
    } ioctlInfo[] = {
        { GSI_IOCTL,        "GSI_IOCTL"        },
        { TCGETS,           "TCGETS"           },
        { TCSETS,           "TCSETS"           },
        { TCSETSW,          "TCSETSW"          },
        { TCSETSF,          "TCSETSF"          },
        { TCGETA,           "TCGETA"           },
        { TCSETA,           "TCSETA"           },
        { TCSETAW,          "TCSETAW"          },
        { TCSETAF,          "TCSETAF"          },
        { TCSBRK,           "TCSBRK"           },
        { TCXONC,           "TCXONC"           },
        { TCFLSH,           "TCFLSH"           },
        { TIOCEXCL,         "TIOCEXCL"         },
        { TIOCNXCL,         "TIOCNXCL"         },
        { TIOCSCTTY,        "TIOCSCTTY"        },
        { TIOCGPGRP,        "TIOCGPGRP"        },
        { TIOCSPGRP,        "TIOCSPGRP"        },
        { TIOCOUTQ,         "TIOCOUTQ"         },
        { TIOCSTI,          "TIOCSTI"          },
        { TIOCGWINSZ,       "TIOCGWINSZ"       },
        { TIOCSWINSZ,       "TIOCSWINSZ"       },
        { TIOCMGET,         "TIOCMGET"         },
        { TIOCMBIS,         "TIOCMBIS"         },
        { TIOCMBIC,         "TIOCMBIC"         },
        { TIOCMSET,         "TIOCMSET"         },
        { TIOCGSOFTCAR,     "TIOCGSOFTCAR"     },
        { TIOCSSOFTCAR,     "TIOCSSOFTCAR"     },
        { FIONREAD,         "FIONREAD"         },
        { TIOCINQ,          "TIOCINQ"          },
        { TIOCLINUX,        "TIOCLINUX"        },
        { TIOCCONS,         "TIOCCONS"         },
        { TIOCGSERIAL,      "TIOCGSERIAL"      },
        { TIOCSSERIAL,      "TIOCSSERIAL"      },
        { TIOCPKT,          "TIOCPKT"          },
        { FIONBIO,          "FIONBIO"          },
        { TIOCNOTTY,        "TIOCNOTTY"        },
        { TIOCSETD,         "TIOCSETD"         },
        { TIOCGETD,         "TIOCGETD"         },
        { TCSBRKP,          "TCSBRKP"          },
        { TIOCTTYGSTRUCT,   "TIOCTTYGSTRUCT"   },
        { TIOCSBRK,         "TIOCSBRK"         },
        { TIOCCBRK,         "TIOCCBRK"         },
        { TIOCGSID,         "TIOCGSID"         },
        { TIOCGPTN,         "TIOCGPTN"         },
        { TIOCSPTLCK,       "TIOCSPTLCK"       },
        { FIONCLEX,         "FIONCLEX"         },
        { FIOCLEX,          "FIOCLEX"          },
        { FIOASYNC,         "FIOASYNC"         },
        { TIOCSERCONFIG,    "TIOCSERCONFIG"    },
        { TIOCSERGWILD,     "TIOCSERGWILD"     },
        { TIOCSERSWILD,     "TIOCSERSWILD"     },
        { TIOCGLCKTRMIOS,   "TIOCGLCKTRMIOS"   },
        { TIOCSLCKTRMIOS,   "TIOCSLCKTRMIOS"   },
        { TIOCSERGSTRUCT,   "TIOCSERGSTRUCT"   },
        { TIOCSERGETLSR,    "TIOCSERGETLSR"    },
        { TIOCSERGETMULTI,  "TIOCSERGETMULTI"  },
        { TIOCSERSETMULTI,  "TIOCSERSETMULTI"  },
        { TIOCMIWAIT,       "TIOCMIWAIT"       },
        { TIOCGICOUNT,      "TIOCGICOUNT"      },
        { TIOCGHAYESESP,    "TIOCGHAYESESP"    },
        { TIOCSHAYESESP,    "TIOCSHAYESESP"    },
#ifdef DBG_PPP_IOCTL
        { PPPIOCGFLAGS,     "PPPIOCGFLAGS"     },
        { PPPIOCSFLAGS,     "PPPIOCSFLAGS"     },
        { PPPIOCGASYNCMAP,  "PPPIOCGASYNCMAP"  },
        { PPPIOCSASYNCMAP,  "PPPIOCSASYNCMAP"  },
        { PPPIOCGUNIT,      "PPPIOCGUNIT"      },
        { PPPIOCGRASYNCMAP, "PPPIOCGRASYNCMAP" },
        { PPPIOCSRASYNCMAP, "PPPIOCSRASYNCMAP" },
        { PPPIOCGMRU,       "PPPIOCGMRU"       },
        { PPPIOCSMRU,       "PPPIOCSMRU"       },
        { PPPIOCSMAXCID,    "PPPIOCSMAXCID"    },
        { PPPIOCGXASYNCMAP, "PPPIOCGXASYNCMAP" },
        { PPPIOCSXASYNCMAP, "PPPIOCSXASYNCMAP" },
        { PPPIOCXFERUNIT,   "PPPIOCXFERUNIT"   },
        { PPPIOCSCOMPRESS,  "PPPIOCSCOMPRESS"  },
        { PPPIOCGNPMODE,    "PPPIOCGNPMODE"    },
        { PPPIOCSNPMODE,    "PPPIOCSNPMODE"    },
        { PPPIOCGDEBUG,     "PPPIOCGDEBUG"     },
        { PPPIOCSDEBUG,     "PPPIOCSDEBUG"     },
        { PPPIOCGIDLE,      "PPPIOCGIDLE"      },
#endif // DBG_PPP_IOCTL
    };
    int x;

    cmdName = NULL;
    for (x = 0; x < _NELEM(ioctlInfo); x++)
    {
        if (cmd == ioctlInfo[x].value)
        {
            cmdName = ioctlInfo[x].name;
        }
    }

    if (cmdName == NULL)
    {
        cmdName = "<<Unknown>>";
    }

    return cmdName;
}
#if DBG
/*+F*************************************************************************
 * Function:
 *   DbgGsiReq
 *
 * Description:
 *   Convert the GSI IOCTL request value to a character string
 *-F*************************************************************************/
const char *
DbgGsiReq(
    struct gsi_req *pReq
    )
{
    static char *name;

    struct {
        int     cmd;
        char   *name;
    } cmdInfo[] = {
        { GSI_IOCTL_GET_VERSION,    "GET_VERSION" },
        { GSI_IOCTL_GET_CONFIG,     "GET_CONFIG" },
        { GSI_IOCTL_SET_CONFIG,     "SET_CONFIG" },
        { GSI_IOCTL_READ_EEPROM,     "READ_EEPROM" },
        { GSI_IOCTL_WRITE_EEPROM,     "WRITE_EEPROM" },
        { GSI_IOCTL_RETRAIN,        "RETRAIN" },
    };
    int x;

    name = NULL;
    for (x = 0; x < _NELEM(cmdInfo); x++)
    {
        if (pReq->command == cmdInfo[x].cmd)
        {
            name = cmdInfo[x].name;
        }
    }

    if (name == NULL)
    {
        name = "<<Unknown>>";
    }

    return name;
}

#endif // DBG


#endif // _NTDDK

/********************************************************************
* Function     : GetSnrMarginPerBin,GetLclSNRMargin,GetDownBitLoadingPerBin,GetUpBitLoadingPerBin
* Description  : This Func will be called from UsbPhyQueueDspFunction
*  end insetred  to the dsp queue from Dispatch func
* Input        :
*
* Output       : None
* Return       : None
**********************************************************************/

void GetSnrMarginPerBin( PUSB_PHY UsbPhy)
{
	Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
						  GTI_SNR_MARGIN_PER_BIN,
						  UsbPhy->snrMarginPerBin,
						  BINS_DOWN_COUNT * sizeof(USHORT),
						  GTI_CH_A);

UsbPhy->StatusEx = 0x1;

}


void GetLclSNRMargin( PUSB_PHY UsbPhy)
{
    Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,GTI_LCL_SNR_MARGIN,
										  &(UsbPhy->lclSnrMargin),
										  GTI_LCL_SNR_MARGIN_LEN,
										  GTI_CH_A);
UsbPhy->StatusEx = 0x2;

}

void GetDownBitLoadingPerBin( PUSB_PHY UsbPhy)
{
    Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
	    				  GTI_BIT_LOADING_DN,
						  UsbPhy->bitLoadCoDwnCpUp,
		    			  BINS_DOWN_COUNT,
						  GTI_CH_A);

UsbPhy->StatusEx = 0x3;

}

void GetUpBitLoadingPerBin( PUSB_PHY UsbPhy)
{
    Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
									      GTI_BIT_LOADING_UP,
										  UsbPhy->bitLoadCoUpCpDwn,
										  BINS_UP_COUNT,
										  GTI_CH_A);

UsbPhy->StatusEx = 0x4;

}

#ifdef ANNEXC
void GetSnrMarginPerBinNext( PUSB_PHY UsbPhy)
{
	Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
						  GTI_SNR_MARGIN_PER_BIN_NEXT,
						  UsbPhy->snrMarginPerBin,
						  BINS_DOWN_COUNT * sizeof(USHORT),
						  GTI_CH_A);

  UsbPhy->StatusEx = 0x7;

}

void GetDownBitLoadingPerBinNext( PUSB_PHY UsbPhy)
{
	Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
	    				  GTI_BIT_LOADING_NEXT_DN,
						  UsbPhy->bitLoadCoDwnCpUp,
		    			  BINS_DOWN_COUNT,
						  GTI_CH_A);


	UsbPhy->StatusEx = 0x5;
}

void GetUpBitLoadingPerBinNext( PUSB_PHY UsbPhy)
{
	Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
									      GTI_BIT_LOADING_NEXT_UP,
										  UsbPhy->bitLoadCoUpCpDwn,
										  BINS_UP_COUNT,
										  GTI_CH_A);


UsbPhy->StatusEx = 0x6;

}
#endif //ANNEXC

void GetGTIStatus(PUSB_PHY UsbPhy, UINT status )
{

    switch(status)
    {
    case GTI_SNR_MARGIN_PER_BIN:
        GetSnrMarginPerBin( UsbPhy);
        break;

    case GTI_LCL_SNR_MARGIN:
        GetLclSNRMargin( UsbPhy);
        break;

    case GTI_BIT_LOADING_DN:
        GetDownBitLoadingPerBin( UsbPhy);
        break;

    case GTI_BIT_LOADING_UP:
        GetUpBitLoadingPerBin( UsbPhy);
        break;

#ifdef ANNEXC
    case GTI_SNR_MARGIN_PER_BIN_NEXT:
        GetSnrMarginPerBinNext( UsbPhy);
        break;


    case GTI_BIT_LOADING_NEXT_DN:
        GetDownBitLoadingPerBinNext( UsbPhy);
        break;

    case GTI_BIT_LOADING_NEXT_UP:
        GetUpBitLoadingPerBinNext( UsbPhy);
        break;
#endif

    default:
        break;
    }//end switch
}




#ifdef ICONDATA
/********************************************************************
*  Get data for gsi Icon.											*
*																	*
********************************************************************/
void GetIconData(PUSB_PHY UsbPhy, PVOID outBuff)
{
	PGSICON_STRUCT      outBuffer;
    ATM_STATISTICS      atmStats;
	PATM_UNI		    atmUni;
	PATM_UNI_STATS      atmUniStats;
	KIRQL               Irql;

	if ( (outBuff == NULL) || (UsbPhy == NULL) )
	   return;

    outBuffer = (PGSICON_STRUCT) outBuff;
	outBuffer->opState = (UCHAR) GetDspState(UsbPhy);
    strcpy(outBuffer->driverVersion, VER_DRIVERVERSION_STR );

	atmUni = UsbPhy->UserHandle;
	atmUniStats = &atmUni->Stats;

	/* Get the Spin Lock */
	KeAcquireSpinLock( &(UsbPhy->DspLock), &Irql);

	// Additional information required by Control Panel Application
	/* *** FIRMWARE VERSION *** */
	Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
						    GTI_FW_REL,
                            (UCHAR *)outBuffer->firmware,
                            sizeof(outBuffer->firmware),
                            GTI_CH_A);

	/* DSP PHY is connected/DataMode? */
	if((GetDspState(UsbPhy) == DSP_PHY_CONNECTED) ||
   		(GetDspState(UsbPhy) == DSP_PHY_LOOPBACK_MODE))
	{
        (UsbPhy->UserCPLGetATMStats) (UsbPhy->UserHandle, &atmStats);
    }

	outBuffer->numXmitPackets = atmUniStats->TxPdusOk;
    outBuffer->numRcvdPackets = atmUniStats->RxPdusOk;

    /* Release the Spin Lock */
	KeReleaseSpinLock( &(UsbPhy->DspLock),Irql);
}
#endif //ICONDATA


/********************************************************************
* Function     : CardLoadData
* Description  :
*
* Input        :
*
* Output       : None
* Return       : None
**********************************************************************/
void CardLoadData(PUSB_PHY UsbPhy, PVOID outBuff)
{
	PATM_UNI			atmUni;
	PATM_UNI_STATS		atmUniStats;
	ULONG				returnValue;
	PGSICPL_STRUCT		outBuffer;
	KIRQL				Irql;
	int					i;
    ATM_UNI_STATS       *atmInfoPtr;
	ATM_STATISTICS		atmStats;


    if ( (outBuff == NULL) || (UsbPhy == NULL) )
        return;

    outBuffer = (PGSICPL_STRUCT) outBuff;
    outBuffer->opState = (UCHAR) GetDspState(UsbPhy);
    outBuffer->xcvrType = GTI_CPE;
    strcpy(outBuffer->driverVersion, VER_DRIVERVERSION_STR );

    atmUni = UsbPhy->UserHandle;
	atmUniStats = &atmUni->Stats;

#ifdef LAN_MINIPORT
	outBuffer->driverType = LAN_TYPE;
#endif

#ifdef GTI_CAP
	//outBuffer->standard = UsbPhy->xcvr[0].item[GTI_STANDARD_ITEM];
#endif /* GTI_CAP */
#ifdef GTI_DMT
	outBuffer->standard = UsbPhy->xcvr[0].item[GTI_STANDARD_ITEM];
#endif /* GTI_DMT */

   if (GetDspState(UsbPhy) == DSP_PHY_LOOPBACK_MODE)
   {
        outBuffer->xcvrOpState = GTI_DL_TEST_OP;
		outBuffer->nBadPdu = 0;
		outBuffer->nPktSent = 0;
		outBuffer->nPktRcvd = 0;
		outBuffer->numErrBytes = 0;
   }
   else
   {
        outBuffer->xcvrOpState = GTI_IDLE_OP;
		outBuffer->nBadPdu = 0;
		outBuffer->nPktSent = 0;
		outBuffer->nPktRcvd = 0;
		outBuffer->numErrBytes = 0; //Call->rxcr->numErrBytes;
   }

	/* Get the Spin Lock */
	KeAcquireSpinLock( &(UsbPhy->DspLock), &Irql);

	// Additional information required by Control Panel Application
	/* *** FIRMWARE VERSION *** */
	returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
							  GTI_FW_REL,
							  (UCHAR *)outBuffer->firmware,
							  sizeof(outBuffer->firmware),
							  GTI_CH_A);

	/* *** REMOTE VENDOR ID *** */
	returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
							  GTI_RMT_VENDOR_ID_STATUS,
							  &(outBuffer->rmtVendorIdStatus),
						  	  sizeof(outBuffer->rmtVendorIdStatus),
							  GTI_CH_A);

	/* *** START UP PROGRESS *** */
	returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
							  GTI_START_PROGRESS,
							  &(outBuffer->startProgress),
							  sizeof(outBuffer->startProgress),
							  GTI_CH_A);

	/* *** LAST FAILED STATUS *** */
	returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
							  GTI_LAST_FAILED_STATUS,
							  &(outBuffer->lastFail),
							  sizeof(outBuffer->lastFail),
							  GTI_CH_A);


#define IT_IS_ANNEXC      1
#define IT_IS_NOT_ANNEXC  2

#if defined (ANNEXA) || defined (ANNEXB)
			outBuffer->whichAnnexC = IT_IS_NOT_ANNEXC;
#elif defined (ANNEXC)
			outBuffer->whichAnnexC = IT_IS_ANNEXC;
#endif // ANNEXA


	/* DSP PHY is connected/DataMode? */
	if ((GetDspState(UsbPhy) == DSP_PHY_CONNECTED) ||
   	(GetDspState(UsbPhy) == DSP_PHY_LOOPBACK_MODE))
	{
        (UsbPhy->UserCPLGetATMStats) (UsbPhy->UserHandle, &atmStats);

		COPY_MEMORY(&(outBuffer->atmStats), &atmStats, sizeof(ATM_STATISTICS));

		outBuffer->numXmitPackets = atmUniStats->TxPdusOk;
		outBuffer->numRcvdPackets = atmUniStats->RxPdusOk;

		/* *** RX BYTES STATUS *** */
#ifndef ANNEXC
		returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
								  GTI_RX_BYTES_STATUS,
								  &(outBuffer->rxBytes),
								  sizeof(outBuffer->rxBytes),
								  GTI_CH_A);

		/* *** TX BYTES STATUS *** */
		returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
								  GTI_TX_BYTES_STATUS,
								  &(outBuffer->txBytes),
								  sizeof(outBuffer->txBytes),
								  GTI_CH_A);
#endif /* !ANNEXC */
		/* *** ACTUAL CONFIGURATION *** */
		returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
								  GTI_ACTUAL_CONFIGURATION,
								  (USHORT *)(outBuffer->actualConfig),
								  sizeof(outBuffer->actualConfig),
								  GTI_CH_A);

		 //  local/remote Attenuation
		returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,GTI_ATTENUATION_STATUS,
								  &(outBuffer->attenuation),
								  sizeof(outBuffer->attenuation),
								  GTI_CH_A);

		/* *** COUNTERS *** */
		// Grab from UsbPhy copy, not directly from DSP. After read,
		// clear UsbPhy copy
		COPY_MEMORY(&(outBuffer->counters), &(UsbPhy->DspCounters),
					sizeof(UsbPhy->DspCounters));
		NdisZeroMemory(UsbPhy->DspCounters, sizeof(UsbPhy->DspCounters));

        outBuffer->lclSnrMargin = UsbPhy->lclSnrMargin;
        outBuffer->StatusEx = UsbPhy->StatusEx;

        memcpy(outBuffer->snrMarginPerBin, UsbPhy->snrMarginPerBin, BINS_DOWN_COUNT * sizeof(USHORT));
        memcpy(outBuffer->bitLoadCoDwnCpUp, UsbPhy->bitLoadCoDwnCpUp, BINS_DOWN_COUNT * sizeof(UCHAR));
        memcpy(outBuffer->bitLoadCoUpCpDwn, UsbPhy->bitLoadCoUpCpDwn, BINS_UP_COUNT * sizeof(UCHAR));

#ifdef ANNEXC
    	returnValue = Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
							  GTI_LCL_ANNEX_C_MODE,
							  &(UCHAR)(outBuffer->annexCMode),
							  sizeof(outBuffer->annexCMode),
							  GTI_CH_A);

#endif//ANNEXC
}
   /* Release the Spin Lock */
	KeReleaseSpinLock( &(UsbPhy->DspLock),Irql);
}


/********************************************************************
* Function     : GsiSetAdapterData
* Description  :
*
* Input        :
*
* Output       : None
* Return       : None
**********************************************************************/
void GsiSetAdapterData(PUSB_PHY Adapter, PGSIDRIVER_SETTINGS inBuf)
{
#ifdef GTI_DMT
   Adapter->xcvr[0].item[GTI_STANDARD_ITEM]           = inBuf->standard;
//   Adapter->xcvr[0].item[GTI_TRELLIS_ITEM]            = inBuf->trellis;
   Adapter->xcvr[0].item[GTI_TX_POWER_ATTENUATION_ITEM]= inBuf->txPowerAttenuation;
   Adapter->xcvr[0].item[GTI_CODING_GAIN_ITEM]        = inBuf->codingGain;
   Adapter->xcvr[0].item[GTI_MAX_BITS_PER_BIN_ITEM]   = inBuf->maxBitsPerBin;
   Adapter->xcvr[0].item[GTI_TX_START_BIN_ITEM]       = inBuf->txStartBin;
   Adapter->xcvr[0].item[GTI_TX_END_BIN_ITEM]         = inBuf->txEndBin;
   Adapter->xcvr[0].item[GTI_TX_BIN_ADJUST_ITEM]      = inBuf->txBinAdjust;
   Adapter->xcvr[0].item[GTI_RX_START_BIN_ITEM]       = inBuf->rxStartBin;
   Adapter->xcvr[0].item[GTI_RX_END_BIN_ITEM]         = inBuf->rxEndBin;
   Adapter->xcvr[0].item[GTI_RX_BIN_ADJUST_ITEM]      = inBuf->rxBinAdjust;
   Adapter->xcvr[0].item[GTI_FRAMING_STRUCTURE_ITEM]  = inBuf->framingStruct;
   Adapter->xcvr[0].item[GTI_EXPANDED_EXCHANGE_ITEM]  = inBuf->expandedExchange;
   Adapter->xcvr[0].item[GTI_CLOCK_TYPE_ITEM]         = inBuf->clockType;

#ifdef ANNEXC
    Adapter->xcvr[0].item[GTI_ANNEX_C_MODE_ITEM] = inBuf->annexCMode;
#endif //ANNEXC

#endif /* GTI_DMT */
}

/********************************************************************
* Function     : GsiGetAdapterData
* Description  :
*
* Input        :
*
* Output       : None
* Return       : None
**********************************************************************/
void GsiGetAdapterData(PUSB_PHY Adapter, PGSIDRIVER_SETTINGS outBuf)
{
    if ( (Adapter == NULL) || (outBuf == NULL) )
        return;

#ifdef GTI_DMT
    outBuf->standard = Adapter->xcvr[0].item[GTI_STANDARD_ITEM];
//    outBuf->trellis = Adapter->xcvr[0].item[GTI_TRELLIS_ITEM] ;
    outBuf->txPowerAttenuation = Adapter->xcvr[0].item[GTI_TX_POWER_ATTENUATION_ITEM];
    outBuf->codingGain = Adapter->xcvr[0].item[GTI_CODING_GAIN_ITEM];
    outBuf->maxBitsPerBin = Adapter->xcvr[0].item[GTI_MAX_BITS_PER_BIN_ITEM];
    outBuf->txStartBin = Adapter->xcvr[0].item[GTI_TX_START_BIN_ITEM];
    outBuf->txEndBin = Adapter->xcvr[0].item[GTI_TX_END_BIN_ITEM];
    outBuf->txBinAdjust = Adapter->xcvr[0].item[GTI_TX_BIN_ADJUST_ITEM];
    outBuf->rxStartBin = Adapter->xcvr[0].item[GTI_RX_START_BIN_ITEM];
    outBuf->rxEndBin = Adapter->xcvr[0].item[GTI_RX_END_BIN_ITEM];
    outBuf->rxBinAdjust = Adapter->xcvr[0].item[GTI_RX_BIN_ADJUST_ITEM];
    outBuf->framingStruct = Adapter->xcvr[0].item[GTI_FRAMING_STRUCTURE_ITEM];
    outBuf->expandedExchange = Adapter->xcvr[0].item[GTI_EXPANDED_EXCHANGE_ITEM];
    outBuf->clockType = Adapter->xcvr[0].item[GTI_CLOCK_TYPE_ITEM];

#ifdef ANNEXC
   outBuf->annexCMode= Adapter->xcvr[0].item[GTI_ANNEX_C_MODE_ITEM];
#endif // ANNEXC

#endif /* GTI_DMT */
}

void GsiSetConfigUData(PUSB_PHY Adapter, PGSIDSL_CONFIGU inBuf)
{
#ifdef GTI_DMT
   Adapter->xcvr[0].item[GTI_STANDARD_ITEM] = inBuf->standard;
#endif // GTI_DMT
}


void GsiGetConfigUData(PATM_USB_INSTANCE Instance, PGSIDSL_CONFIGU outBuf)
{
    PUSB_PHY Adapter = Instance->UsbPhyHandle;

    if ( (Adapter == NULL) || (outBuf == NULL) )
        return;

	outBuf->standard = Adapter->xcvr[0].item[GTI_STANDARD_ITEM];

#ifdef LAN_MINIPORT
	outBuf->Rfc1483Mode = (USHORT)(Instance->Rfc1483Mode);
	outBuf->vpi = Instance->Rfc1483Vpi;
	outBuf->vci = Instance->Rfc1483Vci;
#endif
}


#ifdef _NTDDK_
void WriteConfigReg(PUSB_PHY UsbPhy)
{
NTSTATUS		NtStatus;
NTSTATUS                       Status;
HANDLE			hkey;
NDIS_STRING		Keyword;
NDIS_STRING		KeyValue;
WCHAR			KeyValueString[2];
PNDIS_CONFIGURATION_PARAMETER  Parameter;
NDIS_CONFIGURATION_PARAMETER   tmp;
PATM_UNI                       AtmUni;
NDIS_HANDLE                    WrapperConfigurationContext;
PATM_USB_INSTANCE              Instance;
NDIS_HANDLE                    ConfigHandle;


	if (UsbPhy==NULL)
		return;

	KeyValueString[0] = UsbPhy->xcvr[0].item[GTI_STANDARD_ITEM] + '0';
	KeyValueString[1] = '\0';

   NdisInitUnicodeString(&Keyword, L"Standard");
   NdisInitUnicodeString(&KeyValue, KeyValueString);
	//RtlInitUnicodeString(&Keyword, L"Standard");
	//RtlInitUnicodeString(&KeyValue, KeyValueString);

#ifndef NDIS_CALLS
	NtStatus = IoOpenDeviceRegistryKey( UsbPhy->TopOfStackDeviceObject, PLUGPLAY_REGKEY_DRIVER, KEY_ALL_ACCESS, &hkey);
	if (NT_SUCCESS(NtStatus))
	{
		NtStatus = ZwSetValueKey(hkey, &Keyword, 0, REG_SZ, KeyValue.Buffer, KeyValue.Length * sizeof(UCHAR));
		if (!NT_SUCCESS(NtStatus))
           DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_ERR,
	               ("ERROR:  Unable to write value to Standard key!\n"));

		ZwClose(hkey);
	}
	else
       DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_ERR,
	               ("ERROR:  Standard key not found!\n"));
#endif /* !NDIS_CALLS */
#ifdef NDIS_CALLS
   /* FIXME: The NdisWriteConfiguration value does not work and needs to be
   ** debugged. But in the deja.com it indicated, the argument 4
   ** is pointer to pointer in some OS and just pointer in other OS.
   */
#if 0
   AtmUni = UsbPhy->UserHandle;
   Instance = AtmUni->UserHandle;
   WrapperConfigurationContext = Instance->WrapperConfigurationContext;

   NdisOpenConfiguration(&Status,
                           &ConfigHandle,
                           WrapperConfigurationContext);
   if (Status != NDIS_STATUS_SUCCESS)
   {
       DBGPRINT(DBG_PRINT_MODULE_GSICPL, DBG_PRINT_LEVEL_ERR,
                ("NdisOpenConfiguration failed (Status=%X)\n",Status));
	    return;
   }
   tmp.ParameterType = NdisParameterHexInteger;
   tmp.ParameterData.IntegerData = 5;
   Parameter = &(tmp);

   NdisWriteConfiguration(&Status, ConfigHandle, &Keyword, &tmp);

   /* We should close the registry configuration routine */
   NdisCloseConfiguration (ConfigHandle);
#endif
#endif /* NDIS_CALLS */
}

#endif // _NTDDK_

#if defined(LAN_MINIPORT) || defined(GSI_LAN)
void GetRfc1577Entries(PVOID pUsbPhy ,PQUERY_ARP_BUFFER pArpBuffer )
{
PUSB_PHY UsbPhy = (PUSB_PHY)pUsbPhy;
int Count,i;
PATM_USB_INSTANCE Instance = AtmUniGetUserHandle(UsbPhy->UserHandle );
void *Rfc1577Context = Api1577GetContext(Instance);

   DBGPRINT(DBG_PRINT_MODULE_NDIS_ALL, DBG_PRINT_LEVEL_TRACE,
         ("GetRfc1577Entries\n"));

    if( (GetDspState(UsbPhy)) == DSP_PHY_CONNECTED )
    {
        Rfc1577GetArpEntries(Rfc1577Context , pArpBuffer);
    }
    else
    {
        pArpBuffer->Count = 0;
    }
}

void DeleteRfc1577Entry(PVOID pUsbPhy ,Rfc1577Status_t  *pArpBuffer )
{
PUSB_PHY UsbPhy = (PUSB_PHY)pUsbPhy;
PATM_USB_INSTANCE Instance = AtmUniGetUserHandle(UsbPhy->UserHandle );
void *Rfc1577Context = Api1577GetContext(Instance);

   DBGPRINT(DBG_PRINT_MODULE_NDIS_ALL, DBG_PRINT_LEVEL_TRACE,
         ("DeleteRfc1577Entry\n"));

ASSERT(pArpBuffer);
Rfc1577DeleteArpEntry(Rfc1577Context , pArpBuffer);
}
#endif

#ifdef NEW_CPL_INTERFACE
/********************************************************************
* Function     : IoctlQueryCmd
* Description  : 
*
* Input        : 
*
* Output       : None
* Return       : None
**********************************************************************/
void IoctlQueryCmd(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr)
{
ULONG  dWordValue;
UCHAR  byteValue;
USHORT wordValue;

   DBGPRINT(DBG_PRINT_MODULE_USB_ALL, DBG_PRINT_LEVEL_TRACE, ("IoctlQueryCmd\n"));
   
   outBufPtr->status = GV_STATUS_COMPLETE;
   outBufPtr->length = 0;

#define MASK_BIT_MODULE_REQUEST    0xFF00

   switch (inBufPtr->request & MASK_BIT_MODULE_REQUEST)
   {
       case GV_QUERY_DRV_STATUS_RESERVED:
           USBCPLQueryDrvStatus(UsbPhy, inBufPtr, outBufPtr);
           break;

       case GV_QUERY_DSP_PARAM_RESERVED:
           USBCPLQueryDSPParam(UsbPhy, inBufPtr, outBufPtr);
           break;

       case GV_QUERY_DSP_STATUS_RESERVED:
           USBCPLQueryDSPStatus(UsbPhy, inBufPtr, outBufPtr);
           break;

       case GV_QUERY_ATM_STATS_RESERVED:
//           ATMUNIQueryATMStats(UsbPhy->UserHandle, inBufPtr, outBufPtr);
           break;

       default:
           outBufPtr->status = GV_STATUS_INVALID_REQ;
           break;
   }

   /* Sanity check - for valid data */
   if( (outBufPtr->status == GV_STATUS_COMPLETE) && (outBufPtr->length == 0) )
   {
       /* We can not report COMPLETE and length to be zero for Query command */
       outBufPtr->status = GV_STATUS_INVALID_REQ;
   }
   return;
}

/********************************************************************
* Function     : IoctlSetCmd
* Description  : 
*
* Input        : 
*
* Output       : None
* Return       : None
**********************************************************************/
void IoctlSetCmd(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr)
{
;
}

/********************************************************************
* Function     : USBCPLQueryDrvStatus
* Description  : 
*
* Input        : 
*
* Output       : None
* Return       : None
**********************************************************************/
void USBCPLQueryDrvStatus(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr)
{
USHORT wordValue;

   switch(inBufPtr->request)
   {
       /* Query request identifiers */
       case GV_QUERY_DRV_VERSION:          // 0x0001
           strcpy(outBufPtr->data, VER_DRIVERVERSION_STR);
           outBufPtr->status = GV_STATUS_INVALID_REQ;
           break;

       case GV_QUERY_DRV_TYPE:             // 0x0002
           outBufPtr->status = GV_STATUS_INVALID_REQ;
           break;

       case GV_QUERY_LINE_CONNECTED:       // 0x0003
           /* Is the DSL line connected or not into the device? */
           /* This is really hard to know without the hardware and/or
           ** firmware support. Therefore we are attempting to provide
           ** this information from the resources available to us.
           */
           switch(GetDspState(UsbPhy))
           {
               case DSP_PHY_NO_SIGNAL:
               case DSP_PHY_TRAINING:
                   // Read GTI_START_PROGRESS
			        Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
									          GTI_START_PROGRESS,
									          &wordValue,
									          sizeof(wordValue),
									          GTI_CH_A);

                   *((ULONG*)outBufPtr->data) =(ULONG)((wordValue!=0xA0) &&
                                                       (wordValue!=0x00) &&
                                                       (wordValue!=0x01) &&
                                                       (wordValue!=0x02));
                   break;

               case DSP_PHY_WAIT_CELLDEL:
               case DSP_PHY_CONNECTED:
                   *((ULONG*)outBufPtr->data) = TRUE;
                   break;

               case DSP_PHY_SPECTRUM_MODE: /* Test state: not connected */
               case DSP_PHY_LOOPBACK_MODE: /* Test state: not connected */
               case DSP_PHY_IDLE:          /* Same as not connected */
               case DSP_PHY_DISCONNECT:    /* Same as not connected */
               case DSP_PHY_RESTART:       /* Same as not connected */
               default:
                   *((ULONG*)outBufPtr->data) = FALSE;
                   break;
           }

           outBufPtr->length  = sizeof(ULONG);
#if 0
           // Read GTI_START_PROGRESS
			Gti_SStatusXCVR_USB( UsbPhy->GTISysBlock,
									  GTI_START_PROGRESS,
									  &wordValue,
									  sizeof(wordValue),
									  GTI_CH_A);
			// GV_QUERY_LINE_CONNECTED must be called periodically (ie every sec),
			// If GTI_START_PROGRESS toggles into any state other then 0xA0,0x01,0x02,
			// 		then the line is connected to a far-end CO.
			// If GetDspState == DSP_PHY_CONNECTED,
			//		then the line is connected to a far-end CO.
           *((ULONG*)outBufPtr->data) = (ULONG)( (DSP_PHY_CONNECTED==((UCHAR)GetDspState(UsbPhy))) ||
           								((wordValue!=0xA0)&&(wordValue!=0x01)&&(wordValue!=0x02)) );

           outBufPtr->length  = sizeof(ULONG);
#endif
           break;

       case GV_QUERY_DRIVER_OPSTATE:       // 0x0005
           *((ULONG*)outBufPtr->data) = (ULONG)GetDspState(UsbPhy);
           outBufPtr->length  = sizeof(ULONG);
           break;

       default:
           outBufPtr->status = GV_STATUS_INVALID_REQ;
           break;
   }
}

/********************************************************************
* Function     : USBCPLQueryDSPStatus
* Description  : 
*
* Input        : 
*
* Output       : None
* Return       : None
**********************************************************************/
void USBCPLQueryDSPParam(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr)
{
   switch(inBufPtr->request)
   {
       /* Query/Set DSP DSL FW Parameters 0x01XX */
       case GV_QUERY_ACTION:               // 0x0100
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ACTION_ITEM]);
           break;

       case GV_QUERY_MODE:                 // 0x0101
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_MODE_ITEM]);
           break;

       case GV_QUERY_INITIATE:             // 0x0102
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_INITIATE_ITEM]);
           break;

       case GV_QUERY_DATA_INTERFACE_TYPE:  // 0x0103
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_DATA_INTERFACE_TYPE_ITEM]);
           break;

       case GV_QUERY_TRELLIS:              // 0x0104
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TRELLIS_ITEM]);
           break;

       case GV_QUERY_EC_FDM:               // 0x0105
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_EC_FDM_ITEM]);
           break;

       case GV_QUERY_STANDARD:             // 0x0106
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_STANDARD_ITEM]);
           break;

       case GV_QUERY_MAX_BIT_PER_BIN:      // 0x0107
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_MAX_BITS_PER_BIN_ITEM]);
           break;

       case GV_QUERY_TX_START_BIN:         // 0x0108
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TX_START_BIN_ITEM]);
           break;

       case GV_QUERY_TX_END_BIN:           // 0x0109
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TX_END_BIN_ITEM]);
           break;

       case GV_QUERY_LINE_DR_STBY:         // 0x010A
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_LINE_DR_STBY_ITEM]);
           break;

       case GV_QUERY_RX_START_BIN:         // 0x010B
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_RX_START_BIN_ITEM]);
           break;

       case GV_QUERY_RX_END_BIN:           // 0x010C
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_RX_END_BIN_ITEM]);
           break;

       case GV_QUERY_RX_ADJUST_BIN:        // 0x010D
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_RX_BIN_ADJUST_ITEM]);
           break;

       case GV_QUERY_TX_PWR:               // 0x010E
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TX_POWER_ATTENUATION_ITEM]);
           break;

       case GV_QUERY_NTR:                  // 0x010F
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_NTR_ITEM]);
           break;

       case GV_QUERY_PMODE:                // 0x0110
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_PMODE_ITEM]);
           break;

       case GV_QUERY_CODING_GAIN:          // 0x0111
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_CODING_GAIN_ITEM]);
           break;

       case GV_QUERY_TONE_ORDERING:        // 0x0112
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TONE_ORDERING_ITEM]);
           break;

       case GV_QUERY_FRAMING_STRUCTURE:    // 0x0113
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_FRAMING_STRUCTURE_ITEM]);
           break;

       case GV_QUERY_UTOPIA_L2_TX:         // 0x0114
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_UTOPIA_L2_TX_ADDR_ITEM]);
           break;

       case GV_QUERY_UTOPIA_L2_RX:         // 0x0115
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_UTOPIA_L2_RX_ADDR_ITEM]);
           break;

       case GV_QUERY_CLOCK_TYPE:           // 0x0116
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_CLOCK_TYPE_ITEM]);
           break;

       case GV_QUERY_VENDOR_ID:            // 0x0117
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_VENDOR_ID_ITEM]);
           break;

       case GV_QUERY_VENDOR_REV:           // 0x0118
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_VENDOR_REV_SHORT_ITEM]);
           break;

       case GV_QUERY_EXPANDED_EXCHANGE:    // 0x0119
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_EXPANDED_EXCHANGE_ITEM]);
           break;

       case GV_QUERY_ESCAPE_FAST_RETRAIN:  // 0x011A
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ESCAPE_FAST_RETRAIN_ITEM]);
           break;

       case GV_QUERY_FAST_RETRAIN_ENABLE:  // 0x011B
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_FAST_RETRAIN_ENABLE_ITEM]);
           break;

       case GV_QUERY_BIT_SWAP:             // 0x011C
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_BIT_SWAP_ITEM]);
           break;

       case GV_QUERY_US_BIT_SWAP:          // 0x011D
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_US_BIT_SWAP_ITEM]);
           break;

       case GV_QUERY_ERASE_PROFILES:       // 0x011E
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ERASE_PROFILES_ITEM]);
           break;

       case GV_QUERY_TRIGGER_MODE:         // 0x011F
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TRIGGER_MODE_ITEM]);
           break;

       case GV_QUERY_ANNEX_TYPE:           // 0x0120
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ANNEX_TYPE_ITEM]);
           break;

       case GV_QUERY_ANNEXC_MODE:          // 0x0121
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ANNEX_C_MODE_ITEM]);
           break;

       case GV_QUERY_ANNEXC_PILOT_TONE:    // 0x0122
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ANNEX_C_PILOT_TONE_ITEM]);
           break;

       case GV_QUERY_TX_ADJUST_BIN:        // 0x0123
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_TX_BIN_ADJUST_ITEM]);
           break;

       case GV_QUERY_PILOT_TONE_REQUEST:   // 0x0124
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_PILOT_TONE_REQUEST_ITEM]);
           break;

       case GV_QUERY_MAX_DOWN_RATE:        // 0x0125
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_MAX_DOWN_RATE_ITEM]);
           break;

       case GV_QUERY_DUAL_LATENCY:         // 0x0126
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_DUAL_LATENCY_ITEM]);
           break;

       case GV_QUERY_HW_REV:               // 0x0127
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_HW_REV_ITEM]);
           break;

       case GV_QUERY_CUTBACK:              // 0x0128
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_CUTBACK_ITEM]);
           break;

       case GV_QUERY_ANNEX_CH_OFFSET_TRR:  // 0x0129
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_ANNEX_CH_OFFSET_TTR_R_ITEM]);
           break;

       case GV_QUERY_MAC_D_CP:             // 0x0130
           *((ULONG*)outBufPtr->data) = (ULONG)(UsbPhy->xcvr[0].item[GTI_MAX_D_CP_ITEM]);
           break;

       default:
           outBufPtr->status = GV_STATUS_INVALID_REQ;
           return;
   }

   /* Minimum status size has to be Sizeof(ULONG) */
   outBufPtr->length = sizeof(ULONG);
}

//BYTE DSPStatusTable[] =
//{
//GV_QUERY_FW_REL,           GTI_FW_REL,                 GTI_FW_REL_LEN,
//GV_QUERY_RMT_VENDOR_ID,
//};

/********************************************************************
* Function     : USBCPLQueryDSPStatus
* Description  : 
*
* Input        : 
*
* Output       : None
* Return       : None
**********************************************************************/
void USBCPLQueryDSPStatus(PUSB_PHY UsbPhy, GV_INTF_MSG *inBufPtr, GV_INTF_MSG *outBufPtr)
{
UCHAR  bValue=0;
USHORT wValue=0;
ULONG  dwValue=0;

   switch(inBufPtr->request)
   {
       /* Query DSL (DSP) Status */
       case GV_QUERY_OPSTATE:              // 0x01E3
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                           UsbPhy->GTISysBlock,
                                           GTI_OP_STATE,
                                           outBufPtr->data,
                                           GTI_OP_STATE_LEN,
                                           GTI_CH_A);
           break;

       case GV_QUERY_FW_REL:               // 0x01E4
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_FW_REL,
                                       outBufPtr->data,
                                       GTI_FW_REL_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_RMT_VENDOR_ID:        // 0x01E5
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_RMT_VENDOR_ID_STATUS,
                                       outBufPtr->data,
                                       GTI_RMT_VENDOR_ID_G_DMT_STATUS_LEN, // Max. length
                                       GTI_CH_A);
           break;

       case GV_QUERY_START_PROGRESS:       // 0x01E6
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_START_PROGRESS,
                                       outBufPtr->data,
                                       GTI_START_PROGRESS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_LAST_FAILED:          // 0x01E7
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_LAST_FAILED_STATUS,
                                       outBufPtr->data,
                                       GTI_LAST_FAILED_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_RX_BYTES:             // 0x01E8
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_RX_BYTES_STATUS,
                                       outBufPtr->data,
                                       GTI_RX_BYTES_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_TX_BYTES:             // 0x01E9
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_TX_BYTES_STATUS,
                                       outBufPtr->data,
                                       GTI_TX_BYTES_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_ACTUAL_CONFIG:        // 0x01EA
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_ACTUAL_CONFIGURATION,
                                       outBufPtr->data,
                                       GTI_ACTUAL_CONFIGURATION_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_ATTENUATION:          // 0x01EB
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_ATTENUATION_STATUS,
                                       outBufPtr->data,
                                       GTI_ATTENUATION_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_COUNTERS:             // 0x01EC
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_COUNTERS,
                                       outBufPtr->data,
                                       GTI_COUNTERS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_FAILURES:             // 0x01ED
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_FAILURES,
                                       outBufPtr->data,
                                       GTI_FAILURES_LEN,
                                       GTI_CH_A);
           break;

//       case GV_QUERY_SNR_MARGIN_BIN:       // 0x01EE
       case GV_QUERY_LCL_SNR_MARGIN:       // 0x01EF
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_LCL_SNR_MARGIN,
                                       outBufPtr->data,
                                       GTI_LCL_SNR_MARGIN_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_US_SNR_MARGIN:        // 0x01F0
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_UPSTREAM_MARGIN_STATUS,
                                       outBufPtr->data,
                                       GTI_UPSTREAM_MARGIN_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_LCL_XMIT_PWER:        // 0x01F1
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_LCL_XMIT_POWER_STATUS,
                                       outBufPtr->data,
                                       GTI_LCL_XMIT_POWER_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_RMT_XMIT_PWER:        // 0x01F2
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_RMT_TX_POWER_STATUS,
                                       outBufPtr->data,
                                       GTI_RMT_TX_POWER_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_RMT_VENDOR_REV:       // 0x01F3
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_RMT_VENDOR_REV_STATUS,
                                       outBufPtr->data,
                                       GTI_RMT_VENDOR_REV_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_FAST_RETRAIN:         // 0x01F4
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_FAST_RETRAIN_STATUS,
                                       outBufPtr->data,
                                       GTI_FAST_RETRAIN_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_LCL_ANNEXC_MODE:      // 0x01F5
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_LCL_ANNEX_C_MODE,
                                       outBufPtr->data,
                                       GTI_LCL_ANNEX_C_MODE,
                                       GTI_CH_A);
           break;

       case GV_QUERY_OVERLAP:              // 0x01F6
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_OVERLAP_STATUS,
                                       outBufPtr->data,
                                       GTI_OVERLAP_STATUS_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_LCL_FW_REV:           // 0x01F7
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_LCL_FW_REV_NUM,
                                       outBufPtr->data,
                                       GTI_LCL_FW_REV_NUM_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_LCL_CODING_GAIN:      // 0x01F8
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_LCL_CODING_GAIN,
                                       outBufPtr->data,
                                       GTI_LCL_CODING_GAIN_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_SNR_MARGIN_BIN:       // 0x01F9
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_SNR_MARGIN_PER_BIN,
                                       outBufPtr->data,
                                       GV_MAX_DATA_SIZE, // No default size provided by firmware files
                                       GTI_CH_A);
           break;

       case GV_QUERY_SNR_MARGIN_BIN_NEXT:  // 0x01FA
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_SNR_MARGIN_PER_BIN_NEXT,
                                       outBufPtr->data,
                                       GV_MAX_DATA_SIZE, // No default size provided by firmware files
                                       GTI_CH_A);
           break;

       case GV_QUERY_BIT_LOADING_UP:       // 0x01FB
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_BIT_LOADING_UP,
                                       outBufPtr->data,
                                       GTI_BIT_LOADING_UP_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_BIT_LOADING_UP_NEXT:  // 0x01FD
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_BIT_LOADING_NEXT_UP,
                                       outBufPtr->data,
                                       GTI_BIT_LOADING_NEXT_UP_LEN,
                                       GTI_CH_A);
           break;

       case GV_QUERY_BIT_LOADING_DN:       // 0x01FC
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_BIT_LOADING_DN,
                                       outBufPtr->data,
                                       GV_MAX_DATA_SIZE, // No default size provided by firmware files
                                       GTI_CH_A);
           break;

       case GV_QUERY_BIT_LOADING_DN_NEXT:  // 0x01FE
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_BIT_LOADING_NEXT_DN,
                                       outBufPtr->data,
                                       GV_MAX_DATA_SIZE, // No default size provided by firmware files
                                       GTI_CH_A);
           break;

       case GV_QUERY_DSP_VERSION:          // 0x01FF
           outBufPtr->length = Gti_SStatusXCVR_USB(
                                       UsbPhy->GTISysBlock,
                                       GTI_DSP_VERSION,
                                       outBufPtr->data,
                                       GTI_DSP_VERSION_LEN,
                                       GTI_CH_A);
           break;

       default:
           outBufPtr->status = GV_STATUS_INVALID_REQ;
           return;
   }

   if ( (outBufPtr->length) && (outBufPtr->length < sizeof(ULONG)) )
       outBufPtr->length = sizeof(ULONG);
}
#endif //NEW_CPL_INTERFACE
